#!/usr/bin/env python

import os, re, fpformat
from  defs import *
import curses
from curses import panel
import ui
from ui import *
from reports import *
from  MySQLdb import *
from time import gmtime, strftime

OS_NAME = "Mandrake Linux 8.2"
SERVER_NAME = "MySQL Server 3.23"
VER = "0.7 beta"

def get_user():
    import pwd
    return pwd.getpwuid(os.getuid())[4]

class Store:
    def __init__ (self, win):
	self.user = get_user()
	self.set_colors()
	self.win = win
	self.DrawUI()
	self.mainloop()
	
    def DrawUI(self):
	self.main_panel = Panel(0, 0,
		 curses.LINES, curses.COLS, COL_MAIN)
	self.main_panel.drawbox()
	self.main_panel.set_caption(" COMPANY xx ")
	self.main_panel.writexy(56, 1,
	         "     ", COL_WARN, TRUE)
	self.main_panel.hline(1, 3, 52, COL_MAIN)
	self.main_panel.writexy(3, 2, ":", COL_MAIN)
	self.main_panel.writexy(3, 3, str(self.user), COL_MAIN)
#	+ "    :", COL_MAIN)

	self.DrawLOGO()
	self.main_panel.writexy(67, 2, "ver "+VER, COL_MAIN)
	
	self.menu = MenuBar(4, 21, 2, 73, COL_TEXT)

	self.menu.loadMenu("fin.mnu")
	curses.curs_set(0)
	pflush()
	
    def DrawLOGO(self):
	self.main_panel.drawrect(4, 3, 75, 16, COL_TAB)
	self.main_panel.hline(5, 4, 51, COL_TAB)
	self.main_panel.win.addch(5, 55, curses.ACS_URCORNER)
	self.main_panel.hline(6, 4, 54, COL_TAB)

	self.main_panel.vline(6, 55, 14, COL_TAB)
	self.main_panel.vline(5, 57, 15, COL_TAB)	
	self.main_panel.vline(5, 53, 15, COL_TAB)		
	
	
	titlestr = "COMPANY xx"
	for i in range(6, 16):
	    self.main_panel.writexy(60, i, titlestr[i-6], COL_MAIN)
	self.main_panel.writexy(72, 18, ":", COL_MAIN)
	self.main_panel.writexy(60, 19, " ", COL_MAIN)
	self.main_panel.writexy(5, 20, "Linux OS", COL_MAIN)
	
	
    def set_colors(self):
	if curses.can_change_color() == 1:
	    curses.init_color(5, 800, 800, 800)
	curses.init_pair(1, curses.COLOR_BLUE, curses.COLOR_WHITE)
	curses.init_pair(2, curses.COLOR_WHITE, curses.COLOR_BLUE)
	curses.init_pair(3, curses.COLOR_WHITE, curses.COLOR_RED)
	curses.init_pair(4, curses.COLOR_WHITE, curses.COLOR_BLACK)
	curses.init_pair(5, curses.COLOR_BLACK, curses.COLOR_WHITE)
	curses.init_pair(6, curses.COLOR_RED, curses.COLOR_WHITE)
	curses.init_pair(7, curses.COLOR_BLUE, curses.COLOR_BLACK)
	curses.init_pair(8, curses.COLOR_RED, curses.COLOR_GREEN)

	
    def mainloop(self):
	while 1:
	    cmd = self.menu.mainLoop()
	    if cmd == "cmd_stop": break
	    if cmd == "cmd_record_new":
		papkadlg = EnterPapkaDlg()
		papkadlg.mainLoop()
		if papkadlg.enter == 1 or papkadlg.enter == 2:
		    enter = papkadlg.enter
		    np = papkadlg.nom_papka.text + papkadlg.god.text
		    dd = papkadlg.data_oschet.text
		    papkadlg.destroy()
		    del papkadlg
		    record = RecordDialog(np, dd, enter)
		    record.mainLoop()
		    record.destroy()
		    del record
		else:
		    papkadlg.destroy()
		    del papkadlg
		
		
	    if cmd == "cmd_prihod_raznos":
		razn = RaznosRecord()
		razn.mainLoop()
		razn.destroy()
		del razn
		
	    if cmd == "cmd_plan":
		plandlg = PlanDialog()
		plandlg.mainLoop()
		plandlg.destroy()
		del plandlg
		pflush()
		
	    if cmd == "cmd_get_debit_oborot":
		oborotdlg = Oborot(1)
		oborotdlg.mainLoop()
		oborotdlg.destroy()
		del oborotdlg
		pflush()
	    if cmd == "cmd_get_kredit_oborot":
		oborotdlg = Oborot(2)
		oborotdlg.mainLoop()
		oborotdlg.destroy()
		del oborotdlg
		pflush()
	    if cmd == "cmd_bank_vn_bel":
		vnbeldlg = BankDocument14("1", 1)
		vnbeldlg.mainLoop()
		vnbeldlg.destroy()
		del vnbeldlg
		pflush()
	    if cmd == "cmd_bank_nar_razp":
		bnardlg = BankDocument14("1", 4)
		bnardlg.mainLoop()
		bnardlg.destroy()
		del bnardlg
		pflush()
	    
	    #if cmd == "cmd_finish":
		#self.Finish_kasa()
		#pass
	    if cmd == "cmd_get_saldo":
		#saldolv = GetSaldo(501001)
		#saldo_usd = GetSaldo(501002)
		#saldo_eur = GetSaldo(501003)
		#msgbox = MessageBox(25, 10, 7, 24, COL_TAB, COL_WARN, \
		#                        [" = ", str(saldo)], "", msg_OK)
		#msgbox.mainLoop()
		#msgbox.destroy()
		#del msgbox
		
		show = ShowSaldoDlg()
		show.mainLoop()
		show.destroy()
		del show
		
		pflush()
		
	    if cmd == "cmd_register":
		register = Register()
		register.mainLoop()
		register.destroy()
		del register
		pflush()
				
	
    def Invalidate(self, counter, doc_type):
	db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	curs = db.cursor()
	if doc_type == 1 or doc_type == 2:
	    curs.execute("""INSERT INTO kasadocs (doc_no, doc_type, person, anlperson, purpose, anlpurpose, sum, invalid, date, oper) VALUES (%s, %s, %s, %s, %s, %s, %s, %s, NOW(), %s)""",
	                (counter, doc_type, "", 0, "", 0, 0, 1, "cv")) 
	db.close()


	
    def SelectDocument(self, doc_type):
	docdlg = DocumentDialog(doc_type)
	(doc_no, name) = docdlg.mainLoop()
	docdlg.destroy()
	del docdlg
	pflush()
	return (doc_no, name)
    
    def SelectPartner(self, partner_type):
	partdlg = PartnersDialog(partner_type)
	(dan_no, city, partner_name) = partdlg.mainLoop()
	partdlg.destroy()
	del partdlg
	return (strip(partner_name) + " - " + strip(city), strip(dan_no))

    
def getDoc_counter(doc_no = None, doc_name = ""):
    if doc_no <> None:
	query = " WHERE doc_no = " + str(doc_no)
	if doc_name <> "":
	    query = query + " AND name = \'" + doc_name +"\'"
    else:
	query = " WHERE name = \'" + doc_name + "\'"
    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
    curs = db.cursor()
    curs.execute("UPDATE LOW_PRIORITY documents SET counter=counter+1" + query)
    curs.execute("SELECT CONCAT(counter, '') from documents" + query)
    (counter, ) = curs.fetchone()
    db.commit()
    db.close()
    return counter    

def GetSaldo(account, begdate, full=FALSE):
    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
    curs = db.cursor()
    rec = curs.execute("""SELECT dt FROM kasa WHERE issaldo = 1 AND account=%s""", (account, ))
    if rec > 0:
	(dt, ) = curs.fetchone()
	curs.close()
	del curs
	curs1 = db.cursor()
	curs1.execute("""SELECT sum(dt), sum(kt) FROM kasa WHERE account = %s AND date <= %s AND issaldo = 0""", (account, begdate))
	(sumdt, sumkt) = curs1.fetchone()
	if sumdt == None:
	    sumdt = 0
	if sumkt == None:
	    sumkt = 0
	    db.close()
	if full == TRUE:
	    saldo = dt + sumdt - sumkt
	else:
	    saldo = dt
	found = TRUE
    else:
	saldo = 0
	found = FALSE
    db.close()
    return (saldo, found)

class DropDnBox1(DropDnBox):
    
    def FillBox(self):
	self.box.addItem(" 1")
	self.box.addItem(" 2")
	self.box.addItem(" 3")
	self.box.addItem(" 4")
	self.box.addItem(" 5")	
	self.box.addItem(" 6")	
	self.box.addItem(" 7")	
	self.box.addItem(" 8")	
	self.box.addItem(" 9")	

class EnterPapkaDlg(Dialog):
    def __init__(self):
	Dialog.__init__(self, 23, 9, 10, 34, COL_MAIN)
	self.set_caption("/ ")
	self.nowday = strftime("%d-%m-%Y", gmtime())
	
	self.enter = 0
	
	self.writexy(2, 2, ": "+self.nowday, COL_TEXT1)
	self.np = self.nowday[0:2]+self.nowday[3:5]
	self.nom_papka = LabeledEditLine(self, 2, 4, 4, " ", pos_LEFT)
	self.nom_papka.SetText(self.np)
	self.addWidget(self.nom_papka)
	
	self.god = LabeledEditLine(self, 2, 5, 3,       " ", pos_LEFT)
	self.god.SetText(self.nowday[7:10])
	self.addWidget(self.god)
	
	self.writexy(2, 6, "  .", COL_TEXT1)
	self.data_oschet = DateLine(self, 20, 6, COL_TEXT, COL_TITLE)
	self.data_oschet.SetText(strftime("%d-%m-%y", gmtime()))
	self.addWidget(self.data_oschet)
	
	self.select(0)
	
    def UserFn(self, command, args):
	if command == ev_OK and args == 1:
	    if self.nom_papka.text != self.np:
		db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
		curs = db.cursor()
		r = curs.execute("""SELECT DISTINCT nom_papka FROM foldcat WHERE nom_papka = %s""",
		        (self.nom_papka.text+self.god.text,))
		db.close()
		if r > 0:
		    self.writexy(2, 8, "  ", COL_TAB)
		    self.enter = 1
		else:
		    self.writexy(2, 8, "   ", COL_TAB)
		    self.writexy(2, 9, "  - 'ENTER' - ", COL_TAB)
		    self.enter = 3
		    self.select(2)
		    return ev_NONE
		    
	    elif self.nom_papka.text == self.np:
		db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
		curs = db.cursor()
		r = curs.execute("""SELECT DISTINCT nom_papka FROM foldcat WHERE nom_papka = %s""",
		        (self.nom_papka.text+self.god.text,))
		db.close()
		if r > 0:
		    self.writexy(2, 8, "  ", COL_TAB)
		    self.enter = 1
		else:
		    self.writexy(2, 8, " ", COL_TAB)
		    self.enter = 2
		
	    self.select(2)
	    return ev_NONE
	
	if command == ev_OK and args == 2:
	    return ev_DONE
	    
	    
	else:
	    self.nextWidget()
	    return ev_NONE
	
class GetDocsDialog(Dialog):
    def __init__(self):
	Dialog.__init__(self, 25, 3, 14, 45, COL_MAIN)
	
	self.plist = MultiListBox(self, 2, 1, 10, 40, COL_TEXT)
	self.plist.setItemColors(COL_TITLE, COL_TEXT)
	self.plist.MultiChoice = FALSE
	self.plist.addColon(4, "")
	self.plist.addColon(22, " ")
	self.plist.addColon(11, "")

	self.plist.Focusable = TRUE
	self.plist.dbQuery = "SELECT docno, name, strdoctype FROM findocgr"
	m = Message()
	m.message = cm_RELOAD
	self.plist.Update(m)
	#if nameSearch <> None:
	#    self.plist.Locate(nameSearch)
	self.addWidget(self.plist)

	self.writexy(1, 13, "F1 - ", COL_WARN)
	#self.select(0)
	self.AddHotKey(curses.KEY_F1, 0)
	
    def UserFn(self, command, args):
	if command == ev_OK:
	    return ev_DONE
	if command == ev_ACTIVATE and args == curses.KEY_F1:
	    analpartdlg = AnalPart(self.analitgr)
	    analpartdlg.mainLoop()
	    analpartdlg.destroy()
	    del analpartdlg
	    m = Message()
	    m.message = cm_RELOAD
	    self.plist.Update(m)
	    pflush()
	    
class GetKontDialog(Dialog):
    def __init__(self, docno):
	Dialog.__init__(self, 20, 3, 14, 54, COL_MAIN)
	
	self.plist = MultiListBox(self, 2, 1, 10, 50, COL_TEXT)
	self.plist.setItemColors(COL_TITLE, COL_TEXT)
	self.plist.MultiChoice = FALSE
	self.plist.addColon(4, "")
	self.plist.addColon(32, " - ")
	self.plist.addColon(7, "Dt")
	self.plist.addColon(7, "Kt")

	self.plist.Focusable = TRUE
	self.plist.dbQuery = "SELECT kontno, name, dt1, kt1 FROM finkont WHERE docno = \'" + str(docno) + "\'"
	m = Message()
	m.message = cm_RELOAD
	self.plist.Update(m)
	#if nameSearch <> None:
	#    self.plist.Locate(nameSearch)
	self.addWidget(self.plist)

	self.writexy(1, 13, "F1 - ", COL_WARN)
	#self.select(0)
	self.AddHotKey(curses.KEY_F1, 0)
	
    def UserFn(self, command, args):
	if command == ev_OK:
	    return ev_DONE
	if command == ev_ACTIVATE and args == curses.KEY_F1:
	    analpartdlg = AnalPart(self.analitgr)
	    analpartdlg.mainLoop()
	    analpartdlg.destroy()
	    del analpartdlg
	    m = Message()
	    m.message = cm_RELOAD
	    self.plist.Update(m)
	    pflush()	    

class RaznosRecord(Dialog):
    def __init__(self):
	Dialog.__init__(self, 0, 0, 24, 79)
	self.set_caption("     ")
	self.nowday = strftime("%d-%m-%y", gmtime())
	self.totalsum = 0
	
	#0
	self.date_oschet = LabeledDateLine(self, 1, 2, " ")
	self.date_oschet.SetText(self.nowday)
	self.addWidget(self.date_oschet)
	#1
	self.addWidget(Label(self, 22, 2, " ", COL_TEXT1))
	#2
	self.raznos = DropDnBox1(self, 31, 2, 12, 8, COL_TEXT)
	self.addWidget(self.raznos)
	#3
	self.sumi = MultiListBox(self, 2, 4, 12, 47, COL_TEXT)
	self.sumi.setItemColors(COL_TITLE, COL_TEXT)
	self.sumi.MultiChoice = FALSE
	self.sumi.addColon(10, " ")
	self.sumi.addColon(24, "")
	self.sumi.addColon(12, "")

	self.sumi.Focusable = TRUE	
	self.addWidget(self.sumi)	
	self.writexy(30, 17, ":               ", COL_WARN)
	#4
	self.oboroti = MultiListBox(self, 52, 4, 18, 25, COL_TEXT)
	self.oboroti.setItemColors(COL_TITLE, COL_TEXT)
	self.oboroti.MultiChoice = FALSE
	self.oboroti.addColon(12, "dt - ")
	self.oboroti.addColon(12, "kt - ")

	self.oboroti.Focusable = TRUE	
	self.addWidget(self.oboroti)		

	
	#5
	self.docno = LabeledEditLine(self, 2, 20, 10, " ", pos_UP)
	self.docno.setType(dt_numeric)
	self.addWidget(self.docno)
	
	#6 
	self.klient = OptionLine(self, 13, 20, 24, "", pos_UP)
	self.addWidget(self.klient)
	#7
	self.vnsuma = LabeledEditLine(self, 38, 20, 10, ". ",pos_UP)
	self.addWidget(self.vnsuma)
	
	self.AddHotKey(curses.KEY_F12, 2)
	
	self.select(0)

    def UserFn(self, command, args = None):
	if command == ev_OK and args == 0:
	    self.raznos.Activate(curses.KEY_F12)
	    self.select(5)
	    return ev_NONE
	if command == ev_OK and args == 5:
	    #       
	    #    
	    #       ( .)
	    #      ,
	    # (    ,  
	    #    'storndt', 'stornkt')  
	    #        
	    #   
	    #     ,    
	    #     ,     
	    self.select(6)
	if command == ev_OPTION and args == 6:
	    #   
	    self.select(7)
	if command == ev_OK and args == 7:
	    #   
	    dd = self.docno.text
	    kl = self.klient.text
	    ss = self.vnsuma.text
	    if dd == "" or ss == "":
		return ev_NONE
	    
	    self.totalsum = self.totalsum + float(ss)
	    
	    self.sumi.addItem([dd, kl, ss])
	    self.sumi.draw()
	    
	    self.docno.SetText("")
	    self.klient.SetText("")
	    self.vnsuma.SetText("")
	    self.select(5)
	    
	
	    
class RecordDialog(Dialog):
    def __init__(self, np, dd, LoadFolder = 0):
	Dialog.__init__(self, 0, 0, 24, 79)
	self.nowday = strftime("%d-%m-%y", gmtime())
	
	self.editRec = FALSE
	
	self._loadfolder = LoadFolder
	self.folder_loaded = TRUE
	self.nomp = np
	self.doschet = dd
	self.ri = []
	
	self.statia_no = 0
	self.kont_no = 0
	self.dt1account = 0
	self.kt1account = 0
	
	self.an11 = -1
	self.an12 = -1
	self.an13 = -1
	self.an14 = -1
	self.an15 = -1
	
	self.an21 = -1
	self.an22 = -1
	self.an23 = -1
	self.an24 = -1
	self.an25 = -1	
	
	self.an11x = -1
	self.an12x = -1
	self.an13x = -1
	self.an14x = -1
	self.an15x = -1
	
	self.an21x = -1
	self.an22x = -1
	self.an23x = -1
	self.an24x = -1
	self.an25x = -1		
	
	self.san11 = ""
	self.san12 = ""
	self.san13 = ""
	self.san14 = ""
	self.san15 = ""
	
	self.san21 = ""
	self.san22 = ""
	self.san23 = ""
	self.san24 = ""
	self.san25 = ""	
	
	
	#0
	self.date_oschet = LabeledDateLine(self, 1, 2, " ")
	self.date_oschet.SetText(self.doschet)
	self.addWidget(self.date_oschet)
	#1
	self.no_doc = LabeledEditLine(self, 1, 3, 8,   " .")
	self.addWidget(self.no_doc)
	#2
	self.n_folder = LabeledEditLine(self, 1, 4, 8, "  ")
	self.n_folder.SetText(self.nomp)
	self.addWidget(self.n_folder)
	#3
	self.fak_no = LabeledEditLine(self, 1, 5, 8,   ".  ")
	self.addWidget(self.fak_no)
	#4
	self.fak_date = LabeledDateLine(self, 1, 6,    " ")
	self.fak_date.SetText(self.nowday)
	self.addWidget(self.fak_date)
	#5
	self.statia = OptionLine(self, 1, 11, 35, ". ", pos_UP)
	self.addWidget(self.statia)
	#6
	self.schet_statia = OptionLine(self, 41, 11, 35, ". ", pos_UP)
	self.addWidget(self.schet_statia)
	#7
	self.accinfo1 = EditLine(self, 1, 13, 35, COL_TAB, COL_WARN)
	self.accinfo1.SetText("xxxxxx -   ")
	self.accinfo1.Focusable = FALSE
	self.addWidget(self.accinfo1)
	#8
	self.accinfo2 = EditLine(self, 41, 13, 35, COL_TAB, COL_WARN)
	self.accinfo2.SetText("xxxxxx -   ")
	self.accinfo2.Focusable = FALSE
	self.addWidget(self.accinfo2)	
	#9
	self.an11info = EditLine(self, 1, 15, 19, COL_NICE, COL_NICE)
	self.an11info.Focusable = FALSE
	self.addWidget(self.an11info)
	#10
	self.an11o = OptionLine(self, 19, 15, 19, "", pos_LEFT)
	self.addWidget(self.an11o)
	#11
	self.an12info = EditLine(self, 1, 16, 19, COL_NICE, COL_NICE)
	self.an12info.Focusable = FALSE
	self.addWidget(self.an12info)
	#12
	self.an12o = OptionLine(self, 19, 16, 19, "", pos_LEFT)
	self.addWidget(self.an12o)	
	#13
	self.an13info = EditLine(self, 1, 17, 19, COL_NICE, COL_NICE)
	self.an13info.Focusable = FALSE
	self.addWidget(self.an13info)
	#14
	self.an13o = OptionLine(self, 19, 17, 19, "", pos_LEFT)
	self.addWidget(self.an13o)	
	#15
	self.an14info = EditLine(self, 1, 18, 19, COL_NICE, COL_NICE)
	self.an14info.Focusable = FALSE
	self.addWidget(self.an14info)
	#16
	self.an14o = OptionLine(self, 19, 18, 19, "", pos_LEFT)
	self.addWidget(self.an14o)	
	#17
	self.an15info = EditLine(self, 1, 19, 19, COL_NICE, COL_NICE)
	self.an15info.Focusable = FALSE
	self.addWidget(self.an15info)
	#18
	self.an15o = OptionLine(self, 19, 19, 19, "", pos_LEFT)
	self.addWidget(self.an15o)	

	#---
	#19
	self.an21info = EditLine(self, 41, 15, 19, COL_NICE, COL_NICE)
	self.an21info.Focusable = FALSE
	self.addWidget(self.an21info)
	#20
	self.an21o = OptionLine(self, 59, 15, 19, "", pos_LEFT)
	self.addWidget(self.an21o)
	#21
	self.an22info = EditLine(self, 41, 16, 19, COL_NICE, COL_NICE)
	self.an22info.Focusable = FALSE
	self.addWidget(self.an22info)
	#22
	self.an22o = OptionLine(self, 59, 16, 19, "", pos_LEFT)
	self.addWidget(self.an22o)	
	#23
	self.an23info = EditLine(self, 41, 17, 19, COL_NICE, COL_NICE)
	self.an23info.Focusable = FALSE
	self.addWidget(self.an23info)
	#24
	self.an23o = OptionLine(self, 59, 17, 19, "", pos_LEFT)
	self.addWidget(self.an23o)	
	#25
	self.an24info = EditLine(self, 41, 18, 19, COL_NICE, COL_NICE)
	self.an24info.Focusable = FALSE
	self.addWidget(self.an24info)
	#26
	self.an24o = OptionLine(self, 59, 18, 19, "", pos_LEFT)
	self.addWidget(self.an24o)	
	#27
	self.an25info = EditLine(self, 41, 19, 19, COL_NICE, COL_NICE)
	self.an25info.Focusable = FALSE
	self.addWidget(self.an25info)
	#28
	self.an25o = OptionLine(self, 59, 19, 19, "", pos_LEFT)
	self.addWidget(self.an25o)	
	#----
	#29
	self.sum = LabeledEditLine(self, 2, 21, 10, "", pos=pos_UP)
	self.sum.SetText("0.0")
	self.sum.setType(dt_float)
	self.addWidget(self.sum)
	#30
	self.kol = LabeledEditLine(self, 13, 21, 10, "", pos=pos_UP)
	self.kol.setType(dt_float)
	self.kol.SetText("0.0")
	self.addWidget(self.kol)
	#31
	self.price = LabeledEditLine(self, 24, 21, 10, "", pos=pos_UP)
	self.price.setType(dt_float)
	self.price.SetText("0.0")
	self.addWidget(self.price)
	#32
	self.predmet = LabeledEditLine(self, 35, 21, 32, "  ", pos=pos_UP)
	self.addWidget(self.predmet)
	
	self.reclist = MultiListBox(self, 20, 1, 7, 58, COL_TEXT)
	self.reclist.setItemColors(COL_TITLE, COL_TEXT)
	self.reclist.MultiChoice = FALSE
	self.reclist.addColon(10, " ", dt_float, 0)
	self.reclist.addColon(10, " .", dt_float, 0)
	self.reclist.addColon(7, "Dt a")
	self.reclist.addColon(7, "Kt a")	
	self.reclist.addColon(10, "/", dt_float, 3)
	self.reclist.addColon(10, "-", dt_float, 3)
	self.reclist.addColon(1, "s")
	
	self.reclist.Focusable = FALSE
	self.reclist.addNotifyRecipient(self, cm_ITEM_CHANGED)
	if self._loadfolder == 1:
	    self.reclist.dbQuery = "SELECT fakt_no, nom_doc, kontdt, kontkt, value, amount, mode, price, data_oschet, data_fakt, predmet, doc_name, an11str, an11x, an21str, an21x, an51str, an51x, an12str, an12x, an22str, an22x, an52str, an52x FROM foldcat WHERE nom_papka = \'" + self.nomp + "\'"
	    m = Message()
	    m.message = cm_RELOAD
	    self.reclist.Update(m)
	    self.folder_loaded = TRUE
	self.addWidget(self.reclist)
	
	self.AddHotKey(curses.KEY_F3, 33)
	self.AddHotKey(curses.KEY_F2, 29)
	self.writexy(72, 0, ".", COL_TITLE, TRUE)
	self.select(0)

	
    def Update(self, msg):
	if msg.message == cm_ITEM_CHANGED:
	    indx = msg.args[1]
	    it = self.reclist.items[indx]
	    #a1 = int(it[2].Label)
	    #a2 = int(it[3].Label)
	    #pn = self.n_folder.text
	    #fn = it[0].Label
	    #fd = it[1].Label
	    
	    grstat = self.reclist.hidden_items[indx][3]
	    self.statia.SetText(grstat)
	    predmet = self.reclist.hidden_items[indx][4]
	    self.schet_statia.SetText(strip(predmet))
	    self.predmet.SetText(predmet)
	    self.fillAccountInfo(int(it[2].Label), int(it[3].Label))

	    self.an11o.SetText(self.reclist.hidden_items[indx][5][0:19])
	    self.san11 = self.reclist.hidden_items[indx][5]
	    self.an11x = self.reclist.hidden_items[indx][6]	    

	    self.an12o.SetText(self.reclist.hidden_items[indx][7][0:19])
	    self.san12 = self.reclist.hidden_items[indx][7]
	    self.an12x = self.reclist.hidden_items[indx][8]	    

	    self.an15o.SetText(self.reclist.hidden_items[indx][9][0:19])
	    self.san15 = self.reclist.hidden_items[indx][9]
	    self.an15x = self.reclist.hidden_items[indx][10]	    
	    
	    self.an21o.SetText(self.reclist.hidden_items[indx][11][0:19])
	    self.san21 = self.reclist.hidden_items[indx][11]
	    self.an21x = self.reclist.hidden_items[indx][12]	    

	    self.an22o.SetText(self.reclist.hidden_items[indx][13][0:19])
	    self.san22 = self.reclist.hidden_items[indx][13]
	    self.an22x = self.reclist.hidden_items[indx][14]	    

	    self.an25o.SetText(self.reclist.hidden_items[indx][15][0:19])
	    self.san25 = self.reclist.hidden_items[indx][15]
	    self.an25x = self.reclist.hidden_items[indx][16]	    
	    
	    #self.fillAccountInfo(a1, a2)
	    #db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	    #curs = db.cursor()
	    #curs.execute("""SELECT data_oschet, nom_doc, document, anal1, anal2, anal3, anal4, anal5 FROM accounts WHERE accno=%s AND nom_papka = %s AND fakt_no = %s and data_fakt = %s""", (a1, pn, fn, fd))
	    #r1 = curs.fetchone()
	    #self.writexy(40, 0, str(r1[3]), COL_WARN)
	    #if self.an11 != 0 and r1[3] != 0:
		#curs.execute("SELECT name FROM finanalgr WHERE grno = %s AND anno = %s""", (self.an11, r1[3]))
		#a1s = curs.fetchone()
		#self.an11o.SetText(a1s)
		#pass
	    #db.close()
	    
	
    def fillAccountInfo(self, ac1, ac2):
	db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	curs = db.cursor()
	curs.execute("""SELECT accname, anal1, an1str, anal2, an2str, anal3, an3str, anal4, an4str, anal5, an5str FROM plan WHERE accno =  %s""", (ac1, ))	
	acc1info = curs.fetchone()
	curs.execute("""SELECT accname, anal1, an1str, anal2, an2str, anal3, an3str, anal4, an4str, anal5, an5str FROM plan WHERE accno =  %s""", (ac2, ))	
	acc2info = curs.fetchone()
	db.close()
	self.accinfo1.SetText(str(ac1) + ": " + acc1info[0])
	self.accinfo2.SetText(str(ac2) + ": " + acc2info[0])
	
	self.an11      = acc1info[1]
	self.an11info.SetText(acc1info[2])
	self.an11o.SetText("")
	
	self.an12      = acc1info[3]
	self.an12info.SetText(acc1info[4])
	self.an12o.SetText("")
	
	self.an13      = acc1info[5]
	self.an13info.SetText(acc1info[6])	
	self.an13o.SetText("")
	
	self.an14      = acc1info[7]
	self.an14info.SetText(acc1info[8])	
	self.an14o.SetText("")
	
	self.an15      = acc1info[9]
	self.an15info.SetText(acc1info[10])	
	self.an15o.SetText("")
	
	#----
	
	self.an21      = acc2info[1]
	self.an21info.SetText(acc2info[2])
	self.an21o.SetText("")
	
	self.an22      = acc2info[3]
	self.an22info.SetText(acc2info[4])
	self.an22o.SetText("")
	
	self.an23      = acc2info[5]
	self.an23info.SetText(acc2info[6])	
	self.an23o.SetText("")
	
	self.an24      = acc2info[7]
	self.an24info.SetText(acc2info[8])	
	self.an24o.SetText("")
	
	self.an25      = acc2info[9]
	self.an25info.SetText(acc2info[10])		
	self.an25o.SetText("")

	
    def select_next(self, pos):
	if self.an12 > 0 and pos == 1:
	    self.select(12)
	    return ev_NONE	
	elif self.an13 > 0 and pos <= 2:
	    self.select(14)
	    return ev_NONE
	elif self.an14 > 0 and pos <= 3:
	    self.select(16)
	    return ev_NONE
	elif self.an15 > 0 and pos <= 4:
	    self.select(18)
	    return ev_NONE
	elif self.an21 > 0 and pos <= 5:
	    self.select(20)
	    return ev_NONE
	elif self.an22 > 0 and pos <= 6:
	    self.select(22)
	    return ev_NONE
	elif self.an23 > 0 and pos <= 7:
	    self.select(24)
	    return ev_NONE
	elif self.an24 > 0 and pos <= 8:
	    self.select(26)
	    return ev_NONE
	elif self.an25 > 0 and pos <= 9:
	    self.select(28)
	    return ev_NONE
	else:
	    self.select(29)
	    return ev_NONE

    def mainLoop(self):
	while 1:
	    status = Dialog.mainLoop(self)
	    if status == ev_FAIL and self.quitstatus == 1:
		msgbox = MessageBox(28, 9, 8, 26, COL_TAB, COL_TAB, \
		                        ["  ", "  "], "?", msg_YESNO)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		if yes == cmd_YES:
		    break
		else:
		    self.select(self.control)
		    self.quitstatus = 0
	

    def addToRecList(self, it):
	for i in range(len(self.reclist.items)):
	    rl = self.reclist.items[i]
	    rh = self.reclist.hidden_items[i]
	    
		    
    def UserFn(self, command, args = None):
	
	if command == ev_ACTIVATE and args == curses.KEY_F2:
	    
	    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	    curs = db.cursor()
	    d1 = self.date_oschet.text
	    dd1 = "20"+d1[6:8]+"-"+d1[3:5]+"-"+d1[0:2]
	    d2 = self.fak_date.text
	    dd2 = "20"+d2[6:8]+"-"+d2[3:5]+"-"+d2[0:2]

	    #curs.execute("""INSERT INTO accounts 
	    #		    (accno,
	    #		    nom_papka, data_oschet, nom_doc, fakt_no, data_fakt,
	    #		    dt, kontkt,
	    #		    kt, kontdt,
	    #		    value, amount, price,
	    #		    document, doc_name, predmet,
	    #		    anal1, an1str,
	    #		    anal2, an2str,
	    #		    anal5, an5str,
	    #		    date, oper)
	    #		    
	    #		    VALUES (
	    #		    (
	    
	    curs.execute("""INSERT INTO foldcat 
	                    VALUES (%s,
			    %s, %s, %s, %s, %s,
			    %s, %s,
			    %s, %s, %s,
			    %s, %s,
			    %s, 
			    %s, %s, %s, %s, %s, %s,
			    %s, %s, %s, %s, %s, %s,
			    NOW(), 'nobody')""",
			    (self.nomp,
			     dd1, self.no_doc.text, dd2, self.nomp, self.fak_no.text,
			     self.dt1account, self.kt1account, 
			     self.sum.text, self.kol.text, self.price.text,
			     self.statia.text, self.schet_statia.text,
			     '1',
			     self.san11, self.an11x, 
			     self.san12, self.an12x,
			     self.san15, self.an15x,
			     
			     self.san21, self.an21x,
			     self.san22, self.an22x,
			     self.san25, self.an25x))
	    curs.execute("""SELECT MAX(recno) FROM foldcat""")
	    (rn,) = curs.fetchone()
	    db.close()

	    self.reclist.addItem([self.fak_no.text,
				 self.no_doc.text,
				 str(self.dt1account),
				 str(self.kt1account),
				 self.sum.text,
				 self.kol.text,
				 "1"], hidden = [
				 self.price.text,
				 self.date_oschet.text,
				 self.fak_date.text,
				 self.statia.text,
				 self.schet_statia.text,
				 self.san11, self.an11x,
				 self.san12, self.an12x, 
				 self.san15, self.an15x,
				 self.san21, self.an21x,
				 self.san22, self.an22x,
				 self.san25, self.an25x,
				 rn
				 ])
	    self.reclist.draw()
	    
	    
	    self.select(29)
	    return ev_NONE
	
	if command == ev_ACTIVATE and args == curses.KEY_F3:
	    if self.editRec == FALSE:
		self.editRec = TRUE
		self.writexy(72, 0, ".", COL_TITLE, TRUE)
		return ev_OK
	    else:
		self.editRec = FALSE
		self.writexy(72, 0, ".", COL_TITLE, TRUE)
		self.select(29)
		return ev_NONE
	
	if command == ev_OK and args == 0:
	    pass
	
	if command == ev_OK and args == 2:
	    #if self.folder_loaded == TRUE:
	    #	self.nextWidget()
	    #	return ev_NONE
		
	    if self.n_folder.text != str(self.nomp):
		self.folder_loaded = FALSE
		nf = self.n_folder.text
	    else:
		nf = self.nowday[0:2]+self.nowday[3:5] + "0"+self.nowday[6:8]
		nf = str(int(nf))
		
		self.n_folder.SetText(nf)
		
	    #db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	    #curs = db.cursor()
	    #if self.folder_loaded == FALSE:
	    #	self.reclist.dbQuery = "SELECT fakt_no, nom_doc, kontdt, kontkt, value, amount, mode FROM foldcat WHERE nom_papka = \'" + nf + "\'"
	    #	m = Message()
	    #	m.message = cm_RELOAD
	    #	self.reclist.Update(m)
		#curs.execute("""SELECT * FROM accounts WHERE nom_papka = %s""", (nf, ))
		#self.ri = curs.fetchall()
		#self.folder_loaded == TRUE
	    #db.close()

	
	    
	if command == ev_OPTION and args == 5:
	    statiadlg = GetDocsDialog()
	    status = statiadlg.mainLoop()
	    if status == ev_OK:
		self.statia.SetText(statiadlg.plist.items[statiadlg.plist.hilite][1].Label)
		self.statia_no = int(statiadlg.plist.items[statiadlg.plist.hilite][0].Label)
	    statiadlg.destroy()
	    if status == ev_OK:
		self.select(6)
	    else:
		self.select(5)
	    return ev_NONE
	
	if command == ev_OPTION and args == 6:
	    kontdlg = GetKontDialog(self.statia_no)
	    status = kontdlg.mainLoop()
	    if status == ev_OK:
		self.schet_statia.SetText(kontdlg.plist.items[kontdlg.plist.hilite][1].Label)
		self.predmet.SetText(strip(kontdlg.plist.items[kontdlg.plist.hilite][1].Label))
		self.kont_no = int(kontdlg.plist.items[kontdlg.plist.hilite][0].Label)
		self.dt1account = int(kontdlg.plist.items[kontdlg.plist.hilite][2].Label)
		self.kt1account = int(kontdlg.plist.items[kontdlg.plist.hilite][3].Label)
		self.fillAccountInfo(self.dt1account, self.kt1account)
		
	    kontdlg.destroy()
	    if self.an11 <> 0:
		self.select(10)
	    elif self.an21 <> 0:
		self.select(20)
	    elif status <> ev_OK:
		self.select(5)
	    else:
		self.select(29)
	    return ev_NONE
	
	#----
	
	if command == ev_OPTION and args == 10 and self.an11 > 0:
	    analit = getAnalit(self.an11)
	    status = analit.mainLoop()
	    if status == ev_OK:
		self.an11o.SetText(analit.plist.items[analit.plist.hilite][1].Label[0:19])
		self.san11 = analit.plist.items[analit.plist.hilite][1].Label
		self.an11x = int(analit.plist.items[analit.plist.hilite][0].Label)
	    analit.destroy()
	    return self.select_next(1)
	elif command == ev_OPTION and args == 10 and self.an11 == 0:
	    #self.nextWidget()
	    args = 12
	    #return ev_NONE
	    return self.select_next(1)
	
	
	if command == ev_OPTION and args == 12 and self.an12 > 0:
	    self.select(12)
	    analit = getAnalit(self.an12)
	    status = analit.mainLoop()
	    if status == ev_OK:
		self.an12o.SetText(analit.plist.items[analit.plist.hilite][1].Label[0:19])
		self.san12 = analit.plist.items[analit.plist.hilite][1].Label
		self.an12x = int(analit.plist.items[analit.plist.hilite][0].Label)
	    analit.destroy()
	    return self.select_next(2)
	elif command == ev_OPTION and args == 12 and self.an12 == 0:
	    #self.nextWidget()
	    #return ev_NONE
	    args = 14
	    return self.select_next(2)
	
	
	if command == ev_OPTION and args == 14 and self.an13 > 0:
	    self.select(14)
	    analit = getAnalit(self.an13)
	    status = analit.mainLoop()
	    if status == ev_OK:
		self.an13o.SetText(analit.plist.items[analit.plist.hilite][1].Label[0:19])
		self.san13 = analit.plist.items[analit.plist.hilite][1].Label
		self.an13x = int(analit.plist.items[analit.plist.hilite][0].Label)
	    analit.destroy()
	    return self.select_next(3)
	elif command == ev_OPTION and args == 14 and self.an13 == 0:
	    #self.nextWidget()
	    #return ev_NONE
	    args = 16
	    return self.select_next(3)
	
	if command == ev_OPTION and args == 16 and self.an14 > 0:
	    self.select(16)
	    analit = getAnalit(self.an14)
	    status = analit.mainLoop()
	    if status == ev_OK:
		self.an14o.SetText(analit.plist.items[analit.plist.hilite][1].Label[0:19])
		self.san14 = analit.plist.items[analit.plist.hilite][1].Label
		self.an14x = int(analit.plist.items[analit.plist.hilite][0].Label)
	    analit.destroy()
	    return self.select_next(4)
	elif command == ev_OPTION and args == 16 and self.an14 == 0:
	    #self.nextWidget()
	    #return ev_NONE
	    args = 18
	    return self.select_next(4)
	
	
	if command == ev_OPTION and args == 18 and self.an15 > 0:
	    self.select(18)
	    analit = getAnalit(self.an15)
	    status = analit.mainLoop()
	    if status == ev_OK:
		self.an15o.SetText(analit.plist.items[analit.plist.hilite][1].Label[0:19])
		self.san15 = analit.plist.items[analit.plist.hilite][1].Label
		self.an15x = int(analit.plist.items[analit.plist.hilite][0].Label)
	    analit.destroy()
	    return self.select_next(5)
	elif command == ev_OPTION and args == 18 and self.an15 == 0:
	    #self.nextWidget()
	    #return ev_NONE
	    args = 20
	    return self.select_next(5)
	
	#----
	    
	if command == ev_OPTION and args == 20 and self.an21 > 0:
	    self.select(20)
	    analit = getAnalit(self.an21)
	    status = analit.mainLoop()
	    if status == ev_OK:
		self.an21o.SetText(analit.plist.items[analit.plist.hilite][1].Label[0:19])
		self.san21 = analit.plist.items[analit.plist.hilite][1].Label
		self.an21x = int(analit.plist.items[analit.plist.hilite][0].Label)
	    analit.destroy()
	    return self.select_next(6)
	elif command == ev_OPTION and args == 20 and self.an21 == 0:
	    #self.nextWidget()
	    #return ev_NONE
	    args = 22
	    return self.select_next(6)
		
	
	if command == ev_OPTION and args == 22 and self.an22 > 0:
	    self.select(22)
	    analit = getAnalit(self.an22)
	    status = analit.mainLoop()
	    if status == ev_OK:
		self.an22o.SetText(analit.plist.items[analit.plist.hilite][1].Label[0:19])
		self.san22 = analit.plist.items[analit.plist.hilite][1].Label
		self.an22x = int(analit.plist.items[analit.plist.hilite][0].Label)
	    analit.destroy()
	    return self.select_next(7)
	elif command == ev_OPTION and args == 22 and self.an22 == 0:
	    #self.nextWidget()
	    #return ev_NONE
	    args = 24
	    return self.select_next(7)
	
	if command == ev_OPTION and args == 24 and self.an23 > 0:
	    self.select(24)
	    analit = getAnalit(self.an23)
	    status = analit.mainLoop()
	    if status == ev_OK:
		self.an23o.SetText(analit.plist.items[analit.plist.hilite][1].Label[0:19])
		self.san23 = analit.plist.items[analit.plist.hilite][1].Label
		self.an23x = int(analit.plist.items[analit.plist.hilite][0].Label)
	    analit.destroy()
	    return self.select_next(8)
	elif command == ev_OPTION and args == 24 and self.an23 == 0:
	    #self.nextWidget()
	    #return ev_NONE
	    args = 26
	    return self.select_next(8)
	
	if command == ev_OPTION and args == 26 and self.an24 > 0:
	    self.select(26)
	    analit = getAnalit(self.an24)
	    status = analit.mainLoop()
	    if status == ev_OK:
		self.an24o.SetText(analit.plist.items[analit.plist.hilite][1].Label[0:19])
		self.san24 = analit.plist.items[analit.plist.hilite][1].Label
		self.an24x = int(analit.plist.items[analit.plist.hilite][0].Label)
	    analit.destroy()
	    return self.select_next(9)
	elif command == ev_OPTION and args == 26 and self.an24 == 0:
	    #self.nextWidget()
	    #return ev_NONE
	    args = 28
	    return self.select_next(9)
	
	
	if command == ev_OPTION and args == 28 and self.an25 > 0:
	    self.select(28)
	    analit = getAnalit(self.an25)
	    status = analit.mainLoop()
	    if status == ev_OK:
		self.an25o.SetText(analit.plist.items[analit.plist.hilite][1].Label[0:19])
		self.san25 = analit.plist.items[analit.plist.hilite][1].Label
		self.an25x = int(analit.plist.items[analit.plist.hilite][0].Label)
	    analit.destroy()
	    self.select(29)
	    return ev_NONE
	elif command == ev_OPTION and args == 28 and self.an25 == 0:
	    #self.nextWidget()
	    self.select(29)
	    return ev_NONE
	
	#----
	
	elif command == ev_OK:
	    self.nextWidget()
	    return ev_NONE
	else:
	    return ev_NONE
	
class DocumentDialog(Dialog):
    def __init__(self, doc_type):
	self.doc_type = doc_type
	Dialog.__init__(self, 40, 7, 13, 37, COL_MAIN)
	self.addWidget(Label(self, 2, 1, " ", COL_MAIN))
	self.doclist = MultiListBox(self, 2, 2, 9, 33, COL_TEXT)
	self.doclist.MultipleChoice(FALSE)
	self.doclist.setItemColors(COL_TITLE, COL_TEXT)
	self.doclist.addColon(6, "")
	self.doclist.addColon(24, "")
	self.doclist.dbQuery = "SELECT doc_no, name FROM documents WHERE doc_type rlike \'" + doc_type + "\'"
        m = Message()
	m.message = cm_RELOAD
	self.doclist.Update(m)
	self.addWidget(self.doclist)	

    def mainLoop(self):
	Dialog.mainLoop(self)
	doc_no = self.doclist.items[self.doclist.hilite][0].Label
	name = self.doclist.items[self.doclist.hilite][1].Label
	return (doc_no, name)

if __name__ == '__main__':
    def RunProgram(stdscreen):
	app = Store(stdscreen)
	
	
    str = curses.wrapper(RunProgram)
    print str	
    
