#!/usr/bin/env python

import os, re, fpformat
from  defs import *
import curses
from curses import panel
import ui
from ui import *
from  MySQLdb import *
from time import gmtime, strftime, sleep

OS_NAME = "Mandrake Linux 8.2"
SERVER_NAME = "MySQL Server 3.23"
VER = "1.27-patch"

def get_user():
    import pwd
    return pwd.getpwuid(os.getuid())[4]

class Store:
    def __init__ (self, win):
	self.user = get_user()
	self.set_colors()
	self.win = win
	self.DrawUI()
	self.mainloop()
	
    def DrawUI(self):
	self.main_panel = Panel(0, 0,
		 curses.LINES, curses.COLS, COL_MAIN)
	self.main_panel.drawbox()
	self.main_panel.set_caption(" COMPANY xx ")
	self.main_panel.writexy(49, 1,
	         "     -  ", COL_WARN, TRUE)
	self.main_panel.hline(1, 3, 45, COL_MAIN)
	self.main_panel.writexy(3, 2, ":", COL_MAIN)
	self.main_panel.writexy(3, 3, str(self.user), COL_MAIN)
#	+ "    :", COL_MAIN)

	self.DrawLOGO()
	self.main_panel.writexy(65, 2, "ver " + VER, COL_MAIN)
	
	self.menu = MenuBar(4, 21, 2, 73, COL_TEXT)

	self.menu.loadMenu("kasa.mnu")
	curses.curs_set(0)
	pflush()
	
    def DrawLOGO(self):
	self.main_panel.drawrect(4, 3, 75, 16, COL_TAB)
	self.main_panel.hline(5, 4, 51, COL_TAB)
	self.main_panel.win.addch(5, 55, curses.ACS_URCORNER)
	self.main_panel.hline(6, 4, 54, COL_TAB)

	self.main_panel.vline(6, 55, 14, COL_TAB)
	self.main_panel.vline(5, 57, 15, COL_TAB)	
	self.main_panel.vline(5, 53, 15, COL_TAB)		
	
	
	titlestr = "COMPANY xx"
	for i in range(6, 16):
	    self.main_panel.writexy(60, i, titlestr[i-6], COL_MAIN)
	self.main_panel.writexy(72, 18, ":", COL_MAIN)
	self.main_panel.writexy(60, 19, " ", COL_MAIN)
	self.main_panel.writexy(5, 20, "Linux OS", COL_MAIN)
	
	
    def set_colors(self):
	if curses.can_change_color() == 1:
	    curses.init_color(5, 800, 800, 800)
	curses.init_pair(1, curses.COLOR_BLUE, curses.COLOR_WHITE)
	curses.init_pair(2, curses.COLOR_WHITE, curses.COLOR_BLUE)
	curses.init_pair(3, curses.COLOR_WHITE, curses.COLOR_RED)
	curses.init_pair(4, curses.COLOR_WHITE, curses.COLOR_BLACK)
	curses.init_pair(5, curses.COLOR_BLACK, curses.COLOR_WHITE)
	curses.init_pair(6, curses.COLOR_RED, curses.COLOR_WHITE)
	curses.init_pair(7, curses.COLOR_BLUE, curses.COLOR_BLACK)
	curses.init_pair(8, curses.COLOR_MAGENTA, curses.COLOR_WHITE)

	
    def mainloop(self):
    
        db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
        curs = db.cursor()
        curs.execute("""SELECT sum(dt)-sum(kt) FROM kasa WHERE account=501001""")
        (ss, ) = curs.fetchone()
        db.close()
        self.main_panel.writexy(64, 4, "  " + fix(ss, 2) + "  ", COL_MAIN)
    
	while 1:
	    cmd = self.menu.mainLoop()
	    
 	    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
	    curs = db.cursor()
	    curs.execute("""SELECT sum(dt)-sum(kt) FROM kasa WHERE account=501001""")
	    (ss, ) = curs.fetchone()
	    db.close()
	    self.main_panel.writexy(64, 4, "  " + fix(ss,2) + "  ", COL_MAIN)

	    if cmd == "cmd_stop": break
	    if cmd == "cmd_order_in":
		#counter = self.getDoc_counter(doc_name = "")
		inorder = inOrder()
		op = inorder.mainLoop()
		#if op == ev_FAIL:
		#    self.Invalidate(counter, 1)
		inorder.destroy()
		del inorder
		pflush()
		
	    if cmd == "cmd_order_trade":
		#counter = self.getDoc_counter(doc_name = "")
		inorder = inTradeOrder()
		op = inorder.mainLoop()
		#if op == ev_FAIL:
		#    self.Invalidate(counter, 1)
		inorder.destroy()
		del inorder
		pflush()		

	    if cmd == "cmd_order_out":
		#counter = self.getDoc_counter(doc_name = "")
		outorder = outOrder()
		op = outorder.mainLoop()
		#if op == ev_FAIL:
		#    self.Invalidate(counter, 2)
		outorder.destroy()
		del outorder
		pflush()		
		
	    if cmd == "cmd_plan":
		plandlg = PlanDialog()
		plandlg.mainLoop()
		plandlg.destroy()
		del plandlg
		pflush()
		
	    if cmd == "cmd_first_saldo":
		db = MySQLdb.connect(user="cv", passwd="cv", db="eso")#, host="192.168.0.2")
		c = db.cursor()

		fsaldo = c.execute("""SELECT dt, kt, date, oper FROM kasa WHERE issaldo = 1""")		
		#db.close()
		if fsaldo > 0:
		    (dt, kt, date, oper) = c.fetchone()
		    db.close()
		    msgbox = MessageBox(25, 10, 7, 24, COL_TAB, COL_WARN, \
		                        ["  "], "", msg_OK)
		    msgbox.mainLoop()
		    msgbox.destroy()
		    del msgbox
		    pflush()
		else:
		    db.close()
		    slddlg = FSaldoDialog()
		    slddlg.mainLoop()
		    slddlg.destroy()
		    del slddlg
		    pflush()
		    
	    if cmd == "cmd_get_debit_oborot":
		oborotdlg = Oborot(1)
		oborotdlg.mainLoop()
		oborotdlg.destroy()
		del oborotdlg
		pflush()
	    if cmd == "cmd_get_kredit_oborot":
		oborotdlg = Oborot(2)
		oborotdlg.mainLoop()
		oborotdlg.destroy()
		del oborotdlg
		pflush()
		
	    if cmd == "cmd_kasabook":
		oborotdlg = Oborot(3)
		oborotdlg.mainLoop()
		oborotdlg.destroy()
		del oborotdlg
		pflush()
	    if cmd == "cmd_bank_vn_bel":
		vnbeldlg = BankDocument14("1", 1)
		vnbeldlg.mainLoop()
		vnbeldlg.destroy()
		del vnbeldlg
		pflush()
	    if cmd == "cmd_bank_nar_razp":
		bnardlg = BankDocument14("1", 4)
		bnardlg.mainLoop()
		bnardlg.destroy()
		del bnardlg
		pflush()
	    
	    if cmd == "cmd_get_saldo":
		show = ShowSaldoDlg()
		show.mainLoop()
		show.destroy()
		del show
		
		pflush()
		
	    if cmd == "cmd_get_person_ob":
		persob = PersonOborot()
		persob.mainLoop()
		persob.destroy()
		del persob
		pflush()
		
		
	    if cmd == "cmd_gen_report":
		report = CustomReport()
		report.mainLoop()
		report.destroy()
		del report
		pflush()
		
	    if cmd == "cmd_counters":
		cntrs = Counters()
		cntrs.mainLoop()
		cntrs.destroy()
		del cntrs
		pflush()
		
		
				
 	    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
	    curs = db.cursor()
	    curs.execute("""SELECT sum(dt)-sum(kt) FROM kasa WHERE account=501001""")
	    (ss, ) = curs.fetchone()
	    db.close()
	    self.main_panel.writexy(64, 4, "  " + fix(ss,2) + "  ", COL_MAIN)
	    pflush()
	    
				
	
    def Invalidate(self, counter, doc_type):
	db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
	curs = db.cursor()
	if doc_type == 1 or doc_type == 2:
	    curs.execute("""INSERT INTO kasadocs (doc_no, doc_type, person, anlperson, purpose, anlpurpose, sum, invalid, date, oper) VALUES (%s, %s, %s, %s, %s, %s, %s, %s, NOW(), %s)""",
	                (counter, doc_type, "", 0, "", 0, 0, 1, "cv")) 
	db.close()


	
    def SelectDocument(self, doc_type):
	docdlg = DocumentDialog(doc_type)
	(doc_no, name) = docdlg.mainLoop()
	docdlg.destroy()
	del docdlg
	pflush()
	return (doc_no, name)
    
    def SelectPartner(self, partner_type):
	partdlg = PartnersDialog(partner_type)
	(dan_no, city, partner_name) = partdlg.mainLoop()
	partdlg.destroy()
	del partdlg
	return (strip(partner_name) + " - " + strip(city), strip(dan_no))

    
def getDoc_counter(doc_no = None, doc_name = ""):
    if doc_no <> None:
	query = " WHERE doc_no = " + str(doc_no)
	if doc_name <> "":
	    query = query + " AND name = \'" + doc_name +"\'"
    else:
	query = " WHERE name = \'" + doc_name + "\'"
    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
    curs = db.cursor()
    curs.execute("UPDATE LOW_PRIORITY documents SET counter=counter+1" + query)
    curs.execute("SELECT CONCAT(counter, '') from documents" + query)
    (counter, ) = curs.fetchone()
    db.commit()
    db.close()
    return counter    


class Counters(Dialog):
    def __init__(self):
	Dialog.__init__(self, 25, 12, 8, 37, COL_MAIN)
	self.set_caption(" ")
	self.writexy(2, 2, "   :", COL_TEXT1)
	#0
	self.addWidget(Label(self, 2, 3, ".      . ", COL_TEXT1))
	#1
	self.pko = EditLine(self, 2, 4, 10)
	self.pko.setType(dt_numeric)
	self.addWidget(self.pko)
	#2
	self.rko = EditLine(self, 14, 4, 10)
	self.rko.setType(dt_numeric)
	self.addWidget(self.rko)
	
	self.addWidget(Label(self, 2, 6, "< Enter  > - ", COL_TEXT1))
	self.addWidget(Label(self, 2, 7, "< Escape > - ", COL_TEXT1))

	
	self.select(1)
	
    def UserFn(self, command, args):
	if command == ev_OK and args == 3:
	    
	    db = MySQLdb.connect(user="cv", passwd="cv", db="eso")#, host="192.168.0.2")
	    c = db.cursor()
	    if self.saldo_lv.text <> "":
		dt_lv = float(self.saldo_lv.text)
		c.execute("""INSERT INTO kasa (doc_no, doc_type, issaldo, account, dt, kt, date, oper) VALUES (%s, %s, %s, %s, %s, %s, NOW(), %s)""",
		      (0, 0, 1, 501001, dt_lv, 0, "cv"))
	    if self.saldo_usd.text <> "":
		dt_usd = float(self.saldo_usd.text)  
		c.execute("""INSERT INTO kasa (doc_no, doc_type, issaldo, account, dt, kt, date, oper) VALUES (%s, %s, %s, %s, %s, %s, NOW(), %s)""",
	              (0, 0, 1, 501002, dt_usd, 0, "cv"))  
	    
	    if self.saldo_eur.text <> "":  
		dt_eur = float(self.saldo_eur.text)  
		c.execute("""INSERT INTO kasa (doc_no, doc_type, issaldo, account, dt, kt, date, oper) VALUES (%s, %s, %s, %s, %s, %s, NOW(), %s)""",
	              (0, 0, 1, 501003, dt_eur, 0, "cv"))  	      
		      
	    c.execute("""INSERT INTO lastsaldo (date) VALUES (NOW())""")
	    db.close()
	    curses.curs_set(0)
	    return ev_DONE
	else:
	    self.nextWidget()
	    return ev_NONE


def GetSaldo(account, begdate, full=FALSE):
    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
    curs = db.cursor()
    rec = curs.execute("""SELECT dt FROM kasa WHERE issaldo = 1 AND account=%s""", (account, ))
    if rec > 0:
	(dt, ) = curs.fetchone()
	curs.close()
	del curs
	curs1 = db.cursor()
	curs1.execute("""SELECT sum(dt), sum(kt) FROM kasa WHERE account = %s AND date <= %s AND issaldo = 0""", (account, begdate))
	(sumdt, sumkt) = curs1.fetchone()
	if sumdt == None:
	    sumdt = 0
	if sumkt == None:
	    sumkt = 0
	    db.close()
	if full == TRUE:
	    saldo = dt + sumdt - sumkt
	else:
	    saldo = dt
	found = TRUE
    else:
	saldo = 0
	found = FALSE
    db.close()
    return (saldo, found)

class DropDnBox1(DropDnBox):
    
    def FillBox(self):
	self.box.addItem("  (.)")
	self.box.addItem("(USD)")
	self.box.addItem("  (EUR)")

class CustomReport(Dialog):
    def __init__(self):
	self.nowday = strftime("%d-%m-%y", gmtime())
	self.b =""
	self.e =""
	self.dtsum = 0
	self.ktsum = 0
	self.purpose_list = []
	self.combine = FALSE
	Dialog.__init__(self, 1, 2, 18, 77, COL_MAIN)
	self.set_caption(" ")
	#0    
	self.addWidget(Label(self, 40, 1, ".", COL_TEXT1))
	self.begdate = DateLine(self, 49, 1, COL_TEXT, COL_TITLE)
	self.begdate.SetText(self.nowday)
	#1
	self.addWidget(self.begdate)
	#2
	self.addWidget(Label(self, 59, 1, ".", COL_TEXT1))
	self.enddate = DateLine(self, 67, 1, COL_TEXT, COL_TITLE)
	self.enddate.SetText(self.nowday)
	#3
	self.addWidget(self.enddate)	
	#4
	self.docs = OptionLine(self, 39, 3, 32, " ", pos_UP)
	self.doc_type = -1
	self.docs.SetText("  ")
	self.addWidget(self.docs)
	#5
	self.persons = OptionLine(self, 2, 5, 32, " ", pos_UP)
	self.persons.SetText("")
	self.addWidget(self.persons)
	#6
	self.purpose = OptionLine(self, 39, 5, 32, "", pos_UP)
	self.purpose.SetText("")
	self.addWidget(self.purpose)
	
	self.plist = MultiListBox(self, 1, 7, 9, 75, COL_TEXT)
	self.plist.setItemColors(COL_TITLE, COL_TEXT)
	self.plist.MultiChoice = FALSE
	self.plist.addColon(32, " ")
	self.plist.addColon(33, "")
	self.plist.addColon(10, "", dt_float, 2)
	#self.plist.addColon(9, "", dt_float, 2)
	self.plist.Focusable = TRUE
	self.plist.delPermitted = FALSE
	#4
	self.addWidget(self.plist)
	
	self.addWidget(Label(self, 2, 17, "F2- | F3- | F6- | F7- | F10-", COL_TEXT1))
	self.addWidget(Label(self, 56, 17, " :           ", COL_WARN))
    
	
	self.plist.addNotifyRecipient(self, cm_ITEM_CHANGED)
	
	self.AddHotKey(curses.KEY_F2, 1)
	self.AddHotKey(curses.KEY_F10, 1)
	self.AddHotKey(curses.KEY_F3, 1)
	self.AddHotKey(curses.KEY_F7, 1)
	self.AddHotKey(curses.KEY_F6, 1)
	
	self.select(1)
	
    def Update(self, msg):
	pass
	
    def UserFn(self, command, args):
	if len(self.plist.items) > 7:
	    self.plist.Focusable = TRUE
	elif len(self.plist.items) < 6:
	    self.plist.Focusable = FALSE
	if command == ev_ACTIVATE and args == curses.KEY_F7 and \
	   len(self.plist.items) > 0:
	    fp = open("reporttask", "w+")
	    fp.write("USE eso\n")
	    if self.combine == FALSE:
		if self.doc_type == 1 or self.doc_type == 3 or self.doc_type == 4:
		    qry = "SELECT LEFT(date, 10) AS , doc_no AS , person AS , purpose AS , ad_info AS '.', sumkt AS   " + \
		      self.plist.dbQuery[29:]+";\n"
		elif self.doc_type == 2 or self.doc_type == 5:
		    qry = "SELECT LEFT(date, 10) AS , doc_no AS , person AS , purpose AS , ad_info AS '.', sumdt AS  " + \
		      self.plist.dbQuery[29:]+";\n"
	    else:
		if self.doc_type == 1 or self.doc_type == 3 or self.doc_type == 4:
		    qry = "SELECT person AS , purpose AS , sum(sumkt) AS  " + \
		      self.plist.dbQuery[34:]+";\n"
		elif self.doc_type == 2 or self.doc_type == 5:
		    qry = "SELECT person AS , purpose AS , sum(sumdt) AS  " + \
		      self.plist.dbQuery[34:]+";\n"
	    fp.write(qry)
	    fp.close()
	    
	    fp1 = open("header", "w+")
	    if self.combine == TRUE:
		fp1.write("    " + self.begdate.text + \
	              "  " + self.enddate.text + "-----  ----\n")
	    else:
		fp1.write("    " + self.begdate.text + \
	              "  " + self.enddate.text + "-----  ----\n")
		      
	    fp1.write(" : " + self.docs.text + "\n")
	    fp1.write("OT : " + self.persons.text + "\n")
	    fp1.write(": " + self.purpose.text + "\n")
	    
	    fp1.write("\n")
	    fp1.close()
	    
	    fp2 = open("footer", "w+")
	    fp2.write(" : " + fix(self.dtsum, 2) + "\n")
	    #fp2.write("   : " + fix(self.ktsum, 2) + "\n")
	    fp2.write("\n\n")
	    fp2.write("  " + OS_NAME + "  " + SERVER_NAME + "\n")
	    fp2.write("\n\n\n\n\n\n\n")
	    fp2.close()
	    
	    os.spawnlp(os.P_NOWAIT, './printreport', './printreport', '1')
	    
	if command == ev_ACTIVATE and args == curses.KEY_F10:
	    self.doc_type = -1
	    self.docs.SetText("-")
	    self.persons.SetText("-")
	    self.purpose.SetText("-")
	    del self.purpose_list
	    self.purpose_list = []
	    m = Message()
	    m.message = cm_RELOAD
	    self.plist.dbQuery = "SELECT person, purpose, sumdt, sumkt FROM kasadocs WHERE doc_type = -1"
	    self.plist.Update(m)
	    self.plist.draw()
	    return ev_NONE
	
	if command == ev_OPTION and args == 5:
	    if self.doc_type == 1:
		an = 1
	    elif self.doc_type == 2:
		an = 1
	    elif self.doc_type == 3:
		an = 6
	    elif self.doc_type == 4 or self.doc_type == 5:
		an = 3	    
	    elif self.doc_type == -1:
		msgbox = MessageBox(28, 9, 7, 20, COL_TAB, COL_TAB, \
		                        ["   ", ""], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()		    		
		self.select(4)
		return ev_NONE
	    anpart = getAnalit(report = 2, analit=an)
	    sel = anpart.mainLoop()
	    if sel == ev_OK:
		self.persons.SetText(anpart.plist.items[anpart.plist.hilite][1].Label)
	    elif sel == ev_FAIL:
		self.persons.SetText("")
	    anpart.destroy()
	    del anpart
	    self.select(6)
	    return ev_NONE
	
	if command == ev_OPTION and args == 6:
	    if self.doc_type == 1:
		an = 2
	    elif self.doc_type == 2:
		an = 4
	    elif self.doc_type == 3:
		an = 7
	    elif self.doc_type == 4 or self.doc_type == 5:
		an = 5
	    elif self.doc_type == -1:
		msgbox = MessageBox(28, 9, 7, 20, COL_TAB, COL_TAB, \
		                        ["   ", ""], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()		    
		self.select(4)
		return ev_NONE
		
	    anpart = getAnalit(report = 1, analit=an)
	    if len(self.purpose_list) != 0:
		for i in range(len(anpart.plist.items)):
		    it = anpart.plist.items[i][0]
		    for j in range(len(self.purpose_list)):
			if it.Label == self.purpose_list[j]:
			    anpart.plist.items[i][0].selection = TRUE
		anpart.plist.draw()
		del it
	    sel = anpart.mainLoop()
	    if sel == ev_FAIL:
		self.purpose.SetText("")
		del self.purpose_list
		self.purpose_list = []
	    elif sel == ev_OK:
		self.purpose_list = []
		for i in range(len(anpart.plist.items)):
		    it = anpart.plist.items[i][0]
		    if it.selection == TRUE:
			self.purpose_list.append(it.Label)
		    del it
		if len(self.purpose_list) == len(anpart.plist.items):
		    self.purpose.SetText("")
		elif len(self.purpose_list) == 0:
		    self.purpose.SetText(anpart.plist.items[anpart.plist.hilite][1].Label)
		    self.purpose_list.append(anpart.plist.items[anpart.plist.hilite][0].Label)
		else:
		    self.purpose.SetText("<  >")
		    
	    anpart.destroy()
	    del anpart
	    self.select(1)
	    return ev_NONE
	
	if command == ev_OPTION and args == 4:
	    docsdlg = DocumentDialog("")
	    sel = docsdlg.mainLoop()
	    if sel != ev_FAIL:
		self.doc_type = int(docsdlg.doclist.items[docsdlg.doclist.hilite][0].Label) - 100
		self.docs.SetText(docsdlg.doclist.items[docsdlg.doclist.hilite][1].Label)
	    else:
		self.doc_type = -1
		self.docs.SetText("  ")
	    docsdlg.destroy()
	    del docsdlg
	    self.select(5)
	    return ev_NONE
	
	if command == ev_ACTIVATE and args == curses.KEY_F6:
	    if self.persons.text == "-" or self.purpose.text == "-" \
	       or self.docs.text == "-":
		msgbox = MessageBox(28, 9, 7, 20, COL_TAB, COL_TAB, \
		                        [" ", ". "], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()		    		
		self.select(4)
		return ev_NONE	    
	    
	    #if self.persons.text != "":
		#self.select(1)
		#return ev_NONE
	    
	    self.combine = TRUE
	    strbd = self.begdate.text
	    stred = self.enddate.text
	    
	    self.b = "20"+strbd[6:8]+"-"+strbd[3:5]+"-"+strbd[0:2]
	    self.e = "20"+stred[6:8]+"-"+stred[3:5]+"-"+stred[0:2]
	    
	    if self.persons.text == "":
		perscond = "" 
	    elif self.persons.text == "-":
		perscond = ""
		self.doc_type = -1
	    else:
		perscond = "person = \'"+self.persons.text + "\'"
		
	
	    if self.purpose.text == "":
		purpcond = ""
	    elif self.purpose.text == "-":
		self.doc_type = -1
		purpcond = ""
	    elif self.purpose.text == "<  >":
		purpcond = " anlpurpose IN ("
		for i in range(len(self.purpose_list)):
		    purpcond = purpcond + self.purpose_list[i]
		    if i < len(self.purpose_list) - 1:
			purpcond = purpcond + ","
		    
		purpcond = purpcond + ")"
	    else:
		purpcond = "purpose = \'" + self.purpose.text + "\'"

	    if self.doc_type == 1 or self.doc_type == 3 or self.doc_type == 4:
		query = "SELECT person, purpose, sum(sumkt) FROM kasadocs WHERE invalid = 0 AND LEFT(date, 10) >= \'" + self.b + "\' AND LEFT(date,10) <= \'" + self.e + "\'"
	    elif self.doc_type == 2 or self.doc_type == 5:
		query = "SELECT person, purpose, sum(sumdt) FROM kasadocs WHERE invalid = 0 AND LEFT(date, 10) >= \'" + self.b + "\' AND LEFT(date,10) <= \'" + self.e + "\'"		
		
	    if perscond != "":
		query = query + " AND " + perscond
	    if purpcond != "":
		query = query + " AND " + purpcond
	    query = query + " AND doc_type = " + str(self.doc_type) + " GROUP BY person, purpose ORDER by person ASC"
	    self.plist.dbQuery = query
	    m = Message()
	    m.message = cm_RELOAD
	    self.plist.Update(m)
	    self.dtsum = 0
	    self.ktsum = 0
	    for i in range(len(self.plist.items)):
		it1 = self.plist.items[i]
		self.dtsum = self.dtsum + float(strip(it1[2].Label))
		#self.ktsum = self.ktsum + float(strip(it1[3].Label))
		del it1
	    
	    self.writexy(67, 17, rjust(fix(self.dtsum,2), 10), COL_WARN)
	    #self.writexy(68, 17, rjust(fix(self.ktsum,2), 8), COL_WARN)
	    self.select(1)
	    return ev_NONE
			    
		
	if command == ev_ACTIVATE and args == curses.KEY_F2:
	    if self.persons.text == "-" or self.purpose.text == "-" \
	       or self.docs.text == "-":
		msgbox = MessageBox(28, 9, 7, 20, COL_TAB, COL_TAB, \
		                        [" ", ". "], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()		    		
		self.select(4)
		return ev_NONE
		
	    strbd = self.begdate.text
	    stred = self.enddate.text
	    
	    self.b = "20"+strbd[6:8]+"-"+strbd[3:5]+"-"+strbd[0:2]
	    self.e = "20"+stred[6:8]+"-"+stred[3:5]+"-"+stred[0:2]
	    self.combine = FALSE
	    if self.persons.text == "":
		perscond = "" 
	    elif self.persons.text == "-":
		perscond = ""
		self.doc_type = -1
	    else:
		perscond = "person = \'"+self.persons.text + "\'"
		
	
	    if self.purpose.text == "":
		purpcond = ""
	    elif self.purpose.text == "-":
		self.doc_type = -1
		purpcond = ""
	    elif self.purpose.text == "<  >":
		purpcond = " anlpurpose IN ("
		for i in range(len(self.purpose_list)):
		    purpcond = purpcond + self.purpose_list[i]
		    if i < len(self.purpose_list) - 1:
			purpcond = purpcond + ","
		    
		purpcond = purpcond + ")"
	    else:
		purpcond = "purpose = \'" + self.purpose.text + "\'"

	    if self.doc_type == 1 or self.doc_type == 3 or self.doc_type == 4:
		query = "SELECT person, purpose, sumkt FROM kasadocs WHERE invalid = 0 AND LEFT(date, 10) >= \'" + self.b + "\' AND LEFT(date,10) <= \'" + self.e + "\'"
	    elif self.doc_type == 2 or self.doc_type == 5:
		query = "SELECT person, purpose, sumdt FROM kasadocs WHERE invalid = 0 AND LEFT(date, 10) >= \'" + self.b + "\' AND LEFT(date,10) <= \'" + self.e + "\'"
	    if perscond != "":
		query = query + " AND " + perscond
	    if purpcond != "":
		query = query + " AND " + purpcond
	    query = query + " AND doc_type = " + str(self.doc_type)
	    self.plist.dbQuery = query
	    m = Message()
	    m.message = cm_RELOAD
	    self.plist.Update(m)
	    self.dtsum = 0
	    self.ktsum = 0
	    for i in range(len(self.plist.items)):
		it1 = self.plist.items[i]
		self.dtsum = self.dtsum + float(strip(it1[2].Label))
		#self.ktsum = self.ktsum + float(strip(it1[3].Label))
		del it1
	    
	    self.writexy(67, 17, rjust(fix(self.dtsum,2), 10), COL_WARN)
	    #self.writexy(68, 17, rjust(fix(self.ktsum,2), 8), COL_WARN)
		
	    self.select(7)
	    return ev_NONE
	    
	if command == ev_OK and args == 1:
	    self.select(3)
	    return ev_NONE
	elif command == ev_OK and args == 3:
	    strbd = self.begdate.text
	    stred = self.enddate.text
	    
	    self.b = "20"+strbd[6:8]+"-"+strbd[3:5]+"-"+strbd[0:2]
	    self.e = "20"+stred[6:8]+"-"+stred[3:5]+"-"+stred[0:2]
	    
	    self.select(4)
	    return ev_NONE
	elif command == ev_OK and args == 4:
	    return ev_NONE
	    
class DocumentDialog(Dialog):
    def __init__(self, doc_type):
	self.doc_type = doc_type
	Dialog.__init__(self, 40, 5, 13, 37, COL_MAIN)
	self.addWidget(Label(self, 2, 1, " ", COL_MAIN))
	self.doclist = MultiListBox(self, 2, 2, 9, 33, COL_TEXT)
	self.doclist.MultipleChoice(FALSE)
	self.doclist.setItemColors(COL_TITLE, COL_TEXT)
	self.doclist.addColon(6, "")
	self.doclist.addColon(24, "")
	self.doclist.dbQuery = "SELECT doc_no, name FROM documents WHERE doc_type rlike \'" + doc_type + "\' AND doc_no > 100"
        m = Message()
	m.message = cm_RELOAD
	self.doclist.Update(m)
	self.addWidget(self.doclist)	

    
class ShowSaldoDlg(Dialog):
    def __init__(self):
	self.nowday = strftime("%d-%m-%y", gmtime())
	
	Dialog.__init__(self, 2, 2, 18, 76, COL_MAIN)	
	#0
	self.addWidget(Label(self, 35, 1, " ", COL_TEXT1))
	#1
	self.begdate = DateLine(self, 45, 1, COL_TEXT, COL_TITLE)
	self.begdate.SetText(self.nowday)	
	self.addWidget(self.begdate)	
	#2
	self.addWidget(Label(self, 55, 1, " ", COL_TEXT1))
	self.enddate = DateLine(self, 65, 1, COL_TEXT, COL_TITLE)
	self.enddate.SetText(self.nowday)	
	#3
	self.addWidget(self.enddate)
	
	#4
	self.lvlist = MultiListBox(self, 2, 5, 10, 22, COL_TEXT)
	self.lvlist.setItemColors(COL_TITLE, COL_TEXT)
	self.lvlist.MultiChoice = FALSE
	self.lvlist.addColon(10, "dt", dt_float, 2)
	self.lvlist.addColon(10, "kt", dt_float, 2)
	self.lvlist.Focusable = TRUE
	self.lvlist.delPermitted = FALSE
	self.addWidget(self.lvlist)
	
	self.usdlist = MultiListBox(self, 26, 5, 10, 22, COL_TEXT)
	self.usdlist.setItemColors(COL_TITLE, COL_TEXT)
	self.usdlist.MultiChoice = FALSE
	self.usdlist.addColon(10, "dt", dt_float, 2)
	self.usdlist.addColon(10, "kt", dt_float, 2)
	self.usdlist.Focusable = TRUE
	self.usdlist.delPermitted = FALSE
	self.addWidget(self.usdlist)
	
	self.eurlist = MultiListBox(self, 50, 5, 10, 22, COL_TEXT)
	self.eurlist.setItemColors(COL_TITLE, COL_TEXT)
	self.eurlist.MultiChoice = FALSE
	self.eurlist.addColon(10, "dt", dt_float, 2)
	self.eurlist.addColon(10, "kt", dt_float, 2)
	self.eurlist.Focusable = TRUE
	self.eurlist.delPermitted = FALSE
	self.addWidget(self.eurlist)	
	
		
	
	self.addWidget(Label(self, 2, 3, "() .", COL_TAB))
	self.addWidget(Label(self, 26, 3, "(USD) .", COL_TAB))	
	self.addWidget(Label(self, 50, 3, "() .", COL_TAB))	
	
	self.lv = EditLine(self, 2, 4, 10)
	self.lv.Focusabel = FALSE
	self.addWidget(self.lv)
	
	self.usd = EditLine(self, 26, 4, 10)
	self.usd.Focusabel = FALSE
	self.addWidget(self.usd)
	
	self.eur = EditLine(self, 50, 4, 10)
	self.eur.Focusabel = FALSE
	self.addWidget(self.eur)
	
	
	self.addWidget(Label(self, 2, 16, ". (.)", COL_TAB))
	self.elv = EditLine(self, 2, 17, 10)
	self.elv.Focusabel = FALSE
	self.addWidget(self.elv)
	
	self.addWidget(Label(self, 26, 16, ". (USD)", COL_TAB))
	self.eusd = EditLine(self, 26, 17, 10)
	self.eusd.Focusabel = FALSE
	self.addWidget(self.eusd)	
	
	self.addWidget(Label(self, 50, 16, ". (EUR)", COL_TAB))
	self.eeur = EditLine(self, 50, 17, 10)
	self.eeur.Focusabel = FALSE
	self.addWidget(self.eeur)		

	self.lvlist.addNotifyRecipient(self.usdlist, cm_SYNC)
	self.lvlist.addNotifyRecipient(self.eurlist, cm_SYNC)
	
	self.select(1)
    
    def UserFn(self, command, args = None):
	if command == ev_OK and args == 1:
	    self.nextWidget()
	    return ev_NONE
	if command == ev_OK and args == 3:
	    strbd = self.begdate.text
	    b = "20"+strbd[6:8]+"-"+strbd[3:5]+"-"+strbd[0:2]
	    stred = self.enddate.text
	    e = "20"+stred[6:8]+"-"+stred[3:5]+"-"+stred[0:2]
	    #if b == e:
	    #	curses.beep()
	    #	msgbox = MessageBox(26, 11, 8, 24, COL_TAB, COL_WARN, \
	    #	                        [" ", "   ", "  "], "", msg_OK)
	    #	msgbox.mainLoop()
	    #	msgbox.destroy()
	    #	del msgbox
	    #	pflush()
	    #	self.select(1)
	    #	return ev_NONE
	    
	    (saldo_lv, f) = GetSaldo(501001, begdate=b, full=TRUE)
	    if f == FALSE:
		curses.beep()
		msgbox = MessageBox(26, 11, 7, 24, COL_TAB, COL_WARN, \
		                        ["  ", " !"], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.select(1)
		return ev_NONE
	    
	    (saldo_usd, f) = GetSaldo(501002, begdate=b, full=TRUE)
	    if f == FALSE:
		curses.beep()
		msgbox = MessageBox(26, 11, 7, 24, COL_TAB, COL_WARN, \
		                        ["  ", " !"], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.select(1)
		return ev_NONE
	    
	    (saldo_eur, f) = GetSaldo(501003, begdate=b, full=TRUE)
	    if f == FALSE:
		curses.beep()
		msgbox = MessageBox(26, 11, 7, 24, COL_TAB, COL_WARN, \
		                        ["  ", " !"], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.select(1)
		return ev_NONE
	    
	    self.lv.SetText(fix(saldo_lv, 3))
	    self.usd.SetText(fix(saldo_usd, 3))
	    self.eur.SetText(fix(saldo_eur, 3))
	    
	    self.lvlist.dbQuery = "SELECT dt, kt FROM kasa WHERE issaldo = 0 AND account = 501001 AND LEFT(date,10) >= \'" + str(b) + "\' AND LEFT(date,10) <= \'" + str(e) + "\'"
	    m = Message()
	    m.message = cm_RELOAD
	    self.lvlist.Update(m)
	    
	    self.usdlist.dbQuery = "SELECT dt, kt FROM kasa WHERE issaldo = 0 AND account = 501002 AND LEFT(date,10) >= \'" + str(b) + "\' AND LEFT(date,10) <= \'" + str(e) + "\'"
	    self.usdlist.Update(m)
	    
	    self.eurlist.dbQuery = "SELECT dt, kt FROM kasa WHERE issaldo = 0 AND account = 501003 AND LEFT(date,10) >= \'" + str(b) + "\' AND LEFT(date,10) <= \'" + str(e) + "\'"
	    self.eurlist.Update(m)
	    
	    ilv = len(self.lvlist.items)
	    iusd = len(self.usdlist.items)
	    ieur = len(self.eurlist.items)
	    
	    imax = max(ilv, iusd, ieur)
	    if ilv < imax:
		for i in range(ilv, imax):
		    self.lvlist.addItem(["0.0", "0.0"])
		self.lvlist.draw()
	    if iusd < imax:
		for i in range(iusd, imax):
		    self.usdlist.addItem(["0.0", "0.0"])
		self.usdlist.hilite = self.lvlist.hilite
		self.usdlist.start = 0
		self.usdlist.draw()
	    if ieur < imax:
		for i in range(ieur, imax):
		    self.eurlist.addItem(["0.0", "0.0"])
		self.eurlist.draw()
		    
	    lvdtoborot = 0
	    dt = 0
	    kt = 0
	    for i in range(len(self.lvlist.items)):
		dt = dt + float(self.lvlist.items[i][0].Label)
		kt = kt + float(self.lvlist.items[i][1].Label)
		
	    end_saldo_lv = saldo_lv + dt - kt
	    self.elv.SetText(fix(end_saldo_lv, 3))
	    
	    dt = 0
	    kt = 0
	    for i in range(len(self.usdlist.items)):
		dt = dt + float(self.usdlist.items[i][0].Label)
		kt = kt + float(self.usdlist.items[i][1].Label)
		
	    end_saldo_usd = saldo_usd + dt - kt
	    self.eusd.SetText(fix(end_saldo_usd, 3))

	    dt = 0
	    kt = 0
	    for i in range(len(self.eurlist.items)):
		dt = dt + float(self.eurlist.items[i][0].Label)
		kt = kt + float(self.eurlist.items[i][1].Label)
		
	    end_saldo_eur = saldo_eur + dt - kt
	    self.eeur.SetText(fix(end_saldo_eur, 3))	    
	    
	    self.select(4)
	    return ev_NONE
	    
	    
	
class AnalPart(Dialog):
    def __init__(self, analitno, analno = None, edit = FALSE):
	self.analitno = analitno
	if edit == TRUE:
	    self.mode = 1
	    self.grno = analno
	else:
	    self.mode = 0
	    
	Dialog.__init__(self, 26, 10, 8, 45, COL_MAIN)
	#0
	self.addWidget(Label(self, 2, 7, "< Esc > - ; < Enter > - ", COL_TAB))
	#1
	self.addWidget(Label(self, 2, 1, "", COL_TEXT1))
	self.analitem = EditLine(self, 2, 2, 32)
	#2
	self.addWidget(self.analitem)
	#3
	self.addWidget(Label(self, 2, 3, " ", COL_TEXT1))
	self.addinfo1 = EditLine(self, 2, 4, 40)
	#4
	self.addWidget(self.addinfo1)
	self.addinfo2 = EditLine(self, 2, 5, 40)
	#5
	self.addWidget(self.addinfo2)    

	if edit == TRUE:
	    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
	    c = db.cursor()
	    c.execute("""SELECT name, ad_info FROM kasaanalpart WHERE analitno = %s AND no = %s""",
	              (self.analitno, analno))
	    (name, info) = c.fetchone()
	    db.close()
	    self.analitem.SetText(name)
	    self.addinfo1.SetText(info)
	self.select(2)

    def add_if_no_ExistsItem(self, name, adinfo1, adinfo2):
	db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
	c = db.cursor()
	r = c.execute("SELECT name FROM kasaanalpart WHERE name = %s AND analitno = %s", (name, self.analitno))
	

	#db.close()
	if r > 0:
	    db.close()
	    msgbox = MessageBox(28, 9, 6, 20, COL_TAB, COL_WARN, \
		              [" "], "?", msg_OK)
	    msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()	    
	    return TRUE
	else:
	    c.execute("""SELECT MAX(no) FROM kasaanalpart WHERE analitno = %s""", (self.analitno,))
	    (no,) = c.fetchone()
	    if no == None:
		no = 0
	    no = no + 1
	    c.execute("""INSERT INTO kasaanalpart (no, analitno, name, ad_info, date, oper) VALUES (%s, %s, %s, %s, NOW(), %s)""",
	              (no, self.analitno, name, adinfo1, "cv"))
	    db.close()
	    return FALSE
	
	
    def UserFn(self, command, args):
	if command == ev_OK:
	    self.writexy(1,0, self.analitem.text, COL_TITLE)
	    if args == 2:
		self.select(4)
		return ev_NONE
	    if args == 4:
		self.select(5)
		return ev_NONE
	    if args == 5:
		if self.analitem.text == "":
		    msgbox = MessageBox(28, 9, 7, 20, COL_TAB, COL_WARN, \
		                        ["  ", ""], "", msg_OK)
		    msgbox.mainLoop()
		    msgbox.destroy()
		    del msgbox
		    pflush()		    
		    self.select(2)
		    return ev_NONE
		    pass
		else:
		    ai1 = strip(self.addinfo1.text)
		    ai2 = strip(self.addinfo2.text)
		    person_name = self.analitem.text
		    if self.mode == 0:
			exists = self.add_if_no_ExistsItem(person_name, ai1, ai2)
			if exists == TRUE:
			    self.select(2)
			    return ev_NONE
			else:
			    return ev_DONE
		    else:
			db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
			c = db.cursor()
			c.execute("""UPDATE kasaanalpart SET
			             name = %s,
				     ad_info = %s WHERE
				     analitno = %s AND
				     no = %s""",
				     (person_name, ai1,
				     self.analitno, self.grno))
			db.close()
			return ev_DONE

class getAnalit(Dialog):
    def __init__(self, nameSearch = None, report = 0, analit = 1):
	self.analitno = analit
	self.report = report
	Dialog.__init__(self, 30, 3, 14, 46, COL_MAIN)
	
	self.plist = MultiListBox(self, 2, 1, 10, 42, COL_TEXT)
	self.plist.setItemColors(COL_TITLE, COL_TEXT)
	if self.report == 0 or self.report == 2:
	    self.plist.MultiChoice = FALSE
	elif self.report == 1:
	    self.plist.MultiChoice = TRUE
	self.plist.addColon(6, "")
	if analit == 1:
	    self.plist.addColon(32, "   ")
	elif analit == 2 or analit == 4:
	    self.plist.addColon(32, "")
	elif analit == 3:
	    self.plist.addColon(32, "")
	elif analit == 5:
	    self.plist.addColon(32, "  ")
	elif analit == 6:
	    self.plist.addColon(32, " ")	    
	elif analit == 7:
	    self.plist.addColon(32, " ")
	    
	self.plist.Focusable = TRUE
	if report == 0:
	    self.plist.dbQuery = "SELECT no, name FROM kasaanalpart WHERE analitno =\'" + str(self.analitno) + "\' ORDER BY name ASC"
	else:
	    self.plist.dbQuery = "SELECT no, name FROM kasaanalpart WHERE analitno =\'" + str(self.analitno) + "\' ORDER BY name ASC"
	m = Message()
	m.message = cm_RELOAD
	self.plist.Update(m)
	if nameSearch <> None:
	    self.plist.dbQuery = "SELECT no, name FROM kasaanalpart WHERE analitno=\'" + str(self.analitno) + "\' ORDER BY name ASC"
	    self.plist.Update(m)
	    self.plist.Locate("^" + nameSearch)
	self.addWidget(self.plist)
	if self.report == 0:
	    self.writexy(1, 13, " F1 - ", COL_WARN)
	    self.AddHotKey(curses.KEY_F1, 0)
	    self.writexy(13, 13, " | F10 -  | F5 - ", COL_WARN)
	    self.AddHotKey(curses.KEY_F10, 0)
	    self.AddHotKey(curses.KEY_F5, 0)
	
    def UserFn(self, command, args):
	if command == ev_OK:
	    return ev_DONE
	if command == ev_ACTIVATE and args == curses.KEY_F5 and self.report == 0:
	    anno = int(self.plist.items[self.plist.hilite][0].Label)
	    analpartdlg = AnalPart(self.analitno, analno = anno, edit = TRUE)
	    analpartdlg.mainLoop()
	    anit = analpartdlg.analitem.text
	    analpartdlg.destroy()
	    del analpartdlg
	    m = Message()
	    m.message = cm_RELOAD
	    self.plist.dbQuery = "SELECT no, name FROM kasaanalpart WHERE analitno=\'" + str(self.analitno) + "\' ORDER BY name ASC"
	    self.plist.Update(m)
	    self.plist.Locate(anit)
	    pflush()
	if command == ev_ACTIVATE and args == curses.KEY_F1 and self.report == 0:
	    analpartdlg = AnalPart(self.analitno)
	    analpartdlg.mainLoop()
	    anit = analpartdlg.analitem.text
	    analpartdlg.destroy()
	    del analpartdlg
	    m = Message()
	    m.message = cm_RELOAD
	    self.plist.dbQuery = "SELECT no, name FROM kasaanalpart WHERE analitno=\'" + str(self.analitno) + "\' ORDER BY name ASC"
	    self.plist.Update(m)
	    self.plist.Locate(anit)
	    pflush()
	if command == ev_ACTIVATE and args == curses.KEY_F10 and self.report == 0:
	    anno = int(self.plist.items[self.plist.hilite][0].Label)
	    msgbox = MessageBox(28, 9, 8, 30, COL_TAB, COL_TAB, \
		                        ["  ", "  "], "  . ?", msg_YESNO)
	    yes = msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()
	    if yes == cmd_CANCEL:
		return ev_NONE
	    else:
		db = MySQLdb.connect(user="cv", passwd="cv", db="eso")#, host="192.168.0.2")
		c = db.cursor()
		c.execute("""DELETE FROM kasaanalpart WHERE no = %s AND analitno = %s""",
			     (anno, self.analitno))
		db.close()
		m = Message()
		m.message = cm_RELOAD
		self.plist.dbQuery = "SELECT no, name FROM kasaanalpart WHERE analitno=\'" + str(self.analitno) + "\' ORDER BY name ASC"
		self.plist.Update(m)

		return ev_NONE	    	    	    
	    
class FSaldoDialog(Dialog):
    def __init__(self):
	Dialog.__init__(self, 25, 11, 8, 45, COL_MAIN)
	self.set_caption(" ")
	self.writexy(2, 2, "  :", COL_TEXT1)
	#0
	self.addWidget(Label(self, 2, 3, "       USD   EUR", COL_TEXT1))
	#1
	self.saldo_lv = EditLine(self, 2, 4, 10)
	self.saldo_lv.setType(dt_numeric)
	self.addWidget(self.saldo_lv)
	#2
	self.saldo_usd = EditLine(self, 14, 4, 10)
	self.saldo_usd.setType(dt_numeric)
	self.addWidget(self.saldo_usd)
	#3
	self.saldo_eur = EditLine(self, 26, 4, 10)
	self.saldo_eur.setType(dt_numeric)
	self.addWidget(self.saldo_eur)
	
	self.addWidget(Label(self, 2, 6, "< Enter  > - ", COL_TEXT1))
	self.addWidget(Label(self, 2, 7, "< Escape > - ", COL_TEXT1))

	
	self.select(1)
	
    def UserFn(self, command, args):
	if command == ev_OK and args == 3:
	    
	    db = MySQLdb.connect(user="cv", passwd="cv", db="eso")#, host="192.168.0.2")
	    c = db.cursor()
	    if self.saldo_lv.text <> "":
		dt_lv = float(self.saldo_lv.text)
		c.execute("""INSERT INTO kasa (doc_no, doc_type, issaldo, account, dt, kt, date, oper) VALUES (%s, %s, %s, %s, %s, %s, NOW(), %s)""",
		      (0, 0, 1, 501001, dt_lv, 0, "cv"))
	    if self.saldo_usd.text <> "":
		dt_usd = float(self.saldo_usd.text)  
		c.execute("""INSERT INTO kasa (doc_no, doc_type, issaldo, account, dt, kt, date, oper) VALUES (%s, %s, %s, %s, %s, %s, NOW(), %s)""",
	              (0, 0, 1, 501002, dt_usd, 0, "cv"))  
	    
	    if self.saldo_eur.text <> "":  
		dt_eur = float(self.saldo_eur.text)  
		c.execute("""INSERT INTO kasa (doc_no, doc_type, issaldo, account, dt, kt, date, oper) VALUES (%s, %s, %s, %s, %s, %s, NOW(), %s)""",
	              (0, 0, 1, 501003, dt_eur, 0, "cv"))  	      
		      
	    c.execute("""INSERT INTO lastsaldo (date) VALUES (NOW())""")
	    db.close()
	    curses.curs_set(0)
	    return ev_DONE
	else:
	    self.nextWidget()
	    return ev_NONE
	
	

class BankDocument14(Dialog):
    def __init__(self, counter, botype):
	self.doc_no = counter
	self.botype = botype
	self.analit1 = 0
	self.analit2 = 0
	self.nowday = strftime("%d/%m/%y", gmtime())	
	Dialog.__init__(self, 15, 4, 15, 44, COL_MAIN)
	if self.botype == 1:
	    self.set_caption(" ")
	    self.addWidget(Label(self, 2, 8, "  ", COL_TAB))
	    db = MySQLdb.connect(user="cv", passwd="cv", db="eso")#, host="192.168.0.2")
    	    c = db.cursor()
	    c.execute("SELECT counter FROM documents WHERE doc_no=102""")
	    (cnt, ) = c.fetchone()
	    cnt = cnt + 1
	    db.close()
	    #self.writexy(36, 1, str(cnt), COL_TEXT1)
	    
	elif self.botype == 4:
	    self.set_caption(" ")
	    self.addWidget(Label(self, 2, 8, "  ", COL_TAB))
	    db = MySQLdb.connect(user="cv", passwd="cv", db="eso")#, host="192.168.0.2")
    	    c = db.cursor()
	    c.execute("SELECT counter FROM documents WHERE doc_no=101""")
	    (cnt, ) = c.fetchone()
	    cnt = cnt + 1
	    db.close()
	    #self.writexy(36, 1, str(cnt), COL_TEXT1)
	
	self.date = DateLine(self, 35, 1, COL_TEXT, COL_TITLE)
	self.date.SetText(self.nowday)
	self.date.Focusable = FALSE
	#1
	self.addWidget(self.date)
	#2
	self.addWidget(Label(self, 24, 1, "N " + str(cnt)[-3:], COL_TEXT1))
	self.hline(2, 2, 41, COL_MAIN)
	#3
	self.addWidget(Label(self, 2, 3, " ", COL_TEXT1))
	self.account = EditLine(self, 2, 4, 10)
	#4
	self.addWidget(self.account)
	#5
	self.addWidget(Label(self, 16, 3, ". ", COL_TEXT1))
	self.bankcode = EditLine(self, 16, 4, 8)
	#6
	self.addWidget(self.bankcode)
	
	#7
	self.addWidget(Label(self, 2, 5, " ", COL_TEXT1))
	self.bankname = EditLine(self, 2, 6, 32)
	#8
	self.addWidget(self.bankname)
	#9
	self.addWidget(Label(self, 19, 7, " (F8)", COL_TEXT1))
	self.valuta = DropDnBox1(self, 19, 8, 13, 4, COL_TEXT)
	#10
	self.addWidget(self.valuta)
	
	self.suma = EditLine(self, 32, 8, 10)
	self.suma.setType(dt_float)
	#11
	self.addWidget(self.suma)
	#12
	self.addWidget(Label(self, 2, 9, "", COL_TEXT1))
	
	self.purpose = EditLine(self, 2, 10, 32)
	#13
	self.addWidget(self.purpose)
	self.addWidget(Label(self, 34, 14, "F2 - ", COL_WARN))
	
	self.AddHotKey(curses.KEY_F8, 10)
	self.AddHotKey(curses.KEY_F2, 4)
	
	self.select(4)
	
    def UserFn(self, command, args = None):
	if command == ev_OK and args == 4:
	    self.select(6)
	    return ev_NONE
	elif command == ev_OK and args == 6:
	    self.select(8)
	    return ev_NONE
	elif command == ev_OK and args == 8:
	    bankdlg = getAnalit(analit = 3)
	    status = bankdlg.mainLoop()
	    if status == ev_OK:
		self.bankname.SetText(strip(bankdlg.plist.items[bankdlg.plist.hilite][1].Label))
		self.analit1 = int(bankdlg.plist.items[bankdlg.plist.hilite][0].Label)
		pass
	    bankdlg.destroy()
	    del bankdlg
	    pflush()
	    self.select(11)
	    return ev_NONE
	elif command == ev_OK and args == 13:
	    purposedlg = getAnalit(analit = 5)
	    status = purposedlg.mainLoop()
	    if status == ev_OK:
		self.purpose.SetText(strip(purposedlg.plist.items[purposedlg.plist.hilite][1].Label))
		self.analit2 = int(purposedlg.plist.items[purposedlg.plist.hilite][0].Label)
	    purposedlg.destroy()
	    del purposedlg
	    pflush()
	    command = ev_ACTIVATE
	    args = curses.KEY_F2
	if command == ev_ACTIVATE and args == curses.KEY_F8:
	    return ev_DONE
	if command == ev_ACTIVATE and args == curses.KEY_F2:
	    if self.analit1 == 0 or self.analit2 == 0:
		msgbox = MessageBox(28, 9, 8, 26, COL_TAB, COL_TAB, \
		                        [" ", " "], "", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		return ev_NONE
	    
	    if self.purpose.text == "" or \
	       self.bankname.text == "" or \
	       self.suma.text == "":
		   return ev_NONE
	    
	    msgbox = MessageBox(28, 9, 8, 26, COL_TAB, COL_TAB, \
		                        ["  ", "  "], "?", msg_YESNO)
	    yes = msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()
	    if yes == cmd_CANCEL:
		self.select(4)
		return ev_NONE
	    
	    cash = float(self.suma.text)
	    if self.valuta.box.hilite == 0:
		kasaaccount = 501001
	    elif self.valuta.box.hilite == 1:
		kasaaccount = 501002
	    elif self.valuta.box.hilite == 2:
		kasaaccount = 501003
		
	    if self.botype == 1: #  
		self.doc_no = getDoc_counter(doc_name="")
		db = MySQLdb.connect(user="cv", passwd="cv", db="eso")#, host="192.168.0.2")
		c = db.cursor()
		c.execute("""INSERT INTO kasa (doc_no, doc_type, account, dt, kt, date, oper) VALUES (%s, %s, %s, %s, %s, NOW(), %s)""",
		          (self.doc_no, 5, kasaaccount, 0, cash, "cv"))
		c.execute("""INSERT INTO kasadocs (doc_no, doc_type, person, anlperson, purpose, anlpurpose, sumdt, date, oper) VALUES (%s, %s, %s, %s, %s, %s, %s, NOW(), %s)""",
			  (self.doc_no, 5, self.bankname.text, self.analit1, self.purpose.text, self.analit2, cash, "cv"))
		db.close()
		
		msgbox = MessageBox(28, 10, 8, 26, COL_TAB, COL_TAB, \
		                        ["  ", " ", str(self.doc_no)[-3:]], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		
		return ev_QUIT
	    elif self.botype == 4: #  
		self.doc_no = getDoc_counter(doc_name="")
		db = MySQLdb.connect(user="cv", passwd="cv", db="eso")#, host="192.168.0.2")
		c = db.cursor()
		c.execute("""INSERT INTO kasa (doc_no, doc_type, account, dt, kt, date, oper) VALUES (%s, %s, %s, %s, %s, NOW(), %s)""",
		          (self.doc_no, 4, kasaaccount, cash, 0, "cv"))
		c.execute("""INSERT INTO kasadocs (doc_no, doc_type, person, anlperson, purpose, anlpurpose, sumkt, date, oper) VALUES (%s, %s, %s, %s, %s, %s, %s, NOW(), %s)""",
			  (self.doc_no, 4, self.bankname.text, self.analit1, self.purpose.text, self.analit2, cash, "cv"))
		db.close()
		
		msgbox = MessageBox(28, 10, 8, 26, COL_TAB, COL_TAB, \
		                        ["  ", " ", str(self.doc_no)[-3:]], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		
		return ev_QUIT
	self.nextWidget()
	return ev_NONE
	

class RKOlist(Dialog):
    def __init__(self, person, purpose_flag):
	Dialog.__init__(self, 8, 8, 12, 68, COL_MAIN)
	self.person = person
	self.purpose_flg = purpose_flag
	
	self.set_caption("PKO  "+self.person)
	
	self.plist = MultiListBox(self, 2, 2, 8, 63, COL_TEXT)
	self.plist.setItemColors(COL_TITLE, COL_TEXT)
        self.plist.MultiChoice = TRUE
	self.plist.addColon(13, "")
	self.plist.addColon(7, "", dt_string, [-3, 7])
        self.plist.addColon(33, "  ")
	self.plist.addColon(10, "", dt_float, 2)
	self.plist.Focusable = TRUE
	self.plist.dbQuery = "SELECT LEFT(kasadocs.date, 10), kasadocs.doc_no, kasadocs.purpose, kasadocs.sumdt FROM kasadocs, kasaanalpart WHERE kasadocs.person = \'" + self.person + "\' AND kasaanalpart.name = kasadocs.purpose AND kasaanalpart.ad_info = \'" + self.purpose_flg + "\' and kasadocs.doc_type = 2 AND kasadocs.invalid = 0 AND kasadocs.docref <> ''"
	m = Message()
	m.message = cm_RELOAD
	self.plist.Update(m)
	self.addWidget(self.plist)
	pflush()	
	ss = 0
	for i in range(len(self.plist.items)):
	    ss = ss + float(self.plist.items[i][3].Label)
	self.writexy(26, 11, "    :     ", COL_WARN)
	self.writexy(2, 11, "F10 -  F5 - ", COL_WARN)
	self.writexy(42, 11, rjust(fix(ss, 2), 10), COL_WARN)
	self.AddHotKey(curses.KEY_F10, 0)
	self.select(0)
	
    def UserFn(self, command, args):	
	if command == ev_ACTIVATE and args == curses.KEY_F10:
	    self.plist.dbQuery = "SELECT LEFT(kasadocs.date,10), kasadocs.doc_no, kasadocs.purpose, kasadocs.sumdt FROM kasadocs, kasaanalpart WHERE kasadocs.person = \'" + self.person + "\' AND kasaanalpart.name = kasadocs.purpose AND kasadocs.doc_type = 2 AND kasadocs.invalid = 0 AND kasadocs.docref <> ''"
	    m = Message()
	    m.message = cm_RELOAD
	    self.plist.Update(m)
	    ss = 0
	    for i in range(len(self.plist.items)):
		ss = ss + float(self.plist.items[i][3].Label)
	    self.writexy(26, 11, "    :     ", COL_WARN)
	    self.writexy(42, 11, rjust(fix(ss, 2), 10), COL_WARN)
	    self.select(0)
	    return ev_DONE
	    
	if command == ev_OK and args == 0 and len(self.plist.items) > 0:
	    ss = 0
	    for i in range(len(self.plist.items)):
		if self.plist.items[i][0].selection == TRUE:
		    ss = ss + 1
	    if ss == 0:
		msgbox = MessageBox(28, 9, 7, 26, COL_TAB, COL_TAB, \
		                        ["   ?"], "?", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.select(0)
		return ev_NONE
		
	    msgbox = MessageBox(28, 9, 7, 26, COL_TAB, COL_TAB, \
		                        ["   ?"], "?", msg_YESNO)
	    yes = msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()
	    if yes == cmd_CANCEL:
		self.select(0)
		return ev_NONE
	    else:
		return ev_DONE
			
class Order(Dialog):
    def __init__(self, counter=None):
	self.doc_no = counter
	self.analit1 = 0
	self.analit2 = 0
	self.nowday = strftime("%d/%m/%y", gmtime())
	
	Dialog.__init__(self, 5, 4, 16, 54, COL_MAIN)
	self.date = DateLine(self, 45, 1, COL_TEXT, COL_TITLE)
	self.date.SetText(self.nowday)
	self.date.Focusable = FALSE
	#0
	self.addWidget(self.date)
	self.person = EditLine(self, 2, 2, 32, COL_TEXT, COL_TITLE)
	#1
	self.addWidget(self.person)
	#2
	self.addWidget(Label(self, 34, 1, " ??", COL_TEXT1))
	self.hline(11, 1, 53, COL_MAIN)
	
	self.writexy(44, 15, "F2 - ", COL_WARN)
	self.AddHotKey(curses.KEY_F2, 1)

    def SetAnalit(self, analname, analit = 1):
	if analit == 1 or analit == 6:
	    self.person.SetText(strip(analname))
	    self.select(4)
	elif analit == 2 or analit == 7:
	    self.purpose.SetText(analname)
	    if self.ordertype == 1 or self.ordertype == 3:
		self.select(4)	
	    else:
		self.select(6)
	
    def UserFn(self, command, args = None):
	#if command == ev_ACTIVATE and args == curses.KEY_F8:
	#    return ev_DONE

	if (command == ev_ACTIVATE and args == curses.KEY_F2) or \
	    (command == ev_OK and args == 5 and self.ordertype == 3) or \
	    (command == ev_OK and args == 6 and self.ordertype == 1) or \
	    (command == ev_OK and args == 7 and self.ordertype == 2) :
	    if self.analit1 == 0 or self.analit2 == 0:
		msgbox = MessageBox(28, 9, 8, 26, COL_TAB, COL_TAB, \
		                        [" ", " "], "", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		return ev_NONE
	    
	    if self.purpose.text == "" or \
	       self.person.text == "" or \
	       self.sum.text == "":\
		   return ev_NONE
	    
	    msgbox = MessageBox(28, 9, 8, 26, COL_TAB, COL_TAB, \
		                        ["  ", "  "], "?", msg_YESNO)
	    yes = msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()
	    if yes == cmd_CANCEL:
		self.select(1)
		return ev_NONE
	    
	    cash = float(self.sum.text)
	    
	    
	    if self.ordertype == 1:
	    
	        if self.valuta.box.hilite == 0:
		    kasaaccount = 501001
		elif self.valuta.box.hilite == 1:
		    kasaaccount = 501002
		elif self.valuta.box.hilite == 2:
		    kasaaccount = 501003
	    
		cashbydoc = float(self.docsum.text)
		if cash == 0 and cashbydoc == 0:
		    return ev_NONE
		elif cash == 0 and cashbydoc <> 0:
		    msgbox = MessageBox(28, 9, 8, 30, COL_TAB, COL_TAB, \
		                        ["  ?", "  "], "?", msg_YESNO)
		    yes = msgbox.mainLoop()
		    msgbox.destroy()
		    del msgbox
		    pflush()
		    if yes == cmd_CANCEL:
			self.select(1)
			return ev_NONE
		    rkolist = RKOlist(self.person.text, ".")
		    status = rkolist.mainLoop()
		    if status == ev_OK:
			s = 0
			rkno = ""
			rkl = []
			for i in range(len(rkolist.plist.items)):
			    item = rkolist.plist.items[i]
			    if item[0].selection == TRUE:
				s = s + float(item[3].Label)
				rkl.append(item[1].Label)
				rkno = rkno + ljust(strip(item[1].Label), 4)+","
				rkstr = rkno[0:len(rkno)-1]
			rkolist.destroy()
			del rkolist
			pflush()
			if s <> cashbydoc:
			    msgbox = MessageBox(28, 9, 8, 26, COL_TAB, COL_TAB, \
		                        ["  ", "  "], "", msg_OK)
			    yes = msgbox.mainLoop()
			    msgbox.destroy()
			    del msgbox
			    return ev_NONE
		    elif status == ev_FAIL:
			rkolist.destroy()
			del rkolist
			pflush()
			msgbox = MessageBox(28, 9, 7, 26, COL_TAB, COL_TAB, \
		                        ["  "], "", msg_OK)
			#yes = msgbox.mainLoop()
			sleep(0.5)
			msgbox.destroy()
			del msgbox
			pflush()
			return ev_NONE
		    
		    #        
		    #       
		    self.doc_no = 0
		    pkomode = 1
		elif cash <> 0 and cashbydoc == 0:
		    self.doc_no = getDoc_counter(doc_name="")
		    pkomode = 2
		elif cash <> 0 and cashbydoc <> 0:
		    #sleep(1)
		    msgbox = MessageBox(28, 9, 8, 30, COL_TAB, COL_TAB, \
		                        ["  ?", "  "], "?", msg_YESNO)
		    yes = msgbox.mainLoop()
		    msgbox.destroy()
		    del msgbox
		    pflush()
		    if yes == cmd_CANCEL:
			self.select(1)
			return ev_NONE
		    rkolist = RKOlist(self.person.text, ".")
		    status = rkolist.mainLoop()
		    if status == ev_OK:
			s = 0
			rkno = ""
			rkl = []
			for i in range(len(rkolist.plist.items)):
			    item = rkolist.plist.items[i]
			    if item[0].selection == TRUE:
				s = s + float(item[3].Label)
				rkl.append(item[1].Label)
				rkno = rkno + ljust(strip(item[1].Label), 4) + ","
				rkstr = rkno[0:len(rkno)-1]
			rkolist.destroy()
			del rkolist
			pflush()
			if cash == cashbydoc and s <> cash:
			    msgbox = MessageBox(28, 9, 8, 26, COL_TAB, COL_TAB, \
		                        ["  ", "  "], "", msg_OK)
			    yes = msgbox.mainLoop()
			    msgbox.destroy()
			    del msgbox
			    return ev_NONE
			
			elif s <> cashbydoc + cash:
			    msgbox = MessageBox(28, 9, 8, 26, COL_TAB, COL_TAB, \
		                        ["  ", "  "], "", msg_OK)
			    yes = msgbox.mainLoop()
			    msgbox.destroy()
			    del msgbox
			    return ev_NONE
		    elif status == ev_FAIL:
			rkolist.destroy()
			del rkolist
			pflush()
			msgbox = MessageBox(28, 9, 7, 26, COL_TAB, COL_TAB, \
		                        ["  "], "", msg_OK)
			#yes = msgbox.mainLoop()
			sleep(0.5)
			msgbox.destroy()
			del msgbox
			pflush()
			return ev_NONE
		    		    
		    #        
		    #       
		    self.doc_no = getDoc_counter(doc_name="")
		    pkomode = 3
		db = MySQLdb.connect(user="cv", passwd="cv", db="eso")#, host="192.168.0.2")
		c = db.cursor()
		if pkomode ==  2:
		    c.execute("""INSERT INTO kasa (account, doc_no, doc_type, dt, kt, date, oper) VALUES (%s, %s, %s, %s, %s, NOW(), %s)""",
		               (kasaaccount, self.doc_no, 1, cash, 0, "cv"))
    		    c.execute("""INSERT INTO kasadocs (doc_no, doc_type, person, anlperson, purpose, anlpurpose, sumkt, sumbydoc, date, oper) VALUES (%s, %s, %s, %s, %s, %s, %s, %s, NOW(), %s)""",
			       (self.doc_no, 1, self.person.text, self.analit1, self.purpose.text, self.analit2, cash, cashbydoc, "cv"))
		elif pkomode == 3:
		    c.execute("""INSERT INTO kasa (account, doc_no, doc_type, dt, kt, date, oper) VALUES (%s, %s, %s, %s, %s, NOW(), %s)""",
		               (kasaaccount, self.doc_no, 1, cash, 0, "cv"))
    		    c.execute("""INSERT INTO kasadocs (doc_no, doc_type, person, anlperson, purpose, anlpurpose, sumkt, sumbydoc, date, oper) VALUES (%s, %s, %s, %s, %s, %s, %s, %s, NOW(), %s)""",
		    	       (self.doc_no, 1, self.person.text, self.analit1, self.purpose.text, self.analit2, cash, 0, "cv"))
		    c.execute("""INSERT INTO kasadocs (doc_no, doc_type, person, anlperson, purpose, anlpurpose, sumkt, sumbydoc, date, oper, docref) VALUES (%s, %s, %s, %s, %s, %s, %s, %s, NOW(), %s, %s)""",
		    	       (0, 1, self.person.text, self.analit1, self.purpose.text, self.analit2, 0, cashbydoc, "cv", rkno))
		    c.execute("UPDATE kasadocs SET docref = '' WHERE doc_type = 2 AND doc_no IN (" + rkstr + ")")
		    pass
		elif pkomode == 1:
		    c.execute("""INSERT INTO kasadocs (doc_no, doc_type, person, anlperson, purpose, anlpurpose, sumkt, sumbydoc, date, oper, docref) VALUES (%s, %s, %s, %s, %s, %s, %s, %s, NOW(), %s, %s)""",
		    	       (0, 1, self.person.text, self.analit1, self.purpose.text, self.analit2, 0, cashbydoc, "cv", rkno))		    
		    c.execute("UPDATE kasadocs SET docref = '' WHERE doc_type = 2 AND doc_no IN (" + rkstr + ")")
		    pass
		    			       
		db.close()
		if self.doc_no > 0:
		    msgbox = MessageBox(28, 10, 8, 26, COL_TAB, COL_TAB, \
		                        ["  ", " ", str(self.doc_no)[-3:]], "", msg_OK)
		elif self.doc_no == 0:
		   msgbox = MessageBox(28, 10, 7, 26, COL_TAB, COL_TAB, \
		                        [" ", ""], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		
		return ev_QUIT
	    elif self.ordertype == 2:
	    
	        if self.valuta.box.hilite == 0:
		    kasaaccount = 501001
		elif self.valuta.box.hilite == 1:
		    kasaaccount = 501002
		elif self.valuta.box.hilite == 2:
		    kasaaccount = 501003
	    
		self.doc_no = getDoc_counter(doc_name = "")
		db = MySQLdb.connect(user="cv", passwd="cv", db="eso")#, host="192.168.0.2")
		c = db.cursor()
		c.execute("""INSERT INTO kasa (account, doc_no, doc_type, dt, kt, date, oper) VALUES (%s, %s, %s, %s, %s, NOW(), %s)""",
		          (kasaaccount, self.doc_no, 2, 0, cash, "cv"))
		c.execute("""INSERT INTO kasadocs (doc_no, doc_type, person, anlperson, ad_info, purpose, anlpurpose, sumdt, date, oper) VALUES (%s, %s, %s, %s, %s, %s, %s, %s, NOW(), %s)""",
			  (self.doc_no, 2, self.person.text, self.analit1, self.address.text + "-" + self.addinfo.text, self.purpose.text, self.analit2, cash, "cv"))
		db.close()
		msgbox = MessageBox(28, 10, 8, 26, COL_TAB, COL_TAB, \
		                        ["  ", " ", str(self.doc_no)[-3:]], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		return ev_QUIT
	    elif self.ordertype == 3:
		
		if self.valuta.box.hilite == 0:
		    kasaaccount = 501001
		elif self.valuta.box.hilite == 1:
		    kasaaccount = 501002
		elif self.valuta.box.hilite == 2:
		    kasaaccount = 501003
		
		self.doc_no = getDoc_counter(doc_name="")
		db = MySQLdb.connect(user="cv", passwd="cv", db="eso")#, host="192.168.0.2")
		c = db.cursor()
		c.execute("""INSERT INTO kasa (account, doc_no, doc_type, dt, kt, date, oper) VALUES (%s, %s, %s, %s, %s, NOW(), %s)""",
		          (kasaaccount, self.doc_no, 3, cash, 0, "cv"))
		c.execute("""INSERT INTO kasadocs (doc_no, doc_type, person, anlperson, purpose, anlpurpose, sumkt, date, oper) VALUES (%s, %s, %s, %s, %s, %s, %s, NOW(), %s)""",
			  (self.doc_no, 3, self.person.text, self.analit1, self.purpose.text, self.analit2, cash, "cv"))
		db.close()
		
		msgbox = MessageBox(28, 10, 8, 26, COL_TAB, COL_TAB, \
		                        ["  ", " ", str(self.doc_no)[-3:]], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		
		return ev_QUIT
	    
	if command == ev_OK and args == 1:
	    if self.ordertype == 3:
		an = 6
	    elif self.ordertype == 1 or self.ordertype == 2:
		an = 1
	    search = self.person.text
	    if search == "":
		persondlg = getAnalit(analit = an)
	    else:
		persondlg = getAnalit(nameSearch = search, analit = an)
	    status = persondlg.mainLoop()
	    if status == ev_OK:
		self.SetAnalit(persondlg.plist.items[persondlg.plist.hilite][1].Label)
		self.analit1 = int(persondlg.plist.items[persondlg.plist.hilite][0].Label)
	    else:
		self.select(1)
	    
	    persondlg.destroy()
	    del persondlg
	    pflush()
	else:
	    self.nextWidget()
	    return ev_NONE
	
    
class inOrder(Order):
    def __init__(self, counter = None):
	Order.__init__(self, counter)
	db = MySQLdb.connect(user="cv", passwd="cv", db="eso")#, host="192.168.0.2")
	c = db.cursor()
	c.execute("SELECT counter FROM documents WHERE doc_no=101""")
	(cnt, ) = c.fetchone()
	cnt = cnt + 1
	db.close()
	self.writexy(36, 1, str(cnt)[-3:], COL_TEXT1)

	self.ordertype = 1
	self.set_caption("  ")
	#3
	self.addWidget(Label(self, 2, 1, "    . ", COL_MAIN))
	self.writexy(2, 3, "/", COL_TEXT1)
	self.purpose = EditLine(self, 2, 4, 48, COL_TEXT, COL_TITLE)
	#4
	self.addWidget(self.purpose)
	self.writexy(2, 5, "  ", COL_TEXT1)
	self.sum = EditLine(self, 2, 6, 12)
	self.sum.SetText("0")
	self.sum.setType(dt_float)
	#5
	self.addWidget(self.sum)
	#6
	self.writexy(16, 5, "  .", COL_TEXT1)
	self.docsum = EditLine(self, 16, 6, 12)
	self.docsum.SetText("0")
	self.docsum.setType(dt_float)
	self.addWidget(self.docsum)
    
	self.addWidget(Label(self, 32, 5, " (F8)", COL_TEXT1))
	self.valuta = DropDnBox1(self, 32, 6, 13, 4, COL_TEXT)
	self.addWidget(self.valuta)
	self.AddHotKey(curses.KEY_F8, 8)
	#self.writexy(13, 6, "    ", COL_TEXT1)	

	self.select(1)

#    def SetAnalit(self, analname, analit = 1):
#	if analit == 1:
#	    self.person.SetText(strip(analname))
#	    self.select(4)
#	else:
#	    self.purpose.SetText(analname)
#	    self.select(5)
	
    def UserFn(self, command, args = None):
    	if command == ev_ACTIVATE and args == curses.KEY_F8:
	    return ev_DONE

	if command == ev_OK and args == 4:
	    search = self.purpose.text
	    if search == "":
		purposedlg = getAnalit(analit = 2)
	    else:
		purposedlg = getAnalit(nameSearch = search, analit = 2)
	    status = purposedlg.mainLoop()
	    if status == ev_OK:
		self.SetAnalit(purposedlg.plist.items[purposedlg.plist.hilite][1].Label, 2)
		self.analit2 = int(purposedlg.plist.items[purposedlg.plist.hilite][0].Label)
	    else:
		self.select(4)
	    
	    purposedlg.destroy()
	    del purposedlg
	    pflush()
	    
	if command == ev_NEXT or command == ev_PREV:
	    if args == 1:
		self.analit1 = 0
	    if args == 4:
		self.analit2 = 0
	    return
		
	ret = Order.UserFn(self, command, args)
	return ret

    
    
class inTradeOrder(Order):
    def __init__(self, counter = None):
	Order.__init__(self, counter)
	self.ordertype = 3
	self.set_caption("   - ")
	
	db = MySQLdb.connect(user="cv", passwd="cv", db="eso")#, host="192.168.0.2")
	c = db.cursor()
	c.execute("SELECT counter FROM documents WHERE doc_no=101""")
	(cnt, ) = c.fetchone()
	cnt = cnt + 1
	db.close()
	self.writexy(36, 1, str(cnt)[-3:], COL_TEXT1)
	
	#3
	self.addWidget(Label(self, 2, 1, "    .", COL_MAIN))
	self.writexy(2, 3, "/", COL_TEXT1)
	self.purpose = EditLine(self, 2, 4, 48, COL_TEXT, COL_TITLE)
	#4
	self.addWidget(self.purpose)
	self.writexy(2, 5, "", COL_TEXT1)
	self.sum = EditLine(self, 2, 6, 9)
	self.sum.setType(dt_float)
	#5
	self.addWidget(self.sum)
	#self.writexy(13, 6, "    ", COL_TEXT1)	

	self.addWidget(Label(self, 12, 5, " (F8)", COL_TEXT1))
	self.valuta = DropDnBox1(self, 12, 6, 13, 4, COL_TEXT)
	self.addWidget(self.valuta)
	self.AddHotKey(curses.KEY_F8, 7)
	
	
	self.select(1)

    def UserFn(self, command, args = None):
	if command == ev_ACTIVATE and args == curses.KEY_F8:
	    return ev_DONE

	if command == ev_OK and args == 4:
	    search = self.purpose.text
	    if search == "":
		purposedlg = getAnalit(analit = 7)
	    else:
		purposedlg = getAnalit(nameSearch = search, analit = 7)
	    status = purposedlg.mainLoop()
	    if status == ev_OK:
		self.SetAnalit(purposedlg.plist.items[purposedlg.plist.hilite][1].Label, 2)
		self.analit2 = int(purposedlg.plist.items[purposedlg.plist.hilite][0].Label)
	    else:
		self.select(4)
	    
	    purposedlg.destroy()
	    del purposedlg
	    pflush()
	    
	if command == ev_NEXT or command == ev_PREV:
	    if args == 1:
		self.analit1 = 0
	    if args == 4:
		self.analit2 = 0
	    return
		
	ret = Order.UserFn(self, command, args)
	return ret
    
    
	
class outOrder(Order):
    def __init__(self, counter = None):
	Order.__init__(self, counter)
	self.ordertype = 2
	self.set_caption("  ")
	
	db = MySQLdb.connect(user="cv", passwd="cv", db="eso")#, host="192.168.0.2")
	c = db.cursor()
	c.execute("SELECT counter FROM documents WHERE doc_no=102""")
	(cnt, ) = c.fetchone()
	cnt = cnt + 1
	db.close()
	self.writexy(36, 1, str(cnt)[-3:], COL_TEXT1)
	
	#
	self.addWidget(Label(self, 2, 1, "     ", COL_MAIN))
	self.writexy(2, 3, " (,   .):", COL_TEXT1)
	self.address = EditLine(self, 2, 4, 48)
	#4
	self.addWidget(self.address)
	self.addinfo = EditLine(self, 2, 5, 48)
	#5
	self.addWidget(self.addinfo)
	self.writexy(2, 6, " ()", COL_TEXT1)
	self.purpose = EditLine(self, 2, 7, 48, COL_TEXT, COL_TITLE)
	#6
	self.addWidget(self.purpose)
	self.writexy(2, 8, "", COL_TEXT1)
	self.sum = EditLine(self, 2, 9, 9)
	self.sum.setType(dt_float)
	#7
	self.addWidget(self.sum)
	
	self.addWidget(Label(self, 12, 8, " (F8)", COL_TEXT1))
	self.valuta = DropDnBox1(self, 12, 9, 13, 4, COL_TEXT)
	self.addWidget(self.valuta)
	self.AddHotKey(curses.KEY_F8, 9)
	
	#self.writexy(13, 9, "    ", COL_TEXT1)
	self.select(1)    
	
    #def SetPerson(self, pname):
	#self.person.SetText(strip(pname))
	#self.select(4)	
	
    def UserFn(self, command, args = None):
    	if command == ev_ACTIVATE and args == curses.KEY_F8:
	    return ev_DONE

	if command == ev_OK and args == 6:
	    search = self.purpose.text
	    if search == "":
		purposedlg = getAnalit(analit = 4)
	    else:
		purposedlg = getAnalit(nameSearch = search, analit = 4)
	    status = purposedlg.mainLoop()
	    if status == ev_OK:
		self.SetAnalit(purposedlg.plist.items[purposedlg.plist.hilite][1].Label, 2)
		self.analit2 = int(purposedlg.plist.items[purposedlg.plist.hilite][0].Label)
	    else:
		self.select(7)
	    
	    purposedlg.destroy()
	    del purposedlg
	    pflush()    
	    
	ret = Order.UserFn(self, command, args)
	return ret    

class DocInfoDlg(Dialog):
    def __init__(self, doc_no, doc_type, doc_date):
	self.doc_no = doc_no
	self.doc_type = doc_type
	self.doc_date = doc_date
	Dialog.__init__(self, 20, 10, 12, 42, COL_MAIN)
	#0
	self.addWidget(Label(self, 2, 1, " .", COL_TEXT1))
	self.sdocno = EditLine(self, 2, 2, 10)
	self.sdocno.SetText(self.doc_no)
	self.sdocno.Focusable = FALSE
	#1
	self.addWidget(self.sdocno)
	
	if self.doc_type == "1":
	    s = "  "
	elif self.doc_type == "2":
	    s = "  "
	elif self.doc_type == "5":
	    s = "   "
	elif self.doc_type == "4":
	    s = "   "
	elif self.doc_type == "3":
	    s = "  . "
	else: s = str(self.doc_type)
	#2    
	self.addWidget(Label(self, 2, 3, ".: "+s, COL_TEXT1))
	#3
	self.addWidget(Label(self, 2, 4, "  :" + self.doc_date, COL_TEXT1))

	db = MySQLdb.connect(user="cv", passwd="cv", db="eso")#, host="192.168.0.2")
	c = db.cursor()	
	c.execute("""SELECT person, purpose, ad_info FROM kasadocs WHERE invalid = 0 AND doc_no=%s AND doc_type = %s AND LEFT(date,10) = %s""",
	          (self.doc_no, self.doc_type, self.doc_date))
	(person, purpose, ad_info) = c.fetchone()
	db.close()
	self.addWidget(Label(self, 2, 6, "(1 .-) " + person, COL_TAB))
	self.addWidget(Label(self, 2, 7, "(2 .-) " + purpose, COL_TAB))
	self.addWidget(Label(self, 2, 8, ". :" + ad_info, COL_TAB))
	
	#4
	self.addWidget(Button(self, 14, 10, 7, 1, "< Ok >", COL_TITLE, COL_WARN, 1))
	self.select(7)

class Oborot(Dialog):
    def __init__(self, oborottype, account = 501001):
	self.oborottype = oborottype
	self.nowday = strftime("%d-%m-%y", gmtime())
	Dialog.__init__(self, 2, 4, 15, 76, COL_MAIN)
	if self.oborottype == 1:
	    self.set_caption("  ")
	elif self.oborottype == 2:
	    self.set_caption("  ")
	elif self.oborottype == 3:
	    self.set_caption(" ")
	#0    
	if self.oborottype == 1 or self.oborottype == 2:
	    self.addWidget(Label(self, 40, 1, ".", COL_TEXT1))
	    self.begdate = DateLine(self, 49, 1, COL_TEXT, COL_TITLE)
	    self.begdate.SetText(self.nowday)
	    #1
	    self.addWidget(self.begdate)
	    #2
	    self.addWidget(Label(self, 59, 1, ".", COL_TEXT1))
	    self.enddate = DateLine(self, 67, 1, COL_TEXT, COL_TITLE)
	    self.enddate.SetText(self.nowday)
	    #3
	    self.addWidget(self.enddate)	
	else:
	    #0
	    self.addWidget(Label(self, 58, 1, " ", COL_TEXT1))
	    self.enddate = DateLine(self, 67, 1, COL_TEXT, COL_TITLE)
	    self.enddate.SetText(self.nowday)
	    #1
	    self.addWidget(self.enddate)	
	
	self.doclist = MultiListBox(self, 2, 3, 10, 72, COL_TEXT)
	self.doclist.setItemColors(COL_TITLE, COL_TEXT)
	self.doclist.MultiChoice = FALSE
	self.doclist.addColon(5, '')
	self.doclist.addColon(5, " ", dt_string, [-3, 10])
	self.doclist.addColon(11, "..")
	if self.oborottype == 1 or self.oborottype == 2:
	    self.doclist.addColon(36, " ")
	    self.doclist.addColon(14, "", dt_float, 2)
	elif self.oborottype == 3:
	    self.doclist.addColon(32, " ")
	    self.doclist.addColon(9, "", dt_float, 2)
	    self.doclist.addColon(9, "", dt_float, 2)
	self.doclist.Focusable = TRUE
	self.doclist.delPermitted = FALSE
	#4 #2
	self.addWidget(self.doclist)
	self.addWidget(Label(self, 2, 14, "Esc -  | F1 - .  | F10 - ", COL_TEXT1))
	self.addWidget(Label(self, 50, 14, " :              ", COL_WARN))
	if self.oborottype == 1 or self.oborottype == 2:
	    self.AddHotKey(curses.KEY_F1, 4)
	    self.AddHotKey(curses.KEY_F10, 4)
	elif self.oborottype == 3:
	    self.AddHotKey(curses.KEY_F1, 2)
	    self.AddHotKey(curses.KEY_F10, 2)
	
	self.select(1)
	
    def UserFn(self, command, args):
	if command == ev_ACTIVATE and args == curses.KEY_F10:
	    if len(self.doclist.items) == 0:
		return ev_NONE
	    msgbox = MessageBox(26, 11, 8, 30, COL_TAB, COL_TAB, \
		                        ["   ?", "  "], "?", msg_YESNO)
	    yes = msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()
	    if yes == cmd_CANCEL:
		return ev_NONE
	    i = self.doclist.hilite
	    sdocn = self.doclist.items[i][0].Label
	    sdocd = self.doclist.items[i][1].Label
	    sdoct = self.doclist.hidden_items[i][0]
	    if sdoct == "1" or sdoct == "3" or sdoct == "4":
		dcn = 101
	    elif sdoct == "5" or sdoct == "2":
		dcn = 102
	    db = MySQLdb.connect(user="cv", passwd="cv", db="eso")#, host="192.168.0.2")
	    c = db.cursor()	
	    c.execute("""SELECT counter FROM documents WHERE doc_no = %s""", 
	                 (dcn,))
	    (sd1,) = c.fetchone()
	    if sd1 == int(sdocn):
		c.execute("""UPDATE kasadocs SET invalid = 1 WHERE
	                 doc_no = %s AND
			 doc_type = %s AND
			 LEFT(date, 10) = %s""", 
			 (sdocn, sdoct, sdocd))
		c.execute("""DELETE FROM kasa WHERE
	                 doc_no = %s AND
			 doc_type = %s AND
			 LEFT(date, 10) = %s""",
			 (sdocn, sdoct, sdocd))
		c.execute("""UPDATE LOW_PRIORITY documents SET counter=counter - 1 WHERE doc_no = %s""",
			 (dcn, ))
		db.close()
		m = Message()
		m.message = cm_RELOAD
		self.doclist.Update(m)
		if len(self.doclist.items) == 0:
		    curses.beep()
		    msgbox = MessageBox(26, 11, 7, 24, COL_TAB, COL_WARN, \
		                        ["  ", " !"], "", msg_OK)
		    msgbox.mainLoop()
		    msgbox.destroy()
		    del msgbox
		    pflush()
		    self.select(1)
		else:
		    ts = 0
		    for i in range(len(self.doclist.items)):
			ts = ts + float(self.doclist.items[i][3].Label)
		    self.writexy(62, 14, rjust(fpformat.fix(ts, 3), 12), COL_WARN)
		    self.select(4)
		return ev_NONE
	    else:
		db.close()
		msgbox = MessageBox(26, 11, 7, 24, COL_TAB, COL_WARN, \
		                        ["   ", " !"], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
	    
	if command == ev_ACTIVATE and args == curses.KEY_F1:
	    i = self.doclist.hilite
	    sdocn = self.doclist.items[i][1].Label
	    sdocd = self.doclist.items[i][2].Label
	    sdoct = self.doclist.hidden_items[i][0]
	    info = DocInfoDlg(sdocn, sdoct, sdocd)
	    info.mainLoop()
	    info.destroy()
	    del info
	    pflush()
	    #return ev_DONE
	if command == ev_OK and args == 1 and (self.oborottype == 1 or self.oborottype == 2):
	    self.select(3)
	    return ev_NONE
	if command == ev_OK and args == 3 and (self.oborottype == 1 or self.oborottype == 2):
	    strbd = self.begdate.text
	    stred = self.enddate.text
	    b = "20"+strbd[6:8]+"-"+strbd[3:5]+"-"+strbd[0:2]
	    e = "20"+stred[6:8]+"-"+stred[3:5]+"-"+stred[0:2]
	    if self.oborottype == 1: 
		self.doclist.dbQuery = "SELECT RIGHT(kasa.account, 3), RIGHT(kasadocs.doc_no, 4), LEFT(kasadocs.date, 10), kasadocs.person, CONCAT(kasadocs.sumkt, ''), kasadocs.doc_type FROM kasadocs, kasa WHERE kasadocs.invalid = 0 AND kasadocs.doc_no = kasa.doc_no AND LEFT(kasadocs.date, 10)>=\'"+b+"\' AND LEFT(kasadocs.date,10) <=\'" +e+"\' AND kasadocs.doc_type = kasa.doc_type AND kasadocs.doc_type IN (1, 3, 4)"
	    elif self.oborottype == 2:
		self.doclist.dbQuery = "SELECT RIGHT(kasa.account, 3), RIGHT(kasadocs.doc_no, 4), LEFT(kasadocs.date, 10), kasadocs.person, CONCAT(kasadocs.sumdt, ''), kasadocs.doc_type FROM kasadocs, kasa WHERE kasadocs.invalid = 0 AND kasadocs.doc_no = kasa.doc_no AND LEFT(kasadocs.date, 10)>=\'"+b+"\' AND LEFT(kasadocs.date,10) <=\'" +e+"\' AND kasadocs.doc_type = kasa.doc_type AND kasadocs.doc_type IN (5, 2)"
	    m = Message()
	    m.message = cm_RELOAD
	    self.doclist.Update(m)
	    if len(self.doclist.items) == 0:
		curses.beep()
		msgbox = MessageBox(26, 11, 7, 24, COL_TAB, COL_WARN, \
		                        ["  ", " !"], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.select(1)
	    else:
		ts = 0
		for i in range(len(self.doclist.items)):
		    ts = ts + float(self.doclist.items[i][4].Label)
		self.writexy(62, 14, rjust(fpformat.fix(ts, 3), 12), COL_WARN)
		self.select(4)
	    return ev_NONE
	
	if command == ev_OK and args == 1 and self.oborottype == 3:
	    stred = self.enddate.text
	    e = "20"+stred[6:8]+"-"+stred[3:5]+"-"+stred[0:2]
	    self.doclist.dbQuery = "SELECT RIGHT(kasa.account, 3), RIGHT(kasadocs.doc_no, 4), LEFT(kasadocs.date, 10), kasadocs.person, CONCAT(kasadocs.sumdt, ''), CONCAT(kasadocs.sumkt, ''), kasadocs.doc_type FROM kasadocs, kasa WHERE kasadocs.invalid = 0 AND kasadocs.doc_no = kasa.doc_no AND LEFT(kasadocs.date, 10) =\'" +e+"\' AND kasadocs.doc_type = kasa.doc_type AND kasadocs.doc_type IN (1, 2, 3, 4, 5)"
	    m = Message()
	    m.message = cm_RELOAD
	    self.doclist.Update(m)
	    if len(self.doclist.items) == 0:
		curses.beep()
		msgbox = MessageBox(26, 11, 7, 24, COL_TAB, COL_WARN, \
		                        ["  ", " !"], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.select(1)
	    else:
		ts = 0
		for i in range(len(self.doclist.items)):
		    ts = ts + float(self.doclist.items[i][4].Label)
		self.writexy(62, 14, rjust(fpformat.fix(ts, 3), 12), COL_WARN)
		self.select(2)
	    return ev_NONE	
	elif command == ev_OK and args == 4:
	    return ev_NONE
	    
class PersonOborot(Dialog):
    def __init__(self, person = None):
	self.nowday = strftime("%d-%m-%y", gmtime())
	self.b =""
	self.e =""
	Dialog.__init__(self, 2, 2, 18, 76, COL_MAIN)
	if person == None:
	    self.set_caption("   ")
	else:
	    self.person = person
	    self.set_caption("   "+person)
	#0    
	self.addWidget(Label(self, 40, 1, ".", COL_TEXT1))
	self.begdate = DateLine(self, 49, 1, COL_TEXT, COL_TITLE)
	self.begdate.SetText(self.nowday)
	#1
	self.addWidget(self.begdate)
	#2
	self.addWidget(Label(self, 59, 1, ".", COL_TEXT1))
	self.enddate = DateLine(self, 67, 1, COL_TEXT, COL_TITLE)
	self.enddate.SetText(self.nowday)
	#3
	self.addWidget(self.enddate)	
	
	self.plist = MultiListBox(self, 2, 8, 8, 72, COL_TEXT)
	self.plist.setItemColors(COL_TITLE, COL_TEXT)
	self.plist.MultiChoice = FALSE
	#self.plist.addColon(5, " ")
	self.plist.addColon(30, " ")
	self.plist.addColon(12, ".", dt_float, 2)
	self.plist.addColon(12, " ", dt_float, 2)
	self.plist.addColon(12, ".", dt_float, 2)
	self.plist.Focusable = TRUE
	self.plist.delPermitted = FALSE
	#4
	self.addWidget(self.plist)
	
	self.drawrect(2, 47, 27, 5, COL_TAB)
	self.addWidget(Label(self, 48, 3, "  :", COL_TAB))
	self.addWidget(Label(self, 48, 4, ".:", COL_TAB))	
	self.addWidget(Label(self, 48, 5, " :", COL_TAB))	
	self.addWidget(Label(self, 48, 6, "   :", COL_TAB))	
	
	self.oldsaldo = EditLine(self, 62, 3, 10)
	self.oldsaldo.Focusable = FALSE
	self.addWidget(self.oldsaldo)
	
	self.dtoborot = EditLine(self, 62, 4, 10)
	self.dtoborot.Focusable = FALSE
	self.addWidget(self.dtoborot)
	
	self.ktoborot = EditLine(self, 62, 5, 10)
	self.ktoborot.Focusable = FALSE
	self.addWidget(self.ktoborot)
	
	self.newsaldo = EditLine(self, 62, 6, 10)
	self.newsaldo.Focusable = FALSE
	self.addWidget(self.newsaldo)
	
	self.addWidget(Label(self, 2, 17, "< Esc > -      < F1 > -  ", COL_TEXT1))
	self.addWidget(Label(self, 50, 17, " :              ", COL_WARN))
    
	self.plist.addNotifyRecipient(self, cm_ITEM_CHANGED)
	
	self.select(1)
	
    def Update(self, msg):
	if msg.message == cm_ITEM_CHANGED:
	    indx = msg.args[1]
	    self.dtoborot.SetText(self.plist.items[indx][2].Label)
	    self.ktoborot.SetText(self.plist.items[indx][3].Label)
	    #strbd = self.begdate.text
	    #stred = self.enddate.text
	    #b = "20"+strbd[6:8]+"-"+strbd[3:5]+"-"+strbd[0:2]
	    #e = "20"+stred[6:8]+"-"+stred[3:5]+"-"+stred[0:2]
	    db = MySQLdb.connect(user="cv", passwd="cv", db="eso")#, host="192.168.0.2")
	    c = db.cursor()
	    c.execute("""SELECT SUM(sumdt), SUM(sumkt), SUM(sumbydoc) FROM kasadocs WHERE invalid = 0 AND person = %s AND doc_type IN (1,2) AND LEFT(date, 10) < %s""",
	             (strip(self.plist.items[indx][1].Label), self.b))
	    (sumdt, sumkt, sbd) = c.fetchone()
	    if sumdt == None:
		sumdt = 0
	    if sumkt == None:
		sumkt = 0
	    db.close()
	    self.oldsaldo.SetText(rjust(fix(sumdt - sumkt, 2), 10))
	    ns = float(self.plist.items[indx][3].Label) + (sumdt - sumkt)
		 #float(self.plist.items[indx][2].Label)
		 #(sumdt-sumkt)
	    self.newsaldo.SetText(rjust(fix(ns, 2), 10))
		
	
    def UserFn(self, command, args):
	if command == ev_OK and args == 1:
	    self.select(3)
	    return ev_NONE
	elif command == ev_OK and args == 3:
	    strbd = self.begdate.text
	    stred = self.enddate.text
	    
	    self.b = "20"+strbd[6:8]+"-"+strbd[3:5]+"-"+strbd[0:2]
	    self.e = "20"+stred[6:8]+"-"+stred[3:5]+"-"+stred[0:2]
	    
	    #self.plist.dbQuery = "SELECT kasadocs.person, sum(kasadocs.sumdt), sum(kasadocs.sumkt) + sum(kasadocs.sumbydoc), sum(kasadocs.sumdt)-sum(kasadocs.sumkt)-sum(kasadocs.sumbydoc), kasadocs.purpose FROM kasadocs, kasaanalpart WHERE kasadocs.person = kasaanalpart.name and kasaanalpart.ad_info = \'\' and kasadocs.invalid = 0 AND LEFT(kasadocs.date, 10) >= \'"+self.b+"\' AND LEFT(kasadocs.date, 10) <= \'"+self.e+"\' AND kasadocs.doc_type IN (1,2) GROUP BY kasadocs.person" 
	    self.plist.dbQuery ="SELECT t0.person, SUM(t0.sumdt), SUM(t0.sumkt) + SUM(t0.sumbydoc), SUM(t0.sumdt) - SUM(t0.sumkt) - SUM(t0.sumbydoc) FROM kasadocs AS t0 LEFT JOIN kasaanalpart AS t1 ON (t1.name = t0.person AND t1.ad_info = '') LEFT JOIN kasaanalpart AS t2 ON (t2.name = t0.purpose AND t2.ad_info = '.') WHERE t0.doc_type IN (1,2) AND t0.invalid = 0 AND LEFT(t0.date, 10) >= \'"+self.b+"\' AND LEFT(t0.date, 10) <= \'"+self.e+"\' AND t1.ad_info = '' AND t2.ad_info = '.' GROUP BY 1"
	    m = Message()
	    m.message = cm_RELOAD
	    self.plist.Update(m)
	
	    if len(self.plist.items) == 0:
		curses.beep()
		msgbox = MessageBox(26, 11, 7, 24, COL_TAB, COL_WARN, \
		                        ["  ", " !"], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.select(1)
	    else:
		#db = MySQLdb.connect(user="cv", passwd="cv", db="eso")#, host="192.168.0.2")
		#c = db.cursor()
		#c.execute("""SELECT name FROM kasaanalpart WHERE ad_info = %s""", ('.',))
		#parts = c.fetchall()
		#db.close()
		#newlist = []
		#for i in range(len(self.plist.items)):
		#    it = self.plist.items[i]
		#    p = self.plist.hidden_items[i][0]
		#    for j in range(len(parts)):
		#	if p == parts[j][0]:
		# 	    newlist.append([it[0].Label, it[1].Label, it[2].Label, it[3].Label])
		#	    
		#del self.plist.items
		#del self.plist.hidden_items
		#self.plist.hilite = -1
		#self.plist.start = -1
		#self.plist.end = -1
		#self.plist.items = []
		#self.plist.hidden_items = []
		#for i in range(len(newlist)):
		#    self.plist.addItem([newlist[i][0], newlist[i][1], newlist[i][2], newlist[i][3]])
		#self.plist.draw()
		
		self.dtoborot.SetText(self.plist.items[0][2].Label)
		self.ktoborot.SetText(self.plist.items[0][3].Label)
		db = MySQLdb.connect(user="cv", passwd="cv", db="eso")#, host="192.168.0.2")
		c = db.cursor()
		c.execute("""SELECT SUM(sumdt), SUM(sumkt) FROM kasadocs WHERE invalid = 0 AND person = %s AND doc_type IN (1,2) AND LEFT(date, 10) < %s""",
	                    (strip(self.plist.items[0][1].Label), self.b))
		(sumdt, sumkt) = c.fetchone()
		if sumdt == None:
		    sumdt = 0
		if sumkt == None:
		    sumkt = 0
		db.close()
		self.oldsaldo.SetText(rjust(fix(sumdt - sumkt, 2), 10))
		ns = float(self.plist.items[0][3].Label) + (sumdt - sumkt)
		self.newsaldo.SetText(rjust(fix(ns,2),10))
		#ts = 0
		
		#for i in range(len(self.doclist.items)):
		#    ts = ts + float(self.doclist.items[i][3].Label)
		#self.writexy(62, 14, rjust(fpformat.fix(ts, 3), 12), COL_WARN)
		self.select(4)
	    return ev_NONE
	elif command == ev_OK and args == 4:
	    #strbd = self.begdate.text
	    #stred = self.enddate.text
	    #b = "20"+strbd[6:8]+"-"+strbd[3:5]+"-"+strbd[0:2]
	    #e = "20"+stred[6:8]+"-"+stred[3:5]+"-"+stred[0:2]
	    #self.writexy(60, 0, b, COL_WARN)
	    #self.doclist.dbQuery = "SELECT doc_no, LEFT(date, 10), person, sum FROM kasadocs WHERE invalid = 0 AND LEFT(date, 10)>=\'"+b+"\' AND LEFT(date,10) <=\'" +e+"\'"
	    #m = Message()
	    #m.message = cm_RELOAD
	    #self.doclist.Update(m)
	    return ev_NONE

class BanksSaldo(Dialog):
    def __init__(self, person, purpose_flag):
	Dialog.__init__(self, 15, 6, 12, 55, COL_MAIN)
	self.person = person
	self.purpose_flg = purpose_flag
	
	self.set_caption("  "+self.person)
	
	self.plist = MultiListBox(self, 2, 2, 8, 50, COL_TEXT)
	self.plist.setItemColors(COL_TITLE, COL_TEXT)
        self.plist.MultiChoice = TRUE
	self.plist.addColon(6, "")
        self.plist.addColon(34, "  ")
	self.plist.addColon(10, "", dt_float, 2)
	self.plist.Focusable = TRUE
	self.plist.dbQuery = "SELECT kasadocs.doc_no, kasadocs.purpose, kasadocs.sumdt FROM kasadocs, kasaanalpart WHERE kasadocs.person = \'" + self.person + "\' AND kasaanalpart.name = kasadocs.purpose AND kasaanalpart.ad_info = \'" + self.purpose_flg + "\' and kasadocs.doc_type = 2 AND kasadocs.invalid = 0 AND kasadocs.docref <> ''"
	m = Message()
	m.message = cm_RELOAD
	self.plist.Update(m)
	self.addWidget(self.plist)
	pflush()	
	ss = 0
	for i in range(len(self.plist.items)):
	    ss = ss + float(self.plist.items[i][2].Label)
	self.writexy(26, 11, "    :     ", COL_WARN)
	self.writexy(2, 11, "F10 -  F5 - ", COL_WARN)
	self.writexy(42, 11, rjust(fix(ss, 2), 10), COL_WARN)
	self.AddHotKey(curses.KEY_F10, 0)
	self.select(0)
	
    def UserFn(self, command, args):	
	if command == ev_ACTIVATE and args == curses.KEY_F10:
	    self.plist.dbQuery = "SELECT kasadocs.doc_no, kasadocs.purpose, kasadocs.sumdt FROM kasadocs, kasaanalpart WHERE kasadocs.person = \'" + self.person + "\' AND kasaanalpart.name = kasadocs.purpose AND kasadocs.doc_type = 2 AND kasadocs.invalid = 0 AND kasadocs.docref <> ''"
	    m = Message()
	    m.message = cm_RELOAD
	    self.plist.Update(m)
	    ss = 0
	    for i in range(len(self.plist.items)):
		ss = ss + float(self.plist.items[i][2].Label)
	    self.writexy(26, 11, "    :     ", COL_WARN)
	    self.writexy(42, 11, rjust(fix(ss, 2), 10), COL_WARN)
	    self.select(0)
	    return ev_DONE
	    
	if command == ev_OK and args == 0 and len(self.plist.items) > 0:
	    ss = 0
	    for i in range(len(self.plist.items)):
		if self.plist.items[i][0].selection == TRUE:
		    ss = ss + 1
	    if ss == 0:
		msgbox = MessageBox(28, 9, 7, 26, COL_TAB, COL_TAB, \
		                        ["   ?"], "?", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.select(0)
		return ev_NONE
		
	    msgbox = MessageBox(28, 9, 7, 26, COL_TAB, COL_TAB, \
		                        ["   ?"], "?", msg_YESNO)
	    yes = msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()
	    if yes == cmd_CANCEL:
		self.select(0)
		return ev_NONE
	    else:
		return ev_DONE
	
	
    
if __name__ == '__main__':
    def RunProgram(stdscreen):
	app = Store(stdscreen)
	
	
    str = curses.wrapper(RunProgram)
    print str	
    
