#!/usr/bin/env python

import os
from  defs import *
import curses
from curses import panel
import ui
from ui import *
from  MySQLdb import *
from time import gmtime, strftime, sleep

def get_user():
    import pwd
    return pwd.getpwuid(os.getuid())[4]

class Store:
    def __init__ (self, win):
	self.user = get_user()
	self.set_colors()
	self.win = win
	self.DrawUI()
	self.mainloop()
	
    def DrawUI(self):
	self.main_panel = Panel(0, 0,
		 curses.LINES, curses.COLS, COL_MAIN)
	self.main_panel.drawbox()
	self.main_panel.set_caption(" COMPANY xx ")
	self.main_panel.writexy(38, 1,
	         "        - ", COL_TITLE, TRUE)
	self.main_panel.hline(1, 3, 37, COL_MAIN)
	self.main_panel.writexy(3, 2, ":", COL_MAIN)
	self.main_panel.writexy(3, 3, str(self.user), COL_MAIN)
#	+ "    :", COL_MAIN)

	self.DrawLOGO()
	
	self.menu = MenuBar(4, 21, 2, 73, COL_TEXT)

	self.menu.loadMenu('offers.mnu')
	curses.curs_set(0)
	pflush()
	
    def DrawLOGO(self):
	self.main_panel.drawrect(4, 3, 75, 16, COL_TAB)
	self.main_panel.hline(5, 4, 51, COL_TAB)
	self.main_panel.win.addch(5, 55, curses.ACS_URCORNER)
	self.main_panel.hline(6, 4, 54, COL_TAB)

	self.main_panel.vline(6, 55, 14, COL_TAB)
	self.main_panel.vline(5, 57, 15, COL_TAB)	
	self.main_panel.vline(5, 53, 15, COL_TAB)		
	
	titlestr = "COMPANY xx"
	for i in range(6, 16):
	    self.main_panel.writexy(60, i, titlestr[i-6], COL_MAIN)
	self.main_panel.writexy(72, 18, ":", COL_MAIN)
	self.main_panel.writexy(60, 19, " ", COL_MAIN)
	self.main_panel.writexy(5, 20, "Linux OS", COL_MAIN)
	
	
    def set_colors(self):
	if curses.can_change_color() == 1:
	    curses.init_color(5, 800, 800, 800)
	curses.init_pair(1, curses.COLOR_BLUE, curses.COLOR_WHITE)
	curses.init_pair(2, curses.COLOR_WHITE, curses.COLOR_BLUE)
	curses.init_pair(3, curses.COLOR_WHITE, curses.COLOR_RED)
	curses.init_pair(4, curses.COLOR_WHITE, curses.COLOR_BLACK)
	curses.init_pair(5, curses.COLOR_BLACK, curses.COLOR_WHITE)
	curses.init_pair(6, curses.COLOR_RED, curses.COLOR_WHITE)
	curses.init_pair(7, curses.COLOR_BLUE, curses.COLOR_BLACK)
	curses.init_pair(8, curses.COLOR_MAGENTA, curses.COLOR_WHITE)

	
    def mainloop(self):
	while 1:
	    cmd = self.menu.mainLoop()
	    if cmd == "cmd_exit": break
	    if cmd == "cmd_add_article_offer":
		(offer_no, offer_name) = self.SelectOffer()
		adddlg = addArticle2Offer(offer_no, offer_name)
		adddlg.mainLoop()
		adddlg.destroy()
		del adddlg
		pflush()
	    elif cmd == "cmd_edit_offer":
		(offer_no, offer_name) = self.SelectOffer()
		offersdlg = Offer(offer_no, offer_name)
		offersdlg.mainLoop()
		offersdlg.destroy()
		del offersdlg
		pflush()
	    elif cmd == "cmd_edit_article":
		selartdlg = EditArticle()
		selartdlg.mainLoop()
		selartdlg.destroy()
		del selartdlg
		pflush()
		

    def getDoc_counter(self, doc_no = None, doc_name = ""):
	if doc_no <> None:
	    query = " WHERE doc_no = " + str(doc_no)
	    if doc_name <> "":
		query = query + " AND doc_name = " + doc_name
	else:
	    query = " WHERE doc_name = " + doc_name
	db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	curs = db.cursor()
	curs.execute("UPDATE LOW_PRIORITY documents SET counter=counter+1" + query)
	curs.execute("SELECT CONCAT(counter, '') from documents" + query)
	(counter, ) = curs.fetchone()
	db.commit()
	db.close()
	return counter
	
		
    def SelectCustomer(self):
	custdlg = CustomerDialog()
	(dan_no, city, customer_name) = custdlg.mainLoop()
	custdlg.destroy()
	del custdlg
	return strip(customer_name) + " - " + strip(city)
    
    def SelectOffer(self):
	offerdlg = SelectOfferDialog()
	(offer_no, offer_name) = offerdlg.mainLoop()
	offerdlg.destroy()
	del offerdlg
	return (offer_no, offer_name)

    
class CustomerDialog(Dialog):
    def __init__(self):
	Dialog.__init__(self, 5, 6, 13,  71, COL_MAIN)
	self.addWidget(Label(self, 2, 1, " ", COL_MAIN))
	    
	self.cl = MultiListBox(self, 2, 2, 9, 67, COL_TEXT)
	self.cl.MultipleChoice(FALSE)
	self.cl.setItemColors(COL_TITLE, COL_TEXT)
	self.cl.addColon(13, ". ")
	self.cl.addColon(21," ")
	self.cl.addColon(33, "")
	self.cl.dbQuery = "SELECT dan_no, city, sname from partners"
        m = Message()
	m.message = cm_RELOAD
	self.cl.Update(m)
	self.addWidget(self.cl)
	
    def mainLoop(self):
	Dialog.mainLoop(self)
	dan_no = self.cl.items[self.cl.hilite][0].Label
	city = self.cl.items[self.cl.hilite][1].Label
	cust_name = self.cl.items[self.cl.hilite][2].Label
	return (dan_no, city, cust_name)


    def UserFn(self, command, args = None):
	if command == cm_QUICK_SEARCH:
	    searchdlg = Dialog(36, 10, 10, 40, COL_MAIN)
	    searchdlg.set_caption(" ")
	    searchdlg.addWidget(Label(searchdlg, 2, 2, " :", COL_TEXT1))
	    cust_name = EditLine(searchdlg, 15, 2, 23, COL_TEXT, COL_TITLE)
	    searchdlg.addWidget(cust_name)
	    searchdlg.addWidget(Label(searchdlg, 2, 4, ". :", COL_TEXT1))
	    dan_no = EditLine(searchdlg, 15, 4, 10, COL_TEXT, COL_TITLE)
	    searchdlg.addWidget(dan_no)

	    searchdlg.addWidget(Label(searchdlg, 2, 6, ":", COL_TEXT1))
	    bulst = EditLine(searchdlg, 15, 6, 10, COL_TEXT, COL_TITLE)
	    searchdlg.addWidget(bulst)
	    
	    searchdlg.addWidget(Label(searchdlg, 2, 8, ". :", COL_TEXT1))
	    city = EditLine(searchdlg, 15, 8, 23, COL_TEXT, COL_TITLE)
	    searchdlg.addWidget(city)
	    
	    searchdlg.select(1)
	    
	    searchdlg.mainLoop()
	    
	    scust_name = cust_name.text
	    sdan_no = dan_no.text
	    sbulst = bulst.text
	    scity = city.text
	    
	    p1 = p2 = p3 = p4 = 0
	    if len(scust_name) <> 0 or len(sdan_no) <> 0 or \
	       len(sbulst) <> 0 or len(scity) <> 0:
		query = " WHERE"
		if len(scust_name) <> 0:
		    query = query + " sname RLIKE \'^" + scust_name + "\'"
		    p1 = 1
		if len(sdan_no) <> 0:
		    if p1 == 0:
			query = query + " dan_no RLIKE \'^" + sdan_no + "\'"
		    else:
			query = query + " AND dan_no RLIKE \'^" + sdan_no + "\'"
		    p2 = 1
		if len(sbulst) <> 0:
		    if p2 == 0 and p1 == 0:
			query = query + " buslt RLIKE \'^" + sbulst + "\'"
		    else:
			query = query + " AND buslt RLIKE \'^" + sbulst + "\'"
		    p3 = 1
		if len(scity) <> 0:
		    if p3 == 0 and p2 == 0 and p1 == 0:
			query = query + " city RLIKE \'^" + scity + "\'"
		    else:
			query = query + " AND city RLIKE \'^" + scity + "\'"
		    p4 = 1
		    
		
		m = Message()
		m.message = cm_RELOAD
		m.args = [" ", query, ""]
		success = self.cl.Update(m)
		if success == 0:
		    msgbox = MessageBox(28, 9, 6, 20, COL_TAB, COL_WARN, \
		                        [" ", "", "< Ok >"], "")
		    msgbox.mainLoop()
		    del msgbox
		    m.args = []
		    self.cl.Update(m)
		
		#self.writexy(1, 0, self.cl.dbQuery + query, COL_WARN)
	    
	    
	    searchdlg.destroy()
	    del searchdlg
	    pflush()
	    curses.curs_set(0)
	return ev_DONE
	

class SelectOfferDialog(Dialog):
    def __init__(self):
	Dialog.__init__(self, 45, 7, 13,  30, COL_MAIN)
	self.addWidget(Label(self, 2, 1, " ", COL_MAIN))
	    
	self.ol = MultiListBox(self, 2, 2, 9, 25, COL_TEXT)
	self.ol.MultipleChoice(FALSE)
	self.ol.setItemColors(COL_TITLE, COL_TEXT)
	self.ol.addColon(3, "")
	self.ol.addColon(21,"")
	self.ol.dbQuery = "SELECT offer_no, name from offers_names"
        m = Message()
	m.message = cm_RELOAD
	self.ol.Update(m)
	self.addWidget(self.ol)
	
    def mainLoop(self):
	Dialog.mainLoop(self)
	offer_no = self.ol.items[self.ol.hilite][0].Label
	offer_name = self.ol.items[self.ol.hilite][1].Label
	return (offer_no, offer_name)

    
class RequestDialog(Dialog):
    def __init__(self, customer_name, counter):
	ts = strftime("%d/%m/%y", gmtime())
	Dialog.__init__(self, 0, 0, 24,  79, COL_MAIN)
	self.set_caption("  - ")
	#0
	self.addWidget(Label(self, 3, 1, " :", COL_TEXT1))
	self.objectBox = DropDnBox(self, 16, 1, 18, 6, COL_TEXT1)
	#1
	self.addWidget(self.objectBox)
	#2
	self.addWidget(Label(self, 3, 2, ". :", COL_TEXT1))
	#3
	self.addWidget(Label(self, 62, 2, ".", COL_TEXT1))
	#4
	self.addWidget(Label(self, 46, 1, "", COL_TEXT1))
	self.set_color(COL_MAIN)
	self.win.hline(3, 1, curses.ACS_BSSB, 78, 5)
	self.win.hline(13, 1, curses.ACS_BSSB, 78, 5)	
	#5
	self.addWidget(Label(self, 52, 1, ts, COL_TEXT))
	#6
	self.addWidget(Label(self, 62, 1, ".", COL_TEXT1))
	self.edate = DateLine(self, 70, 1, COL_TEXT, COL_TITLE)
	self.edate.SetText(ts)
	#7
	self.addWidget(self.edate)
	
	#8
	self.addWidget(Label(self, 2, 14, "/", COL_TEXT1))
	self.arttxt = EditLine(self, 2, 15, 23, COL_TEXT, COL_TITLE)
	#9
	self.addWidget(Label(self, 27, 14, ".", COL_TEXT1))	
	self.single = EditLine(self, 27,  15, 7, COL_TEXT, COL_TITLE)	
	self.single.setType(dt_numeric)
	#10
	self.addWidget(Label(self, 66, 14, ".", COL_TEXT1))
	self.artweight = EditLine(self, 66,  15, 4, COL_TEXT, COL_TITLE)
	self.artweight.Focusable = FALSE
	#11
	self.addWidget(Label(self, 45, 14, "", COL_TEXT1))
	self.totalweight = EditLine(self, 45,  15, 9, COL_TEXT, COL_TITLE)
	#12
	self.addWidget(Label(self, 72, 14, "/", COL_TEXT1))	
	self.artpack = EditLine(self, 72,  15, 5,  COL_TEXT, COL_TITLE)	
	self.artpack.Focusable = FALSE
	#13
	self.addWidget(Label(self, 36, 14, ".", COL_TEXT1))	
	self.totalpack = EditLine(self, 36,  15, 7, COL_TEXT, COL_TITLE)	

	#14	
	self.addWidget(Label(self, 56, 14, ".", COL_TEXT1))	
	self.artprice = EditLine(self, 56,  15, 8, COL_TEXT, COL_TITLE)	
	#15
	self.addWidget(self.arttxt)
	#16
	self.addWidget(self.single)
	#17
	self.addWidget(self.totalpack)
	#18
	self.addWidget(self.totalweight)	
	#19
	self.addWidget(self.artprice)	
	#20
	self.addWidget(self.artweight)
	#21
	self.addWidget(self.artpack)	
	
	self.artlist = MultiListBox(self, 2, 17, 6, 75, COL_TEXT)
	self.artlist.MultipleChoice(TRUE)
	self.artlist.setItemColors(COL_TITLE, COL_TEXT)
	self.artlist.Focusable = TRUE
	self.artlist.dbQuery = "SELECT CONCAT(group_no, art_no), name, qty_id, weight, pack1 FROM articles WHERE name RLIKE \'^"
	self.artlist.addColon(9, ".")
	self.artlist.addColon(32, "")
	self.artlist.addColon(6, "/")
	self.artlist.addColon(6, ".")
	self.artlist.addColon(6, ".")	
	self.artlist.Update()
	#22
	self.addWidget(self.artlist)
	
	self.reqlist = MultiListBox(self, 2, 4, 7, 75, COL_TEXT)
	self.reqlist.MultipleChoice(TRUE)
	self.reqlist.setItemColors(COL_TITLE, COL_TEXT)
	self.reqlist.Focusable = FALSE
	self.reqlist.addColon(9, ".")
	self.reqlist.addColon(32, "")
	self.reqlist.addColon(6, "/")
	self.reqlist.addColon(10, "")
	self.reqlist.addColon(6, ".")	
	self.reqlist.Update()
	#23
	self.addWidget(self.reqlist)
	#24
	self.addWidget(Label(self, 19, 2, customer_name, COL_MAIN))
	self.addWidget(Label(self, 70, 2, counter, COL_TEXT1))
	
	self.arttxt.addNotifyRecipient(self.artlist, cm_RELOAD, "\'")	
	self.artlist.addNotifyRecipient(self.artweight, cm_UPDATE, 3)
	self.artlist.addNotifyRecipient(self.artpack, cm_UPDATE, 4)
#	self.artlist.addNotifyRecipient(self.arttxt, cm_UPDATE, 0)
	
#	self.artweight.addNotifyRecipient(self.artlist, cm_LOCATE, 2)
#	self.artpack.addNotifyRecipient(self.artlist, cm_LOCATE, 3)

	
	
	self.AddHotKey(curses.KEY_F4, 1)
	self.AddHotKey(curses.KEY_F1, 15)
	self.AddHotKey(curses.KEY_F8, 15)
	self.writexy(2, 24, "| F1 -  ", COL_TITLE, bold = TRUE)
	self.writexy(17, 24, "| F2 -  |", COL_TITLE, bold=TRUE)
	self.writexy(31, 24, " F8 -  |", COL_TITLE, bold=TRUE)	
	self.writexy(45, 24, " F6 - . |", COL_TITLE, bold=TRUE)	
	self.writexy(60, 24, " F4 -  |", COL_TITLE, bold=TRUE)		
	
	self.select(7)

    def getPrices(self, gr_no, art_no, tpack, tweight):
	return 0

    
    def UserFn(self, command, args = None):
	if command == ev_OK:
	    if args == 22:
		self.select(16)
		return ev_NONE
	    if args == 18 and self.totalweight.text <> "":
#	    if args == 18 and len(self.totalweight.text) > 0:
		weight = float(self.artweight.text)
		if weight == 0: weight = 1
		pack = int(self.artpack.text)
		if pack == 0: pack = 1
		totalweight = float(self.totalweight.text)
		totalpack = round((totalweight / weight) / pack)
		self.totalpack.SetText(str(totalpack))
		totalweight = totalpack * pack * weight
		self.totalweight.SetText(str(totalweight))
		price = self.getPrices(1, 1, totalpack, totalweight)
		self.artprice.SetText(str(price))
		self.nextWidget()
		return ev_NONE
	    if args == 17 and self.totalpack.text <> "":
		totalpack = float(self.totalpack.text)
		pack = int(self.artpack.text)
		weight = float(self.artweight.text)
		totalweight = str(totalpack * pack * weight)
		self.totalweight.SetText(totalweight)
	    if args == 23:
		self.select(18)
		return ev_NONE
	    if args == 15:
		if self.artlist.hilite == -1:
		    msgbox = MessageBox(28, 9, 6, 20, COL_TAB, COL_WARN, \
		                        [" ", "", "< Ok >"], "")
		    msgbox.mainLoop()
		    del msgbox
		    self.select(15)
		    return ev_NONE
		else:
		    self.totalpack.SetText("")
		    self.totalweight.SetText("")
		    self.select(22)
		    return ev_NONE
	    else:
		self.nextWidget()
		return ev_NONE
	if command == ev_FAIL:
	    if args == 20:
		self.select(14)
		return ev_NONE
	if command == ev_ACTIVATE and args == curses.KEY_F8:
	    itno = self.artlist.hilite
	    if itno < 0: return 
	    artcode = self.artlist.items[itno][0].Label
	    art_name = self.artlist.items[itno][1].Label
	    wid = self.artlist.items[itno][2].Label
	    tw = self.totalweight.text
	    tp = self.totalpack.text
	    self.reqlist.addItem([artcode, art_name, wid, tw, tp])
	    self.reqlist.draw()
	elif command == ev_ACTIVATE:
	    return ev_DONE
	    

class addArticle2Offer(Dialog):
    def __init__(self, offer_no, offer_name):
	self.offer_no = offer_no
	self.offer_name = offer_name
	self.listwindow = TRUE
	
	Dialog.__init__(self, 0, 0, 24,  79, COL_MAIN)
	self.set_caption("   -   ")
	#0
	self.addWidget(Label(self, 3, 1, "/:", COL_TEXT1))
#	self.arttxt = EditLine(self, 3, 2, 30, COL_TEXT, COL_TITLE)
#	self.addWidget(self.arttxt)
	
	self.artlist = MultiListBox(self, 3, 2, 9, 41, COL_TEXT)
	self.artlist.MultipleChoice(TRUE)
	self.artlist.setItemColors(COL_TITLE, COL_TEXT)
	self.artlist.Focusable = TRUE
	self.artlist.dbQuery = "SELECT CONCAT(group_no, art_no), name FROM articles" # WHERE name RLIKE \'^"
	self.artlist.addColon(9, ".")
	self.artlist.addColon(32, "")
	m = Message()
	m.message = cm_RELOAD
	self.artlist.Update(m)
	#1
	self.addWidget(self.artlist)
	#2
	self.addWidget(Label(self, 3, 12, " ", COL_TEXT1))
	
	self.oferartlist = MultiListBox(self, 3, 13, 9, 41, COL_TEXT)
	self.oferartlist.setItemColors(COL_TITLE, COL_TEXT)
	self.oferartlist.Focusable = TRUE
	self.oferartlist.addColon(9, ".")
	self.oferartlist.addColon(32, "")
	self.oferartlist.dbQuery = "SELECT CONCAT(offers.group_no, offers.art_no), articles.name AS name FROM offers, articles WHERE articles.group_no = offers.group_no AND articles.art_no = offers.art_no"
	m = Message()
	m.message = cm_RELOAD
	self.oferartlist.Update(m)
	#3
	self.addWidget(self.oferartlist)
	#4
	self.addWidget(Label(self, 53, 1, " / ", COL_TEXT1))
	#5
	self.status_name = EditLine(self, 47, 2, 30, COL_TEXT, COL_TITLE)
	self.status_name.Focusable = FALSE
	self.status_name.SetText(strip(self.artlist.items[0][1].Label))
	self.addWidget(self.status_name)
	#6
	self.status_info = EditLine(self, 47, 3, 30, COL_TEXT, COL_TITLE)
	self.status_info.Focusable = FALSE
	self.addWidget(self.status_info)
	
	#7
	self.addWidget(Label(self, 53, 12, ":", COL_TEXT1))
	#8
	self.offername = EditLine(self, 47, 13, 30, COL_TEXT, COL_TITLE)
	self.offername.Focusable = FALSE
	self.offername.SetText(self.offer_name)
	
	self.addWidget(self.offername)	

	self.artlist.addNotifyRecipient(self.status_name, cm_UPDATE, 1)
	self.artlist.addNotifyRecipient(self, cm_ITEM_CHANGED, 0)
	
	self.AddHotKey(curses.KEY_F2, 3)
	self.AddHotKey(curses.KEY_F1, 1)
	self.writexy(38, 1, ".-F1", COL_TEXT1)
	self.writexy(38, 12,".-F2", COL_TEXT1)
	self.writexy(69, 23, "", COL_WARN)
	
	self.select(1)

    def FindArticle(self, group_no, art_no, offer_no):
	db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	c = db.cursor()
	c.execute("""SELECT group_no, art_no FROM offers
			       WHERE offer_no = %s and
				     group_no = %s and
				     art_no = %s""", (offer_no, group_no, art_no))
	recs = c.fetchall()
	db.close()
	if len(recs) > 0:
	    return TRUE
	else:
	    return FALSE
	
    def Update(self, msg):
	if msg.message == cm_ITEM_CHANGED:
	    it = msg.args[1]
	    group_no = it.Label[0:3]
	    art_no = it.Label[3:6]
	    if self.FindArticle(group_no, art_no, self.offer_no) == TRUE:
		self.status_info.SetText(" ")
	    else:
		self.status_info.SetText("  ")
	    

    def addArticles(self):
	multi_selection = FALSE
	for i in range(len(self.artlist.items)):
	    it = self.artlist.items[i][0]
	    if it.selection == TRUE:
		multi_selection = TRUE
		break
	if multi_selection == FALSE:
	    it = self.artlist.items[self.artlist.hilite]
	    grno = it[0].Label[0:3]
	    artno = it[0].Label[3:6]
	    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	    c = db.cursor()
	    exists = c.execute("""SELECT group_no, art_no FROM offers WHERE offer_no = %s AND group_no = %s AND art_no = %s""",
	                          (self.offer_no, grno, artno))
	    if exists == 0:
		c.execute("""INSERT INTO offers (offer_no, group_no, art_no) VALUES (%s, %s, %s)""",
		           (self.offer_no, grno, artno))
	    else:
		msgbox = MessageBox(28, 9, 6, 20, COL_TAB, COL_WARN, \
		                        [" "], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox		
		
	    db.close()
	    self.status_info.SetText(" ")
	    m = Message()
	    m.message = cm_RELOAD
	    self.oferartlist.Update(m)
		
	    
    def UserFn(self, command, args = None):
	if command == ev_OK:
	    if args == 1:
		self.addArticles()
		return ev_NONE
	if command == ev_ACTIVATE and args == curses.KEY_F1:
	    self.writexy(69, 23, "", COL_WARN)
	    curses.beep()
	    return ev_NONE
	elif command == ev_ACTIVATE and args == curses.KEY_F2:
	    self.writexy(69, 23, "  ", COL_WARN)
	    curses.beep()
	    return ev_NONE
	if command == cm_QUICK_SEARCH:
	    if args <> None:
		if args == 1:
		    vpos = 0
		elif args == 3:
		    vpos = 11
	    searchdlg = Dialog(15, 8 + vpos, 4, 40, COL_MAIN)
	    searchdlg.set_caption(" ")
	    searchdlg.addWidget(Label(searchdlg, 2, 2, "/:", COL_TEXT1))
	    art_name = EditLine(searchdlg, 15, 2, 23, COL_TEXT, COL_TITLE)
	    searchdlg.addWidget(art_name)
	    searchdlg.select(1)
	    searchdlg.mainLoop()
	    name = art_name.text
	    query = " WHERE name RLIKE \'^" + name + "\'"
	    
	    m = Message()
	    m.message = cm_RELOAD
	    m.args = [" ", query, ""]
	    if args == 1:
		success = self.artlist.Update(m)
	    elif args == 3:
		success = self.oferartlist.Update(m)
	    if success == 0:
		msgbox = MessageBox(28, 9, 6, 20, COL_TAB, COL_WARN, \
		                        [" ", "", "< Ok >"], "")
		msgbox.mainLoop()
		del msgbox
		m.args = []
		if args == 1:
		    self.artlist.Update(m)
		elif args == 3:
		    self.oferartlist.Update(m)
		
	    searchdlg.destroy()
	    del searchdlg
	    pflush()
	    curses.curs_set(0)
	return ev_DONE	
	
class EditArticle(Dialog):
    def __init__(self):
	Dialog.__init__(self, 28, 4, 17,  49, COL_MAIN)
	self.set_caption(" ")
	#0
	self.addWidget(Label(self, 3, 1, "/:", COL_TEXT1))
	self.arttxt = EditLine(self, 3, 2, 30, COL_TEXT, COL_TITLE)
	self.addWidget(self.arttxt)
	
	self.artlist = MultiListBox(self, 3, 4, 11, 42, COL_TEXT)
	self.artlist.MultipleChoice(TRUE)
	self.artlist.setItemColors(COL_TITLE, COL_TEXT)
	self.artlist.Focusable = TRUE
	self.artlist.dbQuery = "SELECT CONCAT(group_no, art_no), name FROM articles WHERE name RLIKE \'^"
	self.artlist.addColon(9, ".")
	self.artlist.addColon(32, "")
	self.artlist.Update()
	#2
	self.addWidget(self.artlist)

	self.arttxt.addNotifyRecipient(self.artlist, cm_RELOAD, "\'")		
	
	self.select(1)

    def UserFn(self, command, args = None):
	if command == ev_OK:
	    if args == 1:
		self.select(2)
		return ev_NONE
	    elif args == 2:
		self.PopupArticleData("001222")
	

    def PopupArticleData(self, artcode):
	group_no = artcode[0:3]
	art_no = artcode[3:6]
	art_data_dlg = ShowArticleData(group_no, art_no)
	art_data_dlg.mainLoop()
	art_data_dlg.destroy()
	del art_data_dlg
	pflush()
	
	
	
class ShowArticleData(Dialog):
    def __init__(self, grno, artno):
	self.group_no = grno
	self.art_no = artno
	self.getArticleData()
	Dialog.__init__(self, 0, 0, 24,  79, COL_MAIN)
	self.set_caption(" - ")
	#0
	self.addWidget(Label(self, 3, 2, ":", COL_TEXT1))
	#1
	self.name = EditLine(self, 11, 2, 30, COL_TEXT, COL_TITLE)
	self.addWidget(self.name)
	
    def getArticleData(self):
	pass
	
	
class Offer(Dialog):	    
    def __init__(self, offer_no, offer_name):
	Dialog.__init__(self, 0, 0, 24,  79, COL_MAIN)
	
	self.offer_no = offer_no
	self.offer_name = offer_name
	self.group_no = 0
	self.art_no = 0
	self.offer_no = 0
	
	self.set_caption("   - ")
	self.writexy(3, 21, "< F2 -  >", COL_TITLE, bold = TRUE)
	self.writexy(19, 21, "< F4 -  >", COL_TITLE, bold = TRUE)	
	self.writexy(36, 21, "< F8 -  >", COL_TITLE, bold = TRUE)	
	
	#0
	self.addWidget(Label(self, 3, 2, ":", COL_TEXT1))
	self.offerstr = EditLine(self, 19, 2, 32, COL_TEXT, COL_TITLE)
	self.offerstr.SetText(self.offer_name)
	self.offerstr.Focusable = FALSE
	#1
	self.addWidget(self.offerstr)
	#2
	self.addWidget(Label(self, 50, 5, " ....   .....  ", COL_MAIN))
	self.addWidget(Label(self, 50, 6, "min          max       ", COL_TITLE))	
	self.price1lo = EditLine(self, 50, 7, 10, COL_TEXT, COL_TITLE)	
	self.price1hi = EditLine(self, 63, 7, 10, COL_TEXT, COL_TITLE)
	#4
	self.addWidget(self.price1lo)
	self.addWidget(self.price1hi)
	#6
	self.addWidget(Label(self, 50, 8, " ....   .....  ", COL_MAIN))
	self.addWidget(Label(self, 50, 9, "min          max       ", COL_TITLE))		
	self.price2lo = EditLine(self, 50, 10, 10, COL_TEXT, COL_TITLE)	
	self.price2hi = EditLine(self, 63, 10, 10, COL_TEXT, COL_TITLE)
	#8
	self.addWidget(self.price2lo)
	self.addWidget(self.price2hi)
	#10
	self.addWidget(Label(self, 50, 11, " ....   .....  ", COL_MAIN))	
	self.addWidget(Label(self, 50, 12, "min          max       ", COL_TITLE))		
	self.price3lo = EditLine(self, 50, 13, 10, COL_TEXT, COL_TITLE)	
	self.price3hi = EditLine(self, 63, 13, 10, COL_TEXT, COL_TITLE)
	#12
	self.addWidget(self.price3lo)
	self.addWidget(self.price3hi)
	#14
	self.addWidget(Label(self, 50, 14, " ....   .....  ", COL_MAIN))	
	self.addWidget(Label(self, 50, 15, "min          max       ", COL_TITLE))		
	self.price4lo = EditLine(self, 50, 16, 10, COL_TEXT, COL_TITLE)	
	self.price4hi = EditLine(self, 63, 16, 10, COL_TEXT, COL_TITLE)
	#16
	self.addWidget(self.price4lo)
	self.addWidget(self.price4hi)
	#18
	self.addWidget(Label(self, 50, 17, " ....   .....  ", COL_MAIN))	
	self.addWidget(Label(self, 50, 18, "min          max       ", COL_TITLE))		
	self.price5lo = EditLine(self, 50, 19, 10, COL_TEXT, COL_TITLE)	
	self.price5hi = EditLine(self, 63, 19, 10, COL_TEXT, COL_TITLE)
	#20
	self.addWidget(self.price5lo)
	self.addWidget(self.price5hi)
	#22
	self.addWidget(Label(self, 3, 3, "/:", COL_TEXT1))
	self.arttxt = EditLine(self, 3, 4, 30, COL_TEXT, COL_TITLE)
	#23
	self.addWidget(self.arttxt)
	
	self.artlist = MultiListBox(self, 3, 6, 13, 42, COL_TEXT)
	self.artlist.MultipleChoice(TRUE)
	self.artlist.setItemColors(COL_TITLE, COL_TEXT)
	self.artlist.Focusable = TRUE
	self.artlist.dbQuery = "SELECT CONCAT(offers.group_no, offers.art_no), articles.name FROM offers, articles WHERE offers.group_no = articles.group_no AND offers.art_no = articles.art_no AND articles.name RLIKE \'^"
	self.artlist.addColon(9, ".")
	self.artlist.addColon(32, "")

	self.artlist.Update()
	
	#24
	self.addWidget(self.artlist)
	self.artlist.addNotifyRecipient(self, cm_ITEM_CHANGED, 0)	

	self.arttxt.addNotifyRecipient(self.artlist, cm_RELOAD, "\' ORDER BY articles.name")		
	
	
	self.AddHotKey(curses.KEY_F2, 23)
	self.select(23)

    def Update(self, msg):
	if msg.message == cm_ITEM_CHANGED:
	    it = msg.args[1]
	    self.group_no = it.Label[0:3]
	    self.art_no = it.Label[3:6]
	    [p11, p12, p21, p22, p31, p32, p41, p42, p51, p52] = self.getOfferPrice(1, self.group_no, self.art_no)
	    self.price1lo.SetText(str(p11))
	    self.price1hi.SetText(str(p12))
    
	    self.price2lo.SetText(str(p21))
	    self.price2hi.SetText(str(p22))
    
	    self.price3lo.SetText(str(p31))
	    self.price3hi.SetText(str(p32))

	    self.price4lo.SetText(str(p41))
	    self.price4hi.SetText(str(p42))
	    
	    self.price5lo.SetText(str(p51))
	    self.price5hi.SetText(str(p52))
	    


    def getOfferPrice(self, customer, gr_no, art_no, region = None):
	db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	curs = db.cursor()
	rows = curs.execute("""SELECT price1lo, price1hi, price2lo, price2hi, price3lo, price3hi, price4lo, price4hi, price5lo, price5hi FROM offers WHERE offer_no = 1 AND group_no = %s AND art_no = %s""", (gr_no, art_no))
	if rows > 0: 
	    (p11, p12, p21, p22, p31, p32, p41, p42, p51, p52) = \
	    curs.fetchone()
	else:
	    p11 = "--"
	    p12 = "--"
	    p21 = "--"
	    p22 = "--"
	    p31 = "--"
	    p32 = "--"
	    p41 = "--"
	    p42 = "--"
	    p51 = "--"
	    p52 = "--"
	    
	db.close()
	
	return [p11, p12, p21, p22, p31, p32, p41, p42, p51, p52]
	    

    def UpdateOffer(self, no, gr_no, art_no, \
                    p11, p12, p21, p22, p31, p32, p41, p42, p51, p52):
    	db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	curs = db.cursor()
	curs.execute("""UPDATE LOW_PRIORITY offers SET
	                       price1lo = %s, price1hi = %s,
			       price2lo = %s, price2hi = %s,
			       price3lo = %s, price3hi = %s,
			       price4lo = %s, price4hi = %s,
			       price5lo = %s, price5hi = %s
			       WHERE offer_no = 1 and
				     group_no = %s and
				     art_no = %s """,
			      (p11, p12, p21, p22,
			       p31, p32, p41, p42, p51, p52,
			       gr_no, art_no))
	db.close()

    
    
	
    def UserFn(self, command, args = None):
	if command == ev_OK:
	    if args == 23:
		self.select(24)
		return ev_NONE
	    if args == 24:
		self.select(4)
		return ev_NONE
	    if args >= 4 or args <= 21:
		self.nextWidget()
		return ev_NONE
	if command == ev_ACTIVATE and args == curses.KEY_F2:
	    self.writexy(74, 23, "", COL_WARN, bold=TRUE)
	    p11 = float(self.price1lo.text)
	    p12 = float(self.price1hi.text)
	    p21 = float(self.price2lo.text)
	    p22 = float(self.price2hi.text)
	    p31 = float(self.price3lo.text)
	    p32 = float(self.price3hi.text)
	    p41 = float(self.price4lo.text)
	    p42 = float(self.price4hi.text)
	    p51 = float(self.price5lo.text)
	    p52 = float(self.price5hi.text)
	    self.UpdateOffer(1, self.group_no, self.art_no,
	            p11, p12, p21, p22, p31, p32, p41, p42, p51, p52)
	    self.writexy(74, 23, "     ", COL_MAIN)
	    
	    
	    
if __name__ == '__main__':
    def RunProgram(stdscreen):
	app = Store(stdscreen)
	
	
    str = curses.wrapper(RunProgram)
    print str	
    
