#!/usr/bin/env python

import sys, os, re, fpformat
from  defs import *
import curses
from curses import panel
import ui
from ui import *
from  MySQLdb import *
from time import gmtime, strftime, asctime, localtime
import threading

def get_user():
    import pwd
    return pwd.getpwuid(os.getuid())[4]

class CheckAccess(threading.Thread):
    def __init__(self, scr, shift, warning=TRUE):
	threading.Thread.__init__(self)
	self.iswarn = warning
	self._finished = threading.Event()
	self._interval = 55
	self.Screen = scr
	self.shift = shift
	self.s11 = "05:00"
	self.s12 = "05:10"
	self.s21 = "14:00"
	self.s22 = "14:10"
	self.s31 = "22:00"
	self.s32 = "22:10"
	
    def setInterval(self, interval):
	self._interval = interval
	
    def shutdown(self):
	self._finished.set()
	
    def run(self):
	while 1:
	    if self._finished.isSet():
		return
	    if self.iswarn == FALSE:
		self.task1()
	    else:
		self.task2()
	    self._finished.wait(self._interval)
    
    def task1(self):
	t = asctime()[11:16]
	if t == self.s12:
	    self.Screen.Shift(1)
	elif t == self.s22:
	    self.Screen.Shift(2)
	elif t == self.s32:
	    self.Screen.Shift(3)
	    
    def task2(self):
	t = asctime()[11:16]
	if t == self.s11:
	    self.Screen.Warn(1)
	elif t == self.s21:
	    self.Screen.Warn(2)
	elif t == self.s31:
	    self.Screen.Warn(3)

class Store:
    def __init__ (self, win, shift, counter):
	self.user = get_user()
	self.set_colors()
	self.win = win
	self.shift = shift
	self.shift_indx = counter

	self.SCREEN_LOCKED = FALSE
	self.QUIT_STATUS = FALSE
	self.ScreenLock = threading.Lock()
	self.warn_handler = CheckAccess(self, self.shift)
	self.warn_handler.setInterval(30)
	self.warn_handler.start()
	
	self.quit_handler = CheckAccess(self, self.shift, warning=FALSE)
	self.quit_handler.setInterval(30)
	self.quit_handler.start()
	
	self.DrawUI()
	#try:
	self.mainloop()	
	#except:
	curses.endwin()
	sys.stderr.write(" .     !\n")
	#    for i in range(1000000):
	#	pass
	self.warn_handler.shutdown()
	self.quit_handler.shutdown()	    
	    

    def ScreenLocked(self):
	return self.SCREEN_LOCKED

    def ForceQuit(self, set=0):
	if set==0:
	    return self.QUIT_STATUS
	else:
	    self.QUIT_STATUS = TRUE
	    return self.QUIT_STATUS
	
    
    def Shift(self, _shift):
	self.SCREEN_LOCKED = TRUE
	msgbox = MessageBox(28, 9, 10, 32, COL_TAB, COL_TAB, \
                   ["  ", \
		   "  ", \
		   "   ", 
		   " !", "'ENTER'  ."], \
		   "", msg_OK)
	curses.beep()
	yes = msgbox.mainLoop()
	msgbox.destroy()
	pflush()
	del msgbox
	#self.quit_handler.shutdown()
	self.SCREEN_LOCKED = FALSE
	self.ForceQuit(set=1)
	
    
    def Warn(self, _shift):
	self.ScreenLock.acquire()
	self.SCREEN_LOCKED = TRUE
	
	msgbox = MessageBox(28, 9, 10, 32, COL_TAB, COL_TAB, \
                   [" 10 . ", \
		   "  ", \
		   " !",
		   "'ENTER'  ."], \
		   "", msg_OK)
	curses.beep()
	pflush()
	yes = msgbox.mainLoop()
	msgbox.destroy()
	pflush()
	del msgbox
	self.ScreenLock.release()
	self.SCREEN_LOCKED = FALSE
	curses.curs_set(1)
	
	
    def DrawUI(self):
	self.main_panel = Panel(0, 0,
		 curses.LINES, curses.COLS, COL_MAIN)
	self.main_panel.drawbox()
	self.main_panel.set_caption(" COMPANY xx ")
	self.main_panel.writexy(56, 1,
	         "           ", COL_WARN, TRUE)
	self.main_panel.writexy(68, 3, "  : " + str(self.shift) + " ", COL_WARN, TRUE)
	self.main_panel.hline(1, 3, 52, COL_MAIN)
	self.main_panel.writexy(3, 2, ":", COL_MAIN)
	self.main_panel.writexy(3, 3, str(self.user), COL_MAIN)
#	+ "    :", COL_MAIN)

	self.DrawLOGO()
	
	self.menu = MenuBar(4, 21, 2, 73, COL_TEXT)

	self.menu.loadMenu("pr.mnu")
	curses.curs_set(0)
	pflush()
	
    def DrawLOGO(self):
	self.main_panel.drawrect(4, 3, 75, 16, COL_TAB)
	self.main_panel.hline(5, 4, 51, COL_TAB)
	self.main_panel.win.addch(5, 55, curses.ACS_URCORNER)
	self.main_panel.hline(6, 4, 54, COL_TAB)

	self.main_panel.vline(6, 55, 14, COL_TAB)
	self.main_panel.vline(5, 57, 15, COL_TAB)	
	self.main_panel.vline(5, 53, 15, COL_TAB)		
	
	titlestr = "COMPANY XXx"
	for i in range(6, 16):
	    self.main_panel.writexy(60, i, titlestr[i-6], COL_MAIN)
	self.main_panel.writexy(72, 18, ":", COL_MAIN)
	self.main_panel.writexy(60, 19, " ", COL_MAIN)
	self.main_panel.writexy(5, 20, "Linux OS", COL_MAIN)
	
	
    def set_colors(self):
	if curses.can_change_color() == 1:
	    curses.init_color(5, 800, 800, 800)
	curses.init_pair(1, curses.COLOR_BLUE, curses.COLOR_WHITE)
	curses.init_pair(2, curses.COLOR_WHITE, curses.COLOR_BLUE)
	curses.init_pair(3, curses.COLOR_WHITE, curses.COLOR_RED)
	curses.init_pair(4, curses.COLOR_WHITE, curses.COLOR_BLACK)
	curses.init_pair(5, curses.COLOR_BLACK, curses.COLOR_WHITE)
	curses.init_pair(6, curses.COLOR_RED, curses.COLOR_WHITE)
	curses.init_pair(7, curses.COLOR_BLUE, curses.COLOR_BLACK)
	curses.init_pair(8, curses.COLOR_MAGENTA, curses.COLOR_WHITE)

	
    def mainloop(self):
	while 1:
	    if self.ForceQuit() == TRUE:
		self.warn_handler.shutdown()
		self.quit_handler.shutdown()
		break
	    
	    cmd = self.menu.mainLoop()
	    if cmd == "cmd_stop": 
		self.warn_handler.shutdown()
		self.quit_handler.shutdown()
		break
		
	    if cmd == "cmd_vl_mater":
		journal = JournalBook(self, self.shift, self.shift_indx)
		journal.mainLoop()
		journal.destroy()
		del journal
		pflush()

	    if cmd == "cmd_docs_out":
		docsdlg = DocsOut(self, self.shift, self.shift_indx)
		docsdlg.mainLoop()
		docsdlg.destroy()
		del docsdlg
		pflush()
		
	    if cmd == "cmd_receipe":
		receipedlg = NewReceipe(self, self.shift, self.shift_indx)
		receipedlg.mainLoop()
		receipedlg.destroy()
		del receipedlg
		pflush()
		
	    if cmd == "cmd_normi_product":
		normidlg = NormiProduct(self, self.shift, self.shift_indx)
		normidlg.mainLoop()
		normidlg.destroy()
		del normidlg
		pflush()
		
		

	    if cmd == "cmd_plan":
		dd = ShiftIndx(self)
		status = dd.mainLoop()
		
		if status <> ev_FAIL:
		    _shift = int(dd.shift.text)
		    _date = dd.nowday.text
		    _si = _date[6:8] + _date[3:5] + _date[0:2]
		    _shift_indx = int(_si)
		    
		    dd.destroy()
		    del dd
		    pflush()
		    
		    plan = PlanBook(self, _shift, _shift_indx)
		    plan.mainLoop()
		    plan.destroy()
		    del plan
		    pflush()
		else:
		    dd.destroy()
		    del dd
		pflush()
		    
	    if cmd == "cmd_person_book":
		personb = PersonBook(self, self.shift, self.shift_indx)
		personb.mainLoop()
		personb.destroy()
		del personb
		pflush()

def getDoc_counter(doc_no = None, doc_name = "", update = FALSE):
    if doc_no <> None:
	query = " WHERE doc_no = " + str(doc_no)
	if doc_name <> "":
	    query = query + " AND doc_name = " + doc_name
    else:
	query = " WHERE doc_name = " + doc_name
    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
    curs = db.cursor()
    if update == TRUE:
	curs.execute("UPDATE documents SET counter=counter+1" + query)
	curs.execute("SELECT CONCAT(counter, '') from documents" + query)
    else:
	curs.execute("SELECT counter+1 from documents" + query)
    (counter, ) = curs.fetchone()
    db.commit()
    db.close()
    if update == FALSE:
	sn = str(counter)
	cn = ""
	for i in range(len(sn), 10):
	    cn = cn + "0"
	cn = cn + sn
	counter = cn
    return counter		
		
class ShiftIndx(Dialog):
    def __init__(self, parent):
	Dialog.__init__(self, 44, 11, 6, 20, COL_MAIN)
	self.set_caption("  ")
	self.Parent = parent
	self.now = strftime("%d-%m-%y", gmtime())
	
	self.nowday = LabeledDateLine(self, 2, 2, "")
	self.nowday.SetText(self.now)
	self.addWidget(self.nowday)
	
	self.shift = LabeledEditLine(self, 2, 4, 5, "", pos=pos_LEFT)
	self.shift.setType(dt_numeric)
	self.shift.SetText("-")
	self.addWidget(self.shift)
	
	self.select(0)
	
    def UserFn(self, command, args):
	if command == ev_OK and args == 0:
	    self.select(1)
	    return ev_NONE
	if command == ev_OK and args == 1:
	    if self.shift.text <> "-":
		if int(self.shift.text) > 3 or int(self.shift.text) <= 0:
		    msgbox = MessageBox(28, 9, 8, 32, COL_TAB, COL_TAB, \
		                        ["  ", "  ", "  "], "", msg_OK)
		    yes = msgbox.mainLoop()
		    msgbox.destroy()
		    del msgbox
		    pflush()
		    self.shift.SetText("-")
		    self.select(1)
		    return ev_NONE
		else:
		    return ev_DONE
		
class PersonBook(Dialog):
    def __init__(self, parent, shift, counter):
	Dialog.__init__(self, 0, 0, 24, 79, COL_MAIN)
	self.set_caption(" ")
	self.shift = shift
	self.shift_indx = counter
	self.Parent = parent

	self.lineno = 0
	self.personid = 0
	self.machid = 0
		
	self.person = OptionLine(self, 3, 2, 33, " /   ", pos_UP)
	self.addWidget(self.person)
	
	self.machine = OptionLine(self, 37, 2, 20, " / ", pos_UP)
	self.addWidget(self.machine)
	
	self.interval = LabeledEditLine(self, 58, 2, 5, ".", pos_UP)
	self.addWidget(self.interval)
	
	self.writexy(63, 2, "         ", COL_TEXT)
	
	self.plist = MultiListBox(self, 2, 4, 18, 70, COL_TEXT)
	self.plist.setItemColors(COL_TITLE, COL_TEXT)
	self.plist.MultiChoice = FALSE
	self.plist.addColon(34, " /   ")	    
	self.plist.addColon(21, " / ")
	self.plist.addColon(15, ".")
	m = Message()
	m.message = cm_RELOAD
	self.plist.dbQuery = "SELECT prbook.name, machines.lname, prbook.vreme, prbook.nameid, prbook.lineno FROM prbook, machines WHERE prbook.snindx = " + str(self.shift_indx) + " AND prbook.sm = " + str(self.shift) + " AND prbook.machine = machines.sname"
	self.plist.Update(m)
	
	self.addWidget(self.plist)
	
	for i in range(len(self.plist.items)):
	    if int(self.plist.hidden_items[i][1]) > self.lineno:
		self.lineno = int(self.plist.hidden_items[i][1])	
	
	self.writexy(67, 0, "    : " + str(self.shift) + " ", COL_WARN)
	self.writexy(54, 0, "  : " + str(self.shift_indx) + " ", COL_WARN)	
	
	self.AddHotKey(curses.KEY_NPAGE, 0)
	self.AddHotKey(curses.KEY_PPAGE, 0)
	self.AddHotKey(curses.KEY_F8, 0)
	
	self.writexy(0, 24, "| PDn/PUp  | F8 -  | F12 -  |" , COL_TITLE, TRUE)	
	
	self.select(0)

    def UserFn(self, command, args):
	if self.Parent.SCREEN_LOCKED == TRUE:
	    return ev_NONE
	if self.Parent.QUIT_STATUS == TRUE:
	    return ev_NONE

	if command == ev_ACTIVATE and args == curses.KEY_NPAGE:
	    self.plist.handleEvent(curses.KEY_DOWN)
	    self.select(0)
	    return ev_NONE

	if command == ev_ACTIVATE and args == curses.KEY_PPAGE:
	    self.plist.handleEvent(curses.KEY_UP)
	    self.select(0)
	    return ev_NONE

	if command == ev_ACTIVATE and args == curses.KEY_F8:
	    it = self.plist.items[self.plist.hilite]
	    ih = self.plist.hidden_items[self.plist.hilite]
	    
	    #if int(ih[6]) <> 0:
	    #	msgbox = MessageBox(28, 9, 8, 30, COL_TAB, COL_TAB, \
	    #	                        ["  ", "  ", " !"], "?", msg_OK)
	    #	yes = msgbox.mainLoop()
	    #	msgbox.destroy()
	    #	del msgbox
	    #	pflush()
	    #	self.select(0)
	    #	return ev_NONE
	    
	    msgbox = MessageBox(28, 9, 8, 26, COL_TAB, COL_TAB, \
		                        ["  ", "  "], "?", msg_YESNO)
	    yes = msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()
	    if yes == cmd_CANCEL:
		return ev_NONE
	    
	    self.lineno = 0
	    self.person.SetText(strip(it[0].Label))
	    self.machine.SetText(strip(it[1].Label))
	    self.interval.SetText("")
	    self.personid = ih[0]
	    ll = ih[1]
	    
	    self.plist.items.remove(it)
	    self.plist.hidden_items.remove(ih)
	    self.plist.handleEvent(curses.KEY_HOME)
	    
	    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
	    curs = db.cursor()
	    curs.execute("""DELETE FROM prbook WHERE
	                    snindx = %s AND
			    sm = %s AND
			    lineno = %s""",
			    (self.shift_indx, self.shift, ll))
	    db.close()
	    
	    self.select(0)
	    
	
	if command == ev_OPTION and args == 0:
	    persondlg = getPersonID()
	    persondlg.mainLoop()
	    it = persondlg.plist.items[persondlg.plist.hilite]
	    self.person.SetText(strip(it[1].Label))
	    self.personid = int(it[0].Label)
	    persondlg.destroy()
	    del persondlg
	    self.select(1)
	    return ev_NONE
	if command == ev_OPTION and args == 1:
	    machdlg = getMachID()
	    machdlg.mainLoop()
	    self.machine.SetText(strip(machdlg.plist.items[machdlg.plist.hilite][1].Label))
	    machdlg.destroy()
	    del machdlg
	    self.select(2)
	    return ev_NONE
	if command == ev_OK and args == 2:
	    if self.person.text == "" or \
	       self.machine.text == "":
		msgbox = MessageBox(28, 9, 8, 32, COL_TAB, COL_TAB, \
		                        ["  ", "   ", " /"], "", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.select(0)
		return ev_NONE
	    
	    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
	    curs = db.cursor()
	    curs.execute("""SELECT nameid FROM prbook WHERE nameid = %s AND snindx = %s AND sm = %s""",
	                    (self.personid, self.shift_indx, self.shift))
	    exists = curs.fetchall()
	    if len(exists) > 0:
		msgbox = MessageBox(28, 9, 7, 32, COL_TAB, COL_TAB, \
		                        ["  ", " "], "", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.select(0)
		db.close()
		return ev_NONE
		
	    self.lineno = self.lineno + 1
	    self.plist.addItem([self.person.text,
	                        self.machine.text, 
				"00:00"],
				hidden = [self.personid, 
				          self.lineno])
	    
	    curs.execute("""INSERT INTO prbook (
	                      snindx, sm,
			      lineno, 
			      name, nameid, machine,
			      date, oper) VALUES (
			      %s, %s,
			      %s, 
			      %s, %s, %s,
			      NOW(), %s)""",
			      (self.shift_indx, self.shift,
			       self.lineno,
			       self.person.text, self.personid, self.machine.text, 
			       "cv"))
		    
	    db.close()
	    self.plist.draw()
	    self.person.SetText("")
	    self.machine.SetText("")
	    self.select(0)
	    return ev_NONE
	
		
class MachineBox(DropDnBox):
    
    def FillBox(self):
	self.box.addItem(" 1")
	self.box.addItem(" 2")
	self.box.addItem(" 3  ")
	self.box.addItem(" 4")	
	
	
class getFolioID(Dialog):
    def __init__(self, nameSearch = None, shift_indx = 0, shift = 0):
	Dialog.__init__(self, 30, 2, 19, 45, COL_MAIN)
	self.shift_indx = shift_indx
	self.shift = shift
	
	self.plist = MultiListBox(self, 2, 1, 16, 41, COL_TEXT)
	self.plist.setItemColors(COL_TITLE, COL_TEXT)
	self.plist.MultiChoice = FALSE
	self.plist.addColon(5, "")
	self.plist.addColon(32, "")	    
	
	self.plist.Focusable = TRUE
	if self.shift_indx <> 0 and self.shift <> 0:
	    self.plist.dbQuery = "SELECT artno1, folio, lineno FROM prplan WHERE snindx = " + str(self.shift_indx) + " AND sm = " + str(self.shift) + " ORDER BY folio ASC"
	else:
	    self.plist.dbQuery = "SELECT art_no, name FROM articles WHERE (name RLIKE '' OR name RLIKE '' OR name RLIKE '' OR name RLIKE '^') AND group_no = 9 and object_no = 2 ORDER BY name ASC";
	
	m = Message()
	m.message = cm_RELOAD
	self.plist.Update(m)
	#if nameSearch <> None:
	#    self.plist.dbQuery = "SELECT art_no, name FROM articles WHERE name RLIKE=\'" + str(nameSearch) + "\' AND group_no = 9 ORDER BY name ASC"
	#    self.plist.Update(m)
	#    self.plist.Locate(nameSearch)
	self.addWidget(self.plist)

	self.writexy(2, 18, "F1 - ", COL_WARN)
	self.writexy(12, 18, " | F10 -  ", COL_WARN)
	#self.select(0)
	self.AddHotKey(curses.KEY_F1, 0)
	self.AddHotKey(curses.KEY_F10, 0)
	
    def UserFn(self, command, args):
	if command == ev_OK:
	    return ev_DONE
	if command == cm_QUICK_SEARCH:
	    srch = QuickSearchDlg(35, 10, 36, " ")
	    srch.mainLoop()
	    s = strip(srch.search.text)
	    if s == "":
		return ev_NONE
	    srch.destroy()
	    if self.shift_indx <> 0 and self.shift <> 0:
		self.plist.dbQuery = "SELECT artno1, folio, lineno FROM prplan WHERE snindx = " + str(self.shift_indx) + " AND sm = " + str(self.shift) + " AND folio RLIKE \'" + s + "\' ORDER BY folio ASC"
	    else:
		self.plist.dbQuery = "SELECT art_no, name FROM articles WHERE name RLIKE \'" + s + "\' AND group_no = 9 and object_no = 2 ORDER BY name ASC"
	    m = Message()
	    m.message = cm_RELOAD
	    self.plist.Update(m)
	    curses.curs_set(0)
	    return ev_NONE
	if command == ev_ACTIVATE and args == curses.KEY_F10:
	    if self.shift_indx <> 0 and self.shift <> 0:
		self.plist.dbQuery = "SELECT artno1, folio, lineno FROM prplan WHERE snindx = " + str(self.shift_indx) + " AND sm = " + str(self.shift) + " ORDER BY folio ASC"
	    else:
		self.plist.dbQuery = "SELECT art_no, name FROM articles WHERE (name RLIKE '' OR name RLIKE '' OR name RLIKE '' OR name RLIKE '^') AND group_no = 9 ORDER BY name ASC";
	    m = Message()
	    m.message = cm_RELOAD
	    self.plist.Update(m)
	    return ev_NONE
	    
#	if command == ev_ACTIVATE and args == curses.KEY_F1:
#	    analpartdlg = AnalPart(self.analitno)
#	    analpartdlg.mainLoop()
#	    anit = analpartdlg.analitem.text
#	    analpartdlg.destroy()
#	    del analpartdlg
#	    m = Message()
#	    m.message = cm_RELOAD
	    #self.plist.dbQuery = "SELECT no, name FROM kasaanalpart WHERE analitno=\'" + str(self.analitno) + "\' ORDER BY name ASC"
	    #self.plist.Update(m)
	    #self.plist.Locate(anit)
#	    pflush()


class getPersonID(Dialog):
    def __init__(self, nameSearch = None):
	Dialog.__init__(self, 30, 2, 19, 45, COL_MAIN)
	
	self.plist = MultiListBox(self, 2, 1, 16, 41, COL_TEXT)
	self.plist.setItemColors(COL_TITLE, COL_TEXT)
	self.plist.MultiChoice = FALSE
	self.plist.addColon(5, "")
	self.plist.addColon(32, "  ")	    
	
	self.plist.Focusable = TRUE
	self.plist.dbQuery = "SELECT no, name FROM prpersons ORDER BY name ASC";
	m = Message()
	m.message = cm_RELOAD
	self.plist.Update(m)
	self.addWidget(self.plist)

	self.writexy(2, 18, "F1 - ", COL_WARN)
	self.writexy(12, 18, " | F10 -  ", COL_WARN)
	#self.select(0)
	self.AddHotKey(curses.KEY_F1, 0)
	self.AddHotKey(curses.KEY_F10, 0)
	
    def UserFn(self, command, args):
	if command == ev_OK:
	    return ev_DONE
	if command == cm_QUICK_SEARCH:
	    srch = QuickSearchDlg(35, 10, 36, " ")
	    srch.mainLoop()
	    s = strip(srch.search.text)
	    if s == "":
		return ev_NONE
	    srch.destroy()
	    self.plist.dbQuery = "SELECT no, name FROM prpersons WHERE name RLIKE \'" + s + "\' ORDER BY name ASC"
	    m = Message()
	    m.message = cm_RELOAD
	    self.plist.Update(m)
	    curses.curs_set(0)
	    return ev_NONE
	if command == ev_ACTIVATE and args == curses.KEY_F10:
	    self.plist.dbQuery = "SELECT no, name FROM prpersons ORDER BY name ASC";
	    m = Message()
	    m.message = cm_RELOAD
	    self.plist.Update(m)
	    return ev_NONE



class getArtID(Dialog):
    def __init__(self, nameSearch = None, shift_indx = 0, shift = 0, addqry = ""):
	Dialog.__init__(self, 30, 2, 19, 45, COL_MAIN)
	self.shift_indx = shift_indx
	self.shift = shift
	self.addqry = addqry
	
	self.plist = MultiListBox(self, 2, 1, 16, 42, COL_TEXT)
	self.plist.setItemColors(COL_TITLE, COL_TEXT)
	self.plist.MultiChoice = FALSE
	self.plist.addColon(7, "")
	self.plist.addColon(32, "")	    
	
	self.plist.Focusable = TRUE
	if self.shift_indx <> 0 and self.shift <> 0:
	    self.plist.dbQuery = "SELECT CONCAT(grno2, artno2), product, lineno FROM prplan WHERE grno2 IN (1, 2) AND snindx = \'" + str(self.shift_indx) + "\' AND sm = \'" + str(self.shift) + "\' ORDER BY product ASC";
	else:
	    self.plist.dbQuery = "SELECT CONCAT(group_no, art_no), name FROM articles WHERE group_no = 1 IN (1, 2) AND object_no = 2 " + addqry + " ORDER BY name ASC";
	m = Message()
	m.message = cm_RELOAD
	self.plist.Update(m)
	#if nameSearch <> None:
	#    self.plist.dbQuery = "SELECT CONCAT(group_no, art_no), name FROM articles WHERE name RLIKE=\'" + str(nameSearch) + "\' AND (group_no = 1 or group_no = 2) ORDER BY name ASC"
	#    self.plist.Update(m)
	#    self.plist.Locate(nameSearch)
	self.addWidget(self.plist)

	self.writexy(2, 18, "F1 - ", COL_WARN)
	self.writexy(12, 18, " | F10 -  ", COL_WARN)
	#self.select(0)
	self.AddHotKey(curses.KEY_F1, 0)
	self.AddHotKey(curses.KEY_F10, 0)
	
    def UserFn(self, command, args):
	if command == ev_OK:
	    return ev_DONE
	if command == cm_QUICK_SEARCH:
	    srch = QuickSearchDlg(35, 10, 36, " ")
	    srch.mainLoop()
	    s = strip(srch.search.text)
	    if s == "":
		return ev_NONE
	    srch.destroy()
	    if self.shift_indx <> 0 and self.shift <> 0:
		self.plist.dbQuery = "SELECT CONCAT(grno2, artno2), product, lineno FROM prplan WHERE product RLIKE \'" + s + "\' AND (grno2 = 1 OR grno2 = 2) AND snindx = \'" + str(self.shift_indx) + "\' AND sm = \'" + str(self.shift) + "\' ORDER BY product ASC"
	    else:
		self.plist.dbQuery = "SELECT CONCAT(group_no, art_no), name FROM articles WHERE name RLIKE \'" + s + "\' AND (group_no = 1 or group_no = 2) AND object_no = 2" + self.addqry + " ORDER BY name ASC"
	    m = Message()
	    m.message = cm_RELOAD
	    self.plist.Update(m)
	    curses.curs_set(0)
	    return ev_NONE
	if command == ev_ACTIVATE and args == curses.KEY_F10:
	    if self.shift_indx <> 0 and self.shift <> 0:
		self.plist.dbQuery = "SELECT CONCAT(grno2, artno2), product, lineno FROM prplan WHERE (grno2 = 1 OR grno2 = 2) AND snindx = \'" + str(self.shift_indx) + "\' AND sm = \'" + str(self.shift) + "\' ORDER BY product ASC";
	    else:
		self.plist.dbQuery = "SELECT CONCAT(group_no, art_no), name FROM articles WHERE group_no = 1 OR group_no = 2 ORDER BY name ASC";
	    m = Message()
	    m.message = cm_RELOAD
	    self.plist.Update(m)
	    return ev_NONE
	    
#	if command == ev_ACTIVATE and args == curses.KEY_F1:
#	    analpartdlg = AnalPart(self.analitno)
#	    analpartdlg.mainLoop()
#	    anit = analpartdlg.analitem.text
#	    analpartdlg.destroy()
#	    del analpartdlg
#	    m = Message()
#	    m.message = cm_RELOAD
	    #self.plist.dbQuery = "SELECT no, name FROM kasaanalpart WHERE analitno=\'" + str(self.analitno) + "\' ORDER BY name ASC"
	    #self.plist.Update(m)
	    #self.plist.Locate(anit)
#	    pflush()


class getMachID(Dialog):
    def __init__(self, nameSearch = None):
	Dialog.__init__(self, 38, 2, 12, 28, COL_MAIN)
	
	self.plist = MultiListBox(self, 2, 1, 9, 24, COL_TEXT)
	self.plist.setItemColors(COL_TITLE, COL_TEXT)
	self.plist.MultiChoice = FALSE
	self.plist.addColon(3, "")
	self.plist.addColon(20, "")	    
	
	self.plist.Focusable = TRUE
	self.plist.dbQuery = "SELECT no, lname, sname FROM machines";
	m = Message()
	m.message = cm_RELOAD
	self.plist.Update(m)
	self.addWidget(self.plist)

	#self.writexy(2, 18, "F1 - ", COL_WARN)
	#self.writexy(12, 18, " | F10 -  ", COL_WARN)
	#self.select(0)
	self.AddHotKey(curses.KEY_F1, 0)
	self.AddHotKey(curses.KEY_F10, 0)
	
    def UserFn(self, command, args):
	if command == ev_OK:
	    return ev_DONE
	
class JournalBook(Dialog):
    def __init__(self, parent, shift, counter):
	Dialog.__init__(self, 0, 0, 24, 79, COL_MAIN)
	self.set_caption(" ")
	self.shift = shift
	self.shift_indx = counter
	self.Parent = parent
	
	self.artno1 = 0
	self.grno2 = 0
	self.artno2 = 0
	
	self.kgdadeno = 0
	self.kgost = 0
	self.kgspul = 0
	self.kgbrak = 0
	
	self.prod_brstek = 0
	self.prod_edbr = 0
	self.prod_pak = 1
	self.prod_gr = 0
	self.sum_dadeno = 0
	self.sum_ost = 0
	self.sum_prod = 0
	
	self.total_dadeno = 0
	self.total_spul = 0
	self.total_brak = 0
	self.total_ost = 0
	self.total_prod = 0
	
	#     
	self.lineindx = 0
	#  -   
	self.brakmode = 0
	
	self.planline = 0
	
	self.DrawNo(self.shift)
	
	#0
	self.material = OptionLine(self, 2, 2, 33, "   ()", pos_UP)
	self.addWidget(self.material)
	#1
	self.product = OptionLine(self, 2, 4, 33, "  ", pos_UP)
	self.addWidget(self.product)
	#2
	self.dadeno = LabeledEditLine(self, 2, 6, 6, "", pos_UP)
	self.dadeno.SetText("0")
	self.dadeno.setType(dt_float)
	self.addWidget(self.dadeno)
	#3
	self.ost = LabeledEditLine(self, 10, 6, 6, ".", pos_UP)
	self.ost.SetText("0")
	self.ost.setType(dt_float)
	self.addWidget(self.ost)	
	#4
	self.brak = LabeledEditLine(self, 18, 6, 5, "", pos_UP)
	self.brak.SetText("0")
	self.brak.setType(dt_float)
	self.addWidget(self.brak)	
	#5
	self.spul = LabeledEditLine(self, 25, 6, 5, "", pos_UP)
	self.spul.SetText("0")
	self.spul.setType(dt_float)
	self.addWidget(self.spul)	
	#6
	self.brstek = LabeledEditLine(self, 2, 8, 10, ".", pos_UP)
	self.brstek.SetText("0")
	self.brstek.setType(dt_numeric)
	self.addWidget(self.brstek)
	#7
	self.edbr = LabeledEditLine(self, 14, 8, 10, "+ . .", pos_UP)
	self.edbr.SetText("0")
	self.edbr.setType(dt_numeric)
	self.addWidget(self.edbr)
	#8
	self.pak = LabeledEditLine(self, 26, 8, 10, "  ", pos_UP)
	self.pak.SetText("1")
	self.pak.setType(dt_numeric)
	self.addWidget(self.pak)	
	#9
	self.gr =  LabeledEditLine(self, 38, 8, 10, "", pos_UP)
	self.gr.SetText("0")
	self.gr.setType(dt_float)
	self.addWidget(self.gr)	
	#10
	self.jlist = MultiListBox(self, 1, 13, 9, 77, COL_TEXT)
	self.jlist.setItemColors(COL_TITLE, COL_TEXT)
	self.jlist.MultiChoice = FALSE
	self.jlist.addColon(32, "/.")
	self.jlist.addColon(9, "", dt_float, 3)
	self.jlist.addColon(7, "", dt_float, 3)
	self.jlist.addColon(7, "", dt_float, 3)
	self.jlist.addColon(7, ".", dt_float, 3)
	self.jlist.addColon(6, "/", dt_float, 0)
	self.jlist.addColon(3, "", dt_float, 0)
	self.jlist.addColon(6, "")
	
	self.jlist.dbQuery = "SELECT folio, dadeno, spul, brak, ostat, brstek, pak, machine, gr, lineno, product, artno1, grno2, artno2, printed FROM prjournal WHERE sm = " + str(self.shift) + " AND snindx = " + str(self.shift_indx)
	m = Message()
	m.message = cm_RELOAD
	self.jlist.Update(m)
	
	self.addWidget(self.jlist)
	
	for i in range(len(self.jlist.items)):
	    if int(self.jlist.hidden_items[i][1]) > self.lineindx:
		self.lineindx = int(self.jlist.hidden_items[i][1])
	
	#11
	#self.machine = MachineBox(self, 36, 4, 20, 8, COL_TEXT)
	self.machine = OptionLine(self, 36, 4, 20, "/", pos_UP)
	self.machine.SetText("")
	
	
	self.addWidget(self.machine)
	
	#12
	self.product_info = EditLine(self, 11, 12, 32, normcol = COL_TITLE)
	self.product_info.Focusable = FALSE
	if len(self.jlist.items) > 0:
	    self.product_info.SetText(self.jlist.hidden_items[0][2])
	self.addWidget(self.product_info)
	
	self.AddHotKey(curses.KEY_F2, 0)
	self.AddHotKey(curses.KEY_F5, 10)
	self.AddHotKey(curses.KEY_F4, 10)	
	self.AddHotKey(curses.KEY_F10, 11)
	self.AddHotKey(curses.KEY_F8, 0)
	self.AddHotKey(curses.KEY_F12, 0)
	
	self.AddHotKey(curses.KEY_NPAGE, 0)
	self.AddHotKey(curses.KEY_PPAGE, 0)
	
	self.jlist.addNotifyRecipient(self, cm_ITEM_CHANGED)

	self.writexy(30, 6, " :      .", COL_TAB)
	
	#self.writexy(36, 3, ". ", COL_TEXT1)
	self.writexy(27, 23, " :                                              ", COL_WARN, TRUE)
	self.writexy(1, 23, "                          ", COL_WARN)
	
	#self.writexy(1, 10, " :      .", COL_WARN, TRUE)
	self.writexy(1, 12, " : ", COL_TITLE, TRUE)
	self.writexy(43, 12, "                                    ", COL_TITLE)
	
	self.writexy(0, 24, "| F2 -  | F4 -  | PDn/PUp  | F8 -  | F10 - / |" , COL_TITLE, TRUE)
	self.CalculateSums()
	self.select(0)
	
    def DrawNo(self, no):
	self.writexy(67, 0, "    : " + str(no) + " ", COL_WARN)
	self.writexy(54, 0, "  : " + str(self.shift_indx) + " ", COL_WARN)
	if no == 1:
	    self.writexy(69, 2,"       ", COL_MAIN)
	    self.writexy(69, 3,"     ", COL_MAIN)
	    self.writexy(69, 4,"     ", COL_MAIN)
	    self.writexy(69, 5,"       ", COL_MAIN)
	    self.writexy(69, 6,"       ", COL_MAIN)
	    self.writexy(69, 7,"       ", COL_MAIN)
	elif no == 2:
	    self.writexy(69, 2,"  ", COL_MAIN)
	    self.writexy(69, 3,"    ", COL_MAIN)
	    self.writexy(69, 4,"      ", COL_MAIN)
	    self.writexy(69, 5,"      ", COL_MAIN)
	    self.writexy(69, 6,"      ", COL_MAIN)
	    self.writexy(69, 7,"", COL_MAIN)
	elif no == 3:
	    self.writexy(69, 2,"  ", COL_MAIN)
	    self.writexy(69, 3,"    ", COL_MAIN)
	    self.writexy(69, 4,"      ", COL_MAIN)
	    self.writexy(69, 5,"      ", COL_MAIN)
	    self.writexy(69, 6,"    ", COL_MAIN)
	    self.writexy(69, 7,"  ", COL_MAIN)
	    
	    

    def GetValues(self):
	self.kgdadeno = float(self.dadeno.text)
	self.kgost = float(self.ost.text)
	self.kgspul = float(self.spul.text)
	self.kgbrak = float(self.brak.text)
	
	self.prod_brstek = int(self.brstek.text)
	self.prod_edbr = int(self.edbr.text)
	self.prod_pak = int(self.pak.text)
	self.prod_gr = float(self.gr.text)
	
	self.prod_obsto = self.prod_edbr + self.prod_brstek * self.prod_pak
	
    def CheckValues(self):
	nameexpr = '^'
	namematch = re.compile(nameexpr)
	m = namematch.match(self.material.text)
	f = TRUE
	if self.brakmode == 0:
	    if self.kgdadeno == 0: f = FALSE
	    if self.kgost > self.kgdadeno: f = FALSE
	    if self.kgbrak > self.kgdadeno: f = FALSE
	    
	    vl = self.kgdadeno - self.kgost - self.kgspul
	    
	    #      ,   
	    #    
	    #if self.kgbrak > ((self.kgdadeno - self.kgost - self.kgspul) * 0.05) / 100: f = FALSE
	    
	    if self.kgspul > 1.6 and self.kgost == 0: f = FALSE
	    if self.kgspul > self.kgdadeno and self.kgost == 0: f = FALSE
	    if self.kgspul < 0.3 and self.kgost == 0: f = FALSE
	    if (not m and self.kgspul <> 0): f = FALSE
	    if (m and self.kgost == 0 and self.kgspul == 0) or \
	       (m and self.kgost <> 0 and self.kgspul <> 0): f = FALSE
	    if self.kgspul + self.kgbrak + self.kgost > self.kgdadeno: f = FALSE
	    if self.prod_brstek + self.prod_edbr == 0: f = FALSE
	    if (self.prod_pak == 0) or \
	       (self.prod_gr == 0): f = FALSE
	    if (strip(self.material.text) == "") or \
	       (strip(self.machine.text) == "") or \
	       (strip(self.product.text) == ""): f = FALSE
	    if f == FALSE:
		msgbox = MessageBox(28, 9, 9, 32, COL_TAB, COL_TAB, \
		                        ["  ", "  ", "     ", " "], "", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		return FALSE
	    else:
		return TRUE
	    
	else:
	    return FALSE

    def CalculateSums(self):
	self.total_dadeno = 0
	self.total_spul = 0
	self.total_brak = 0
	self.total_ost = 0
	self.total_prod = 0
	    
	for i in range(len(self.jlist.items)):
	    it = self.jlist.items[i]
	    self.total_dadeno = self.total_dadeno + float(it[1].Label)
	    self.total_spul = self.total_spul + float(it[2].Label)
	    self.total_brak = self.total_brak + float(it[3].Label)
	    self.total_ost = self.total_ost + float(it[4].Label)
	    self.total_prod = self.total_prod + float(it[5].Label)
	    
	self.writexy(35, 23, rjust(fix(self.total_dadeno, 3), 7) + "|", COL_WARN, TRUE)
	self.writexy(43, 23, rjust(fix(self.total_spul, 3), 6) + "|", COL_WARN, TRUE)
	self.writexy(50, 23, rjust(fix(self.total_brak, 3), 6) + "|", COL_WARN, TRUE)
	self.writexy(57, 23, rjust(fix(self.total_ost, 3), 6) + "|", COL_WARN, TRUE)
	self.writexy(64, 23, rjust(fix(self.total_prod, 0), 5) + "|", COL_WARN, TRUE)
	

    def Update(self, msg):
	if msg.message == cm_ITEM_CHANGED:
	    i = msg.args[1]
	    self.product_info.SetText(self.jlist.hidden_items[i][2])

	    
    def PrintDocument(self):
	db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
	curs = db.cursor()
	curs.execute("""SELECT CONCAT(grno2, artno2), product, sum(brstek) FROM prjournal WHERE printed = '0' AND snindx = %s AND sm = %s GROUP BY product""",
			(self.shift_indx, self.shift))
	ll = curs.fetchall()
	curs.execute("""UPDATE prjournal SET printed = '1' WHERE printed = '0' AND snindx = %s AND sm = %s""", 
			(self.shift_indx, self.shift))
	db.close()
	if len(ll) == 0:
	    msgbox = MessageBox(28, 9, 7, 32, COL_TAB, COL_TAB, \
		                        ["   ", " !"], "", msg_OK)
	    yes = msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()
	    return
	
	fp = open("proizv"+str(self.shift_indx) + "-" + str(self.shift), "w+")
	fp.write(" :  " + ljust(str(self.shift), 11) + " :COMPANY xx,  2\n")
	
	fp.write("\n")
	fp.write("                                \n")
	#fp.write("                        No: "+ljust(str(self.doc_counter), 15) + ":" + self.nowDate + "\n")
	fp.write(strftime("%d-%m-%Y : %H:%m", gmtime()) + "\n")
	fp.write("+----+--------+---------------------------------+-------+------------+\n")
	fp.write("| No |   |                     |  |  |\n")
	fp.write("+----+--------+---------------------------------+-------+------------+\n")
	for i in range(len(ll)):
	    it = ll[i]
	    artcode = rjust(it[0], 7)
	    artname = ljust(it[1], 32)
	    wid = center("xx", 7)
	    #wid = center(it[2].Label, 7)
	    ww = rjust(str(it[2]), 12)
	    #if strip(it[2].Label) == ".":
	    #	np = float(tp) * int(p1)
	    #	ww = ljust(str(np), 12)
	    #	sum = rjust(str(np * float(pr)), 10)
	    fp.write("| " + ljust(str(i+1),3) + "| " +  artcode + "| " + artname + "|"+wid+"|"+ww+"|\n")
	fp.write("+----+--------+---------------------------------+-------+------------+\n\n\n")
	fp.write(": " + ljust(get_user(), 32) + "  /               /\n\n")
	fp.write(" : " + ljust(" ", 32) + "  /               /\n\n")
	
	    
	fp.close()
	os.spawnlp(os.P_NOWAIT, './printdoc', './printdoc', 'proizv'+str(self.shift_indx) + "-" + str(self.shift))
	
	self.jlist.hilite = 0
	self.jlist.start = -1
	self.jlist.end = 0
	del self.jlist.items
	del self.jlist.hidden_items
	self.jlist.items = []
	self.jlist.hidden_items = []
	
	m = Message()
	m.message = cm_RELOAD
	self.jlist.dbQuery = "SELECT folio, dadeno, spul, brak, ostat, brstek, pak, machine, gr, lineno, product, artno1, grno2, artno2, printed FROM prjournal WHERE sm = " + str(self.shift) + " AND snindx = " + str(self.shift_indx)
	self.jlist.Update(m)
	self.jlist.draw()
	    
    def getPlanLine(self, line):
	db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
	curs = db.cursor()
	curs.execute("""SELECT machine, folio, artno1, product, grno2, artno2, qty2 FROM prplan WHERE snindx = %s AND sm = %s AND lineno = %s""", 
	                (self.shift_indx, self.shift, line))
	(mm, ff, a1, pp, g2, a2, qty) = curs.fetchone()
	curs.execute("""SELECT weight, pack1 FROM articles WHERE group_no = %s AND art_no = %s""",
			(g2, a2))
	(_weight, _pack) = curs.fetchone()
	curs.execute("""SELECT SUM(ostat) FROM prjournal WHERE artno1 = %s AND snindx = %s AND sm = %s""",
			(a1, self.shift_indx, self.shift))
	(ost_folio, ) = curs.fetchone()
	db.close()
	self.machine.SetText(mm)
	self.material.SetText(ff)
	self.artno1 = a1
	self.product.SetText(pp)
	self.grno2 = g2
	self.artno2 = a2
	self.pak.SetText(str(_pack))
	self.gr.SetText(str(_weight))
	self.prod_pak = _pack
	self.prod_gr = _weight
	self.writexy(49, 7, "  :", COL_TEXT1)
	self.writexy(49, 8, str(qty), COL_WARN, TRUE)
	
    def UserFn(self, command, args):
	if self.Parent.SCREEN_LOCKED == TRUE:
	    return ev_NONE
	if self.Parent.QUIT_STATUS == TRUE:
	    return ev_NONE
	
	self.GetValues()

	if command == ev_ACTIVATE and args == curses.KEY_F12:
	    self.PrintDocument()
	    self.select(0)
	    return ev_NONE
	
	if command == ev_ACTIVATE and args == curses.KEY_NPAGE:
	    self.jlist.handleEvent(curses.KEY_DOWN)
	    self.select(0)
	    return ev_NONE

	if command == ev_ACTIVATE and args == curses.KEY_PPAGE:
	    self.jlist.handleEvent(curses.KEY_UP)
	    self.select(0)
	    return ev_NONE
	
	if command == ev_ACTIVATE and args == curses.KEY_F4:
	    plan = ViewPlan(self.Parent, self.shift, self.shift_indx)
	    stat = plan.mainLoop()
	    plan.destroy()
	    pflush()
	    self.select(0)
	    return ev_NONE
	
	if command == ev_ACTIVATE and args == curses.KEY_F10:
	    self.brakmode = self.brakmode + 1
	    if self.brakmode == 3:
		self.brakmode = 0
	    
	    if self.brakmode == 1:
		self.writexy(36, 2, " /", COL_WARN, TRUE)
	    elif self.brakmode == 2:
		self.writexy(36, 2, "  ", COL_WARN, TRUE)
	    elif self.brakmode == 0:
		self.writexy(36, 2, "                     ", COL_MAIN, TRUE)
	    return ev_DONE
	
	if command == ev_OPTION and args == 0:
	    #if self.planline <> 0:
	    #	self.select(2)
	    #	return ev_NONE
	    foliodlg = getFolioID(shift_indx=self.shift_indx, shift=self.shift)
	    foliodlg.mainLoop()
	    if foliodlg.plist.hilite == -1:
		foliodlg.destroy()
		del foliodlg
		msgbox = MessageBox(28, 9, 8, 32, COL_TAB, COL_TAB, \
		                        ["  ", "   ", " !"], "", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		
		self.select(0)
		return ev_NONE
	    self.material.SetText(foliodlg.plist.items[foliodlg.plist.hilite][1].Label)
	    self.artno1 = int(foliodlg.plist.items[foliodlg.plist.hilite][0].Label)
	    
	    self.planline = foliodlg.plist.hidden_items[foliodlg.plist.hilite][0]
	    self.getPlanLine(self.planline)
	    
	    foliodlg.destroy()
	    del foliodlg
	    self.select(2)
	    
	    if self.planline == 0:
		self.select(1)
	    return ev_NONE
	if command == ev_OPTION and args == 1:
	    #if self.planline <> 0:
	    #	self.select(2)
	    #	return ev_NONE
	    artdlg = getArtID(shift_indx=self.shift_indx, shift=self.shift)
	    artdlg.mainLoop()
	    if artdlg.plist.hilite == -1:
		artdlg.destroy()
		del artdlg
		msgbox = MessageBox(28, 9, 8, 32, COL_TAB, COL_TAB, \
		                        ["  ", "   ", " !"], "", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()		
		self.select(1)
		return ev_NONE
	    
	    self.product.SetText(artdlg.plist.items[artdlg.plist.hilite][1].Label)
	    artid = artdlg.plist.items[artdlg.plist.hilite][0].Label
	    self.grno2 = int(artid[0:3])
	    self.artno2 = int(artid[3:6])
	    
	    self.planline = artdlg.plist.hidden_items[artdlg.plist.hilite][0]
	    self.getPlanLine(self.planline)
	    
	    artdlg.destroy()
	    del artdlg
	    
	    self.select(2)
	    
	    if self.planline == 0:
		self.select(11)
	    return ev_NONE

	if command == ev_OPTION and args == 11:
	    #if self.planline <> 0:
	    #	self.select(2)
	    #	return ev_NONE
	    machdlg = getMachID()
	    machdlg.mainLoop()
	    self.machine.SetText(strip(machdlg.plist.items[machdlg.plist.hilite][1].Label))
	    machdlg.destroy()
	    del machdlg
	    self.select(2)
	    return ev_NONE
	
	if command == ev_OK and args == 2:
	    self.kgdadeno = float(self.dadeno.text)
	    if self.kgdadeno == 0:
		msgbox = MessageBox(28, 9, 8, 32, COL_TAB, COL_TAB, \
		                        ["  ", "   ", "   "], "", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.select(2)
		return ev_NONE
		
	    self.select(3)
	    return ev_NONE
	if command == ev_OK and args == 3:
	    self.kgost = float(self.ost.text)
	    if self.kgost >= self.kgdadeno:
		msgbox = MessageBox(28, 9, 9, 32, COL_TAB, COL_TAB, \
		                        ["  ", "   ", "   -"," !"], "", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.select(3)
		return ev_NONE
	    self.select(4)
	    return ev_NONE
	if command == ev_OK and args == 4:
	    self.kgbrak = float(self.brak.text)
	    if self.kgbrak >= self.kgdadeno:
		msgbox = MessageBox(28, 9, 9, 32, COL_TAB, COL_TAB, \
		                        ["  ", "  ", "    ", ""], "", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.select(4)
		return ev_NONE
	    self.select(5)
	    return ev_NONE
	if command == ev_OK and args == 5:
	    self.kgost = float(self.ost.text)
	    self.kgspul = float(self.spul.text)
	    nameexpr = '^'
	    namematch = re.compile(nameexpr)
	    m = namematch.match(self.material.text)
	    if not m and self.kgspul <> 0:
		msgbox = MessageBox(28, 9, 8, 32, COL_TAB, COL_TAB, \
		                        ["  ", "    ", "   !"], "", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.kgspul = 0
		self.spul.SetText("0")
		self.select(6)
		return ev_NONE
	    elif not m and self.kgspul == 0:
		self.select(6)
		return ev_NONE
	    if self.kgspul > 1.6 or (self.kgspul > self.kgdadeno) or (self.kgspul < 0.3 and self.kgost == 0):
		msgbox = MessageBox(28, 9, 7, 32, COL_TAB, COL_TAB, \
		                        ["  ", "    !"], "", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.kgspul = 0
		self.spul.SetText("0")
		self.select(5)
		return ev_NONE
	    if self.kgost == 0 and self.kgspul == 0 or \
	       self.kgost <> 0 and self.kgspul <> 0:
		msgbox = MessageBox(28, 9, 10, 32, COL_TAB, COL_TAB, \
		                        ["  ", "    ", "   ", "    0!"], "", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.select(5)
		return ev_NONE
	    else:
		self.select(6)
		return ev_NONE
	    
	if command == ev_OK and args == 6:
	    self.prod_brstek = int(self.brstek.text)
	    #if self.prod_brstek == 0:
		#msgbox = MessageBox(28, 9, 10, 32, COL_TAB, COL_TAB, \
		#                        ["  ", "   ", "  ", "   "], "", msg_OK)
		#yes = msgbox.mainLoop()
		#msgbox.destroy()
		#del msgbox
		#pflush()
		#self.select(5)
		#return ev_NONE
	    self.select(7)
	    return ev_NONE
	
	if command == ev_OK and args == 7:
	    self.prod_edbr = int(self.edbr.text)
	    if self.prod_brstek + self.prod_edbr == 0:
		msgbox = MessageBox(28, 9, 10, 32, COL_TAB, COL_TAB, \
		                        ["  ", "    !", "  ", "     ", "!"], "", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.select(6)
		return ev_NONE

	    self.select(8)
	    return ev_NONE
	
	if command == ev_OK and args == 8:
	    self.prod_pak = int(self.pak.text)
	    if self.prod_pak == 0:
		msgbox = MessageBox(28, 9, 10, 32, COL_TAB, COL_TAB, \
		                        ["  ", "    ", "  ", "  1"], "", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.select(8)
		return ev_NONE
	    self.prod_obsto = self.prod_edbr + self.prod_brstek * self.prod_pak
	    self.select(9)
	    return ev_NONE

	if command == ev_OK and args == 9:
	    self.prod_gr = float(self.gr.text)
	    if self.prod_gr == 0:
		msgbox = MessageBox(28, 9, 10, 32, COL_TAB, COL_TAB, \
		                        ["  ", "   ", "   -", " "], "", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.select(9)
		return ev_NONE
	    self.select(2)
	    return ev_NONE	
	
	if command == ev_OK and args == 10:
	    self.select(0)
	    return ev_NONE
	
	if command == ev_ACTIVATE and args == curses.KEY_F8:
	    it = self.jlist.items[self.jlist.hilite]
	    ih = self.jlist.hidden_items[self.jlist.hilite]
	    
	    if int(ih[6]) <> 0:
		msgbox = MessageBox(28, 9, 8, 30, COL_TAB, COL_TAB, \
		                        ["  ", "  ", " !"], "?", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.select(0)
		return ev_NONE
	    
	    msgbox = MessageBox(28, 9, 8, 26, COL_TAB, COL_TAB, \
		                        ["  ", "  "], "?", msg_YESNO)
	    yes = msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()
	    if yes == cmd_CANCEL:
		return ev_NONE
	    
	    self.planline = 0
	    self.writexy(49, 7, "                  ", COL_TEXT1)
	    self.writexy(49, 8, "          ", COL_TEXT1)
	    
	    self.material.SetText(strip(it[0].Label))
	    self.product.SetText(strip(ih[2]))
	    self.machine.SetText(strip(it[7].Label))
	    self.dadeno.SetText(strip(it[1].Label))
	    self.ost.SetText(strip(it[4].Label))
	    self.brak.SetText(strip(it[3].Label))
	    self.spul.SetText(strip(it[2].Label))
	    self.artno1 = int(ih[3])
	    self.grno2 = int(ih[4])
	    self.artno2 = int(ih[5])
	    self.brakmode = int(ih[6])
	    
	    if self.brakmode == 1:
		self.writexy(36, 2, " /", COL_WARN, TRUE)
	    elif self.brakmode == 2:
		self.writexy(36, 2, "  ", COL_WARN, TRUE)
	    elif self.brakmode == 0:
		self.writexy(36, 2, "                     ", COL_MAIN, TRUE)

	 
	    ll = int(ih[1])
	    
	    br = int(int(it[5].Label) / int(it[6].Label))
	    self.brstek.SetText(str(br))
	    bre = int(it[5].Label) - br * int(it[6].Label)
	    self.edbr.SetText(str(bre))
	    self.pak.SetText(strip(it[6].Label))
	    self.gr.SetText(str(ih[0]))
	    
	    self.jlist.items.remove(it)
	    self.jlist.hidden_items.remove(ih)
	    self.jlist.handleEvent(curses.KEY_HOME)
	    self.CalculateSums()
	    
	    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
	    curs = db.cursor()
	    curs.execute("""DELETE FROM prjournal WHERE
	                    snindx = %s AND
			    sm = %s AND
			    lineno = %s AND printed = 0""",
			    (self.shift_indx, self.shift, ll))
	    db.close()
	    
	    self.select(0)
	
	if command == ev_ACTIVATE and args == curses.KEY_F2:
	    if self.CheckValues() == FALSE:
		self.select(2)
		return ev_NONE
	    self.planline = 0
	    
	    self.writexy(36, 2, "                     ", COL_MAIN, TRUE)
	    self.lineindx = self.lineindx + 1
	    self.jlist.addItem([self.material.text,\
	                        str(self.kgdadeno), \
				str(self.kgspul), \
				str(self.kgbrak), \
				str(self.kgost), \
				str(self.prod_obsto), \
				str(self.prod_pak),\
				self.machine.text[0:5]],
				hidden = [self.prod_gr,\
				          self.lineindx,\
					  self.product.text,\
					  self.artno1,\
					  self.grno2,\
					  self.artno2,
					  self.brakmode, 0])
	    self.jlist.draw()
	    
	    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
	    curs = db.cursor()
	    curs.execute("""INSERT INTO prjournal (
			    snindx, sm, mode,
			    lineno,
			    artno1, folio,
			    grno2, artno2, product,
			    dadeno, spul, brak, ostat,
			    brstek, pak, gr,
			    machine, date) VALUES (
			    %s, %s, %s,
			    %s, 
			    %s, %s,
			    %s, %s, %s,
			    %s, %s, %s, %s,
			    %s, %s, %s,
			    %s, NOW())""",
			    (self.shift_indx, self.shift, self.brakmode,
			    self.lineindx,
			    self.artno1, self.material.text,
			    self.grno2, self.artno2, self.product.text,
			    self.kgdadeno, self.kgspul, self.kgbrak, self.kgost,
			    self.prod_obsto, self.prod_pak, self.prod_gr,
			    self.machine.text[0:5]))
	    
	    # 
	    #   /   2 
	    #
	    #curs.execute("""INSERT INTO delivery (group_no, art_no, object_no, partn_dn, doc_no, doc_counter, doc_date, deliv_qnty, price, rest_qnty, valid, valid_date, valid_oper, source_ty, source_no, date, oper) VALUES (%s, %s, %s, %s, %s, %s, NOW(), %s, %s, %s, %s, NOW(), %s, %s, %s, NOW(), %s)""",
	    #		    (int(grno2), int(artno2), 2,
	    #		    4, 
	    #		    int(self.doc_no), int(self.doc_counter),
	    #		    self.prod_obsto, pr, self.prod_obsto, 
	    #		    1, "cv",
	    #		    0, 0, 
	    #		    "nobody"))

	    db.close()
	    self.brakmode = 0
	    self.material.SetText("")
	    self.product.SetText("")
	    self.machine.SetText("")
	    self.dadeno.SetText("0")
	    self.ost.SetText("0")
	    self.brak.SetText("0")
	    self.spul.SetText("0")
	    self.brstek.SetText("0")
	    self.edbr.SetText("0")
	    self.pak.SetText("1")
	    self.gr.SetText("0")
	    self.product_info.SetText(self.jlist.hidden_items[self.jlist.hilite][2])
	    self.writexy(49, 7, "                  ", COL_TEXT1)
	    self.writexy(49, 8, "          ", COL_TEXT1)
	    
	    self.CalculateSums()
		
	    self.select(0)
	    return ev_NONE


class PWDDialog(Dialog):
    def __init__(self, parent, shift, counter, pwdtype= 1):
	Dialog.__init__(self, 28, 6, 4, 20, COL_MAIN)
	self.shift = shift
	self.shift_indx = counter
	self.pwdtype = pwdtype
	self.Parent = parent
	
	self.writexy(2, 1, " .", COL_TEXT1)
	self.pwd = EditLine(self, 2, 2, 14)
	self.addWidget(self.pwd)
	
	self.select(0)
	
	
#------------------------------------------------------------------------------

class DocsOut(Dialog):
    def __init__(self, parent, shift, counter):
	Dialog.__init__(self, 0, 0, 24, 79, COL_MAIN)
	self.set_caption(" ")
	self.shift = shift
	self.shift_indx = counter
	self.Parent = parent
	
	self.artno1 = 0
	self.grno2 = 0
	self.artno2 = 0
	
	self.kgdadeno = 0
	self.kgost = 0
	self.kgspul = 0
	self.kgbrak = 0
	
	self.prod_brstek = 0
	self.prod_edbr = 0
	self.prod_pak = 1
	self.prod_gr = 0
	self.sum_dadeno = 0
	self.sum_ost = 0
	self.sum_prod = 0
	
	self.total_dadeno = 0
	self.total_spul = 0
	self.total_brak = 0
	self.total_ost = 0
	self.total_prod = 0
	
	#     
	self.lineindx = 0
	#  -   
	self.brakmode = 0
	
	self.planline = 0
	
	self.DrawNo(self.shift)
	#0
	self.product = OptionLine(self, 2, 3, 33, "  ", pos_UP)
	self.addWidget(self.product)
	#1
	self.machine = OptionLine(self, 36, 3, 20, " /", pos_UP)
	self.machine.SetText("")
	self.addWidget(self.machine)
	#2
	self.brstek = LabeledEditLine(self, 2, 5, 10, ".", pos_UP)
	self.brstek.SetText("0")
	self.brstek.setType(dt_numeric)
	self.addWidget(self.brstek)
	#3
	self.edbr = LabeledEditLine(self, 14, 5, 10, "+ . .", pos_UP)
	self.edbr.SetText("0")
	self.edbr.setType(dt_numeric)
	self.addWidget(self.edbr)
	#4
	self.pak = LabeledEditLine(self, 26, 5, 10, "  ", pos_UP)
	self.pak.SetText("1")
	self.pak.setType(dt_numeric)
	self.pak.Focusable = FALSE
	self.addWidget(self.pak)	
	#5
	self.gr =  LabeledEditLine(self, 38, 5, 10, "", pos_UP)
	self.gr.SetText("0")
	self.gr.setType(dt_float)
	self.gr.Focusable = FALSE
	self.addWidget(self.gr)	
	
	#6
	self.jlist = MultiListBox(self, 2, 9, 13, 75, COL_TEXT)
	self.jlist.setItemColors(COL_TITLE, COL_TEXT)
	self.jlist.MultiChoice = FALSE
	self.jlist.addColon(32, "")
	self.jlist.addColon(7, ".", dt_float, 0)
	self.jlist.addColon(7, ".", dt_float, 0)
	self.jlist.addColon(9, "", dt_float, 0)
	
	self.jlist.addColon(5, "", dt_float, 0)
	self.jlist.addColon(7, ".", dt_float, 3)
	self.jlist.addColon(6, "")
	
	self.addWidget(self.jlist)
	
	self.AddHotKey(curses.KEY_F2, 0)
	self.AddHotKey(curses.KEY_F5, 10)
	self.AddHotKey(curses.KEY_F4, 0)	
	self.AddHotKey(curses.KEY_F10, 0)
	self.AddHotKey(curses.KEY_F8, 0)
	self.AddHotKey(curses.KEY_F12, 0)
	
	self.AddHotKey(curses.KEY_NPAGE, 0)
	self.AddHotKey(curses.KEY_PPAGE, 0)
	
	self.jlist.addNotifyRecipient(self, cm_ITEM_CHANGED)

	self.writexy(27, 23, " :                                              ", COL_WARN, TRUE)
	
	self.writexy(0, 24, "| F2 -  | F4 -  | PDn/PUp  | F8 -  | F10 - /. |" , COL_TITLE, TRUE)
	self.CalculateSums()
	self.select(0)
	
    def DrawNo(self, no):
	self.writexy(67, 0, "    : " + str(no) + " ", COL_WARN)
	self.writexy(54, 0, "  : " + str(self.shift_indx) + " ", COL_WARN)
	if no == 1:
	    self.writexy(69, 2,"       ", COL_MAIN)
	    self.writexy(69, 3,"     ", COL_MAIN)
	    self.writexy(69, 4,"     ", COL_MAIN)
	    self.writexy(69, 5,"       ", COL_MAIN)
	    self.writexy(69, 6,"       ", COL_MAIN)
	    self.writexy(69, 7,"       ", COL_MAIN)
	elif no == 2:
	    self.writexy(69, 2,"  ", COL_MAIN)
	    self.writexy(69, 3,"    ", COL_MAIN)
	    self.writexy(69, 4,"      ", COL_MAIN)
	    self.writexy(69, 5,"      ", COL_MAIN)
	    self.writexy(69, 6,"      ", COL_MAIN)
	    self.writexy(69, 7,"", COL_MAIN)
	elif no == 3:
	    self.writexy(69, 2,"  ", COL_MAIN)
	    self.writexy(69, 3,"    ", COL_MAIN)
	    self.writexy(69, 4,"      ", COL_MAIN)
	    self.writexy(69, 5,"      ", COL_MAIN)
	    self.writexy(69, 6,"    ", COL_MAIN)
	    self.writexy(69, 7,"  ", COL_MAIN)
	    

    def GetValues(self):
	self.prod_brstek = int(self.brstek.text)
	self.prod_edbr = int(self.edbr.text)
	self.prod_pak = int(self.pak.text)
	self.prod_gr = float(self.gr.text)
	
	self.prod_obsto = self.prod_edbr + self.prod_brstek * self.prod_pak
	
    def CheckValues(self):
	return FALSE

    def CalculateSums(self):
	self.total_dadeno = 0
	self.total_spul = 0
	self.total_brak = 0
	self.total_ost = 0
	self.total_prod = 0
	    
	for i in range(len(self.jlist.items)):
	    it = self.jlist.items[i]
	    self.total_prod = self.total_prod + float(it[5].Label)
	    
	self.writexy(64, 23, rjust(fix(self.total_prod, 0), 5) + "|", COL_WARN, TRUE)
	

    def Update(self, msg):
	if msg.message == cm_ITEM_CHANGED:
	    i = msg.args[1]
	    self.product_info.SetText(self.jlist.hidden_items[i][2])

	    
    def PrintDocument(self):
	fp = open("proizv"+str(self.shift_indx) + "-" + str(self.shift), "w+")
	fp.write(" :  " + ljust(str(self.shift), 11) + " :COMPANY xx,  2\n")
	
	fp.write("\n")
	fp.write("                                \n")
	#fp.write("                        No: "+ljust(str(self.doc_counter), 15) + ":" + self.nowDate + "\n")
	fp.write(strftime("%d-%m-%Y : %H:%M:%S", localtime()) + "\n")
	fp.write("+----+--------+---------------------------------+-------+------------+\n")
	fp.write("| No |   |                     |  |  |\n")
	fp.write("+----+--------+---------------------------------+-------+------------+\n")
	for i in range(len(self.jlist.items)):
	    it = self.jlist.items[i]
	    ih = self.jlist.hidden_items[i]
	    _grno = ih[1]
	    _artno = ih[2]
	    _qnty = float(it[3].Label)
	    artcode = rjust(str(_grno)+str(_artno), 7)
	    artname = ljust(it[0].Label, 32)
	    wid = center("xx", 7)
	    #wid = center(it[2].Label, 7)
	    ww = rjust(fix(_qnty,3), 12)
	    #if strip(it[2].Label) == ".":
	    #	np = float(tp) * int(p1)
	    #	ww = ljust(str(np), 12)
	    #	sum = rjust(str(np * float(pr)), 10)
	    fp.write("| " + ljust(str(i+1),3) + "| " +  artcode + "| " + artname + "|"+wid+"|"+ww+"|\n")
	fp.write("+----+--------+---------------------------------+-------+------------+\n\n\n")
	fp.write(": " + ljust(get_user(), 32) + "  /               /\n\n")
	fp.write(" : " + ljust(" ", 32) + "  /               /\n\n")
	
	    
	fp.close()
	os.spawnlp(os.P_NOWAIT, './printdoc', './printdoc', 'proizv'+str(self.shift_indx) + "-" + str(self.shift))
	
    def getPlanLine(self, line):
	db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
	curs = db.cursor()
	curs.execute("""SELECT machine, folio, artno1, product, grno2, artno2, qty2 FROM prplan WHERE snindx = %s AND sm = %s AND lineno = %s""", 
	                (self.shift_indx, self.shift, line))
	(mm, ff, a1, pp, g2, a2, qty) = curs.fetchone()
	curs.execute("""SELECT weight, pack1 FROM articles WHERE group_no = %s AND art_no = %s""",
			(g2, a2))
	(_weight, _pack) = curs.fetchone()
	curs.execute("""SELECT SUM(ostat) FROM prjournal WHERE artno1 = %s AND snindx = %s AND sm = %s""",
			(a1, self.shift_indx, self.shift))
	(ost_folio, ) = curs.fetchone()
	db.close()
	self.machine.SetText(mm)
	self.material.SetText(ff)
	self.artno1 = a1
	self.product.SetText(pp)
	self.grno2 = g2
	self.artno2 = a2
	self.pak.SetText(str(_pack))
	self.gr.SetText(str(_weight))
	self.prod_pak = _pack
	self.prod_gr = _weight
	self.writexy(49, 7, "  :", COL_TEXT1)
	self.writexy(49, 8, str(qty), COL_WARN, TRUE)
	
    def UserFn(self, command, args):
	if self.Parent.SCREEN_LOCKED == TRUE:
	    return ev_NONE
	if self.Parent.QUIT_STATUS == TRUE:
	    return ev_NONE
	
	#self.GetValues()

	if command == ev_ACTIVATE and args == curses.KEY_F12:
	    self.PrintDocument()
	    self.select(0)
	    return ev_NONE
	
	if command == ev_ACTIVATE and args == curses.KEY_NPAGE:
	    self.jlist.handleEvent(curses.KEY_DOWN)
	    self.select(0)
	    return ev_NONE

	if command == ev_ACTIVATE and args == curses.KEY_PPAGE:
	    self.jlist.handleEvent(curses.KEY_UP)
	    self.select(0)
	    return ev_NONE
	
	if command == ev_ACTIVATE and args == curses.KEY_F4:
	    plan = ViewPlan(self.Parent, self.shift, self.shift_indx)
	    stat = plan.mainLoop()
	    plan.destroy()
	    pflush()
	    self.select(0)
	    return ev_NONE
	
	if command == ev_OPTION and args == 0:
	    #if self.planline <> 0:
	    #	self.select(2)
	    #	return ev_NONE
	    artdlg = getArtID(shift_indx=self.shift_indx, shift=self.shift)
	    artdlg.mainLoop()
	    if artdlg.plist.hilite == -1:
		artdlg.destroy()
		del artdlg
		msgbox = MessageBox(28, 9, 8, 32, COL_TAB, COL_TAB, \
		                        ["  ", "   ", " !"], "", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()		
		self.select(1)
		return ev_NONE
	    
	    self.product.SetText(artdlg.plist.items[artdlg.plist.hilite][1].Label)
	    artid = artdlg.plist.items[artdlg.plist.hilite][0].Label
	    self.grno2 = artid[0:3]
	    self.artno2 = artid[3:6]
	    self.planline = artdlg.plist.hidden_items[artdlg.plist.hilite][0]
	    
	    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
	    curs = db.cursor()
	    curs.execute("""SELECT weight, pack1 FROM articles WHERE group_no = %s AND art_no = %s AND object_no = 2""",
 	    		(self.grno2, self.artno2))
	    (_weight, _pack) = curs.fetchone()
	    db.close()
	    self.pak.SetText(str(_pack))
	    self.gr.SetText(str(_weight))
	    
	    #self.getPlanLine(self.planline)
	    
	    artdlg.destroy()
	    del artdlg
	    
	    self.select(1)
	    
	    if self.planline == 0:
		self.select(11)
	    return ev_NONE

	if command == ev_OPTION and args == 1:
	    #if self.planline <> 0:
	    #	self.select(2)
	    #	return ev_NONE
	    machdlg = getMachID()
	    machdlg.mainLoop()
	    self.machine.SetText(strip(machdlg.plist.items[machdlg.plist.hilite][1].Label))
	    machdlg.destroy()
	    del machdlg
	    self.select(2)
	    return ev_NONE
	
	if command == ev_OK and args == 2:
	    self.prod_brstek = int(self.brstek.text)
	    #if self.prod_brstek == 0:
		#msgbox = MessageBox(28, 9, 10, 32, COL_TAB, COL_TAB, \
		#                        ["  ", "   ", "  ", "   "], "", msg_OK)
		#yes = msgbox.mainLoop()
		#msgbox.destroy()
		#del msgbox
		#pflush()
		#self.select(5)
		#return ev_NONE
	    self.select(3)
	    return ev_NONE
	
	if command == ev_OK and args == 3:
	    self.prod_edbr = int(self.edbr.text)
	    if self.prod_brstek + self.prod_edbr == 0:
		msgbox = MessageBox(28, 9, 10, 32, COL_TAB, COL_TAB, \
		                        ["  ", "    !", "  ", "     ", "!"], "", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.select(2)
		return ev_NONE

	    self.select(0)
	    return ev_NONE
	

	if command == ev_ACTIVATE and args == curses.KEY_F10:
	    if len(self.jlist.items) == 0:
		msgbox = MessageBox(28, 9, 8, 25, COL_TAB, COL_TAB, \
	                        ["   !", ""], " !", \
				msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		return ev_DONE
	    msgbox = MessageBox(28, 2, 7, 20, COL_TAB, COL_TAB, \
	                        [" "], "?", \
				msg_YESNO)
	    yes = msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()
	    if yes == cmd_YES:
		#    /   
		pwd = PWDDialog(self.Parent, self.shift, self.shift_indx)
		pwd.mainLoop()
		_pwd = pwd.pwd.text
		pwd.destroy()
		del pwd
		pflush()
		
		if _pwd <> "cv":
		    return ev_DONE

		odocno = getDoc_counter(doc_no = 23, update = TRUE)    		
		
		db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
		curs = db.cursor()
		for i in range(len(self.jlist.items)):
		    it = self.jlist.items[i]
		    ih = self.jlist.hidden_items[i]
		    _grno = ih[1]
		    _artno = ih[2]
		    _qnty = float(it[3].Label)
		    curs.execute("""INSERT INTO delivery (group_no, art_no, object_no, partn_dn, doc_no, doc_counter, doc_date, deliv_qnty, price, rest_qnty, valid, valid_date, valid_oper, source_ty, source_no, date, oper) VALUES (%s, %s, %s, %s, %s, %s, NOW(), %s, %s, %s, %s, NOW(), %s, %s, %s, NOW(), %s)""",
	    		    (int(_grno), int(_artno), 2,
	    		    4, 
	    		    23, int(odocno),
	    		    _qnty, 0, _qnty, 
	    		    1, "proizv",
	    		    0, 0, 
	    		    "proizv"))

		db.close()		
		self.PrintDocument()
		return ev_QUIT
		
	    return ev_DONE
	
	
	if command == ev_ACTIVATE and args == curses.KEY_F8:
	    it = self.jlist.items[self.jlist.hilite]
	    ih = self.jlist.hidden_items[self.jlist.hilite]
	    
	    if int(ih[6]) <> 0:
		msgbox = MessageBox(28, 9, 8, 30, COL_TAB, COL_TAB, \
		                        ["  ", "  ", " !"], "?", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.select(0)
		return ev_NONE
	    
	    msgbox = MessageBox(28, 9, 8, 26, COL_TAB, COL_TAB, \
		                        ["  ", "  "], "?", msg_YESNO)
	    yes = msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()
	    if yes == cmd_CANCEL:
		return ev_NONE
	    
	    self.planline = 0
	    self.writexy(49, 7, "                  ", COL_TEXT1)
	    self.writexy(49, 8, "          ", COL_TEXT1)
	    
	    self.material.SetText(strip(it[0].Label))
	    self.product.SetText(strip(ih[2]))
	    self.machine.SetText(strip(it[7].Label))
	    self.dadeno.SetText(strip(it[1].Label))
	    self.ost.SetText(strip(it[4].Label))
	    self.brak.SetText(strip(it[3].Label))
	    self.spul.SetText(strip(it[2].Label))
	    self.artno1 = int(ih[3])
	    self.grno2 = int(ih[4])
	    self.artno2 = int(ih[5])
	    self.brakmode = int(ih[6])
	    
	    if self.brakmode == 1:
		self.writexy(36, 2, " /", COL_WARN, TRUE)
	    elif self.brakmode == 2:
		self.writexy(36, 2, "  ", COL_WARN, TRUE)
	    elif self.brakmode == 0:
		self.writexy(36, 2, "                     ", COL_MAIN, TRUE)

	 
	    ll = int(ih[1])
	    
	    br = int(int(it[5].Label) / int(it[6].Label))
	    self.brstek.SetText(str(br))
	    bre = int(it[5].Label) - br * int(it[6].Label)
	    self.edbr.SetText(str(bre))
	    self.pak.SetText(strip(it[6].Label))
	    self.gr.SetText(str(ih[0]))
	    
	    self.jlist.items.remove(it)
	    self.jlist.hidden_items.remove(ih)
	    self.jlist.handleEvent(curses.KEY_HOME)
	    self.CalculateSums()
	    
	    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
	    curs = db.cursor()
	    curs.execute("""DELETE FROM prjournal WHERE
	                    snindx = %s AND
			    sm = %s AND
			    lineno = %s AND printed = 0""",
			    (self.shift_indx, self.shift, ll))
	    db.close()
	    
	    self.select(0)
	
	if command == ev_ACTIVATE and args == curses.KEY_F2:
	    #if self.CheckValues() == FALSE:
	    #	self.select(2)
	    #	return ev_NONE
	    self.planline = 0
	    self.prod_brstek = int(self.brstek.text)
	    self.prod_edbr = int(self.edbr.text)
	    
	    if self.prod_brstek + self.prod_edbr == 0 or \
	       self.product.text == "" or \
	       self.machine.text == "":
		msgbox = MessageBox(28, 9, 8, 25, COL_TAB, COL_TAB, \
	                        ["  ", "  !"], " !", \
				msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		return ev_DONE
		   
	    
	    self.lineindx = self.lineindx + 1
	    _pack = int(self.pak.text)
	    self.jlist.addItem([self.product.text,\
				str(self.prod_brstek), \
				str(self.prod_edbr), \
				str(_pack * self.prod_brstek + self.prod_edbr),\
				str(_pack),
				self.gr.text,
				self.machine.text[0:5]],
				hidden = [self.lineindx,\
					  self.grno2,\
					  self.artno2,
					  self.brakmode, 0])
	    self.jlist.draw()
	    
	    #db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
	    #curs = db.cursor()
	    #curs.execute("""INSERT INTO prjournal (
	    #		    snindx, sm, mode,
	    #		    lineno,
	    #		    artno1, folio,
	    #		    grno2, artno2, product,
	    #		    dadeno, spul, brak, ostat,
	    #		    brstek, pak, gr,
	    #		    machine, date) VALUES (
	    #		    %s, %s, %s,
	    #		    %s, 
	    #		    %s, %s,
	    #		    %s, %s, %s,
	    #		    %s, %s, %s, %s,
	    #		    %s, %s, %s,
	    #		    %s, NOW())""",
	    #		    (self.shift_indx, self.shift, self.brakmode,
	    #		    self.lineindx,
	    #		    self.artno1, self.material.text,
	    #		    self.grno2, self.artno2, self.product.text,
	    #		    self.kgdadeno, self.kgspul, self.kgbrak, self.kgost,
	    #		    self.prod_obsto, self.prod_pak, self.prod_gr,
	    #		    self.machine.text[0:5]))
	    
	    # 
	    #   /   2 
	    #
	    
	    self.brakmode = 0
	    self.product.SetText("")
	    self.machine.SetText("")
	    self.brstek.SetText("0")
	    self.edbr.SetText("0")
	    self.pak.SetText("1")
	    self.gr.SetText("0")
	    #self.CalculateSums()
		
	    self.select(0)
	    return ev_NONE


class PlanBook(Dialog):
    def __init__(self, parent, shift, counter, viewonly = 0):
	Dialog.__init__(self, 0, 0, 24, 79, COL_MAIN)
	self.set_caption(" ")
	self.shift = shift
	self.shift_indx = counter
	self.Parent = parent
	self.viewonly = viewonly
	
	self.artno1 = 0
	self.grno2 = 0
	self.artno2 = 0

	self.kgnorma = 0
	self.npersons = 0
	
	self.kgdadeno = 0
	self.kgost = 0
	self.kgspul = 0
	self.kgbrak = 0
	
	self.prod_brstek = 0
	self.prod_edbr = 0
	self.prod_pak = 1
	self.prod_gr = 0
	self.sum_dadeno = 0
	self.sum_ost = 0
	self.sum_prod = 0
	
	self.total_dadeno = 0
	self.total_spul = 0
	self.total_brak = 0
	self.total_ost = 0
	self.total_prod = 0
	
	#     
	self.lineindx = 0
	#  -   
	self.brakmode = 0
	
	self.DrawNo(self.shift)
	
	#0
	self.material = OptionLine(self, 2, 2, 33, "    ()", pos_UP)
	self.addWidget(self.material)
	#1
	self.product = OptionLine(self, 2, 4, 33, "  ", pos_UP)
	self.addWidget(self.product)
	#2
	self.machine = OptionLine(self, 36, 4, 20, "/", pos_UP)
	self.machine.SetText("")
	self.addWidget(self.machine)
	#3
	self.norma = LabeledEditLine(self, 2, 6, 6, "", pos_UP)
	self.norma.SetText("0")
	self.norma.setType(dt_numeric)
	self.addWidget(self.norma)
	#4
	self.brpersons = LabeledEditLine(self, 10, 6, 6, "..", pos_UP)
	self.brpersons.SetText("0")
    	self.brpersons.setType(dt_numeric)
	self.addWidget(self.brpersons)	
	#5	
	self.jlist = MultiListBox(self, 1, 12, 10, 77, COL_TEXT)
	self.jlist.setItemColors(COL_TITLE, COL_TEXT)
	self.jlist.MultiChoice = FALSE
	self.jlist.addColon(6, "")
	self.jlist.addColon(31, "")
	self.jlist.addColon(9, "", dt_float, 0)
	self.jlist.addColon(31, "  ()")
	
	self.jlist.dbQuery = "SELECT machine, product, qty2, folio, lineno, artno1, grno2, artno2, npersons, mode FROM prplan WHERE sm = " + str(self.shift) + " AND snindx = " + str(self.shift_indx)
	m = Message()
	m.message = cm_RELOAD
	self.jlist.Update(m)
	
	self.addWidget(self.jlist)
	
	for i in range(len(self.jlist.items)):
	    if int(self.jlist.hidden_items[i][0]) > self.lineindx:
		self.lineindx = int(self.jlist.hidden_items[i][0])
	
	#6
	self.person_info = EditLine(self, 11, 11, 32, normcol = COL_TITLE)
	self.person_info.Focusable = FALSE
	if len(self.jlist.items) > 0:
	    self.person_info.SetText(self.jlist.hidden_items[0][2])
	self.addWidget(self.person_info)
	
	self.AddHotKey(curses.KEY_F2, 0)
	self.AddHotKey(curses.KEY_F4, 0)
	self.AddHotKey(curses.KEY_F10, 11)
	self.AddHotKey(curses.KEY_F8, 0)
	
	self.AddHotKey(curses.KEY_NPAGE, 0)
	self.AddHotKey(curses.KEY_PPAGE, 0)
	
	self.jlist.addNotifyRecipient(self, cm_ITEM_CHANGED)

	self.writexy(16, 5, "  :     /", COL_TAB)
	self.writexy(16, 6, "   ,    - ", COL_TAB)
	
	
	self.writexy(36, 3, ". ", COL_TEXT1)
	self.writexy(1, 23, "  :                                              ", COL_WARN, TRUE)
	
	self.writexy(1, 11, " . : ", COL_TITLE, TRUE)
	self.writexy(43, 11, "                                    ", COL_TITLE)
	
	self.writexy(0, 24, "| F2 -  | F4 -  | F5 -  | PDn/PUp  | F8 -  |" , COL_TITLE, TRUE)
	#self.CalculateSums()
	self.select(0)
	
    def DrawNo(self, no):
	self.writexy(67, 0, "    : " + str(no) + " ", COL_WARN)
	self.writexy(54, 0, "  : " + str(self.shift_indx) + " ", COL_WARN)
	if no == 1:
	    self.writexy(69, 2,"       ", COL_MAIN)
	    self.writexy(69, 3,"     ", COL_MAIN)
	    self.writexy(69, 4,"     ", COL_MAIN)
	    self.writexy(69, 5,"       ", COL_MAIN)
	    self.writexy(69, 6,"       ", COL_MAIN)
	    self.writexy(69, 7,"       ", COL_MAIN)
	elif no == 2:
	    self.writexy(69, 2,"  ", COL_MAIN)
	    self.writexy(69, 3,"    ", COL_MAIN)
	    self.writexy(69, 4,"      ", COL_MAIN)
	    self.writexy(69, 5,"      ", COL_MAIN)
	    self.writexy(69, 6,"      ", COL_MAIN)
	    self.writexy(69, 7,"", COL_MAIN)
	elif no == 3:
	    self.writexy(69, 2,"  ", COL_MAIN)
	    self.writexy(69, 3,"    ", COL_MAIN)
	    self.writexy(69, 4,"      ", COL_MAIN)
	    self.writexy(69, 5,"      ", COL_MAIN)
	    self.writexy(69, 6,"    ", COL_MAIN)
	    self.writexy(69, 7,"  ", COL_MAIN)
	    
	
    def CheckValues(self):
	self.kgnorma = int(self.norma.text)
	self.npersons = int(self.brpersons.text)
	if self.material.text == "" or self.product.text == "" or \
	   self.machine.text == "":
	    msgbox = MessageBox(28, 9, 9, 32, COL_TAB, COL_TAB, \
		                        ["  ", "  ", "  , ", " "], "", msg_OK)
	    yes = msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()
	    return FALSE
	
	
	if self.machine.text[0:3] == "" and self.npersons < 3:
	    msgbox = MessageBox(28, 9, 8, 32, COL_TAB, COL_TAB, \
		                        ["  ", "  ", "  !"], "", msg_OK)
	    yes = msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()
	    return FALSE
	    
	if self.kgnorma == 0 or self.npersons == 0:
	    msgbox = MessageBox(28, 9, 9, 32, COL_TAB, COL_TAB, \
		                        ["  ", " ", "    ", "  "], "", msg_OK)
	    yes = msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()
	    return FALSE
	
	return TRUE

    def CalculateSums(self):
	self.total_dadeno = 0
	self.total_spul = 0
	self.total_brak = 0
	self.total_ost = 0
	self.total_prod = 0
	    
	for i in range(len(self.jlist.items)):
	    it = self.jlist.items[i]
	    self.total_dadeno = self.total_dadeno + float(it[1].Label)
	    self.total_spul = self.total_spul + float(it[2].Label)
	    self.total_brak = self.total_brak + float(it[3].Label)
	    self.total_ost = self.total_ost + float(it[4].Label)
	    self.total_prod = self.total_prod + float(it[5].Label)
	    
	self.writexy(35, 22, rjust(fix(self.total_dadeno, 3), 7) + "|", COL_WARN, TRUE)
	self.writexy(43, 22, rjust(fix(self.total_spul, 3), 6) + "|", COL_WARN, TRUE)
	self.writexy(50, 22, rjust(fix(self.total_brak, 3), 6) + "|", COL_WARN, TRUE)
	self.writexy(57, 22, rjust(fix(self.total_ost, 3), 6) + "|", COL_WARN, TRUE)
	self.writexy(64, 22, rjust(fix(self.total_prod, 0), 5) + "|", COL_WARN, TRUE)
	

    def Update(self, msg):
	if msg.message == cm_ITEM_CHANGED:
	    i = msg.args[1]
	    if len(self.jlist.items) > 0:
		self.person_info.SetText(str(self.jlist.hidden_items[i][4]))
	    else:
		self.person_info.SetText("")
	
    def UserFn(self, command, args):
	if self.Parent.SCREEN_LOCKED == TRUE:
	    return ev_NONE
	if self.Parent.QUIT_STATUS == TRUE:
	    return ev_NONE
	#self.GetValues()

	if command == ev_ACTIVATE and args == curses.KEY_NPAGE:
	    self.jlist.handleEvent(curses.KEY_DOWN)
	    self.select(0)
	    return ev_NONE

	if command == ev_ACTIVATE and args == curses.KEY_PPAGE:
	    self.jlist.handleEvent(curses.KEY_UP)
	    self.select(0)
	    return ev_NONE
	
	if command == ev_ACTIVATE and args == curses.KEY_F10:
	    self.brakmode = self.brakmode + 1
	    if self.brakmode == 3:
		self.brakmode = 0
	    
	    if self.brakmode == 1:
		self.writexy(36, 2, " /", COL_WARN, TRUE)
	    elif self.brakmode == 2:
		self.writexy(36, 2, "  ", COL_WARN, TRUE)
	    elif self.brakmode == 0:
		self.writexy(36, 2, "                     ", COL_MAIN, TRUE)
	    return ev_DONE
	
	if command == ev_OPTION and args == 0:
	    foliodlg = getFolioID()
	    foliodlg.mainLoop()
	    self.material.SetText(foliodlg.plist.items[foliodlg.plist.hilite][1].Label)
	    self.artno1 = int(foliodlg.plist.items[foliodlg.plist.hilite][0].Label)
	    foliodlg.destroy()
	    del foliodlg
	    self.select(1)
	    return ev_NONE
	if command == ev_OPTION and args == 1:
	    artdlg = getArtID()
	    artdlg.mainLoop()
	    self.product.SetText(artdlg.plist.items[artdlg.plist.hilite][1].Label)
	    artid = artdlg.plist.items[artdlg.plist.hilite][0].Label
	    self.grno2 = int(artid[0:2])
	    self.artno2 = int(artid[2:5])
	    artdlg.destroy()
	    del artdlg
	    self.select(2)
	    return ev_NONE

	if command == ev_OPTION and args == 2:
	    machdlg = getMachID()
	    machdlg.mainLoop()
	    self.machine.SetText(strip(machdlg.plist.items[machdlg.plist.hilite][1].Label))
	    machdlg.destroy()
	    del machdlg
	    self.select(3)
	    return ev_NONE
	
	if command == ev_OK and args == 3:
	    self.kgnorma = int(self.norma.text)
	    if self.kgnorma == 0:
		msgbox = MessageBox(28, 9, 8, 32, COL_TAB, COL_TAB, \
		                        ["  ", "   ", "  "], "", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.select(3)
		return ev_NONE
		
	    self.select(4)
	    return ev_NONE
	if command == ev_OK and args == 4:
	    self.npersons = int(self.brpersons.text)
	    if self.npersons == 0:
		msgbox = MessageBox(28, 9, 8, 32, COL_TAB, COL_TAB, \
		                        ["  ", "    ", "   !"], "", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.select(4)
		return ev_NONE
	    self.select(0)
	    return ev_NONE
	
	if command == ev_ACTIVATE and args == curses.KEY_F8:
	    msgbox = MessageBox(28, 9, 8, 26, COL_TAB, COL_TAB, \
		                        ["  ", "  "], "?", msg_YESNO)
	    yes = msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()
	    if yes == cmd_CANCEL:
		return ev_NONE
	    
	    it = self.jlist.items[self.jlist.hilite]
	    ih = self.jlist.hidden_items[self.jlist.hilite]
	    
	    self.material.SetText(strip(it[3].Label))
	    self.product.SetText(strip(it[1].Label))
	    self.norma.SetText(strip(it[2].Label))
	    self.machine.SetText(strip(it[0].Label))
	    
	    self.artno1 = int(ih[1])
	    self.grno2 = int(ih[2])
	    self.artno2 = int(ih[3])
	    self.npersons = int(ih[4])
	    self.brpersons.SetText(str(self.npersons))
	    
	    self.brakmode = int(ih[5])
	    
	    if self.brakmode == 1:
		self.writexy(36, 2, " /", COL_WARN, TRUE)
	    elif self.brakmode == 2:
		self.writexy(36, 2, "  ", COL_WARN, TRUE)
	    elif self.brakmode == 0:
		self.writexy(36, 2, "                     ", COL_MAIN, TRUE)
	 
	    ll = int(ih[0])
	    
	    self.jlist.items.remove(it)
	    self.jlist.hidden_items.remove(ih)
	    self.jlist.handleEvent(curses.KEY_HOME)
	    #self.CalculateSums()
	    
	    #db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
	    #curs = db.cursor()
	    #curs.execute("""DELETE FROM prjournal WHERE
	    #                snindx = %s AND
	    #		    sm = %s AND
	    #		    lineno = %s""",
	    #		    (self.shift_indx, self.shift, ll))
	    #db.close()
	    
	    self.select(0)
	
	if command == ev_ACTIVATE and args == curses.KEY_F2:
	    if self.CheckValues() == FALSE:
	    	self.select(0)
	    	return ev_NONE
	    self.writexy(36, 2, "                     ", COL_MAIN, TRUE)
	    self.lineindx = self.lineindx + 1
	    self.jlist.addItem([self.machine.text[0:5],
	                        strip(self.product.text),\
	                        str(self.kgnorma), \
				strip(self.material.text)], 
				hidden = [self.lineindx,\
					  self.artno1,\
					  self.grno2,\
					  self.artno2,
					  self.npersons,
					  self.brakmode])
	    self.jlist.draw()
	    
	    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
	    curs = db.cursor()
	    curs.execute("""INSERT INTO prplan (
	    		    snindx, sm, lineno, mode,
			    machine, npersons,
			    folio, artno1, qty1,
	    		    product, grno2, artno2, qty2,
			    date, oper) VALUES (
	    		    %s, %s, %s, %s,
	    		    %s, %s,
	    		    %s, %s, %s,
	    		    %s, %s, %s, %s,
	    		    NOW(), %s )""",
			    
	    		    (self.shift_indx, self.shift, self.lineindx, self.brakmode,
	    		    self.machine.text[0:5], self.npersons,
			    self.material.text, self.artno1, 0,
	     		    self.product.text, self.grno2, self.artno2, self.kgnorma,
			    "cv"))
	    db.close()

	    self.material.SetText("")
	    self.product.SetText("")
	    self.machine.SetText("")
	    self.norma.SetText("0")
	    self.brpersons.SetText("0")
	    self.brakmode = 0
	    self.person_info.SetText(str(self.jlist.hidden_items[self.jlist.hilite][4]))
	    
	    #self.CalculateSums()
		
	    self.select(0)
	    return ev_NONE

#----------------------------------------------------------------------------

class ViewPlan(Dialog):
    def __init__(self, parent, shift, counter, viewonly = 0):
	Dialog.__init__(self, 0, 10, 14, 79, COL_MAIN)
	self.set_caption(" ", color = COL_WARN, pos = pos_RIGHT)
	self.shift = shift
	self.shift_indx = counter
	self.Parent = parent
	self.viewonly = viewonly
	
	self.artno1 = 0
	self.grno2 = 0
	self.artno2 = 0

	self.kgnorma = 0
	self.npersons = 0
	
	#     
	self.lineindx = 0
	#  -   
	self.brakmode = 0
	
	#0
	self.jlist = MultiListBox(self, 1, 2, 9, 77, COL_TEXT)
	self.jlist.setItemColors(COL_TITLE, COL_TEXT)
	self.jlist.MultiChoice = FALSE
	self.jlist.addColon(6, "")
	self.jlist.addColon(31, "")
	self.jlist.addColon(9, "", dt_float, 0)
	self.jlist.addColon(31, "  ()")
	
	self.jlist.Focusable = TRUE
	
	self.jlist.dbQuery = "SELECT machine, product, qty2, folio, lineno, artno1, grno2, artno2, npersons, mode FROM prplan WHERE sm = " + str(self.shift) + " AND snindx = " + str(self.shift_indx)
	m = Message()
	m.message = cm_RELOAD
	self.jlist.Update(m)
	
	self.addWidget(self.jlist)
	
	#6
	self.person_info = EditLine(self, 11, 1, 32, normcol = COL_TITLE)
	self.person_info.Focusable = FALSE
	if len(self.jlist.items) > 0:
	    self.person_info.SetText(self.jlist.hidden_items[0][2])
	self.addWidget(self.person_info)
	
	self.AddHotKey(curses.KEY_NPAGE, 0)
	self.AddHotKey(curses.KEY_PPAGE, 0)
	
	self.jlist.addNotifyRecipient(self, cm_ITEM_CHANGED)

	self.writexy(1, 12, "  :                                              ", COL_WARN, TRUE)
	
	self.writexy(1, 1, " . : ", COL_TITLE, TRUE)
	self.writexy(43, 1, "                                    ", COL_TITLE)
	
	self.select(0)
	
    def UserFn(self, command, args):
	if command == ev_OK and args == 0:
	    return ev_DONE
	else:
	    return ev_NONE
	
#---------------------------------------------------------------------------
class NormiProduct(Dialog):
    def __init__(self, parent, shift, counter, viewonly = 0):
	Dialog.__init__(self, 0, 0, 24, 79, COL_MAIN)
	self.set_caption("   ")
	self.shift = shift
	self.shift_indx = counter
	self.Parent = parent
	self.viewonly = viewonly
	
	self.lineindx = 0
	#0
	self.set_color(COL_MAIN)
	self.win.hline(10, 1, curses.ACS_BSSB, 78, 5)
	
	self.norma = LabeledEditLine(self, 54, 12, 10, "", pos_UP)
	self.norma.setType(dt_float)
	self.addWidget(self.norma)
	
	self.jlist = MultiListBox(self, 2, 12, 10, 48, COL_TEXT)
	self.jlist.setItemColors(COL_TITLE, COL_TEXT)
	self.jlist.MultiChoice = FALSE
	self.jlist.addColon(6, ".")
	self.jlist.addColon(32, "")
	self.jlist.addColon(10, ".", dt_float, 5)
	
	self.jlist.dbQuery = "SELECT CONCAT(group_no, art_no), name, norma FROM articles WHERE group_no IN (1, 2) AND object_no = 2"
	m = Message()
	m.message = cm_RELOAD
	self.jlist.Update(m)	
	self.addWidget(self.jlist)
    
	self.AddHotKey(curses.KEY_F2, 0)
	self.AddHotKey(curses.KEY_F4, 0)
	self.AddHotKey(curses.KEY_F10, 0)
	self.AddHotKey(curses.KEY_F8, 0)
	
	#self.AddHotKey(curses.KEY_NPAGE, 0)
	#self.AddHotKey(curses.KEY_PPAGE, 0)
	
	self.jlist.addNotifyRecipient(self.norma, cm_UPDATE, 2)

	#self.writexy(35, 2, " F10 -  ", COL_WARN, TRUE)
	#self.writexy(2, 23, "  :                                        ", COL_WARN, TRUE)
	
	#self.writexy(0, 24, "| F2 -  | F5 -  | PDn/PUp  |" , COL_TITLE, TRUE)
	#self.CalculateSums()
	self.select(1)

	
    def UserFn(self, command, args):
	if self.Parent.SCREEN_LOCKED == TRUE:
	    return ev_NONE
	if self.Parent.QUIT_STATUS == TRUE:
	    return ev_NONE
	#self.GetValues()
	
	if command == ev_OK and args == 1:
	    self.select(0)
	    return ev_NONE
	
	if command == ev_OK and args == 0:
	    if strip(self.norma.text) <> "":
		k = float(self.norma.text)
		i = self.jlist.hilite
		self.jlist.items[i][2].SetText(str(k))
		self.jlist.draw()
		artid = self.jlist.items[i][0].Label
		gr = artid[0:2]
		ar = artid[2:]
		db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
		curs = db.cursor()
		curs.execute("""UPDATE articles SET norma = %s 
		                WHERE group_no = %s AND
				art_no = %s AND object_no = 2""",
				(k, gr, ar))
		db.close()
		
		self.select(1)
		return ev_NONE
	    else:
		self.select(0)
		return ev_NONE
	
	
class NewReceipe(Dialog):
    def __init__(self, parent, shift, counter, viewonly = 0):
	Dialog.__init__(self, 29, 0, 24, 50, COL_MAIN)
	self.set_caption(" -  ", pos = pos_RIGHT)
	self.shift = shift
	self.shift_indx = counter
	self.Parent = parent
	self.viewonly = viewonly
	
	self.browse = FALSE
	
	self.artno1 = 0
	self.grno1 = 0
	
	self.artno2 = 0
	self.grno2 = 0
	self.k1 = 0
	
	self.artno3 = 0
	self.grno3 = 0
	self.k2 = 0
	
	self.artno4 = 0
	self.grno4 = 0
	self.k3 = 0
	
	#     
	self.lineindx = 0
	#0
	self.name = LabeledEditLine(self, 2, 2, 20, "  ", pos_UP)
	self.addWidget(self.name)
	
	#1
	self.product = OptionLine(self, 2, 4, 33, "  ", pos_UP)
	self.product.canClear = TRUE
	self.addWidget(self.product)
	#2
	self.sur1 = OptionLine(self, 2, 6, 33, "  1", pos_UP)
	self.sur1.canClear = TRUE
	self.addWidget(self.sur1)	
	
	#3
	self.sk1 = LabeledEditLine(self, 36, 6, 8, ".", pos_UP)
	self.sk1.setType(dt_numeric)
	self.sk1.SetText("0")
	self.addWidget(self.sk1)
	#4
	self.sur2 = OptionLine(self, 2, 8, 33, "  2", pos_UP)
	self.sur2.canClear = TRUE
	self.addWidget(self.sur2)	
	#5
	self.sk2 = LabeledEditLine(self, 36, 8, 8, ".", pos_UP)
	self.sk2.setType(dt_numeric)	
	self.sk2.SetText("0")
	self.addWidget(self.sk2)
	#6
	self.sur3 = OptionLine(self, 2, 10, 33, "  3", pos_UP)
	self.sur3.canClear = TRUE
	self.addWidget(self.sur3)	
	#7
	self.sk3 = LabeledEditLine(self, 36, 10, 8, ".", pos_UP)
	self.sk3.setType(dt_numeric)		
	self.sk3.SetText("0")
	self.addWidget(self.sk3)
	
	#8
	self.jlist = MultiListBox(self, 2, 12, 10, 46, COL_TEXT)
	self.jlist.setItemColors(COL_TITLE, COL_TEXT)
	self.jlist.MultiChoice = FALSE
	self.jlist.addColon(7, "")
	self.jlist.addColon(32, "")
	self.jlist.addColon(7, "o.")
	
	#self.jlist.dbQuery = "SELECT machine, product, qty2, folio, lineno, artno1, grno2, artno2, npersons, mode FROM prplan WHERE sm = " + str(self.shift) + " AND snindx = " + str(self.shift_indx)
	#m = Message()
	#m.message = cm_RELOAD
	#self.jlist.Update(m)
	
	self.addWidget(self.jlist)
	
	
	self.AddHotKey(curses.KEY_F2, 0)
	self.AddHotKey(curses.KEY_F4, 0)
	self.AddHotKey(curses.KEY_F10, 0)
	self.AddHotKey(curses.KEY_F8, 0)
	
	self.AddHotKey(curses.KEY_NPAGE, 0)
	self.AddHotKey(curses.KEY_PPAGE, 0)
	
	self.jlist.addNotifyRecipient(self, cm_ITEM_CHANGED)

	self.writexy(35, 2, " F10 -  ", COL_WARN, TRUE)
	self.writexy(2, 23, "  :                                        ", COL_WARN, TRUE)
	
	self.writexy(0, 24, "| F2 -  | F5 -  | PDn/PUp  |" , COL_TITLE, TRUE)
	#self.CalculateSums()
	self.select(0)
	
	
    def CheckValues(self, final = FALSE):
	
	if self.product.text == "" or self.name.text == "":
	    msgbox = MessageBox(28, 9, 8, 32, COL_TAB, COL_TAB, \
		["  ", "  ", ""], "", msg_OK)
	    yes = msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()
	    return FALSE
	count = 0
	fail = FALSE
	if self.artno2 <> 0 and self.grno2 <> 0:
	    if strip(self.sk1.text) == "":
		fail = TRUE
	    else:
		self.k1 = int(self.sk1.text)
		if self.k1 > 0:
		    count = count + 1
		
	if self.artno3 <> 0 and self.grno3 <> 0:
	    if strip(self.sk2.text) == "":
		fail = TRUE
	    else:
		self.k2 = int(self.sk2.text)
		if self.k2 > 0:
		    count = count + 1
	    
	if self.artno4 <> 0 and self.grno4 <> 0:
	    if strip(self.sk3.text) == "":
		fail = TRUE
	    else:
		self.k3 = int(self.sk3.text)
		if self.k2 > 0:
		    count = count + 1
	    
	if count == 0 or fail == TRUE:
	    msgbox = MessageBox(28, 9, 8, 32, COL_TAB, COL_TAB, \
		    ["  ", "  ", ""], "", msg_OK)
	    yes = msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()
	    return FALSE
	
	if count == 1 and final == TRUE:
	    if self.grno2 <> 0 and self.artno2 <> 0:
		self.k1 = 1
	    elif self.grno3 <> 0 and self.artno3 <> 0:
		self.k2 = 1
	    elif self.grno4 <> 0 and self.artno4 <> 0:
		self.k3 = 1
	return TRUE


    def Update(self, msg):
	if msg.message == cm_ITEM_CHANGED and self.browse == TRUE:
	    it = self.jlist.items[self.jlist.hilite]
	    ih = self.jlist.hidden_items[self.jlist.hilite]
	    
	    self.name.SetText(it[1].Label)
	    self.product.SetText(ih[2])
	    self.sur1.SetText(ih[5])
	    self.sur2.SetText(ih[9])
	    self.sur3.SetText(ih[13])
	    self.sk1.SetText(str(ih[6]))
	    self.sk2.SetText(str(ih[10]))
	    self.sk3.SetText(str(ih[14]))
	    pass
	
    def UserFn(self, command, args):
	if self.Parent.SCREEN_LOCKED == TRUE:
	    return ev_NONE
	if self.Parent.QUIT_STATUS == TRUE:
	    return ev_NONE
	#self.GetValues()

	if command == ev_ACTIVATE and args == curses.KEY_NPAGE:
	    self.browse = TRUE
	    self.sk1.Focusable = FALSE
	    self.sk2.Focusable = FALSE
	    self.sk3.Focusable = FALSE
	    self.name.Focusable = FALSE
	    self.jlist.handleEvent(curses.KEY_DOWN)
	    self.select(1)
	    return ev_NONE

	if command == ev_ACTIVATE and args == curses.KEY_PPAGE:
	    self.browse = TRUE
	    self.sk1.Focusable = FALSE
	    self.sk2.Focusable = FALSE
	    self.sk3.Focusable = FALSE	    
	    self.name.Focusable = FALSE
	    self.jlist.handleEvent(curses.KEY_UP)
	    self.select(1)
	    return ev_NONE
	
	if command == ev_ACTIVATE and args == curses.KEY_F10:
	    self.broswe = FALSE
	    self.sk1.Focusable = TRUE
	    self.sk2.Focusable = TRUE
	    self.sk3.Focusable = TRUE
	    self.name.Focusable = TRUE
	    
	    self.product.SetText("")
	    self.name.SetText("")
	    
	    self.sur1.SetText("")
	    self.sk1.SetText("0")
	    
	    self.sur2.SetText("")
	    self.sk2.SetText("0")
	    
	    self.sur3.SetText("")
	    self.sk3.SetText("0")
	    
	    self.artno1 = 0
	    self.grno1 = 0
	
	    self.artno2 = 0
	    self.grno2 = 0
	    self.k1 = 0
	
	    self.artno3 = 0
	    self.grno3 = 0
	    self.k2 = 0
	
	    self.artno4 = 0
	    self.grno4 = 0
	    self.k3 = 0
	    self.select(0)
	    return ev_DONE

	if self.browse == TRUE:
	    return ev_NONE
	
	
	if command == ev_OK and args == 0:
	    self.select(1)
	    return ev_NONE
	
	if command == ev_OPTION and args == 1:
	    artdlg = getArtID()
	    artdlg.mainLoop()
	    self.product.SetText(artdlg.plist.items[artdlg.plist.hilite][1].Label)
	    artid = artdlg.plist.items[artdlg.plist.hilite][0].Label
	    self.grno1 = int(artid[0:3])
	    self.artno1 = int(artid[3:6])
	    artdlg.destroy()
	    del artdlg
	    self.select(2)
	    return ev_NONE

	if command == ev_OPTION and args == 2:
	    artdlg = getArtID(addqry = " AND name RLIKE '' ")
	    artdlg.mainLoop()
	    self.sur1.SetText(artdlg.plist.items[artdlg.plist.hilite][1].Label)
	    artid = artdlg.plist.items[artdlg.plist.hilite][0].Label
	    self.grno2 = int(artid[0:3])
	    self.artno2 = int(artid[3:6])
	    artdlg.destroy()
	    del artdlg
	    self.select(3)
	    return ev_NONE

	if command == ev_OK and args == 3:
	    self.select(4)
	    return ev_NONE
	
	
	if command == ev_OPTION and args == 4:
	    artdlg = getArtID(addqry = " AND name RLIKE '' ")
	    artdlg.mainLoop()
	    self.sur2.SetText(artdlg.plist.items[artdlg.plist.hilite][1].Label)
	    artid = artdlg.plist.items[artdlg.plist.hilite][0].Label
	    self.grno3 = int(artid[0:3])
	    self.artno3 = int(artid[3:6])
	    artdlg.destroy()
	    del artdlg
	    self.select(5)
	    return ev_NONE
	
	if command == ev_OK and args == 5:
	    self.select(6)
	    return ev_NONE
	
	if command == ev_OPTION and args == 6:
	    artdlg = getArtID(addqry = " AND name RLIKE '' ")
	    artdlg.mainLoop()
	    self.sur3.SetText(artdlg.plist.items[artdlg.plist.hilite][1].Label)
	    artid = artdlg.plist.items[artdlg.plist.hilite][0].Label
	    self.grno4 = int(artid[0:3])
	    self.artno4 = int(artid[3:6])
	    artdlg.destroy()
	    del artdlg
	    self.select(7)	    
	    return ev_NONE

	if command == ev_OK and args == 7:
	    self.select(0)
	    return ev_NONE
	
	
	if command == ev_ACTIVATE and args == curses.KEY_F8:
	    msgbox = MessageBox(28, 9, 8, 26, COL_TAB, COL_TAB, \
		                        ["  ", "  "], "?", msg_YESNO)
	    yes = msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()
	    if yes == cmd_CANCEL:
		return ev_NONE
	    
	    it = self.jlist.items[self.jlist.hilite]
	    ih = self.jlist.hidden_items[self.jlist.hilite]
	    
	    #self.artno1 = int(ih[1])
	    #self.grno2 = int(ih[2])
	    #self.artno2 = int(ih[3])
	    #self.npersons = int(ih[4])
	    #self.brpersons.SetText(str(self.npersons))
	    
	    #ll = int(ih[0])
	    
	    #self.jlist.items.remove(it)
	    #self.jlist.hidden_items.remove(ih)
	    #self.jlist.handleEvent(curses.KEY_HOME)
	    #self.CalculateSums()
	    
	    #db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
	    #curs = db.cursor()
	    #curs.execute("""DELETE FROM prjournal WHERE
	    #                snindx = %s AND
	    #		    sm = %s AND
	    #		    lineno = %s""",
	    #		    (self.shift_indx, self.shift, ll))
	    #db.close()
	    
	    self.select(0)
	
	if command == ev_ACTIVATE and args == curses.KEY_F2:
	    if self.CheckValues() == FALSE:
	    	self.select(0)
	    	return ev_NONE
	    kk = str(self.k1) + ":" + str(self.k2) + ":" + str(self.k3)
	    self.lineindx = self.lineindx + 1
	    self.jlist.addItem([str(self.lineindx),
	                        strip(self.name.text),\
	                        kk], \
				hidden = [self.grno1, self.artno1, self.product.text, \
					  self.grno2, self.artno2, self.sur1.text, self.k1, \
					  self.grno3, self.artno3, self.sur2.text, self.k2, \
					  self.grno4, self.artno4, self.sur3.text, self.k3])
		
	    self.jlist.draw()
	    self.jlist.handleEvent(curses.KEY_END)
	    
	    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
	    curs = db.cursor()
	    curs.execute("""INSERT INTO prplan (
	    		    snindx, sm, lineno, mode,
	    		    machine, npersons,
	    		    folio, artno1, qty1,
	    		    product, grno2, artno2, qty2,
	    		    date, oper) VALUES (
	    		    %s, %s, %s, %s,
	     		    %s, %s,
	    		    %s, %s, %s,
	    		    %s, %s, %s, %s,
	    		    NOW(), %s )""",
	    		    
	     		    (self.shift_indx, self.shift, self.lineindx, self.brakmode,
	    		    self.machine.text[0:5], self.npersons,
	    		    self.material.text, self.artno1, 0,
	     		    self.product.text, self.grno2, self.artno2, self.kgnorma,
	    		    "cv"))
	    db.close()

	    self.product.SetText("")
	    self.name.SetText("")
	    
	    self.sur1.SetText("")
	    self.sk1.SetText("0")
	    
	    self.sur2.SetText("")
	    self.sk2.SetText("0")
	    
	    self.sur3.SetText("")
	    self.sk3.SetText("0")
	    
	    self.artno1 = 0
	    self.grno1 = 0
	
	    self.artno2 = 0
	    self.grno2 = 0
	    self.k1 = 0
	
	    self.artno3 = 0
	    self.grno3 = 0
	    self.k2 = 0
	
	    self.artno4 = 0
	    self.grno4 = 0
	    self.k3 = 0
	    
	    
	    #self.CalculateSums()
		
	    self.select(0)
	    return ev_NONE
	
	
if __name__ == '__main__':
    def RunProgram(stdscreen):
	shift = 0
	sys.stderr.write("  ")
	sys.stderr.write(" ..") 
	i = 0
	while shift == 0:
	    hh = int(asctime()[11:13])
	    mm = int(asctime()[14:16])
	    tt = mm + 100*hh
	    if tt >= 511 and tt < 1410:
		shift = 1
	    elif tt >= 1411 and tt < 2210:
		shift = 2
	    elif (tt >= 2211 and tt < 2359) or \
	         (tt >= 0 and tt < 510):
		shift = 3
	    i = i + 1
	    if i == 30000:
		sys.stderr.write(".")
		i = 0
	sys.stderr.write("\n")
	
	sys.stderr.write("  \n")
	db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
	curs = db.cursor()
	curs.execute("""SELECT LEFT(date, 10), counter FROM documents WHERE doc_no = 200""")
	(sdate, counter) = curs.fetchone()
	if shift == 1:
	    now = strftime("%Y-%m-%d", gmtime())
	    new_sdate = strftime("%y%m%d", gmtime())
	    if sdate != now:
		curs.execute("""UPDATE documents SET 
	                    counter = %s,
			    date = NOW() WHERE
			    doc_no = 200""",
			    (int(new_sdate), ))
		counter = int(new_sdate)
	db.close()
	
	app = Store(stdscreen, shift, counter)
	
	
    str = curses.wrapper(RunProgram)
    print str	
    
