import os, re
from  defs import *
import curses
from curses import panel
import ui
from ui import *
from  MySQLdb import *
from support import *
from time import gmtime, strftime, localtime
from string import *

#-----------------------------------------------------------------------------
#     

class ObjectBox(DropDnBox):
    def LoadBox(self, user, passwd, dbase, tablename, loadfn=1):
	self.db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	self.curs = self.db.cursor()
	if loadfn == 24:
	    self.curs.execute("""SELECT objid FROM objects WHERE flag ='' AND obj_no = 2""")
	elif loadfn == 1:
	    self.curs.execute("""SELECT objid FROM objects WHERE flag = ''""")
	elif loadfn == 4:
	    self.curs.execute("""SELECT objid FROM objects WHERE flag = ''""")
	recs = self.curs.fetchall()
	self.db.commit()
	self.db.close()
	l = len(recs)
	for i in range(l):
	    self.box.addItem(recs[i][0])


class GroupDialog(Dialog):
    def __init__(self, report = FALSE, x=50, y=7):
	self._statusf = 0
	self.report = report
	
	self._selcount = 0
	self._totalselect = FALSE
	self._sellist = []	
	
	Dialog.__init__(self, x, y, 12, 28, COL_MAIN)
	self.addWidget(Label(self, 2, 1, "  ", COL_MAIN))
	self.grlist = MultiListBox(self, 2, 2, 8, 24, COL_TEXT)
	self.grlist.MultipleChoice(self.report)
	self.grlist.setItemColors(COL_WARN, COL_TEXT)
	self.grlist.addColon(4, "")
	self.grlist.addColon(20, "")
	self.grlist.dbQuery = "SELECT gr_no, gr_name FROM artgroups"
	m = Message()
	m.message = cm_RELOAD
	self.grlist.Update(m)
	self.addWidget(self.grlist)
    
    def mainLoop(self):
	self._statusf = Dialog.mainLoop(self)
	for i in range(len(self.grlist.items)):
	    if self.grlist.items[i][0].selection == TRUE:
		self._selcount = self._selcount + 1
		self._sellist.append(self.grlist.items[i][0].Label)
	if self._selcount == len(self.grlist.items):
	    self._totalselect = TRUE	
	
	gr_no = self.grlist.items[self.grlist.hilite][0].Label
	gr_name = self.grlist.items[self.grlist.hilite][1].Label
	return (gr_no, gr_name)

class ObjectDialog(Dialog):
    def __init__(self, report = FALSE, x=50, y=7, addqry = ""):
	self._statusf = 0
	self._selcount = 0
	self._totalselect = FALSE
	self._sellist = []
	self.report = report
	Dialog.__init__(self, x, y, 12, 28, COL_MAIN)
	self.addWidget(Label(self, 2, 1, " ", COL_MAIN))
	self.objlist = MultiListBox(self, 2, 2, 8, 24, COL_TEXT)
	self.objlist.MultipleChoice(self.report)
	self.objlist.setItemColors(COL_WARN, COL_TEXT)
	self.objlist.addColon(4, "")
	self.objlist.addColon(18, "")
	self.objlist.dbQuery = "SELECT obj_no, objid FROM objects" + addqry
	m = Message()
	m.message = cm_RELOAD
	self.objlist.Update(m)
	self.addWidget(self.objlist)
    
    def mainLoop(self):
	self._statusf = Dialog.mainLoop(self)
	if self.report == TRUE:
	    for i in range(len(self.objlist.items)):
		if self.objlist.items[i][0].selection == TRUE:
		    self._selcount = self._selcount + 1
		    self._sellist.append(self.objlist.items[i][0].Label)
	    if self._selcount == len(self.objlist.items):
		self._totalselect = TRUE
		
	obj_no = self.objlist.items[self.objlist.hilite][0].Label
	obj_name = self.objlist.items[self.objlist.hilite][1].Label
	return (obj_no, obj_name)


class DocTYPEBox(DropDnBox):
    def LoadBox(self, user, passwd, dbase, tablename, loadfn=1):
	self.box.addItem("")
	self.box.addItem("")
	self.box.addItem("/")

    
class AddNewDocument(Dialog):
    def __init__(self, doc_type, load = FALSE, doc_no = None, base = 1):
	self.doc_type = doc_type
	self.load = load
	self.doc_no = doc_no
	self.base = base
	Dialog.__init__(self, 2, 5, 8, 40, COL_MAIN)
	if self.load == FALSE:
	    self.set_caption("   ")
	else:
	    self.set_caption("  ")
	
	self.dno = LabeledEditLine(self, 2, 3, 3, "", pos_UP)
	self.dno.setType(dt_numeric)
	self.dno.SetText("0")
	self.addWidget(self.dno)
	
	self.name = LabeledEditLine(self, 7, 3, 32, "", pos_UP)
	self.addWidget(self.name)
	self.writexy(2, 4, " ", COL_TEXT1)
	self.typebox = DocTYPEBox(self, 2, 5, 20, 4, COL_WARN)
	self.typebox.Focusable = TRUE
	self.addWidget(self.typebox)
	
	self.counter = LabeledEditLine(self, 24, 5, 6, "", pos_UP)
	self.counter.SetText("000000")
	self.counter.setType(dt_numeric)
	self.addWidget(self.counter)
	
	self.writexy(28, 7, " F2 -  ", COL_WARN, TRUE) 
	self.AddHotKey(curses.KEY_F2, 0)
	self.select(0)
    
    def mainLoop(self):
	self._statusf = Dialog.mainLoop(self)
	return (int(self.dno.text), self._statusf)
	
	
    def UserFn(self, command, args):
	if command == ev_ACTIVATE and args == curses.KEY_F2:
	    _no = int(self.dno.text)
	    _name = strip(self.name.text)
	    _dtype = strip(self.typebox.text)
	    _cntr = strip(self.counter.text)
	    if _no == 0 or _name == "":
		msgbox = MessageBox(35, 7, 8, 24, COL_TAB, COL_TAB, \
				    ["  ", "  "], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		return ev_DONE
	    return ev_QUIT
	    
	if command == ev_OK:
	    self.nextWidget()
	    return ev_NONE
	    
    

class DocumentDialog(Dialog):
    def __init__(self, doc_type, report = FALSE, strict = 99, x=40, y=7):
	self._statusf = 0
	self._selcount = 0
	self._totalselect = FALSE
	self._sellist = []
	self.report = report
	self.strict = strict
	self.doc_type = doc_type
	Dialog.__init__(self, x, y, 13, 37, COL_MAIN)
	self.addWidget(Label(self, 2, 1, " ", COL_MAIN))
	self.doclist = MultiListBox(self, 2, 2, 9, 33, COL_TEXT)
	self.doclist.MultipleChoice(self.report)
	self.doclist.setItemColors(COL_TITLE, COL_TEXT)
	self.doclist.addColon(6, "")
	self.doclist.addColon(24, "")
	self.doclist.dbQuery = "SELECT doc_no, name FROM documents WHERE doc_type RLIKE \'" + doc_type + "\' AND doc_no < " + str(self.strict) + " AND documents.base = 1"
        m = Message()
	m.message = cm_RELOAD
	self.doclist.Update(m)
	self.addWidget(self.doclist)	
	
    def UserFn(self, command, args):
	if command == cm_ADD_ITEM and args == self.doclist.control:
	    add = AddNewDocument(self.doc_type)
	    (no, op) = add.mainLoop()
	    if op == ev_OK:
		pass
	    add.destroy()
	    del add
	    return ev_NONE
	if command == ev_OK:
	    return ev_QUIT
	    

    def mainLoop(self):
	self._statusf = Dialog.mainLoop(self)
	if self.report == TRUE:
	    for i in range(len(self.doclist.items)):
		if self.doclist.items[i][0].selection == TRUE:
		    self._selcount = self._selcount + 1
		    self._sellist.append(self.doclist.items[i][0].Label)
	    if self._selcount == len(self.doclist.items):
		self._totalselect = TRUE
	#d_no = int(self.doclist.items[self.doclist.hilite][0].Label)
	d_no = self.doclist.items[self.doclist.hilite][0].Label
	name = self.doclist.items[self.doclist.hilite][1].Label
	#doc_no = str(TranslateDocNo(d_no))
	return (d_no, name)


class RekapParams(Dialog):
    def __init__(self, _doctype = "", _customers = FALSE, _firma = FALSE):
	Dialog.__init__(self, 0, 0, 24, 79, COL_MAIN)
	if _doctype == "":
	    self.set_caption("    ")
	elif _doctype == "":
	    self.set_caption("    ")
	self.nowday = strftime("%d/%m/%y", gmtime())
	
	self.doc_type = _doctype
	self.firma = _firma
	self.selectCustomers = _customers
	self.object_list = []
	self.customers_list = []
	self.docs_list = []
	self.docsAll = FALSE
	#0
	self.object = OptionLine(self, 2, 2, 30, "()    :", pos_LEFT)
	self.object.SetText("  ")
	self.addWidget(self.object)
	#1
	self.document = OptionLine(self, 2, 3, 30,  "() :", pos_LEFT)
	self.document.SetText("  ")
	self.addWidget(self.document)
	#2
	self.customers = OptionLine(self, 2, 4, 30, "()   :", pos_LEFT)
	self.customers.Focusable = self.selectCustomers
	if self.selectCustomers == FALSE:
	    self.customers.SetText("  ")
	else:
	    self.customers.SetText("  ")
	self.addWidget(self.customers)
	#3
	self.begdate = LabeledDateLine(self, 2, 6, ".    :")
	self.begdate.SetText(self.nowday)
	self.addWidget(self.begdate)
	#4
	self.enddate = LabeledDateLine(self, 26, 6, "  .: ")
	self.enddate.SetText(self.nowday)
	self.addWidget(self.enddate)
	
	self.writexy(2, 8, "[ F2 ]    , [ F10 ] - ", COL_TAB)
	#5
	self.rp = MultiListBox(self, 2, 9, 14, 75, COL_TEXT)
	self.rp.MultipleChoice(FALSE)
	self.rp.setItemColors(COL_TITLE, COL_TEXT)
	self.rp.Focusable = TRUE
	#self.rp.dbQuery = "SELECT CONCAT(group_no, art_no), name, qty_id, weight, pack1 FROM articles WHERE name RLIKE \'^"
	self.rp.addColon(30, "")
	if self.doc_type == "":
	    self.rp.addColon(15, "", dt_float, 3)
	    self.rp.addColon(15, " - ", dt_float, 2)
	    self.rp.addColon(15, ".- + ", dt_float, 2)
	elif self.doc_type == "":
	    self.rp.addColon(15, " -- ")
	    self.rp.addColon(15, " -- ")
	    self.rp.addColon(15, ". -", dt_float, 2)
	#self.rp.Update()
	self.addWidget(self.rp)
	
	self.AddHotKey(curses.KEY_F2, 5)
	self.AddHotKey(curses.KEY_F10, 0)
	
	self.select(0)

	
    def UserFn(self, command, args):
	if command == ev_ACTIVATE and args == curses.KEY_F10:
	    del self.object_list
	    del self.customers_list
	    del self.docs_list
	    
	    self.object_list = []
	    self.customers_list = []
	    self.docs_list = []
	    self.docsAll = FALSE
	    
	    self.object.SetText("  ")
	    if self.selectCustomers == FALSE:
		self.customers.SetText("  ")
	    else:
		self.customers.SetText("  ")
	    self.document.SetText("  ")
	    
	    return ev_OK
	if command == ev_ACTIVATE and args == curses.KEY_F2:
	    strbd = self.begdate.text
	    stred = self.enddate.text
	    b = "20" + strbd[6:8] + "-" + strbd[3:5] + "-" + strbd[0:2]
	    e = "20" + stred[6:8] + "-" + stred[3:5] + "-" + stred[0:2]
	    b1 = int(strbd[6:8] + strbd[3:5] + strbd[0:2])
	    e1 = int(stred[6:8] + stred[3:5] + stred[0:2])
	    if e1 < b1:
		msgbox = MessageBox(35, 7, 8, 24, COL_TAB, COL_TAB, \
				    [" ", "   -", "  !"], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		return ev_DONE
	    if len(self.object_list) == 0 or \
	       (len(self.docs_list) == 0 and self.docsAll == FALSE):
		msgbox = MessageBox(33, 7, 8, 26, COL_TAB, COL_TAB, \
				    ["  ", "  "], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		return ev_DONE
	    qry = ""   
	    if self.doc_type == "":
		qry = "SELECT documents.name, SUM(sales.weight), SUM(sales.price * sales.qnty) / 1.2, SUM(sales.price * sales.qnty) FROM documents, sales WHERE documents.doc_no = sales.doc_no AND documents.base = 1" 
	    elif self.doc_type == "":
		qry = "SELECT documents.name, '--' , '--' , SUM(delivery.price * delivery.deliv_qnty) FROM documents, delivery WHERE documents.doc_no = delivery.doc_no AND documents.base = 1" 
	    if self.firma == TRUE:
		pass
	    else:
		if self.doc_type == "":
		    q1 = " AND sales.object_no = \'" + strip(self.object_list[0]) + "\'"
		elif self.doc_type == "":
		    q1 = " AND delivery.object_no = \'" + strip(self.object_list[0]) + "\'"
	    if self.docsAll == TRUE:
		q2 = ""
	    else:
		q21 = ""
		for i in range(len(self.docs_list)):
		    q21 = q21 + str(self.docs_list[i])
		    if i == len(self.docs_list) - 1:
			q21 = q21 + ")"
		    else:
			q21 = q21 + ","
		if self.doc_type == "":
		    q2 = " AND sales.doc_no IN (" + q21
		elif self.doc_type == "":
		    q2 = " AND delivery.doc_no IN (" + q21
	    #self.writexy(0, 0, qry + q1 + q2, COL_TAB, TRUE)
	    if self.doc_type == "":
		q3 = " AND LEFT(sales.date, 10) >= \'" + b + "\' AND LEFT(sales.date, 10) <= \'" + e + "\'"
	    elif self.doc_type == "":
		q3 = " AND LEFT(delivery.doc_date, 10) >= \'" + b + "\' AND LEFT(delivery.doc_date, 10) <= \'" + e + "\'"
	    if self.doc_type == "":
		self.rp.dbQuery = qry + q1 + q2 + q3 + " GROUP BY sales.doc_no"
	    elif self.doc_type == "":
		self.rp.dbQuery = qry + q1 + q2 + q3 + " GROUP BY delivery.doc_no"
	    m = Message()
	    m.message = cm_RELOAD
	    self.rp.Update(m)
	    self.rp.draw()
	    return ev_OK
	if command == ev_OPTION and args == 0:
	    del self.object_list
	    self.object_list = []
	    objdlg = ObjectDialog(report = self.firma, x=49, y=2)
	    (ono, oname) = objdlg.mainLoop()
	    if self.firma == TRUE:
		pass
	    else:
		self.object.SetText(oname)
		self.object_list.append(ono)
	    objdlg.destroy()
	    del objdlg
	    self.select(1)
	    return ev_NONE
	if command == ev_OPTION and args == 1:
	    self.docsAll = FALSE
	    del self.docs_list
	    self.docs_list = []
	    docdlg = DocumentDialog(self.doc_type, report = TRUE, x=40, y=2)
	    (dno, dname) = docdlg.mainLoop()
	    if docdlg._statusf == ev_FAIL or docdlg._totalselect == TRUE:
		self.document.SetText("")
		self.docsAll = TRUE
	    else:
		if docdlg._selcount > 1:
		    self.document.SetText("")
		    del self.docs_list
		    self.docs_list = docdlg._sellist
		else:
		    self.document.SetText(dname)
		    self.docs_list.append(dno)
	    docdlg.destroy()
	    del docdlg
	    if self.selectCustomers == TRUE:
		self.select(2)
	    else:
		self.select(3)
	    return ev_NONE
    
	if command == ev_OPTION and args == 2:
	    self.select(3)
	    return ev_NONE
	
	if command == ev_OK and args == 3:
	    self.select(4)
	    return ev_NONE
	
	if command == ev_OK and args == 4:
	    self.select(0)
	    return ev_NONE
	
class ObRekapRazhDoc(Dialog):
    def __init__(self):
	Dialog.__init__(self, 5, 5, 14,  71, COL_MAIN)
	self.set_caption("    ")
	params = RekapParams()
	status = params.mainLoop()
    
#-----------------------------------------------------------------------------
#    

class AvailableArts(Dialog):
    def __init__(self, Object_no=2, Object_name=" 2"):
	self.object_no = Object_no
	self.object_name = Object_name
	self.combine = FALSE
	self.loaded = TRUE
	self.nowday = strftime("%d/%m/%y", gmtime())
	self.finalDate = self.nowday
		
	Dialog.__init__(self, 0, 0, 24,  79, COL_MAIN)
	self.set_caption("  ")	
	#0
	self.writexy(6, 2, ": " + self.object_name, COL_WARN, TRUE)
	self.edate = LabeledDateLine(self, 56, 1, " ")
	self.edate.SetText(self.finalDate)	
	self.addWidget(self.edate)
	#1
	self.groups = OptionLine(self, 42, 4, 21, ". ", pos_UP)
	self.addWidget(self.groups)
	#2
	self.doc_counter = LabeledEditLine(self, 6, 6, 10, ".    :")
	self.doc_counter.Focusable = FALSE
	self.addWidget(self.doc_counter)
	#3
	self.ddate = LabeledEditLine(self, 6, 7, 10,       ". :")
	self.ddate.Focusable = FALSE
	self.addWidget(self.ddate)
	#4
	self.customer = LabeledEditLine(self, 31, 7, 32, ":")
	self.customer.Focusable = FALSE
	self.addWidget(self.customer)
        #5
	self.dtype = LabeledEditLine(self, 31, 6, 32, " :")
	self.dtypeFocusable = FALSE
	self.addWidget(self.dtype)
	
	
	#6
	self.artlist = MultiListBox(self, 6, 8, 14, 67, COL_TEXT)
	self.artlist.MultipleChoice(FALSE)
	self.artlist.setItemColors(COL_TITLE, COL_TEXT)
	self.artlist.Focusable = TRUE
	#self.artlist.dbQuery = "SELECT CONCAT(articles.group_no, articles.art_no), articles.name, articles.qty_id, sum(delivery.rest_qnty) FROM articles, delivery WHERE delivery.object_no = " + str(self.current_object) + " AND articles.group_no = delivery.group_no AND articles.art_no = delivery.art_no AND delivery.valid = 1 AND delivery.rest_qnty > 0 GROUP by 1 ORDER BY articles.name"
	self.artlist.addColon(6, ".")
	self.artlist.addColon(31, "")
	self.artlist.addColon(5, "/")
	self.artlist.addColon(12, "", dt_float, 3)
	self.artlist.addColon(13, ".-", dt_float, 3)
	#m = Message()
	#m.message = cm_RELOAD
	#self.artlist.Update(m)	
	self.artlist.addNotifyRecipient(self, cm_ITEM_CHANGED)
	self.addWidget(self.artlist)
	
	self.writexy(6, 4, "             ", COL_TITLE, TRUE)
	
	self.writexy(2, 24, " | F1 -  | F2 -  | F6 -  | F10 -  | ", COL_TITLE, bold = TRUE)
	self.AddHotKey(curses.KEY_F2, 6)
	self.AddHotKey(curses.KEY_F6, 6)
	self.AddHotKey(curses.KEY_F1, 0)
	
	self.select(0)
	
    def Update(self, msg):
	if msg.message == cm_ITEM_CHANGED and self.combine == FALSE:
	    indx = msg.args[1]
	    #self.writexy(60, 0, str(self.artlist.hidden_items[indx][0]), COL_WARN)
	    self.ddate.SetText(self.artlist.hidden_items[indx][0])
	    self.customer.SetText(self.artlist.hidden_items[indx][1])
	    self.doc_counter.SetText(str(self.artlist.hidden_items[indx][2]))
	    self.dtype.SetText(self.artlist.hidden_items[indx][3])
	    
	
    def UserFn(self, command, args):
	if command == ev_OK and args == 0:
	    self.nextWidget()
	    return ev_NONE
	if command == ev_ACTIVATE and args == curses.KEY_F1:
	    return ev_OK
	if command == ev_ACTIVATE and args == curses.KEY_F2:
	    stred = self.edate.text
	    mbox =  MessageBox(30, 9, 6, 22, COL_WARN, COL_WARN, \
		                        ["  "], "", msg_MSG)
	    mbox.show()
	    e = "20" + stred[6:8] + "-" + stred[3:5] + "-" + stred[0:2]
	    
	    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	    curs = db.cursor()

	    mbox.writexy(2, 6, " 1", COL_WARN, TRUE)
	    pflush()
	    curs.execute("""SELECT 
	                 delivery.rid,
	                 CONCAT(articles.group_no, articles.art_no),
	    		 articles.name,
	    		 articles.qty_id,
	    		 delivery.deliv_qnty,
	    		 delivery.price,
	    		 LEFT(delivery.doc_date,10),
	    		 partners.lname, delivery.doc_counter, documents.name,
	    		 articles.pack1 FROM
	    		 articles, delivery, partners, documents
	    		 WHERE 
	    		 documents.base = 1 AND
	    		 delivery.object_no = %s AND 
	    		 articles.object_no = delivery.object_no AND
	    		 articles.group_no = delivery.group_no AND
	    		 articles.art_no = delivery.art_no AND
	    		 delivery.valid = 1 AND
	    		 LEFT(delivery.doc_date, 10) <= %s AND
	    		 partners.dan_no = delivery.partn_dn AND
	    		 partners.ptype = 1 AND partners.object_no = %s AND
	    		 delivery.doc_no = documents.doc_no
	    		 ORDER BY 3,7""",
	    		 (self.object_no, e, self.object_no))
	    
	    delivered = curs.fetchall()
	    mbox.writexy(2, 6, " 2", COL_WARN, TRUE)
	    pflush()
	    curs.execute("""SELECT 
		         source_rid,
			 RIGHT(CONCAT(sales.group_no, sales.art_no), 5),
			 sales.qnty FROM sales
			 WHERE sales.object_no = %s AND
			 LEFT(sales.date, 10) <= %s""", 
			 (self.object_no, e))
			 
	    sales = curs.fetchall()
	    db.close()
	    
	    rest = []
	    
	    del self.artlist.items
	    del self.artlist.hidden_items
	    self.artlist.items =[]
	    self.artlist.hidden_items = []
	    self.artlist.hilite = -1
	    self.artlist.start = -1
	    self.artlist.end = 0
	    reccount = 0
	    for i in range(len(delivered)):
		rqnty = delivered[i][4]
	    	for j in range(len(sales)):
		    if sales[j][0] == delivered[i][0]:
			rqnty = rqnty - sales[j][2]
		if rqnty > 0:	
		    reccount = reccount + 1
		    self.artlist.addItem([delivered[i][1], delivered[i][2], delivered[i][3], str(rqnty), str(delivered[i][5]*rqnty)], hidden = [delivered[i][6], delivered[i][7], delivered[i][8], delivered[i][9]])
		    mbox.writexy(2, 6, " : " + str(reccount), COL_WARN, TRUE)
		    pflush()
	    self.artlist.draw()
	    self.select(self.artlist.control)
	    self.loaded = TRUE
	    self.combine = FALSE
	    mbox.destroy()
	    del mbox
	    return ev_OK
	    
	if command == ev_ACTIVATE and args == curses.KEY_F6 and self.loaded == TRUE:
	    self.combine = TRUE
	    self.loaded = FALSE
	    stred = self.edate.text
	    mbox =  MessageBox(30, 9, 6, 22, COL_WARN, COL_WARN, \
		                        ["  "], "", msg_MSG)
	    mbox.show()
	    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	    curs = db.cursor()
	    mbox.writexy(2, 6, " 1", COL_WARN, TRUE)
	    pflush()
	    curs.execute("""DELETE FROM tempstore WHERE operid = 'cv'""")
	    
	    for i in range(len(self.artlist.items)):
		it = self.artlist.items[i]
		mbox.writexy(2, 6, " : " + str(i), COL_WARN, TRUE)
		pflush()
		curs.execute("""INSERT INTO tempstore
		                VALUES (%s, %s, %s, %s, %s, %s, %s, %s)""",
			 (it[0].Label[0:2],
			  it[0].Label[2:5],
			  it[1].Label,
			  it[2].Label,
			  it[3].Label,
			  it[4].Label, "cv", 1))
	    
	    db.close()
	    mbox.destroy()
	    del mbox
	    self.artlist.dbQuery = "SELECT CONCAT(group_no, art_no) as no, name, qty_id, SUM(qnty) as sqnty, SUM(price) FROM tempstore GROUP BY group_no, art_no ORDER BY 2"
	    m = Message()
	    m.message = cm_RELOAD
	    self.artlist.Update(m)

	    self.artlist.draw()
	    
	    self.ddate.SetText("--")
	    self.customer.SetText("--")
	    self.doc_counter.SetText("--")
	    self.dtype.SetText("--")
	    return ev_OK

class DateDialog(Dialog):
    def __init__(self, x=40, y=10):
	Dialog.__init__(self, x, y, 5, 20, COL_MAIN)
	self.set_caption(" ")
	self.date = LabeledDateLine(self, 2, 3, "", pos_UP)
	self.date.SetText(strftime("%d/%m/%y", gmtime()))
	self.addWidget(self.date)
	self.select(0)
	
    def mainLoop(self):
	while 1:
	    status = Dialog.mainLoop(self)	
	    if status == ev_OK:
		strd = self.date.text
		d = "20" + strd[6:8] + "-" + strd[3:5] + "-" + strd[0:2]
		break
	    elif status == ev_FAIL and self.quitstatus == 1:
		d = None
		break
	return (status, d)
	    
	
#-----------------------------------------------------------------------------
#   

class Expedition(Dialog):
    pass


class ExpedName(Dialog):
    def __init__(self):
	    
	Dialog.__init__(self, 31, 11, 8, 45, COL_MAIN)
	#0
	self.addWidget(Label(self, 2, 7, "< Esc > - ; < Enter > - ", COL_TAB))
	#1
	self.addWidget(Label(self, 2, 1, " ", COL_TEXT1))
	self.analitem = EditLine(self, 2, 2, 32)
	#2
	self.addWidget(self.analitem)
	#3
	self.addWidget(Label(self, 2, 3, "  / ", COL_TEXT1))
	self.addinfo1 = EditLine(self, 2, 4, 40)
	#4
	self.addWidget(self.addinfo1)

	self.select(2)

	
    def UserFn(self, command, args):
	if command == ev_OK:
	    self.writexy(1,0, self.analitem.text, COL_TITLE)
	    if args == 2:
		self.select(4)
		return ev_NONE
	    if args == 4:
		if self.analitem.text == "" or self.addinfo1.text == "":
		    msgbox = MessageBox(28, 9, 7, 25, COL_TAB, COL_TAB, \
		                        ["  ", ""], "", msg_OK)
		    msgbox.mainLoop()
		    msgbox.destroy()
		    del msgbox
		    pflush()		    
		    self.select(2)
		    return ev_NONE
		else:
		    return ev_DONE


class ExpedCatalog(Dialog):
    def __init__(self, _date, object = None):
	Dialog.__init__(self, 0, 10, 14, 79, COL_MAIN)
	self.date = _date
	self.addWidget(Label(self, 3, 1, "     : " + self.date, COL_TEXT1))
	
	
	self.cl = MultiListBox(self, 3, 2, 10, 73, COL_TEXT)
	self.cl.MultipleChoice(FALSE)
	self.cl.setItemColors(COL_TITLE, COL_TEXT)
	self.cl.addColon(8, "", dt_float, 0)
	self.cl.addColon(11, "")	
	self.cl.addColon(23, "")

	self.cl.addColon(12, "", dt_float, 3)
	self.cl.addColon(12, "", dt_float, 3)
	self.cl.addColon(5, "", dt_float, 0)
	
	self.cl.dbQuery = "SELECT expeditions.doc_no, LEFT(expeditions.doc_date, 10), expeditions.name, 0, 0, 0, dtypes, objects FROM expeditions WHERE expeditions.date = \'" + self.date + "\' ORDER by expeditions.doc_no"
        m = Message()
	m.message = cm_RELOAD
	self.cl.Update(m)
	self.addWidget(self.cl)
	
	self.writexy(17, 14, "| F1 -   | F4 - . / . | F10 -  | ", COL_TITLE, TRUE)
	self.writexy(1, 14, " | DEL -  ", COL_WARN, TRUE)
	
	self.AddHotKey(curses.KEY_F1, 1)
	self.AddHotKey(curses.KEY_F4, 1)
	self.AddHotKey(curses.KEY_F10, 1)
	
	self.select(self.cl.control)
	
    def beginNewExped(self, name, car):
	exped_no = getDoc_counter(doc_no = 198, update = TRUE)
	docs = PartnersOutList(name + "  -  : " + car, exped_no, _date = self.date)
	status = docs.mainLoop()
	if status == ev_OK:
	    _docs_date = docs.docs_date
	    _docslist = ""
	    for i in range(len(docs.docs_list)):
		_docslist = _docslist + strip(str(docs.docs_list[i]))
		if i == len(docs.docs_list) - 1:
		    pass
		else:
		    _docslist = _docslist + ","
		
	    _objects = ""
	    for i in range(len(docs.object_list)):
		_objects = _objects + strip(str(docs.object_list[i]))
		if i == len(docs.object_list) - 1:
		    pass
		else:
		    _objects = _objects + ","
	    
	    #   
	    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host = "192.168.0.2")
	    curs = db.cursor()
	    curs.execute("""INSERT INTO expeditions (
			    doc_no, doc_date, name, dtypes, objects, date, oper) VALUES (
			    %s, %s, %s, %s, %s, %s, %s)""",
			    (exped_no, _docs_date, name+"::"+car, _docslist, _objects, self.date, "cv"))
	    db.close()
	    self.cl.addItem([exped_no[5:], _docs_date, name+"::"+car, "0", "0", "0"], hidden = [_docslist, _objects])
	    self.cl.draw()
	    
	docs.destroy()
	del docs
	pflush()
	
    def PrintExped(self, exped_no, exped_name, exped_date, object):
	
	db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host = "192.168.0.2")
	curs = db.cursor()
	curs.execute("""SELECT 
			    articles.name, 
			    CONCAT(sales.group_no, sales.art_no),
			    SUM(sales.qnty),
			    SUM(sales.weight),
			    SUM(sales.qnty) / articles.pack1
			    FROM articles, sales WHERE 
			    sales.object_no = %s AND
			    sales.object_no = articles.object_no AND
			    sales.group_no = articles.group_no AND
			    sales.art_no = articles.art_no AND 
			    sales.exped_no = %s AND sales.palet = 0
			    GROUP BY sales.group_no, sales.art_no""",
			    (object, exped_no))
			    
			    
			    
	#       1		    
	
	#curs.execute("""UPDATE expeditions SET printed = 
	
	recs = curs.fetchall()
	db.close()
	#if len(recs) > 0:
	n1 = find(exped_name, "::")
	_name = exped_name[:n1]
	_car = exped_name[n1+1:]
	
	fp = open("exped"+exped_no+"."+str(object), "w+")
	fp.write("     No: " + exped_no + " ..." + _name + "\n")
	fp.write(" : " + _car + "\n")
	fp.write("\n")
	
	#self.obj = object
	
	fp.write(" " + str(object) + " cyty  .........       : " + exped_date + "\n\n")
	fp.write("                              " + OS_VER + "  " + SERVER_VER + "\n")
	fp.write("+-------------------------------------------------------------------------------+\n")
	fp.write("|                     |  |  |  -  | .  |\n")
	fp.write("+-------------------------------------------------------------------------------+\n")
	totalsum = 0
	for i in range(len(recs)):
	    it = recs[i]
	    artname = ljust(it[0], 32)
	    code = center(it[1], 7)
	    qnty = rjust(fix(it[2], 3), 12)
	    ton = rjust(fix(it[3], 3), 12)
	    packs = rjust(fix(it[4], 3), 11)
	    
	    totalsum = totalsum + float(ton)
		
	    fp.write("| " + artname + "|"+code+"|"+qnty+"|"+ton +"|"+packs + "|\n")
	tsum = rjust(fix(totalsum, 3), 12)
	fp.write("+-------------------------------------------------------------------------------+\n")
	fp.write("|                                             |"+tsum+"            |\n")
	fp.write("+-------------------------------------------------------------------------------+\n")
	
	fp.write("\n")
	
	db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host = "192.168.0.2")
	curs = db.cursor()
	curs.execute("""SELECT 
	                    DISTINCT sales.partn_dn,
			    partners.sname, partners.city 
			    FROM sales, partners WHERE
			    sales.partn_dn = partners.dan_no AND
			    sales.object_no = %s AND
			    sales.object_no = partners.object_no AND
			    sales.exped_no = %s AND sales.palet = 1""",
			    (object, exped_no))
	partners = curs.fetchall()
	if len(partners) > 0:
	    #fp.write("\n -----------    ---------------------------\n\n")
	    curs.execute("""SELECT sales.partn_dn,
			    articles.name, 
			    CONCAT(sales.group_no, sales.art_no),
			    SUM(sales.qnty),
			    SUM(sales.weight),
			    SUM(sales.qnty) / articles.pack1
			    FROM articles, sales WHERE 
			    sales.object_no = %s AND
			    sales.object_no = articles.object_no AND
			    sales.group_no = articles.group_no AND
			    sales.art_no = articles.art_no AND 
			    sales.exped_no = %s AND sales.palet = 1
			    GROUP BY sales.group_no, sales.art_no, sales.partn_dn""",
			    (object, exped_no))
			    
	    recs = curs.fetchall()
	    db.close()
	    for pp in range(len(partners)):
		ip = partners[pp]
		fp.write("\n -----------    ---------------------------\n")
		fp.write("     : " + ljust(ip[1], 32) + ". : " + ip[0] +  "\n")
		fp.write(".  : " + ljust(ip[2], 32) + "\n\n")
		fp.write("+-------------------------------------------------------------------------------+\n")
		fp.write("|                     |  |  |  -  | .  |\n")
		fp.write("+-------------------------------------------------------------------------------+\n")
		totalsum = 0
		for i in range(len(recs)):
		    it = recs[i]
		    if ip[0] == it[0]:
			artname = ljust(it[1], 32)
			code = center(it[2], 7)
			qnty = rjust(fix(it[3], 3), 12)
			ton = rjust(fix(it[4], 3), 12)
			packs = rjust(fix(it[5], 3), 11)
			totalsum = totalsum + float(ton)
			
			fp.write("| " + artname + "|"+code+"|"+qnty+"|"+ton +"|"+packs + "|\n")
		tsum = rjust(fix(totalsum, 3), 12)
		fp.write("+-------------------------------------------------------------------------------+\n")
		fp.write("|                                             |"+tsum+"            |\n")
		fp.write("+-------------------------------------------------------------------------------+\n\n")
			
			
	else:
	    db.close()
	
	fp.write("\n:" + USER + "..........       .  ............\n\n\n")
	
	fp.write("\n: ...............        - : .................\n\n*\n")
	fp.close()
	os.spawnlp(os.P_NOWAIT, './printdoc', './printdoc', "exped"+exped_no+"."+str(object))
	pass
	
	
	
    def UserFn(self, command, args = None):
	if command == ev_ACTIVATE and args == curses.KEY_F10:
	    i = self.cl.hilite
	    obn = self.cl.hidden_items[i][1]
	    p = 1
	    while p > 0:
		p = find(obn, ",")
		_obj = obn[0:p]
		if p > 0:
		    self.PrintExped(strip(self.cl.items[i][0].Label), strip(self.cl.items[i][2].Label), strip(self.cl.items[i][1].Label), _obj)
		elif p < 0:
		    self.PrintExped(strip(self.cl.items[i][0].Label), strip(self.cl.items[i][2].Label), strip(self.cl.items[i][1].Label), obn)
		obn = obn[p+1:]
	    return ev_OK
			    
	if command == ev_ACTIVATE and args == curses.KEY_F4:
	    it = self.cl.items[self.cl.hilite]
	    docs = PartnersOutList(it[2].Label, it[0].Label, load= TRUE, dtypes = self.cl.hidden_items[self.cl.hilite][0], objects = self.cl.hidden_items[self.cl.hilite][1], _date = self.cl.items[self.cl.hilite][1].Label)
	    docs.mainLoop()
	    docs.destroy()
	    del docs
	    pflush()
	    return ev_OK
	    
	if command == ev_ACTIVATE and args == curses.KEY_F1:
	    namedlg = ExpedName()
	    status = namedlg.mainLoop()
	    if status == ev_OK:
		_name = namedlg.analitem.text
		_car =  namedlg.addinfo1.text
		namedlg.destroy()
		del namedlg
		pflush()
		self.beginNewExped(_name, _car)
	    else:
		namedlg.destroy()
		del namedlg
		pflush()
	    return ev_OK
	    
	
class OutDocsView(Dialog):
    def __init__(self, exped_no, city, partname, dan_no, exped_sum):
	Dialog.__init__(self, 10, 5, 15, 67, COL_MAIN)
	
	self.exped_no = exped_no
	self.dan_no = dan_no
	self.name = partname
	self.city = city
	self.exped_sum = exped_sum
	self.sum = 0
	self.old_sum = 0
	
	self.set_caption(" ")
	self.writexy(2, 2, strip(self.name) + " - " + strip(self.city), COL_TEXT1)
	self.writexy(42, 2, ":", COL_TEXT1)
	self.writexy(42, 3, "      ", COL_WARN, TRUE)
	self.writexy(42, 4, center(fix(self.exped_sum, 3), 24), COL_WARN, TRUE)
	self.writexy(42, 5, "        ", COL_WARN, TRUE)
	self.writexy(42, 6, "                        ", COL_WARN, TRUE)	
	
	self.docs = MultiListBox(self, 2, 3, 10, 36, COL_TEXT)
	self.docs.MultipleChoice(TRUE)
	self.docs.setItemColors(COL_TITLE, COL_TEXT)
	self.docs.Focusable = TRUE
	
	self.docs.addColon(13, "")
	self.docs.addColon(11, "")	
	self.docs.addColon(12, "", dt_float, 3)
	self.docs.dbQuery = "SELECT CONCAT(doc_counter, ''), LEFT(doc_date, 10), sweight, sel FROM expedcatalog WHERE partn_dn = \'" + self.dan_no + "\' AND userid = " + str(self.exped_no)
	m = Message()
	m.message = cm_RELOAD
	self.docs.Update(m)
	
	self.addWidget(self.docs)
	self.UpdateSelections()
	
	self.CalculateSum() 
	self.exped_sum = self.exped_sum - self.sum
	self.writexy(42, 4, center(fix(self.exped_sum + self.sum, 3), 24), COL_WARN, TRUE)
	
	self.writexy(42, 12,  "    F5 / F9 -    ", COL_TITLE, TRUE)
	self.writexy(42, 13,  "       ESC -       ", COL_TITLE, TRUE)
	self.select(0)

    def CalculateSum(self):
	self.old_sum = self.sum
     	self.sum = 0
	for i in range(len(self.docs.items)):
	    if self.docs.items[i][0].selection == TRUE:
		self.sum = self.sum + float(self.docs.items[i][2].Label)
	self.writexy(42, 6, center(fix(self.sum, 3), 24), COL_WARN, TRUE)
	self.writexy(42, 4, center(fix(self.exped_sum + self.sum, 3), 24), COL_WARN, TRUE)
	
    def UpdateSelections(self):
	for i in range(len(self.docs.items)):
	    if self.docs.hidden_items[i][0] == '1':
		self.docs.SelectThis(i)
	self.docs.draw()
	
    def UserFn(self, command, args):
	if command == cm_SELECTION:
	    self.CalculateSum()
	    return ev_NONE
	return ev_NONE
    
    def mainLoop(self):
	while 1:
	    status = Dialog.mainLoop(self)
	    if status == ev_FAIL and self.quitstatus == 1:
		msgbox = MessageBox(28, 9, 8, 26, COL_TAB, COL_TAB, \
		                        ["  ", " ?"], "?", msg_YESNO)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		if yes == cmd_YES:
		    nsel = 0
		    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host = "192.168.0.2")
		    curs = db.cursor()
		    for i in range(len(self.docs.items)):
			if self.docs.items[i][0].selection == TRUE:
			    _sel = 1
			    nsel = nsel + 1
			else:
			    _sel = 0
			curs.execute("""UPDATE expedcatalog SET sel = %s 
					WHERE doc_counter = %s AND
					userid = %s AND
					partn_dn = %s""", 
					(_sel, self.docs.items[i][0].Label, 
					 self.exped_no, self.dan_no))
		    db.close()
		    status = ev_OK
		    break
		else:
		    nsel = 0
		    status = ev_FAIL
		    break
		    
	return (status, nsel, self.sum)
	
class PartnersOutList(Dialog):
    def __init__(self, exped_name, exped_no, load = FALSE, dtypes = None, objects = None, _date = None):
	Dialog.__init__(self, 0, 0, 24, 79, COL_MAIN)
	self.set_caption(exped_name)
	
	self.load = load
	self.documents = dtypes
	self.objects = objects
	self.expdate = _date
	self.exped_no = exped_no
	self.nowday = strftime("%d/%m/%y", gmtime())
	
	self.exped_total = 0
	
	#self.doc_type = _doctype
	#self.firma = _firma
	#self.selectCustomers = _customers
	self.object_list = []
	self.customers_list = []
	self.docs_list = []
	self.docsAll = FALSE
	self.objAll = FALSE
	
	self.docrecs = []
	self.docs_date = ""
	
	self.expedrecs = []
	
	#0
	self.object = OptionLine(self, 2, 2, 30, "()    :", pos_LEFT)
	self.object.SetText("  ")
	self.addWidget(self.object)
	#1
	self.document = OptionLine(self, 2, 3, 30,  "() :", pos_LEFT)
	self.document.SetText("  ")
	self.addWidget(self.document)
	#2
	self.customers = OptionLine(self, 2, 4, 30, "()   :", pos_LEFT)
	#self.customers.Focusable = self.selectCustomers
	
	#if self.selectCustomers == FALSE:
	#    self.customers.SetText("  ")
	#else:
	#    self.customers.SetText("  ")
	self.addWidget(self.customers)
	#3
	self.begdate = LabeledDateLine(self, 2, 6, " .:")
	#self.begdate.SetText(self.nowday)
	_bb = self.expdate[8:10] + "/" + self.expdate[5:7] + "/" + self.expdate[2:4]
	self.begdate.SetText(_bb)
	self.addWidget(self.begdate)
	#4
	#self.enddate = LabeledDateLine(self, 26, 6, "  .: ")
	#self.enddate.SetText(self.nowday)
	#self.addWidget(self.enddate)
	
	self.writexy(2, 8, "[ F2 ]    , [ F10 ] - ", COL_TAB)
	#5
	self.rp = MultiListBox(self, 1, 9, 14, 77, COL_TEXT)
	self.rp.MultipleChoice(TRUE)
	self.rp.setItemColors(COL_TITLE, COL_TEXT)
	self.rp.Focusable = TRUE
	
	self.rp.addColon(21, ". ")
	self.rp.addColon(28, "")
	self.rp.addColon(10, "", dt_float, 3)
	self.rp.addColon(4, "1", dt_float, 0)
	self.rp.addColon(10, " .", dt_float, 3)
	self.rp.addColon(4, "2", dt_float, 0)
	
	#self.writexy(0, 0, str(self.expdate), COL_WARN)
	#self.writexy(12, 0, str(self.documents), COL_WARN)
	#self.writexy(45, 0, str(self.exped_no), COL_WARN)
	#self.writexy(55, 0, str(self.objects), COL_WARN)
	#if self.load == TRUE:
	#    q = "SELECT partners.city, partners.sname, SUM(sales.weight), COUNT(DISTINCT sales.doc_no, sales.doc_counter), 0, 0, partners.dan_no FROM partners, sales WHERE partners.dan_no = sales.partn_dn AND partners.ptype = 2 AND sales.exped_no IN (0," + strip(str(self.exped_no)) + ") AND sales.object_no IN (" + self.objects + ") AND sales.object_no = partners.object_no AND sales.doc_date = \'" + self.expdate + "\' GROUP BY partners.dan_no ORDER BY partners.sname"
	#    self.writexy(0, 1, q, COL_WARN)
	if self.load == TRUE:
	    #self.writexy(0, 0, str(self.expdate), COL_WARN)
	    #self.writexy(12, 0, str(self.documents), COL_WARN)
	    #self.writexy(45, 0, str(self.exped_no), COL_WARN)
	    #self.writexy(55, 0, str(self.objects), COL_WARN)
	    if strip(self.documents) == "":
		self.rp.dbQuery = "SELECT partners.city, partners.sname, SUM(sales.weight), COUNT(DISTINCT sales.doc_no, sales.doc_counter), 0, 0, partners.dan_no FROM partners, sales WHERE partners.dan_no = sales.partn_dn AND partners.ptype = 2 AND sales.exped_no IN (0," + strip(str(self.exped_no)) + ") AND sales.object_no IN (" + self.objects + ") AND partners.object_no = 2 AND sales.doc_date = \'" + self.expdate + "\' GROUP BY partners.dan_no ORDER BY partners.sname"
	    else:
		self.rp.dbQuery = "SELECT partners.city, partners.sname, SUM(sales.weight), COUNT(DISTINCT sales.doc_no, sales.doc_counter), 0, 0, partners.dan_no FROM partners, sales WHERE partners.dan_no = sales.partn_dn AND partners.ptype = 2 AND sales.exped_no IN (0," + strip(str(self.exped_no)) + ") AND sales.object_no IN (" + self.objects + ") AND partners.object_no = 2 AND sales.doc_no IN (" + self.documents + ") AND sales.doc_date = \'" + self.expdate + "\' GROUP BY partners.dan_no ORDER BY partners.sname"
	    m = Message()
	    m.message = cm_RELOAD
	    self.rp.Update(m)
	    #self.rp.SelectAll(TRUE)
	    if len(self.rp.items) > 0:
	    	db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host = "192.168.0.2")
		curs = db.cursor()
		
		#      
		#        
		curs.execute("""INSERT INTO tempexped SELECT * from expedcatalog WHERE userid = %s""", (self.exped_no,))
		if strip(self.documents) == "":
		    qry = "INSERT INTO expedcatalog SELECT sales.doc_counter, sales.doc_no, sales.doc_date, " + str(self.exped_no) + ", partners.dan_no, partners.sname, SUM(sales.weight), SUM(sales.weight * sales.price), 0 FROM sales, partners WHERE sales.partn_dn = partners.dan_no AND partners.ptype = 2 AND sales.object_no IN (" + self.objects + ") AND sales.exped_no = 0 AND sales.object_no = partners.object_no AND LEFT(sales.doc_date, 10) = \'" + self.expdate + "\' GROUP BY sales.doc_no, sales.doc_counter ORDER by partners.sname"
		else:
		    qry = "INSERT INTO expedcatalog SELECT sales.doc_counter, sales.doc_no, sales.doc_date, " + str(self.exped_no) + ", partners.dan_no, partners.sname, SUM(sales.weight), SUM(sales.weight * sales.price), 0 FROM sales, partners WHERE sales.partn_dn = partners.dan_no AND partners.ptype = 2 AND sales.object_no IN (" + self.objects + ") AND sales.exped_no = 0 AND sales.doc_no IN (" + self.documents + ") AND sales.object_no = partners.object_no AND LEFT(sales.doc_date, 10) = \'" + self.expdate + "\' GROUP BY sales.doc_no, sales.doc_counter ORDER by partners.sname"
		curs.execute(qry)
			      
	    	curs.execute("""SELECT expedcatalog.partn_dn, SUM(expedcatalog.sweight), COUNT(DISTINCT expedcatalog.doc_no, expedcatalog.doc_counter) FROM expedcatalog WHERE expedcatalog.userid = %s AND expedcatalog.sel = 1 GROUP BY expedcatalog.partn_dn ORDER BY expedcatalog.partn_sname""",
	                 (self.exped_no,))
	    	recs = curs.fetchall()
	    	db.close()
	    	if len(recs) > 0:
	    	    for i in range(len(recs)):
			rit = recs[i]
			for j in range(len(self.rp.items)):
			    hit = self.rp.hidden_items[j]
			    if hit[0] == rit[0]:
				self.rp.items[j][4].SetText(str(rit[1]))
				self.rp.items[j][5].SetText(str(rit[2]))
				if rit[2] > 0:
				    self.rp.SelectThis(j)
				
		    self.rp.draw()
		    self.CalculateSum()
		    del recs
	
	self.addWidget(self.rp)
	
	self.AddHotKey(curses.KEY_F2, 4)
	self.AddHotKey(curses.KEY_F10, 0)
	
	self.AddHotKey(curses.KEY_F1, 4)
	if self.load == FALSE:
	    self.select(0)
	else:
	    self.select(4)

    def mainLoop(self):
	while 1:
	    status = Dialog.mainLoop(self)
	    if status == ev_FAIL and self.quitstatus == 1:
		msgbox = MessageBox(28, 9, 8, 27, COL_TAB, COL_TAB, \
		                        ["  ", "  ?"], "?", msg_YESNO)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		if yes == cmd_YES:
		    if len(self.rp.items) == 0:
			status = ev_FAIL
			break
		    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host = "192.168.0.2")
		    curs = db.cursor()
		    curs.execute("""SELECT doc_counter, doc_no, sel FROM expedcatalog WHERE userid = %s""", (self.exped_no,))
		    recs = curs.fetchall()
		    for i in range(len(recs)):
			if str(recs[i][2]) == '1':
			    curs.execute("""UPDATE sales SET exped_no = %s WHERE doc_no = %s AND doc_counter = %s""", (self.exped_no, recs[i][1], recs[i][0])) 
			elif str(recs[i][2]) == '0':
			    curs.execute("""UPDATE sales SET exped_no = 0 WHERE doc_no = %s AND doc_counter = %s""", (recs[i][1], recs[i][0])) 
		    curs.execute("""DELETE FROM expedcatalog WHERE sel = 0 AND userid = %s""", (self.exped_no,))
		    curs.execute("""DELETE FROM tempexped WHERE userid = %s""", (self.exped_no,))
		    #       SALES
		    #         
		
		    db.close()
		    status = ev_OK
		    break
		else:
		    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host = "192.168.0.2")
		    curs = db.cursor()
		    curs.execute("""DELETE FROM expedcatalog WHERE userid = %s""", (self.exped_no,))
		    if self.load == TRUE:
			curs.execute("""INSERT INTO expedcatalog SELECT * FROM tempexped WHERE userid = %s""", (self.exped_no,))
			curs.execute("""DELETE FROM tempexped WHERE userid = %s""", (self.exped_no,))
		    db.close()
		    status = ev_FAIL
		    break
	return status

    def CalculateSum(self):
	self.exped_total = 0
	for i in range(len(self.rp.items)):
	    if self.rp.items[i][0].selection == TRUE:
		self.exped_total = self.exped_total + float(self.rp.items[i][4].Label)
	self.writexy(64, 24, rjust(fix(self.exped_total, 3), 10) + " ", COL_TITLE, TRUE)
    
    def UserFn(self, command, args):
	if command == cm_SELECTION and args == self.rp.control:
	    if self.rp.items[self.rp.hilite][0].selection == FALSE:
		i = self.rp.hilite
		self.rp.items[i][4].SetText("0")
		self.rp.items[i][5].SetText("0")
		
		# !!!      expedcatalog
		db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host = "192.168.0.2")
		curs = db.cursor()
		curs.execute("""UPDATE expedcatalog SET sel = 0 WHERE partn_dn = %s AND userid = %s""", (self.rp.hidden_items[i][0], self.exped_no))
		db.close()
	    elif self.rp.items[self.rp.hilite][0].selection == TRUE:
		i = self.rp.hilite
		self.rp.items[i][4].SetText(self.rp.items[i][2].Label)
		self.rp.items[i][5].SetText(self.rp.items[i][3].Label)
		db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host = "192.168.0.2")
		curs = db.cursor()
		curs.execute("""UPDATE expedcatalog SET sel = 1 WHERE partn_dn = %s AND userid = %s""", (self.rp.hidden_items[i][0], self.exped_no))
		db.close()
		pass
	    self.rp.draw()
	    self.CalculateSum()
	    return ev_NONE
	
	if command == ev_ACTIVATE and args == curses.KEY_F1:
	    if len(self.rp.items) == 0:
		msgbox = MessageBox(35, 7, 7, 24, COL_TAB, COL_TAB, \
				    [" ", " !"], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		return ev_DONE
	    it = self.rp.items[self.rp.hilite]
	    view = OutDocsView(self.exped_no, it[0].Label, it[1].Label, 
	        self.rp.hidden_items[self.rp.hilite][0], self.exped_total)
	    (_status, _nsel, _sum) = view.mainLoop()
	    view.destroy()
	    del view
	    if _status == ev_OK:
		i = self.rp.hilite
		self.rp.items[i][4].SetText(str(_sum))
		self.rp.items[i][5].SetText(str(_nsel))
		if _nsel == 0:
		    self.rp.DeselectThis(i)
		elif _nsel > 0:
		    self.rp.SelectThis(i)
		self.rp.draw()
		self.CalculateSum()
	    return ev_DONE
	
	if command == ev_ACTIVATE and args == curses.KEY_F10 and self.load == FALSE:
	    del self.object_list
	    del self.customers_list
	    del self.docs_list
	    
	    self.object_list = []
	    self.customers_list = []
	    self.docs_list = []
	    self.docsAll = FALSE
	    self.objAll = FALSE
	    
	    self.object.SetText("  ")
	    self.document.SetText("  ")
	    
	    return ev_OK
	if command == ev_ACTIVATE and args == curses.KEY_F2 and self.load == FALSE:
	    strbd = self.begdate.text
	    #stred = self.enddate.text
	    b = "20" + strbd[6:8] + "-" + strbd[3:5] + "-" + strbd[0:2]
	    self.docs_date = b
	    
	    #e = "20" + stred[6:8] + "-" + stred[3:5] + "-" + stred[0:2]
	    #e1 = int(stred[6:8] + stred[3:5] + stred[0:2])
	    #if e1 < b1:
	    #	msgbox = MessageBox(35, 7, 8, 24, COL_TAB, COL_TAB, \
	    #			    [" ", "   -", "  !"], "", msg_OK)
	    #	msgbox.mainLoop()
	    #	msgbox.destroy()
	    #	del msgbox
	    #	return ev_DONE
	    if (len(self.object_list) == 0 and self.objAll == FALSE) or \
	       (len(self.docs_list) == 0 and self.docsAll == FALSE):
		msgbox = MessageBox(33, 7, 8, 26, COL_TAB, COL_TAB, \
				    ["  ", "  "], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		return ev_DONE
	    _expno = 0
	    qry = ""   
	    qry = "SELECT partners.city, partners.sname, SUM(sales.weight), COUNT(DISTINCT sales.doc_no, sales.doc_counter), SUM(sales.weight), COUNT(DISTINCT sales.doc_no, sales.doc_counter), partners.dan_no FROM partners, sales WHERE partners.dan_no = sales.partn_dn AND partners.ptype = 2 AND sales.exped_no = " + str(_expno)
	    
	    q11 = ""
	    #for i in range(len(self.object_list)):
	    #	q11 = q11 + str(self.object_list[i])
	    #	if i == len(self.object_list) - 1:
	    #	    q11 = q11 + ")"
	    #	else:
	    #	    q11 = q11 + ","
	    
	    q11 = " AND sales.object_no IN (" + str(self.object_list)[1:-1] + ") "
	    
	    q1 = q11 + " AND sales.object_no = partners.object_no "
	    if self.docsAll == TRUE:
		q2 = ""
	    else:
		q21 = ""
		for i in range(len(self.docs_list)):
		    q21 = q21 + str(self.docs_list[i])
		    if i == len(self.docs_list) - 1:
			q21 = q21 + ")"
		    else:
			q21 = q21 + ","
		q2 = " AND sales.doc_no IN (" + q21
		
	    q3 = " AND LEFT(sales.doc_date, 10) = \'" + b + "\' "
	    self.rp.dbQuery = qry + q1 + q2 + q3 + " GROUP BY partners.dan_no ORDER BY partners.sname"
	    #self.writexy(0,0, self.rp.dbQuery, COL_WARN)
	    #return ev_OK
	    m = Message()
	    m.message = cm_RELOAD
	    self.rp.Update(m)
	    self.rp.SelectAll(TRUE)
	    #for i in range(len(self.rp.items)):
	    #	self.rp.hidden_items[i].append([1])
	    self.rp.draw()
	    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host = "192.168.0.2")
	    curs = db.cursor()
	    qry = "INSERT INTO expedcatalog SELECT sales.doc_counter, sales.doc_no, sales.doc_date," + str(self.exped_no) + ", partners.dan_no, partners.sname, SUM(sales.weight), SUM(sales.weight * sales.price), 1 FROM sales, partners WHERE sales.partn_dn = partners.dan_no AND partners.ptype = 2 AND sales.object_no IN (" + str(self.object_list)[1:-1] + ") AND sales.exped_no = 0 AND sales.object_no = partners.object_no AND LEFT(sales.doc_date, 10) = \'" + b + "\' GROUP BY sales.doc_no, sales.doc_counter ORDER by partners.sname"
	    curs.execute(qry)
	    #curs.execute("""INSERT INTO expedcatalog SELECT 
	    #                  sales.doc_counter, sales.doc_no, sales.doc_date,
	    #		      %s, partners.dan_no, partners.sname,
	    #		      SUM(sales.weight), SUM(sales.weight * sales.price), 
	    #		      1 FROM sales, partners
	    #		      WHERE sales.partn_dn = partners.dan_no AND
	    #		      partners.ptype = 2 AND
	    #		      sales.object_no IN (%s) AND sales.exped_no = 0 AND
	    #		      sales.object_no = partners.object_no AND
	    #		      LEFT(sales.doc_date, 10) = %s
	    #		      GROUP BY sales.doc_no, sales.doc_counter
	    #		      ORDER by partners.sname""",
	    #		      (self.exped_no, str(self.object_list)[1:-1], b))
	    #self.docrecs = curs.fetchall()
	    db.close()
	    self.CalculateSum()
	    return ev_OK
	if command == ev_OPTION and args == 0:
	    del self.object_list
	    self.object_list = []
	    objdlg = ObjectDialog(report = TRUE, x=49, y=2, addqry = " WHERE flag = ''")
	    (ono, oname) = objdlg.mainLoop()
	    if objdlg._statusf == ev_FAIL or objdlg._totalselect == TRUE:
		self.object.SetText("")
		self.objAll = TRUE
		for i in range(len(objdlg.objlist.items)):
		    self.object_list.append(objdlg.objlist.items[i][0].Label)
	    else:
		if objdlg._selcount > 1:
		    self.object.SetText("")
		    del self.object_list
		    self.object_list = objdlg._sellist
		else:
		    self.object.SetText(oname)
		    self.object_list.append(ono)
	
	    #self.writexy(0, 0, str(objdlg._sellist), COL_WARN)
	    #self.object.SetText(oname)
	    #self.object_list.append(ono)
	    objdlg.destroy()
	    del objdlg
	    
	    self.select(1)
	    return ev_NONE
	if command == ev_OPTION and args == 1:
	    self.docsAll = FALSE
	    del self.docs_list
	    self.docs_list = []
	    docdlg = DocumentDialog("", report = TRUE, x=40, y=2)
	    (dno, dname) = docdlg.mainLoop()
	    if docdlg._statusf == ev_FAIL or docdlg._totalselect == TRUE:
		self.document.SetText("")
		self.docsAll = TRUE
	    else:
		if docdlg._selcount > 1:
		    self.document.SetText("")
		    del self.docs_list
		    self.docs_list = docdlg._sellist
		else:
		    self.document.SetText(dname)
		    self.docs_list.append(dno)
	    docdlg.destroy()
	    del docdlg
	    #   
	    self.select(3)
	    return ev_NONE
    
	if command == ev_OPTION and args == 2:
	    self.select(3)
	    return ev_NONE
	
	if command == ev_OK and args == 3:
	    self.select(3)
	    return ev_NONE
	

#-----------------------------------------------------------------------------
#    

class ListArtsIn(Dialog):
    def __init__(self, Object_no=2, Object_name=" 2"):
	self.object_no = int(Object_no)
	self.object_name = Object_name
	self.combine = FALSE
	self.loaded = TRUE
	self.nowday = strftime("%d/%m/%y", gmtime())
	self.finalDate = self.nowday
		
	Dialog.__init__(self, 0, 0, 24,  79, COL_MAIN)
	self.set_caption("   ")	
	#0
	self.writexy(6, 2, ": " + self.object_name, COL_WARN, TRUE)
	self.writexy(65, 1, " ", COL_TEXT1)
	
	self.bdate = DateLine(self, 56, 2)
	self.bdate.SetText(self.finalDate)
	self.addWidget(self.bdate)
	
	self.edate = DateLine(self, 65, 2)
	self.edate.SetText(self.finalDate)	
	self.addWidget(self.edate)
	#1
	self.groups = OptionLine(self, 42, 4, 21, ". ", pos_UP)
	self.addWidget(self.groups)
	#2
	self.doc_counter = LabeledEditLine(self, 6, 6, 10, ".    :")
	self.doc_counter.Focusable = FALSE
	self.addWidget(self.doc_counter)
	#3
	self.ddate = LabeledEditLine(self, 6, 7, 10,       ". :")
	self.ddate.Focusable = FALSE
	self.addWidget(self.ddate)
	#4
	self.customer = LabeledEditLine(self, 31, 7, 32, ":")
	self.customer.Focusable = FALSE
	self.addWidget(self.customer)
        #5
	self.dtype = LabeledEditLine(self, 31, 6, 32, " :")
	self.dtypeFocusable = FALSE
	self.addWidget(self.dtype)
	
	
	#6
	self.artlist = MultiListBox(self, 6, 8, 14, 67, COL_TEXT)
	self.artlist.MultipleChoice(FALSE)
	self.artlist.setItemColors(COL_TITLE, COL_TEXT)
	self.artlist.Focusable = TRUE
	#self.artlist.dbQuery = "SELECT CONCAT(articles.group_no, articles.art_no), articles.name, articles.qty_id, sum(delivery.rest_qnty) FROM articles, delivery WHERE delivery.object_no = " + str(self.current_object) + " AND articles.group_no = delivery.group_no AND articles.art_no = delivery.art_no AND delivery.valid = 1 AND delivery.rest_qnty > 0 GROUP by 1 ORDER BY articles.name"
	self.artlist.addColon(6, ".")
	self.artlist.addColon(31, "")
	self.artlist.addColon(5, "/")
	self.artlist.addColon(12, "", dt_float, 3)
	self.artlist.addColon(13, ".-", dt_float, 3)
	#m = Message()
	#m.message = cm_RELOAD
	#self.artlist.Update(m)	
	self.artlist.addNotifyRecipient(self, cm_ITEM_CHANGED)
	self.addWidget(self.artlist)
	
	self.writexy(6, 4, "             ", COL_TITLE, TRUE)
	
	self.writexy(2, 24, " | F1 -  | F2 -  | F6 -  | F10 -  | ", COL_TITLE, bold = TRUE)
	self.AddHotKey(curses.KEY_F2, 6)
	self.AddHotKey(curses.KEY_F6, 6)
	self.AddHotKey(curses.KEY_F1, 0)
	
	self.select(0)
	
    def Update(self, msg):
	if msg.message == cm_ITEM_CHANGED and self.combine == FALSE:
	    indx = msg.args[1]
	    #self.writexy(60, 0, str(self.artlist.hidden_items[indx][0]), COL_WARN)
	    self.ddate.SetText(self.artlist.hidden_items[indx][0])
	    self.customer.SetText(self.artlist.hidden_items[indx][1])
	    self.doc_counter.SetText(str(self.artlist.hidden_items[indx][2]))
	    self.dtype.SetText(self.artlist.hidden_items[indx][3])
	    
	    self.writexy(50, 0, str(self.artlist.hidden_items[indx][4]), COL_WARN)
	    
	
    def UserFn(self, command, args):
	if command == ev_OK and args == 0:
	    self.nextWidget()
	    return ev_NONE
	if command == ev_OK and args == 1:
	    self.nextWidget()
	    return ev_NONE
	    
	if command == ev_ACTIVATE and args == curses.KEY_F1:
	    return ev_OK
	if command == ev_ACTIVATE and args == curses.KEY_F2:
	    stred = self.edate.text
	    strbe = self.bdate.text
	    mbox =  MessageBox(30, 9, 6, 22, COL_WARN, COL_WARN, \
		                        ["  "], "", msg_MSG)
	    mbox.show()
	    e = "20" + stred[6:8] + "-" + stred[3:5] + "-" + stred[0:2]
	    b = "20" + strbe[6:8] + "-" + strbe[3:5] + "-" + strbe[0:2]
	    
	    self.writexy(0, 0, str(self.object_no), COL_WARN)
	    self.writexy(20, 0, str(b), COL_WARN)
	    self.writexy(40, 0, str(e), COL_WARN)
	    
	    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	    curs = db.cursor()

	    mbox.writexy(2, 6, " 1", COL_WARN, TRUE)
	    pflush()
	    curs.execute("""SELECT 
	                 delivery.rid,
	                 CONCAT(articles.group_no, articles.art_no),
	    		 articles.name,
	    		 articles.qty_id,
	    		 delivery.deliv_qnty,
	    		 delivery.price * delivery.deliv_qnty,
	    		 LEFT(delivery.doc_date,10),
	    		 partners.lname, delivery.doc_counter, documents.name,
	    		 articles.pack1 FROM
	    		 articles, delivery, partners, documents
	    		 WHERE 
	    		 documents.base = 1 AND
	    		 delivery.object_no = %s AND 
            		 articles.object_no = delivery.object_no AND
	    		 articles.group_no = delivery.group_no AND
	    		 articles.art_no = delivery.art_no AND
	    		 delivery.valid = 1 AND delivery.archive = 0 AND
	    		 LEFT(delivery.doc_date, 10) >= %s AND
	    		 LEFT(delivery.doc_date, 10) <= %s AND
	    		 partners.dan_no = delivery.partn_dn AND
	    		 partners.ptype = 1 AND 
	    		 partners.object_no = %s AND
	    		 delivery.doc_no = documents.doc_no
	    		 ORDER BY 3,7""",
	    		 (self.object_no, b, e, self.object_no))
	    
	    delivered = curs.fetchall()
	    mbox.writexy(2, 6, " 2", COL_WARN, TRUE)
	    pflush()
	    db.close()
	    
	    del self.artlist.items
	    del self.artlist.hidden_items
	    self.artlist.items =[]
	    self.artlist.hidden_items = []
	    self.artlist.hilite = -1
	    self.artlist.start = -1
	    self.artlist.end = 0
	    reccount = 0
	    for i in range(len(delivered)):
	    	reccount = reccount + 1
	    	self.artlist.addItem([delivered[i][1], delivered[i][2], delivered[i][3], str(delivered[i][4]), str(delivered[i][5])], hidden = [delivered[i][6], delivered[i][7], delivered[i][8], delivered[i][9], delivered[i][0]])
	    	mbox.writexy(2, 6, " : " + str(reccount), COL_WARN, TRUE)
	    	pflush()
	    self.artlist.draw()
	    self.select(self.artlist.control)
	    self.loaded = TRUE
	    self.combine = FALSE
	    mbox.destroy()
	    del mbox
	    self.writexy(0, 0, str(self.object_no), COL_WARN)
	    self.writexy(20, 0, str(b), COL_WARN)
	    self.writexy(40, 0, str(e), COL_WARN)
	    return ev_OK
	    
	if command == ev_ACTIVATE and args == curses.KEY_F6 and self.loaded == TRUE:
	    self.combine = TRUE
	    self.loaded = FALSE
	    stred = self.edate.text
	    mbox =  MessageBox(30, 9, 6, 22, COL_WARN, COL_WARN, \
		                        ["  "], "", msg_MSG)
	    mbox.show()
	    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	    curs = db.cursor()
	    mbox.writexy(2, 6, " 1", COL_WARN, TRUE)
	    pflush()
	    curs.execute("""DELETE FROM tempstore WHERE operid = 'cv'""")
	    
	    for i in range(len(self.artlist.items)):
		it = self.artlist.items[i]
		mbox.writexy(2, 6, " : " + str(i), COL_WARN, TRUE)
		pflush()
		curs.execute("""INSERT INTO tempstore
		                VALUES (%s, %s, %s, %s, %s, %s, %s, %s)""",
			 (it[0].Label[0:2],
			  it[0].Label[2:5],
			  it[1].Label,
			  it[2].Label,
			  it[3].Label,
			  it[4].Label, "cv", 1))
	    
	    db.close()
	    mbox.destroy()
	    del mbox
	    self.artlist.dbQuery = "SELECT CONCAT(group_no, art_no) as no, name, qty_id, SUM(qnty) as sqnty, SUM(price) FROM tempstore GROUP BY group_no, art_no ORDER BY 2"
	    m = Message()
	    m.message = cm_RELOAD
	    self.artlist.Update(m)

	    self.artlist.draw()
	    
	    self.ddate.SetText("--")
	    self.customer.SetText("--")
	    self.doc_counter.SetText("--")
	    self.dtype.SetText("--")
	    return ev_OK
    



#-----------------------------------------------------------------------------
#

class DocumentsList(Dialog):
    def __init__(self, customer_type, customer_dan_no, customer_name, object = None):
	self.customer_type = customer_type
	self.customer_name = strip(customer_name)
	self.dan_no = customer_dan_no
	self.object = object
	Dialog.__init__(self, 0, 10, 14, 79, COL_MAIN)
	
	if self.customer_type == 1:
	    self.addWidget(Label(self, 3, 1, "     :" + self.customer_name, COL_TEXT1))
	elif self.customer_type == 2:
	    self.addWidget(Label(self, 3, 1, "     :" + self.customer_name, COL_TEXT1))
	    
	self.cl = MultiListBox(self, 3, 2, 10, 73, COL_TEXT)
	self.cl.MultipleChoice(FALSE)
	self.cl.setItemColors(COL_TITLE, COL_TEXT)
	self.cl.addColon(11, "")
	self.cl.addColon(11, "")	
	self.cl.addColon(26, "")

	self.cl.addColon(12, "", dt_float, 3)
	self.cl.addColon(12, "", dt_float, 3)
	
	if self.object == None:
	    self.cl.dbQuery = "SELECT CONCAT(sales.doc_counter, ''), LEFT(sales.doc_date, 10), documents.name, SUM(sales.weight), SUM(sales.qnty * sales.price) FROM sales, partners, documents WHERE sales.partn_dn = partners.dan_no AND partners.object_no = sales.object_no AND partners.ptype = 2 AND sales.doc_no = documents.doc_no AND sales.partn_dn = \'" + self.dan_no + "\' GROUP BY sales.doc_counter, sales.doc_no ORDER by sales.doc_date"
	else:
	    self.cl.dbQuery = "SELECT dan_no, city, sname from partners WHERE ptype=" + str(self.customer_type) + " AND object_no = " + str(self.object) + " ORDER BY sname"
        m = Message()
	m.message = cm_RELOAD
	self.cl.Update(m)
	self.addWidget(self.cl)
	
	self.select(self.cl.control)

    def UserFn(self, command, args = None):
	pass
	
#-----------------------------------------------------------------------------
#
class PartnersDialog(Dialog):
    def __init__(self, customer_type, object = None):
	self.customer_type = customer_type
	self.object = object
	Dialog.__init__(self, 5, 5, 14,  71, COL_MAIN)
	if self.customer_type == 1:
	    self.addWidget(Label(self, 2, 1, " ", COL_MAIN))
	elif self.customer_type == 2:
	    self.addWidget(Label(self, 2, 1, " ", COL_MAIN))
	    
	self.cl = MultiListBox(self, 2, 2, 10, 67, COL_TEXT)
	self.cl.MultipleChoice(FALSE)
	self.cl.setItemColors(COL_TITLE, COL_TEXT)
	self.cl.addColon(13, ". ")
	self.cl.addColon(21," ")
	self.cl.addColon(33, "")
	if self.object == None:
	    self.cl.dbQuery = "SELECT DISTINCT dan_no, city, sname from partners WHERE ptype=" + str(self.customer_type) + " ORDER BY sname"
	else:
	    self.cl.dbQuery = "SELECT dan_no, city, sname from partners WHERE ptype=" + str(self.customer_type) + " AND object_no = " + str(self.object) + " ORDER BY sname"
        m = Message()
	m.message = cm_RELOAD
	self.cl.Update(m)
	self.addWidget(self.cl)
	if self.object == None:
	    self.cl.dbQuery = "SELECT DISTINCT dan_no, city, sname from partners WHERE ptype=" + str(self.customer_type)
	else:
	    self.cl.dbQuery = "SELECT dan_no, city, sname from partners WHERE ptype=" + str(self.customer_type) + " AND object_no = " + str(self.object)

	    
	self.AddHotKey(curses.KEY_F1, 1)
	self.select(self.cl.control)
	
	
    def mainLoop(self):
	status = Dialog.mainLoop(self)
	if status == ev_OK and len(self.cl.items) > 0:
	    dan_no = self.cl.items[self.cl.hilite][0].Label
	    city = self.cl.items[self.cl.hilite][1].Label
	    cust_name = self.cl.items[self.cl.hilite][2].Label
	    return (dan_no, city, cust_name)
	else:
	    return (None, None, None)

    def UserFn(self, command, args = None):
	if command == ev_ACTIVATE and args == curses.KEY_F1:
	    dn = self.cl.items[self.cl.hilite][0].Label
	    name = self.cl.items[self.cl.hilite][2].Label
	    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	    curs = db.cursor()
	    recs = curs.execute("""SELECT doc_counter FROM sales WHERE partn_dn = %s""", (dn, ))
	    if recs > 0:
		db.close()
		info = DocumentsList(self.customer_type, dn, name)
		info.mainLoop()
		info.destroy()
		del info
		pflush()
		return ev_DONE
	    db.close()
	    return ev_DONE
	
	if command == cm_QUICK_SEARCH:
	    searchdlg = Dialog(36, 10, 10, 40, COL_MAIN)
	    searchdlg.set_caption(" ")
	    searchdlg.addWidget(Label(searchdlg, 2, 2, " :", COL_TEXT1))
	    cust_name = EditLine(searchdlg, 15, 2, 23, COL_TEXT, COL_TITLE)
	    searchdlg.addWidget(cust_name)
	    searchdlg.addWidget(Label(searchdlg, 2, 4, ". :", COL_TEXT1))
	    dan_no = EditLine(searchdlg, 15, 4, 10, COL_TEXT, COL_TITLE)
	    searchdlg.addWidget(dan_no)

	    searchdlg.addWidget(Label(searchdlg, 2, 6, ":", COL_TEXT1))
	    bulst = EditLine(searchdlg, 15, 6, 10, COL_TEXT, COL_TITLE)
	    searchdlg.addWidget(bulst)
	    
	    searchdlg.addWidget(Label(searchdlg, 2, 8, ". :", COL_TEXT1))
	    city = EditLine(searchdlg, 15, 8, 23, COL_TEXT, COL_TITLE)
	    searchdlg.addWidget(city)
	    
	    searchdlg.select(1)
	    
	    searchdlg.mainLoop()
	    
	    scust_name = cust_name.text
	    sdan_no = dan_no.text
	    sbulst = bulst.text
	    scity = city.text
	    
	    p1 = p2 = p3 = p4 = 0
	    if len(scust_name) <> 0 or len(sdan_no) <> 0 or \
	       len(sbulst) <> 0 or len(scity) <> 0:
		query = " AND"
		if len(scust_name) <> 0:
		    query = query + " sname RLIKE \'^" + scust_name + "\'"
		    p1 = 1
		if len(sdan_no) <> 0:
		    if p1 == 0:
			query = query + " dan_no RLIKE \'^" + sdan_no + "\'"
		    else:
			query = query + " AND dan_no RLIKE \'^" + sdan_no + "\'"
		    p2 = 1
		if len(sbulst) <> 0:
		    if p2 == 0 and p1 == 0:
			query = query + " buslt RLIKE \'^" + sbulst + "\'"
		    else:
			query = query + " AND buslt RLIKE \'^" + sbulst + "\'"
		    p3 = 1
		if len(scity) <> 0:
		    if p3 == 0 and p2 == 0 and p1 == 0:
			query = query + " city RLIKE \'^" + scity + "\'"
		    else:
			query = query + " AND city RLIKE \'^" + scity + "\'"
		    p4 = 1
		    
		
		query = query + " ORDER BY sname"
		
		m = Message()
		m.message = cm_RELOAD
		m.args = [" ", query, ""]
		success = self.cl.Update(m)
		if success == 0:
		    msgbox = MessageBox(28, 9, 6, 20, COL_TAB, COL_TAB, \
		                        [" "], "", msg_OK)
		    msgbox.mainLoop()
		    msgbox.destroy()
		    del msgbox
		    pflush()
		    m.args = []
		    self.cl.Update(m)
		
    
	    searchdlg.destroy()
	    del searchdlg
	    pflush()
	    curses.curs_set(0)
	return ev_DONE
	


