import os, re
from  defs import *
import curses
from curses import panel
import ui
from ui import *
from  MySQLdb import *
from support import *
from reports import *
from time import gmtime, strftime, localtime
from string import *

class PTBox(DropDnBox):
    def LoadBox(self, user, passwd, dbase, tablename, loadfn=1):
	self.box.addItem("")
	self.box.addItem("")

class QTYBox(DropDnBox):
    def LoadBox(self, user, passwd, dbase, tablename, loadfn=1):
	self.box.addItem(".")
	self.box.addItem(".")
	
	

class AddCustomer(Dialog):
    def __init__(self, dn = None, customer_type = 0, loadfn = 0):
	self.loadfn = loadfn
	self.dn = dn
	self.customer_type = customer_type
	Dialog.__init__(self, 6, 4, 16, 65, COL_MAIN)
	self.set_caption("  - ")
	
	self.writexy(2, 2, " ", COL_TEXT1)
	self.ptbox = PTBox(self, 2, 3, 12, 4, COL_WARN)
	self.addWidget(self.ptbox)
	
	self.dan_no = LabeledEditLine(self, 16, 3, 10, ". ", pos_UP)
	self.dan_no.setType(dt_numeric)
	self.addWidget(self.dan_no)

	self.bulst = LabeledEditLine(self, 28, 3, 10, "", pos_UP)
	self.addWidget(self.bulst)
	
	self.sname = LabeledEditLine(self, 2, 5, 20, "   ( )", pos_UP)
	self.addWidget(self.sname)
	
	self.lname = LabeledEditLine(self, 24, 5, 32, "   ( )", pos_UP)
	self.addWidget(self.lname)

	self.city = LabeledEditLine(self, 2, 7, 20, " ", pos_UP)
	self.addWidget(self.city)
	
	self.address = LabeledEditLine(self, 24, 7, 33, "", pos_UP)
	self.addWidget(self.address)

	self.mol = LabeledEditLine(self, 2, 9, 32, "", pos_UP)
	self.addWidget(self.mol)
	
	self.pasp = LabeledEditLine(self, 36, 9, 12, ". ", pos_UP)
	self.addWidget(self.pasp)

	self.egn = LabeledEditLine(self, 50, 9, 10, "", pos_UP)
	self.egn.setType(dt_numeric)
	self.addWidget(self.egn)

	self.tel1 = LabeledEditLine(self, 2, 11, 15, ". .", pos_UP)
	self.addWidget(self.tel1)

	self.tel2 = LabeledEditLine(self, 18, 11, 15, ". .", pos_UP)
	self.addWidget(self.tel2)
	
	self.fax = LabeledEditLine(self, 35, 11, 15, "", pos_UP)
	self.addWidget(self.fax)
	
	self.email = LabeledEditLine(self, 2, 13, 48, "-mail", pos_UP)
	self.addWidget(self.email)
	
	self.writexy(33, 15, " F4 -   | F2 -  ", COL_WARN, TRUE)

	self.AddHotKey(curses.KEY_F4, 0)
	self.AddHotKey(curses.KEY_F2, 1)
	if self.loadfn == 1:
	    self.Load(self.dn)
	self.select(1)
	
	
    def Load(self, dan_no):
	pass
    
    def UserFn(self, command, args):
	if command == ev_ACTIVATE and args == curses.KEY_F2:
	    if strip(self.ptbox.text) == "":
		ptype = 2
	    elif strip(self.ptbox.text) == "":
		ptype = 1
		
	    dn = strip(self.dan_no.text)
	    bst = strip(self.bulst.text)
	    sname = strip(self.sname.text)
	    lname = strip(self.lname.text)
	    city = strip(self.city.text)
	    addr = strip(self.address.text)
	    mol = strip(self.mol.text)
	    pasp = strip(self.pasp.text)
	    egn = strip(self.egn.text)
	    t1 = strip(self.tel1.text)
	    t2 = strip(self.tel2.text)
	    fax = strip(self.fax.text)
	    email = strip(self.email.text)
	    if dn == "" or sname == "":
		msgbox = MessageBox(35, 7, 8, 24, COL_TAB, COL_TAB, \
				    ["  ", "  !"], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		return ev_DONE
	    
	    return ev_QUIT
	    
	    
	    
	if command == ev_OK:
	    self.nextWidget()
	    return ev_NONE
	if command == ev_ACTIVATE and args == curses.KEY_F4:
	    return ev_DONE
	return ev_NONE

    
class AddArticle(Dialog):
    def __init__(self, object_no, object_name, grno = None, artno = None, loadfn = 0):
	self.loadfn = loadfn
	self._group_no = grno
	self._art_no = artno
	self.object_no = object_no
	self.object_name = object_name
	Dialog.__init__(self, 6, 4, 16, 65, COL_MAIN)
	self.set_caption(" -  - " + self.object_name )

	self.grno = EditLine(self, 2, 3, 3)
	self.grno.SetText("0")
	self.grno.Focusable = FALSE
	self.addWidget(self.grno)
	
	self.group = OptionLine(self, 6, 3, 32, " ", pos_UP)
	self.addWidget(self.group)
	
	self.artno = LabeledEditLine(self, 40, 3, 10, ". ", pos_UP)
	self.artno.Focusable = FALSE
	self.addWidget(self.artno)

	self.altno = LabeledEditLine(self, 52, 3, 10, ". ", pos_UP)
	self.altno.setType(dt_numeric)
	self.altno.SetText("0")
	self.addWidget(self.altno)
	
	self.name = LabeledEditLine(self, 2, 5, 30, "", pos_UP)
	self.addWidget(self.name)
	
	self.altname = LabeledEditLine(self, 34, 5, 30, " ", pos_UP)
	self.addWidget(self.altname)

	self.writexy(2, 6, "", COL_TEXT1)
	self.qtybox = QTYBox(self, 2, 7, 7, 4, COL_WARN)
	self.addWidget(self.qtybox)
	
	self.weight = LabeledEditLine(self, 11, 7, 10, "", pos_UP)
	self.weight.setType(dt_float)
	self.weight.SetText("0.0")
	self.addWidget(self.weight)

	self.pack1 = LabeledEditLine(self, 23, 7, 10, "1", pos_UP)
	self.pack1.setType(dt_numeric)
	self.pack1.SetText("0")
	self.addWidget(self.pack1)

	self.pack2 = LabeledEditLine(self, 35, 7, 10, "- 2 ()", pos_UP)
	self.pack2.setType(dt_numeric)
	self.pack2.SetText("0")
	self.addWidget(self.pack2)

	self.lim = LabeledEditLine(self, 2, 10, 10, "", pos_UP)
	self.lim.setType(dt_numeric)
	self.addWidget(self.lim)

	self.minqty = LabeledEditLine(self, 14, 10, 10, ". -", pos_UP)
	self.minqty.setType(dt_numeric)
	self.addWidget(self.minqty)

	self.normqty = LabeledEditLine(self, 26, 10, 10, ".-", pos_UP)
	self.normqty.setType(dt_numeric)
	self.addWidget(self.normqty)

	self.godnost = LabeledEditLine(self, 2, 12, 4, " (.)", pos_LEFT)
	self.godnost.setType(dt_numeric)
	self.addWidget(self.godnost)
	
	self.writexy(40, 15, " F4 -  | F2 -  ", COL_WARN, TRUE)	

	self.AddHotKey(curses.KEY_F2, 1)
	self.AddHotKey(curses.KEY_F4, self.qtybox.control)
	
	if self.loadfn == 1:
	    self.Load(self.dn)
	self.select(1)
	
	
    def Load(self, dan_no):
	pass
    
    def UserFn(self, command, args):
	if command == ev_ACTIVATE and args == curses.KEY_F4:
	    return ev_DONE

	if command == ev_OPTION and args == 1:
	    grdlg = GroupDialog()
	    (no, name) = grdlg.mainLoop()
	    grdlg.destroy()
	    del grdlg
	    self.group.SetText(strip(name))
	    self.grno.SetText(strip(no))
	    db = MySQLdb.connect(user = "cv", passwd="cv", db=DBASE)#, host = "192.168.0.2")
	    curs = db.cursor()
	    curs.execute("""SELECT MAX(art_no) 
			    FROM articles
			    WHERE group_no = %s AND
			    object_no = %s""", 
			    (int(self.grno.text), self.object_no))
	    (maxno, ) = curs.fetchone()
	    if maxno == None:
		maxno = 0
	    db.close()
	    self.artno.SetText(str(maxno+1))
	    self.select(3)
	    return ev_NONE
	    
	if command == ev_ACTIVATE and args == curses.KEY_F2:
	    _name = strip(self.name.text)
	    _altname = strip(self.altname.text)
	    _grno = int(self.grno.text)
	    _artno = int(self.artno.text)
	    _altno = int(self.altno.text)
	    _qtyid = strip(self.qtybox.text)
	    _ww = float(self.self.weight.text)
	    _pp1 = int(self.pack1.text)
	    _pp2 = int(self.pack2.text)
	    
	    if _name == "" or _grno == 0:
		msgbox = MessageBox(35, 7, 8, 24, COL_TAB, COL_TAB, \
				    ["   ", "    !"],  "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		return ev_DONE
	    
	    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host = "192.168.0.2")
	    curs = db.cursor()
	    curs.execute("""SELECT MAX(art_no) 
			    FROM articles
			    WHERE group_no = %s AND
			    object_no = %s""", 
			    (int(self.grno.text), self.object_no))
	    (maxno, ) = curs.fetchone()	    
	    _artno = maxno + 1
	    db.close()
	    return ev_QUIT
	    
	if command == ev_OK:
	    self.nextWidget()
	    return ev_NONE
	return ev_NONE
    
    
class STOREOPERBox(DropDnBox):
    def LoadBox(self, user, passwd, dbase, tablename, loadfn=1):
	self.box.addItem("")
	self.box.addItem("")

    

class CreateObject(Dialog):
    def __init__(self):
	Dialog.__init__(self, 50, 8, 10, 25, COL_MAIN)
	self.set_caption("   ")
	
	self.oname = LabeledEditLine(self, 2, 3, 20, "", pos_UP)
	self.addWidget(self.oname)
	
	self.writexy(2, 4, "", COL_TEXT1)
	self.opers = STOREOPERBox(self, 2, 5, 15, 3, COL_WARN)
	self.opers.Focusable = TRUE
	self.addWidget(self.opers)
	
	self.hidden = OptionLine(self, 2, 7, 10, "", pos_UP)
	self.hidden.SetText("")
	self.addWidget(self.hidden)

	self.writexy(15, 9, " F2- ", COL_WARN, TRUE)
	self.AddHotKey(curses.KEY_F2, 0)
	
	self.select(0)
	
    def UserFn(self, command, args):
	if command == ev_ACTIVATE and args == curses.KEY_F2:
	    _name = strip(self.oname.text)
	    _op = strip(self.opers.text)
	    _access = strip(self.hidden.text)
	    if _name == "":
		msgbox = MessageBox(30, 7, 8, 24, COL_TAB, COL_TAB, \
				    ["   ", "  !"],  "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		return ev_DONE
	    
	    return ev_QUIT
	if command == ev_OPTION:
	    if strip(self.hidden.text) == "":
		self.hidden.SetText("")
	    elif strip(self.hidden.text) == "":
		self.hidden.SetText("")
	    return ev_NONE
	if command == ev_OK:
	    self.nextWidget()
	    return ev_NONE
	
	
    
