
from defs import *
import re, sys, string
import curses
from string import *
from fpformat import fix
from curses import panel, ascii
import MySQLdb


UI_VERSION = "1.54.2-beta"

PANEL  = 0
DIALOG = 1
MSGBOX = 2


pos_UP = 1
pos_LEFT = 2
pos_RIGHT = 3

#---          curses
KEY_ALTE = 5
KEY_ALTA = 1
KEY_ESC  = 27
KEY_CR   = 10


ev_NEXT = 1
ev_PREV = 2
ev_CANCEL = 10
ev_OK = 11
ev_NONE = 12

ev_ACTIVATE = 15
ev_CLEARED = 16

ev_OPTION = 251
ev_QUIT = 252
ev_FAIL = 253
ev_DONE = 254
ev_PASS = 255

cm_NONE = 0
cm_UPDATE = 1
cm_CLEAR = 2

cm_RELOAD = 12
cm_LOCATE = 13
cm_SYNC   = 14

cm_EDIT_ITEM = 100
cm_ADD_ITEM = 101

cm_QUICK_SEARCH_2 = 250
cm_SELECTION = 251
cm_CANDELETE = 252
cm_ITEM_CHANGED = 253
cm_QUICK_SEARCH = 254

cm_USER = 255


ty_Widget = 0
ty_Menu = 1
ty_Dialog = 3
ty_Lable = 4
ty_ListItem = 5
ty_EditLine = 6

# Data types for EditLine
dt_numeric = 1
dt_text = 2
dt_date = 3
dt_float = 4
dt_string = 5
dt_biz = 6

msg_YESNO  = 1
msg_OK     = 2
msg_MSG    = 3

cmd_YES = 1
cmd_CANCEL = 2

class Event:
    pass



def pflush():
    panel.update_panels()
    curses.doupdate()

def create_string(length):
    s = ""
    for i in range(length):
	s = s + " "
    return s
    
class Panel:
    def __init__(self, px, py, rows, cols, color):
    	self.win = curses.newwin(rows, cols, py, px)
    	self.pan = panel.new_panel(self.win)
	self.hidden = FALSE
	self.sizex = cols
	self.sizey = rows
	self.top = py
	self.left = px
	if curses.has_colors():
	    self.win.bkgdset(ord(' '), curses.color_pair(color))
	else:
	    self.win.bkgdset(ord(' '), curses.A_BOLD)
	self.clear()

    def setptr(self, Object):
	self.pan.set_userptr(Object)
	
    def set_color(self, color, bold = FALSE):
	if bold == FALSE:
	    self.win.attrset(curses.color_pair(color))
	else:
	    self.win.attrset(curses.color_pair(color)+curses.A_BOLD)
    
    def clear(self):
	self.win.erase()

    def show(self):
	self.pan.show()
	self.hidden = FALSE
	pflush()
    
    def hide(self):
	self.pan.hide()
	self.hidden = TRUE
	pflush()
    
    def set_caption(self, caption, color = COL_TITLE, pos = pos_LEFT):
	if pos == pos_LEFT:
	    self.win.move(0, 3)
	else:
	    self.win.move(0, self.sizex - len(caption) - 1)
	self.set_color(color, TRUE)
	self.win.addstr(caption)     
    
    def writexy(self, x, y, msg, color, bold=FALSE):
	self.win.move(y, x)
	if curses.has_colors():
	    self.set_color(color, bold)
	self.win.addstr(msg)

    def writech(self, x, y, ch, color, bold = FALSE):
	if curses.has_colors():
	    self.set_color(color, bold)
	self.win.addch(x, y, ch)
	
    def hline(self, y, x, length, color, bold = FALSE):
	self.set_color(color, bold)
	self.win.hline(y, x, curses.ACS_HLINE, length)
    
    def vline(self, y, x, length, color, bold = FALSE):
	self.set_color(color, bold)
	self.win.vline(y, x, curses.ACS_VLINE, length)
	
    def drawrect(self, y, x, a, b, color, bold = FALSE):
	self.set_color(color, bold)
	self.win.vline(y + 1, x, curses.ACS_VLINE, b - 1)
	self.win.hline(y, x + 1, curses.ACS_HLINE, a - 1)
	self.win.vline(y + 1, x + a, curses.ACS_VLINE, b - 1)
	self.win.hline(y + b, x + 1, curses.ACS_HLINE, a - 1)
	self.win.addch(y, x, curses.ACS_ULCORNER)
	self.win.addch(y, x + a, curses.ACS_URCORNER)
	self.win.addch(y + b, x, curses.ACS_LLCORNER)
	self.win.addch(y + b, x + a, curses.ACS_LRCORNER)
	
    def drawrect1(self, y, x, a, b, color):
	self.set_color(color)
	self.win.vline(y, x, curses.ACS_SBBS, b, 2)
	self.win.vline(y, x + a, curses.ACS_SBBS, b, 2)
	self.win.hline(y, x + 1, curses.ACS_BSSB, a - 1, 5)
	self.win.hline(y + b, x, curses.ACS_BSSB, a + 1, 5)

    def drawbox(self):
	self.win.box()
    

class Dialog(Panel):
    def __init__(self, px, py, rows, cols, color = COL_MAIN, border = TRUE):
	Panel.__init__(self, px, py, rows+1, cols+1, color)
	if border == TRUE:
	    self.drawrect1(0, 0, cols, rows, 1)
	self.wlist = []
	self.hotkeys = {}
	self.control = -1
	self.win.keypad(1)
	self.quitstatus = 0
	self.Parent = self
	self.visual = DIALOG
	
	self.win.timeout(0)
	
#	self.clear()
#	self.pan.show()


    def moveTo(self, x, y):
	self.pan.move(x, y)

    def addWidget(self, widget):
	if self.control >= 0:
	    self.wlist[self.control].Leave()
		
	self.wlist.append(widget)
	self.control = self.control + 1
	widget.control = self.control
	#widget.widgetSelect()
	widget.draw()
	
	
    def select(self, tabPos):
	self.wlist[self.control].Leave()
	self.control = tabPos
	if self.wlist[tabPos].canFocus():
	    self.wlist[tabPos].widgetSelect()
	    return TRUE
	else:
	    return FALSE
	
    def nextWidget(self):
	while 1:
	    self.wlist[self.control].Leave()
	    if self.control > len(self.wlist) - 2:
		self.control = 0
	    else:
		self.control = self.control + 1
	    if self.select(self.control) == TRUE:
		break
	    
    def prevWidget(self):
	while 1:
	    self.wlist[self.control].Leave()
	    if self.control == 0:
		self.control = len(self.wlist) - 1
	    else:
		self.control = self.control - 1
	    if self.select(self.control) == TRUE:
		break
	
    def destroy(self):
	del self.pan
	pflush()
    
    def Update(self, msg):
	pass

    def ScreenLocked(self):
	return FALSE
    
    def ForceQuit(self):
	return FALSE
    
    def GetKey(self):
	if self.Parent.ForceQuit() == TRUE:
	    key = 27
	if self.Parent.ScreenLocked() == TRUE:
	    key = 0
	else:
	    key = self.win.getch()	
	    if key == -1:
		key = 0
	return key
    
    def mainLoop(self):
	status = 0
	while 1:
	    w = self.wlist[self.control]
	    if self.Parent.ForceQuit() == TRUE:
		curses.curs_set(0)
		self.quitstatus = 1
		status = ev_FAIL
		key = 27
		break
	    
	    if self.Parent.ScreenLocked() == TRUE:
		continue
	    else:
		key = self.GetKey()
		
	    #if key <> 0:
	    #	self.writexy(0, 0, str(key) + "  ", COL_WARN)
		
	    if key == 27:
		#key = self.win.getch()
		#event = Event()
		#event.command = ev_FAIL
		curses.curs_set(0)
		self.quitstatus = 1
		status = ev_FAIL
		break
	    if self.hotkeys.has_key(key):
		self.wlist[self.control].Leave(key)
		n = self.hotkeys[key]
		wa = self.wlist[n]
		event = wa.Activate(key)
		activation = self.UserFn(ev_ACTIVATE, key)
		if activation == ev_DONE:
		    self.select(self.control)
		elif activation == ev_QUIT:
		    status = ev_OK
		    curses.curs_set(0)
		    break
		elif activation != ev_NONE:
		    self.select(n)
	    else:
		event = w.handleEvent(key)
	    if event.command == ev_NEXT:
		self.nextWidget()
	    elif event.command == ev_PREV:
		self.prevWidget()
	    elif event.command == ev_OK or \
	         event.command == ev_FAIL or \
		 event.command == ev_OPTION:
		uf = self.UserFn(event.command, self.control)
		if  uf == ev_DONE:
		    #self.UserFn(event.command, self.control) == None:
		    status = ev_OK
		    break
		elif uf == ev_QUIT:
		    status = ev_OK
		    break
	return status

    def UserFn(self, command, args = None):
	return ev_DONE
	    
    def AddHotKey(self, key, widgetn):
	self.hotkeys[key] = widgetn

class QuickSearchDlg(Dialog):
    def __init__(self, px, py, cols, title = None, color = COL_MAIN):
	Dialog.__init__(self, px, py, 2, cols, color)
	self.set_caption(title)
	self.search = EditLine(self, 2, 1, cols-3, COL_TEXT, COL_TITLE)
	self.addWidget(self.search)
	self.select(0)
	
class SortBox(Dialog):
    def __init__(self, px, py, listbox):
	mw = listbox.maxwidth
	if mw < 12:
	    mw = 12
	Dialog.__init__(self, px, py, 10, mw + 4)
	self.set_caption("")
	
	self.clist = ListBox(self, 2, 1, 8, mw)
	self.clist.setItemColors(COL_WARN, COL_TEXT)
	for i in range(listbox.getColonsNumber()):
	    (w, colon) = listbox.getColon(i)
	    self.clist.addItem(colon)
	
	self.addWidget(self.clist)
	self.select(0)
	
class MessageBox(Dialog):
    def __init__(self, px, py, rows, cols, \
                 bgcolor, txtcolor, message, title, \
		 buttons = None):
	if buttons == msg_YESNO and cols < 24:
	    cols = 24
	if buttons == msg_MSG:
	    drawborder = FALSE
	else:
	    drawborder = TRUE
	Dialog.__init__(self, px, py, rows, cols, bgcolor, border = drawborder)
	self.message = message
	self.visual = MSGBOX
	self.set_caption(title)
	curses.curs_set(0)
	yp = len(self.message)
	
	if buttons == msg_YESNO:
	    self.addWidget(Button(self, 13, yp+4, 7, 1, \
	          "<  >", COL_TITLE, COL_WARN, 2))	    
	    self.addWidget(Button(self, 2, yp+4, 7, 1, \
	          "< . >", COL_TITLE, COL_WARN, 1))	    
	    #self.select(1)
	if buttons == msg_OK:
	    self.addWidget(Button(self, 8, yp+3, 7, 1, \
	          "< Ok >", COL_TITLE, COL_WARN, 1))
	    #self.select(0)
	    
	for i in range(len(self.message)):
	    t = self.message[i]
	    l = len(t) / 2
	    x = cols / 2 - l
	    self.addWidget(Label(self, x, 2+i, t, txtcolor))	    
	if buttons == msg_YESNO:
	    self.select(1)
	elif buttons == msg_OK:
	    self.select(0)
	
    
    def mainLoop(self):
	Dialog.mainLoop(self)
	return self.wlist[self.control].cmd
	    
    
class MenuBar(Panel):
    def __init__(self, px, py, rows, cols, color):
	self.menucolor = color
	self.items = []
	self.count = 0
	self.current = -1
	Panel.__init__(self, px, py, 3, cols+1, color)
	self.set_color(color, TRUE)
	self.drawbox()
	self.subpanel = Dialog(4, 5, 14, 49, COL_MAIN)
	self.subpanel.hide()
	pflush()
	
	self.win.keypad(1)
	self.exitStatus = FALSE
	self.command = ""
	
    def addmenu(self, menustr):
	self.items.append (menustr)
	self.drawItem(self.count, FALSE)
	self.addSeparator(self.count)
	self.count = self.count + 1

	
    def drawItem(self, indx, selected):
	if indx < 0: return
	menustr = self.items[indx][0]
	ll = 0
	for i in range(0, indx):
	    menuitem = self.items[i][0]
	    ll = ll + len(menuitem) + 1
	if selected == FALSE:
	    self.writexy(ll+1, 1, menustr, COL_TEXT, FALSE)
	else:
	    self.writexy(ll+1, 1, menustr, COL_TITLE, TRUE)

    def drawSubitem(self, menuindx, subindx, selected):
	submenu = self.items[menuindx][2]
	submenustr = submenu[subindx][0]
	for i in range(len(submenustr), self.subpanel.sizex-9):
	    submenustr = submenustr + " "

	if selected == TRUE:
	    self.subpanel.writexy(3, subindx+3, 
	      str(subindx+1) + ". " + submenustr, 
	      COL_TITLE, bold = TRUE)
	else:
	    self.subpanel.writexy(3, subindx+3, 
	      str(subindx+1) + ". " + submenustr, COL_TEXT)


	    
    def addSeparator(self, indx):
	ll = 0 
	menustr = self.items[indx][0]
	ss = len(menustr)
	for i in range(0, indx):
	    menuitem = self.items[i][0]
	    ll = ll + len(menuitem) + 1
	self.set_color(self.menucolor, bold=TRUE)
	self.win.vline(1, ll + 1 + ss,
	      curses.ACS_VLINE, 1)
	self.win.addch(0, ll + 1 + ss, 
	      curses.ACS_TTEE)
	self.win.addch(2, ll + 1 + ss, 
	      curses.ACS_BTEE)

    def mainLoop(self):
	while 1:
	    key = self.getChoice()
	    if key == 0:
		break
	    if self.current >= 0:
		self.subpanel.moveTo(5, self.current * 2 + 5)
		#self.updateSubpanel()
		self.subpanel.show()
	    if key == 27 and self.exitStatus == TRUE: 
		self.command = "cmd_exit"
		break
	    if key == 27 and self.exitStatus == FALSE:
		self.exitStatus = TRUE
		if self.subpanel.hidden == FALSE: 
		    self.subpanel.hide()
	return self.command

	      
    def updateSubpanel(self):
	self.subpanel.clear()
	self.subpanel.drawrect1(0, 0, 
	       self.subpanel.sizex - 1, 
	       self.subpanel.sizey - 1, 1)
	self.subpanel.set_caption(" " + self.items[self.current][0]
	     + " - " + self.items[self.current][1] + " ")
	submenu = self.items[self.current][2]
	clearstr = ""
	for i in range(2, self.subpanel.sizex  - 2):
	    clearstr = clearstr + " "
	for i in range(2, self.subpanel.sizey - 2):
	    self.subpanel.writexy(2, i, clearstr,  COL_TEXT)
	self.subpanel.drawrect(2, 2,
	      self.subpanel.sizex - 5, 
	      self.subpanel.sizey - 5, COL_TEXT, bold = TRUE)
	for i in range(len(submenu)):
	    if i == 0:
		self.drawSubitem(self.current, i, TRUE)
	    else:
		self.drawSubitem(self.current, i, FALSE)
	self.subcurrent = 0
		    
		    
    def getChoice(self):
	key = self.win.getch()
	if key == 10:
	    if (self.current >= 0):
#		self.writexy(50, 1,
#		    self.items[self.current][2][self.subcurrent][1],
#	            COL_MAIN, TRUE)
		self.command = \
		   self.items[self.current][2][self.subcurrent][1]
		return 0
	if key == curses.KEY_RIGHT and self.current < self.count - 1:
	    self.drawItem(self.current, FALSE)
	    self.current = self.current + 1
	    self.drawItem(self.current, TRUE)
	    self.exitStatus = FALSE
	    self.updateSubpanel()
	if key == curses.KEY_LEFT and self.current > 0:
	    self.drawItem(self.current, FALSE)
	    self.current = self.current - 1
	    self.drawItem(self.current, TRUE)
	    self.exitStatus = FALSE
	    self.updateSubpanel()
	if ((key == curses.KEY_UP or key == curses.KEY_DOWN) 
	       and self.subpanel.hidden == TRUE):
	    if self.current >= 0:
		self.subpanel.moveTo(6, self.current * 8 + 5)
		self.updateSubpanel()
		self.subpanel.show()
		self.exitStatus = FALSE
		self.subcurrent = 0
	    elif self.current < 0:
		self.current = 0
		self.drawItem(self.current, TRUE)
		self.updateSubpanel()
		self.exitStatus = FALSE
	if (key == curses.KEY_DOWN 
	      and self.subcurrent < len(self.items[self.current][2]) - 1):
	    self.exitStatus = FALSE
	    self.drawSubitem(self.current, self.subcurrent, 
	       FALSE)	    
	    self.subcurrent = self.subcurrent + 1
	    self.drawSubitem(self.current, self.subcurrent, 
	       TRUE)
	if key == curses.KEY_UP and self.subcurrent > 0:
	    self.exitStatus = FALSE
	    self.drawSubitem(self.current, self.subcurrent, 
	       FALSE)	    
	    self.subcurrent = self.subcurrent - 1
	    self.drawSubitem(self.current, self.subcurrent, 
	       TRUE)
	       
	return key
	    
		
    def loadMenu(self, fname):
	menuexpr = '^[ \t]*menu[ \t]*\=([-- ]+)\:([-- ]+)'
	submenuexpr = '^[ \t]*([--a-z\(\)\, ]+)[ \t]*\>([--a-z_]+)'
	menumatch = re.compile(menuexpr)
	submenumatch = re.compile(submenuexpr)
	
	try:
	    fp = open(fname, 'r')
	except:
	    sys.stderr.write('Cannot open %s\n' % fname)
	    return
	while 1:
	    line = fp.readline()
	    if not line:
	    	break
	    m = menumatch.match(line)
	    if m:
		menustr = m.group(1)
		menudesc = m.group(2)
		
		sublist = []
		while 1:
		    line = fp.readline()
		    if len(line) < 2:
			break
		    s = submenumatch.match(line)
		    if s:
			submenustr = s.group(1)
			submenucmd = s.group(2)
			sublist.append([submenustr, submenucmd])
		self.addmenu([menustr, menudesc, sublist])
	    

class Rect:
    pass

class Message:
    def __init__(self):
	self.message = cm_NONE
	self.args = []

class dbExtention:
    def __init__(self, user, passwd, dbase, tablename):	
	self.User = User
	self.PassWd = passwd
	self.Dbase = dbase
	self.table = tablename
	self.query = ""
	self.condition = ""
	self.FetchFactor = 100
	
    def setQuery(self, command):
	self.query = command
	
    def setCondition(self, condition):
	self.condition = condition
    
    def setFetchFactor(self, factor):
	self.FetchFactor = factor
    
    def dbOpen(self):
	self.db = MySQLdb.connect(user = self.User, \
	                          passwd=self.PassWd,\
			          db=self.Dbase)
	

    def ExecuteQuery(self):
	self.curs = self.db.cursor()
	self.curs.execute(self.query+self.condition)
	
    def Fetch(self, factor):
	recs = self.curs.fetchmany(factor)
	return recs
    
    def dbClose(self):
	self.db.close()
	
class Widget:
    def __init__(self, parent, px, py, rows, cols, color):
	self.control = -1
	self.Parent = parent
	self.color = color
	self.rect = Rect()
	self.rect.top = py
	self.rect.left = px
	self.rect.width = cols
	self.rect.height = rows
	self.wSelected = FALSE
	self.Focusable = FALSE
	self.notifyChain = []
	self.dbQuery = ""
	self.dbQCondition = ""
	self.User = ""
	self.Passwd = ""
	self.Dbase = ""
	
    def setDbSource(self, user, passwd, dbase):
	self.User = user
	self.Passwd = passwd
	self.Dbase = dbase
	
    def dbConnect(self, source=None):
	if source == None:
	    self.db = MySQLdb.connect(user=self.User,\
	                              passwd=self.Passwd, db=self.Dbase)

    def dbExecuteQuery(self, args=None):
	self.cursor = self.db.cursor()
	self.cursor.execute(self.dbQuery + " " + self.dbQCondition, args)
	
    def dbClose(self, source=None):
	if source == None:
	    self.db.close()

    def dbLoad(self):
	pass
	    
    def draw(self, drawColor = 0):
	s = create_string(self.rect.width)
	if drawColor == 0:
	    c = self.color
	else:
	    c = drawColor
	for i in range(self.rect.top, self.rect.top+self.rect.height):
	    self.Parent.writexy(self.rect.left, i, s, c)

    def canFocus(self):
	return self.Focusable

    def widgetSelect(self):
	self.wSelected = TRUE
	self.Parent.win.move(self.rect.top, self.rect.left)	

    def doActivation(self):
	pass
	
    def Activate(self, key):
	self.widgetSelect()
	self.doActivation()
	e = self.handleEvent(key)
	return e

    def Leave(self, key = None):
	pass
    
    def Enter(self):
	pass
    
    def addNotifyRecipient(self, Object, cmd, args=None):
	self.notifyChain.append([Object, cmd, args])
	
    # ??????         
    def changeNotifyArgs(self, index, args):
	self.notifyChain[index][2] = args
    
    def Notify(self):
	pass
    
    def Update(self, msg):
	pass
	
    def handleEvent(self, key):
#	e = Event()
#	try:
#	    if key.message == cm_UPDATE:
#		self.Update(key)
#		e.command = ev_NONE
#		return e
#	except AttributeError:
#	    e.command = ev_NONE
#	    return e
	pass


class Label(Widget):
    def __init__(self, parent, px, py, text, color, bold = FALSE):
	Widget.__init__(self, parent, px, py, 1, len(text), color)
	self.Label = text
	self.bold = bold

    def draw(self):
	self.Parent.writexy(self.rect.left, self.rect.top,
	      self.Label, self.color, bold = self.bold)

class ListItem(Widget):
    def __init__(self, parent, width, normcolor, hicolor, label, \
                 formated = FALSE, dtype = None, formatwidth = None):
	self.Parent = parent
	self.Formated = formated
	self.width = width
	self.selection = FALSE
	self.Label = label
	if self.Formated == TRUE:
	    w = width - 2
	else:
	    w = width 
	if dtype == dt_string:
	    #for i in range(len(label), w):
	    #	self.Label = " " + self.Label
	    self.Label = rjust(self.Label, w)
	else:
	    for i in range(len(label), w):
		self.Label = self.Label + " "
#        self.Label = rjust(self.Label, w)
	self.data_type = dtype
	self.data_width = formatwidth
	if self.data_type == dt_float:
	    self.Label = rjust(fix(float(self.Label), self.data_width), w)
	    
	if self.data_type == dt_biz:
	    if float(self.Label) == 0:
		self.LabelValue = float(self.Label)
		self.Label = rjust(" ", w)
	    elif float(self.Label) <> 0:
		self.LabelValue = float(self.Label)
		self.Label = rjust(fix(float(self.Label), self.data_width), w)
		
	self.normColor = normcolor
	self.hiColor = hicolor

    def SetText(self, text):
	self.Label = text
	if self.Formated == TRUE:
	    w = self.width - 2
	else:
	    w = self.width 
	if self.data_type == dt_string:
	    for i in range(len(text), w):
		self.Label = " " + self.Label
	else:
	    for i in range(len(text), w):
		self.Label = self.Label + " "
	if self.data_type == dt_float:
	    self.Label = rjust(fix(float(self.Label), self.data_width), w)
	    
	if self.data_type == dt_biz:
	    if float(self.Label) == 0:
		self.LabelValue = float(self.Label)
		self.Label = rjust(" ", w)
	    elif float(self.Label) <> 0:
		self.LabelValue = float(self.Label)
		self.Label = rjust(fix(float(self.Label), self.data_width), w)
	    
	
    def SelectToggle(self):
	if self.Formated == TRUE:
	    self.selection = not self.selection
    
    def Select(self):
	if self.Formated == TRUE:
	    self.selection = TRUE
    
    def Deselect(self):
	if self.Formated == TRUE:
	    self.selection = FALSE
	
    def draw(self, px, py, hilite = FALSE, selected = FALSE):
	if self.Formated == TRUE:
	    w = self.width - 2
	else:
	    w = self.width
	if hilite == FALSE:
	    if self.selection == TRUE:
		_selcolor = COL_WARN
	    else:
		_selcolor = self.normColor
	    if self.Formated == TRUE:
		self.Parent.set_color(self.normColor)
		if self.selection == TRUE:
		    self.Parent.win.addch(py, px, curses.ACS_BULLET)
		    self.Parent.win.addch(py, px + 1, " ")
		    _selcolor = COL_WARN
		else:
		    self.Parent.win.addch(py, px, " ")
		    self.Parent.win.addch(py, px + 1, " ")
		    _selcolor = self.normColor
		if self.data_type == dt_string:
		    self.Parent.writexy(px + 2, py, rjust(self.Label[self.data_width[0]:], w), _selcolor)
		else:
		    self.Parent.writexy(px + 2, py, self.Label, _selcolor)
	    else:
		if self.data_type == dt_string:
		    self.Parent.writexy(px, py, rjust(self.Label[self.data_width[0]:], w), _selcolor)
		else:
		    self.Parent.writexy(px, py, self.Label, _selcolor)
	else:
	    if self.Formated == TRUE:
		self.Parent.set_color(self.hiColor, bold = TRUE)
		if self.selection == TRUE:
		    self.Parent.win.addch(py, px, curses.ACS_BULLET)
		    self.Parent.win.addch(py, px + 1, " ")
		else:
		    self.Parent.win.addch(py, px, " ")
		    self.Parent.win.addch(py, px + 1, " ")
		if self.data_type == dt_string:
		    self.Parent.writexy(px + 2, py, rjust(self.Label[self.data_width[0]:], w), self.hiColor, TRUE)
		else:
		    self.Parent.writexy(px + 2, py, self.Label, self.hiColor, TRUE)
	    else:
		if self.data_type == dt_string:
		    self.Parent.writexy(px, py, rjust(self.Label[self.data_width[0]:], w), self.hiColor, TRUE)
		else:
		    self.Parent.writexy(px, py, self.Label, self.hiColor, TRUE)
		
class ListBox(Widget):
    def __init__(self, parent, px, py, rows, cols, color = COL_TEXT):
	Widget.__init__(self, parent, px, py, rows, cols, color)
	self.items =[]
	self.hidden_items = []
	self.MultiChoice = FALSE
	self.numerate = FALSE
	self.hilite = -1
	self.start = -1
	self.end = 0
	self.selectAll = FALSE
	self.delPermitted = FALSE
	self.quickLocate = FALSE

    def CanDelete(self):
	delstatus = self.Parent.UserFn(cm_CANDELETE, self.control)
	#return self.delPermitted
	return delstatus	

    def MultipleChoice(self, multi):
	self.MultiChoice = multi
	
    def setItemColors(self, hicolor, normcolor):
	self.hiColor = hicolor
	self.normColor = normcolor
	
    def addItem(self, item):
	if self.MultiChoice == TRUE: f = TRUE
	else:  f = FALSE
	self.items.append(ListItem(self.Parent,
	                           self.rect.width - 1,
	                           self.normColor,
				   self.hiColor,
				   item, f))
	self.hilite = 0
	self.start = 0
	if self.end < self.rect.height - 1:
	    self.end = self.end + 1
	
    def draw(self):
	Widget.draw(self)
	self.Parent.drawrect(self.rect.top, 
			      self.rect.left,
			      self.rect.width,
			      self.rect.height, 
			      self.color, TRUE)
	self.DrawItems()
			      
    def DrawItems(self):
	for i in range(self.start, self.end):
	    if i == self.hilite: hilitef = TRUE
	    else: hilitef = FALSE
	    self.items[i].draw(self.rect.left+1,
	           i+self.rect.top+1 - self.start,
		   hilite = hilitef)

    def Numerate(self):
	self.numerate = TRUE

    def Notify(self):
	for i in range(len(self.notifyChain)):
	    obj = self.notifyChain[i][0]
	    msg = Message()
	    msg.message = self.notifyChain[i][1]
	    msg.args.append(ty_ListItem)
	    msg.args.append(self.items[self.hilite])
	    obj.Update(msg)

    def handleEvent(self, key):
	e = Event()
#	e = Widget.handleEvent(self, key)
	if self.hilite == -1:
	    e.command = ev_FAIL
	    return e
	
	if ascii.isprint_bg(key) and self.quickLocate == TRUE:
	    pass
	
	if key == KEY_ALTE:
	    self.Parent.UserFn(cm_EDIT_ITEM, self.Parent.control)
	    e.command = ev_NONE
	if key == KEY_ALTA:
	    self.Parent.UserFn(cm_ADD_ITEM, self.Parent.control)
	    e.command = ev_NONE
	
	if (key == curses.KEY_DOWN) and  \
	         (self.hilite < len(self.items)-1):
	    self.hilite = self.hilite + 1
	    if self.hilite == self.end:
		self.start = self.start + 1
		self.end = self.end + 1
	    self.draw()
	    e.command = ev_NONE
	    
	elif (key == curses.KEY_UP) and (self.hilite > 0):
	    self.hilite = self.hilite - 1
	    if self.hilite < self.start:
		self.start = self.start - 1
		self.end = self.end - 1
	    self.draw()
	    e.command = ev_NONE
	    
	elif key == curses.KEY_HOME:
	    self.hilite = 0
	    self.start = 0
	    if len(self.items)  > self.rect.height - 1:
		self.end = self.rect.height - 1
	    else:
		self.end = len(self.items)
	    self.draw()
	    e.command = ev_NONE
	    
	elif key == curses.KEY_END:
	    self.end = len(self.items)
	    self.hilite = len(self.items) -1
	    if self.end < self.rect.height:
		self.start = 0
	    else:
		self.start = self.end - self.rect.height + 1
	    self.draw()
	    e.command = ev_NONE
	    
	elif (key == curses.KEY_NPAGE) and \
	        (self.hilite < len(self.items)):
	    if len(self.items) < self.rect.height:
		self.end = len(self.items)
		self.start = 0
		self.hilite = self.end - 1
		
	    elif self.end <= len(self.items) - self.rect.height - 1:
		self.hilite = self.hilite + self.rect.height - 1
		self.end = self.end + self.rect.height - 1
		self.start = self.start + self.rect.height - 1
	    else:
		self.end = len(self.items)
		self.hilite = self.end - 1
		self.start = self.end - self.rect.height + 1
	    self.draw()
	    e.command = ev_NONE

	elif (key == curses.KEY_PPAGE) and (self.hilite > 0):
	    if self.start > self.rect.height - 1:
		self.start = self.start - self.rect.height + 1
		self.end = self.end - self.rect.height + 1
		self.hilite = self.hilite - self.rect.height + 1
	    else:
		self.start = self.hilite = 0
		if len(self.items)  > self.rect.height - 1:
		    self.end = self.rect.height - 1
		else:
		    self.end = len(self.items)
	    self.draw()
	    e.command = ev_NONE
	    
	elif key == curses.KEY_F5:
	    if self.MultiChoice == TRUE:
		self.SelectThis(self.hilite, toggle = 1)
		self.draw()
		e.command = ev_NONE
		self.Parent.UserFn(cm_SELECTION, self.Parent.control)
	    else:
		e.command = ev_NONE
	    
	elif key == curses.KEY_F9:
	    if self.MultiChoice == TRUE:
		self.selectAll = not self.selectAll
		self.SelectAll(sel = self.selectAll)
		self.draw()
		e.command = ev_NONE
		#self.Parent.UserFn(cm_SELECTION, self.Parent.control)
	    else:
		e.command == ev_NONE

	elif key == curses.KEY_DC:
	    
	    ## ??????????????
	    if self.CanDelete() == TRUE:
		del self.items[self.hilite]
		del self.hidden_items[self.hilite]
#		self.items.remove(self.hilite)
		if self.end < len(self.items):
		    self.end = self.end #+ 1
		else:
		    self.end = len(self.items) 
		    self.hilite = self.end - 1
		    self.draw()
		self.Parent.UserFn(cm_UPDATE, self.Parent.control)
		e.command = ev_NONE
	    else:
		e.command = ev_NONE
		
	elif key == curses.KEY_RIGHT:
	    self.Parent.UserFn(cm_QUICK_SEARCH, self.Parent.control)
	    e.command = ev_NONE
	    
	elif key == curses.KEY_LEFT:
	    self.Parent.UserFn(cm_QUICK_SEARCH_2, self.Parent.control)
	    e.command = ev_NONE
		
	elif key == 10:
	    e.command = ev_OK
	    e.args = self.hilite
    
	else:
	    e.command = ev_NONE
	self.Notify()
	#self.Parent.writexy(1, 0, str(self.hilite) + "-" +str(self.start) + "-"+str(self.end), COL_WARN)
	return e
	
    def SelectThis(self, indx, toggle = 0):
	if toggle == 1:
	    self.items[indx].SelectToggle()
	else:
	    self.items[indx].Select()
    
    def DeselectThis(self, indx):
	self.items[indx].Deselect()
    
    def SelectAll(self, sel):
	for i in range(len(self.items)):
	    if sel == TRUE:
		self.SelectThis(i)
	    else:
		self.DeselectThis(i)	
	    self.Parent.UserFn(cm_SELECTION, self.Parent.control)
		
    def Locate(self, item):
	for i in range(len(self.items)):
	    pass
	return 0
    
	
	
		
class MultiListBox(ListBox):
    def __init__(self, parent, px, py, rows, cols, color = COL_TEXT):
	ListBox.__init__(self, parent, px, py, rows, cols, color)
	self.Colons = []
	self.lastSearch = 0
	self.rect.height = self.rect.height - 2
	self.maxwidth = 0
	
    def widgetSelect(self):
	Widget.widgetSelect(self)
	curses.curs_set(0)
	
    def Numerate(self, width):
	self.numerate = TRUE
	#self.Colons.append([width, ""])
	self.addColon(width, "", dt_float, 0)
	
    def addColon(self, width, title, format=None, dfwidth = None):
	self.Colons.append([width, title, format, dfwidth])
	if width > self.maxwidth:
	    self.maxwidth = width
	
    def getColonsNumber(self):
	if self.numerate == TRUE:
	    return len(self.Colons) -1
	else:
	    return len(self.Colons)
    
    def getColon(self, colindx):
	return (self.Colons[colindx][0], self.Colons[colindx][1])
	
    def addItem(self, item, hidden = None):
	it = []
	if self.numerate == TRUE:
	    if self.MultiChoice == TRUE: f = TRUE
	    else:  f = FALSE
	    it.append(ListItem(self.Parent,
	                       self.Colons[0][0],
			       self.normColor, 
			       self.hiColor,
			       str(len(self.items) + 1), f))
	for i in range(len(item)):
	    if self.MultiChoice == TRUE and i == 0 and \
	       self.numerate == FALSE:
		f = TRUE
	    else: f = FALSE
	    it.append(ListItem(self.Parent, 
	                       self.Colons[i][0] - 1,
			       self.normColor, 
			       self.hiColor, 
			       item[i], f,
			       dtype=self.Colons[i][2],
			       formatwidth=self.Colons[i][3]))
	self.items.append(it)
	self.hilite = 0
	self.start = 0
	if self.end < self.rect.height - 1:
	    self.end = self.end + 1
	if hidden <> None:
	    self.hidden_items.append(hidden)
	else:
	    self.hidden_items.append([])
	

    def rplceItem(self, indx, items, hidden = None):
	for i in range(len(items)):
	    self.items[indx][i].SetText(items[i])
	for i in range(len(hidden)):
	    self.hidden_items[indx].__setitem__(i, hidden[i])
	self.draw()
	    
    def Notify(self):
	for i in range(len(self.notifyChain)):
	    obj = self.notifyChain[i][0]
	    msg = Message()
	    msg.message = self.notifyChain[i][1]
	    msg.args.append(ty_ListItem)
	    arg = self.notifyChain[i][2]
	    if arg == None:
		msg.args.append(self.hilite)
	    else:
		msg.args.append(self.items[self.hilite][arg])
#	    msg.args.append(self.hilite)
	    obj.Update(msg)
	

    def Locate(self, item, column = 1):
	if self.hilite == -1: return
	if len(self.items) < self.rect.height: return
	for i in range(len(self.items)):
	    it = self.items[i][column]
	    #nameexpr = '^'+item
	    nameexpr = item
	    namematch = re.compile(nameexpr)
	    #m = namematch.match(it.Label)
	    m = namematch.search(it.Label)
#	    self.Parent.writexy(25,0, it.Label, COL_WARN)
	    if m:
		self.hilite = i
		if self.hilite < len(self.items) - self.rect.height:
		    self.start = self.hilite
		    self.end = self.start + self.rect.height - 1
		else:
		    self.end = len(self.items)
		    self.start = self.end - self.rect.height + 1
		    
		
		self.draw()
		found = i
		break
	    else:
		found = -1
		    
#		self.start = self.start + self.rect.height - 1
#		self.end = self.end + self.rect.height - 1
	#self.lastSearch = found
	return found
    
	    
    def dbLoad(self, wait):
	#recs = self.curs.fetchmany(200)
	recs = self.curs.fetchall()
	
	#self.Parent.writexy(20, 0, str(len(recs)), COL_WARN)
	if len(recs) == 0:
	    return 0
	self.db.commit()
	self.db.close()
	l = len(recs)
	if l > 100 and wait == TRUE:
	    mbox =  MessageBox(30, 9, 6, 22, COL_WARN, COL_WARN, \
		                        ["  "], "", msg_MSG)
	    mbox.show()

	for i in range(l):
	    it = []
	    ih = []
	    #for j in range(len(recs[i])):
		#it.append(str(recs[i][j]))
	    for j in range(len(self.Colons)):
		it.append(str(recs[i][j]))
	    for j in range(len(self.Colons), len(recs[i])):
		ih.append(str(recs[i][j]))
	    self.addItem(it, hidden=ih)
	if l > 100 and wait == TRUE:
	    mbox.destroy()
	    del mbox
	    pflush()
	self.lastSearch = 0
	return l

    def Update(self, msg=None, wait = FALSE):
	if msg == None:
	    return
	if msg.message == cm_SYNC:
	    foreign_hilite = msg.args[1]
	    if foreign_hilite == 0:
		self.hilite = 0
		self.start = 0
		if self.end < self.rect.height-1:
		    self.end = len(self.items)
		else:
		    self.end = self.rect.height-1
		self.draw()
		return
	    if foreign_hilite < self.hilite:       
		ch = curses.KEY_UP
		self.handleEvent(ch)
	    elif foreign_hilite > self.hilite:
		ch = curses.KEY_DOWN
		self.handleEvent(ch)
	    
	    return
	    	    
	if msg.message == cm_RELOAD:
	    if wait == TRUE:
		mbox =  MessageBox(30, 9, 6, 22, COL_WARN, COL_WARN, \
		                        ["  "], "", msg_MSG)
		mbox.show()

#	    condition = msg.args[1]
#	    addargs = (msg.args[2], )
	    if len(msg.args) > 0:
		addargs = ""
		for i in range(1, len(msg.args)):
		    addargs = addargs + str(msg.args[i])
	    else: addargs = ""
	    self.db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	    self.curs = self.db.cursor()
	    rr = self.curs.execute(self.dbQuery + addargs)
	    #if rr == 0:
	    #	return 0
	    #else:
	    del self.items
	    del self.hidden_items
	    self.hidden_items = []
	    self.items = []
	    self.hilite = -1
	    self.start = -1
	    self.end = 0
	    if rr > 0:
		items_loaded = self.dbLoad(not wait)
	    else:
		items_loaded = 0
	    #if items_loaded > 0:
	    self.draw()
	    if wait == TRUE:
		mbox.destroy()
		del mbox
	    return items_loaded
	elif msg.message == cm_LOCATE:
	    item = msg.args[1]
	    column = msg.args[2]
	    found = self.Locate(item, column)
	    self.draw()
	    return found
	    
    def draw(self):
	self.rect.height = self.rect.height + 2
	Widget.draw(self)
	self.Parent.drawrect(self.rect.top, 
			      self.rect.left,
			      self.rect.width,
			      self.rect.height, 
			      self.color, TRUE)
	xofs = 0
	for j in range(len(self.Colons)):
	    if j > 0:
		xofs = xofs + self.Colons[j-1][0]
	    self.Parent.writexy(self.rect.left + 1 + \
	                        xofs + self.Colons[j][0] \
				/ 2 - len(self.Colons[j][1])  /  2,
				self.rect.top + 1,
				self.Colons[j][1], 
				self.normColor)
	    if j == 0:			
		self.Parent.hline(self.rect.top+2,
	                      self.rect.left + 1,
	    		      self.rect.width -1,
      	    		      self.color, TRUE)
		self.Parent.writech(self.rect.top+2,
		                        self.rect.left,
					curses.ACS_LTEE,
					self.color, TRUE)
		self.Parent.writech(self.rect.top+2,
	                        self.rect.left + self.rect.width,
				curses.ACS_RTEE,
				self.color, TRUE)
		    
	    if j > 0:
		self.Parent.vline(self.rect.top + 1,
			      self.rect.left+xofs,
			      self.rect.height - 1,
			      self.color, TRUE)
		self.Parent.writech(self.rect.top,
		                    self.rect.left + xofs,
				    curses.ACS_TTEE,
				    self.color, TRUE)
		self.Parent.writech(self.rect.height + self.rect.top,
		                    self.rect.left + xofs,
				    curses.ACS_BTEE,
				    self.color, TRUE)
		self.Parent.writech(self.rect.top + 2,
		                    self.rect.left + xofs,
				    curses.ACS_PLUS,
				    self.color, TRUE)
		
	self.DrawItems()
	self.rect.height = self.rect.height - 2
	#self.Notify()

    def DrawItems(self):
	if self.start == -1:
	    return
	for i in range(self.start, self.end):
	    if i == self.hilite: hilitef = TRUE
	    else: hilitef = FALSE
	    it = self.items[i]
	    xofs = 0
	    for j in range (len(it)):
		if j > 0:
		    xofs = xofs + self.Colons[j-1][0]
		it[j].draw(self.rect.left+1 + xofs,
	           i+self.rect.top+3 - self.start,
		   hilite = hilitef)

    def SelectThis(self, indx, toggle = 0):
	if toggle == 1:
	    self.items[indx][0].SelectToggle()
	else:
	    self.items[indx][0].Select()
    
    def DeselectThis(self, indx):
	self.items[indx][0].Deselect()

	
class EditLine(Widget):	
    def __init__(self, parent, px, py, width, normcol=COL_TEXT, selcol=COL_TITLE):
	Widget.__init__(self, parent, px, py, 1, width, normcol)
	self.selcolor = selcol
	self.maxlength = width
	self.text = ""
	self.oldtext = ""
	self.typeid = dt_text
	self.needUpdate = TRUE
	self.Focusable = TRUE
	self.firstchar = FALSE
	self.clearOnEnter = TRUE

    def validate(self, ch, x, y):
	if self.typeid == dt_text:
	    if chr(ascii.ascii(ch)) == '\\' or chr(ascii.ascii(ch)) == '\'':
		msgbox = MessageBox(28, 9, 6, 20, COL_TAB, COL_TAB, \
		                    [" "], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.Parent.win.move(y, x)
		curses.curs_set(1)
		return FALSE
	    else:
		return TRUE
	elif self.typeid == dt_float:
	    if ascii.isdigit(ch) or chr(ascii.ascii(ch)) == '.': # or chr(ascii.ascii(ch)) == ' ':
		#
		(y, x) = self.Parent.win.getyx()
		t = ""
		for i in range(self.rect.left, self.rect.left+self.rect.width):
		    t = t + \
		    chr(ascii.ascii_bg(self.Parent.win.inch(self.rect.top, i)))		
		t = strip(t)
		self.Parent.win.move(y,x)
		if chr(ascii.ascii(ch)) == '.' and find(t, '.') >= 0:
		    msgbox = MessageBox(28, 9, 6, 20, COL_TAB, COL_TAB, \
		                [" "], "", msg_OK)
		    msgbox.mainLoop()
		    msgbox.destroy()
		    del msgbox
		    pflush()
		    self.Parent.win.move(y, x)
		    curses.curs_set(1)
		    return FALSE
		return TRUE
	    else:
		msgbox = MessageBox(28, 9, 6, 20, COL_TAB, COL_TAB, \
		                    [" "], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.Parent.win.move(y, x)
		curses.curs_set(1)
		return FALSE
	
	elif self.typeid == dt_numeric:
	    if ascii.isdigit(ch):
		return TRUE
	    else:
		msgbox = MessageBox(28, 9, 6, 20, COL_TAB, COL_TAB, \
		                    [" "], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.Parent.win.move(y, x)
		curses.curs_set(1)
		return FALSE

    def setType(self, typeid):
	self.typeid = typeid

    def Notify(self):
	for i in range(len(self.notifyChain)):
	    obj = self.notifyChain[i][0]
	    msg = Message()
	    msg.message = self.notifyChain[i][1]
	    msg.args.append(ty_EditLine)
	    msg.args.append(self.text)
	    msg.args.append(self.notifyChain[i][2])
	    obj.Update(msg)
    
    
    def Update(self, msg):
	if msg.message == cm_CLEAR:
	    self.text = ""
	    self.needUpdate = TRUE
	    self.draw()
	elif msg.message == cm_UPDATE:
	    if msg.args[0] == ty_ListItem:
		self.text = msg.args[1].Label[0:self.rect.width]
		self.needUpdate = TRUE
		self.draw()
#		self.Parent.writexy(12, 1, self.text, COL_WARN)
    
    def SetText(self, text):
	self.oldtext = self.text
	self.text = text
	self.needUpdate = TRUE
	self.draw()

    def GetText(self):
	t= ""
	for i in range(self.rect.left, self.rect.left+self.rect.width):
	    t = t + \
		chr(ascii.ascii_bg(self.Parent.win.inch(self.rect.top, i)))
	    self.text = strip(t)
	return self.text
	
    def draw(self):
	#if self.needUpdate == FALSE:
	#    return
	if len(self.text) > self.rect.width:
	    t = self.text[1:self.rect.width]
	else:
	    t = self.text
	if self.wSelected == FALSE:
	    Widget.draw(self)
	    self.Parent.writexy(self.rect.left, self.rect.top, 
		        t, self.color)
	else:
	    Widget.draw(self, drawColor = self.selcolor)
	    self.Parent.writexy(self.rect.left, self.rect.top,
	    	        t, self.selcolor)
	self.Parent.win.move(self.rect.top, self.rect.left)
	self.needUpdate = FALSE
    
    def widgetSelect(self):
#	self.Parent.writexy(40, 0, self.text, COL_TEXT1)	
	Widget.widgetSelect(self)
	#if len(self.text) > 0:
	#    self.wSelected = TRUE
	#    self.needUpdate = TRUE
	#    self.draw()
	#else:
	#    self.wSelected = TRUE
	#    self.draw()
	self.oldtext = self.text
	self.wSelected = TRUE
	self.firstchar = TRUE
	self.draw()
	pflush()
	curses.curs_set(1)
	self.Enter()
	

    def do_command(self, ch):
	if self.wSelected == TRUE:
	    #self.wSelected = FALSE
	    #self.needUpdate = TRUE
	    self.draw()
	(y, x) = self.Parent.win.getyx()
#	self.Parent.writexy(18, 1, str(ch), COL_WARN)
	if ascii.isprint_bg(ch) and self.validate(ch, x, y):
	    if self.firstchar == TRUE:
		if self.clearOnEnter == TRUE:
		    self.SetText("")
		self.firstchar = FALSE
#	if ord(ch) > 32 and self.validate(ch, x):
	    if x < self.rect.left + self.rect.width:
		self.wSelected = FALSE
		try:
		    self.Parent.win.addch(ch)
		    (y, x) = self.Parent.win.getyx()
		    if x == self.rect.left + self.rect.width:
			self.Parent.win.move(y, x - 1)
		except curses.error:
		    pass
	elif ch == curses.KEY_HOME:
	    self.Parent.win.move(self.rect.top, self.rect.left)
	elif ch == curses.KEY_END:
	    if len(self.text) > 0:
		self.Parent.win.move(y, self.rect.left + len(self.text))
	    else: 
		self.Parent.win.move(y, self.rect.left + self.rect.width - 1)
	elif ch == curses.KEY_RIGHT and \
	         x < self.rect.left + self.rect.width -1:
	    self.Parent.win.move(y, x + 1)
	elif ch in (curses.KEY_LEFT, curses.KEY_BACKSPACE):
	    if x > self.rect.left:
		self.Parent.win.move(y, x-1)
	    if ch == curses.KEY_BACKSPACE and x > self.rect.left:
#		self.Parent.win.move(y, x-1)
		self.Parent.win.addch(y, x-1, " ")
	    	self.Parent.win.move(y, x-1)
	    if ch == curses.KEY_BACKSPACE and x == self.rect.left:
		self.Parent.win.addch(y, x, " ")
		self.Parent.win.move(y, x)

    def doActivation(self):
	curses.curs_set(1)
	#self.widgetSelect()

    def Leave(self, key = None):
	self.GetText()
	self.wSelected = FALSE
	self.draw()
	return
	
    def handleEvent(self, key):
	e = Event()
#	e = Widget.handleEvent(self, key)
#	if e.command == ev_PASS:
#	    return e
	self.do_command(key)
	if (key == 10) or (key == curses.KEY_DOWN) or (key == curses.KEY_UP):
	    t = ""
	    for i in range(self.rect.left, self.rect.left+self.rect.width):
		t = t + \
		    chr(ascii.ascii_bg(self.Parent.win.inch(self.rect.top, i)))
	    self.text = strip(t)
#	    self.Notify()
	    if key == curses.KEY_DOWN:
		self.SetText(self.oldtext)
		e.command = ev_NEXT
	    elif key == curses.KEY_UP:
		self.SetText(self.oldtext)
		e.command = ev_PREV
	    elif key == 10:
		self.Notify()
		e.command = ev_OK
	else:
	    e.command = ev_NONE
	return e


class OptionLine(EditLine):
    def __init__(self, parent, px, py, width, label, pos = pos_LEFT, normcol = COL_TEXT, selcol = COL_TITLE):
	if pos == pos_LEFT:
	    EditLine.__init__(self, parent, px + len(label) + 1, py, width, normcol, selcol)
	    self.Parent.writexy(px, py, label, COL_TEXT1)
	elif pos == pos_UP:
	    EditLine.__init__(self, parent, px, py, width, normcol, selcol)
	    self.Parent.writexy(px, py-1, label, COL_TEXT1)
	    
	self.canClear = FALSE

    def do_command(self, ch):
	if self.wSelected == TRUE:
	    self.wSelected = FALSE
	    self.needUpdate = TRUE
	    self.draw()
	    
    def handleEvent(self, key):
	e = Event()
	#self.do_command(key)
	if key == 32 and self.canClear == TRUE:
	    self.SetText("")
	    e.command = ev_CLEARED
	    return e
	if (key == 10) or (key == curses.KEY_DOWN) or (key == curses.KEY_UP):
	    if key == curses.KEY_DOWN:
		e.command = ev_NEXT
	    elif key == curses.KEY_UP:
		e.command = ev_PREV
	    elif key == 10:
		self.Notify()
		e.command = ev_OPTION
	else:
	    e.command = ev_NONE
	return e	    
    
class LabeledEditLine(EditLine):
    def __init__(self, parent, px, py, width, label, pos=pos_LEFT, normcol=COL_TEXT, selcol=COL_TITLE):
	if pos==pos_LEFT:
	    EditLine.__init__(self, parent, px + len(label) + 1, py, width, normcol, selcol)
	    self.Parent.writexy(px, py, label, COL_TEXT1)
	elif pos==pos_UP:
	    EditLine.__init__(self, parent, px, py, width, normcol, selcol)
	    self.Parent.writexy(px, py-1, label, COL_TEXT1)
    
class DateLine(EditLine):
    
    def __init__(self, parent, px, py, normcol = COL_TEXT, selcol = COL_TITLE):
	EditLine.__init__(self, parent, px, py, 8, normcol, selcol)
    
    def validate(self, ch, x, y):
	if ascii.isdigit(ch):
	    return TRUE
	else:
	    return FALSE
    
#    def canFocus(self):
#	return TRUE
	
    def do_command(self, ch):
	EditLine.do_command(self, ch)
	(y, x) = self.Parent.win.getyx()
	if x == self.rect.left + 2 or x == self.rect.left + 5:
	    if ascii.isprint(ch) or ch == curses.KEY_RIGHT:
		x = x + 1
	    if ch == curses.KEY_LEFT or ch == curses.KEY_BACKSPACE:
		x = x - 1
	self.Parent.win.move(y, x)	
	
    def widgetSelect(self):
	EditLine.widgetSelect(self)
	self.firstchar = FALSE
	
class LabeledDateLine(DateLine):
    def __init__(self, parent, px, py,  label, pos = pos_LEFT, normcol=COL_TEXT, selcol=COL_TITLE):
	
	if pos==pos_LEFT:
	    DateLine.__init__(self, parent, px + len(label) + 1, py, normcol, selcol)
	    self.Parent.writexy(px, py, label, COL_TEXT1)
	elif pos==pos_UP:
	    DateLine.__init__(self, parent, px, py, normcol, selcol)
	    self.Parent.writexy(px, py-1, label, COL_TEXT1)
	
	#DateLine.__init__(self, parent, px + len(label) + 1, py, normcol, selcol)
	#self.Parent.writexy(px, py, label, COL_TEXT1)	
	
class DropDnBox(Widget):
    def __init__(self, parent, px, py, width, height, color, loadfn = 1):
	Widget.__init__(self, parent, px, py, 1, width, color)
	
	tx = parent.left
	ty = parent.top
	self.subpanel = Dialog(tx + px, ty + py+1, height, width, COL_MAIN, border = FALSE)
	self.subpanel.hide()
	self.state = FALSE
	pflush()
	self.box = ListBox(self.subpanel,  0, 0, height, width-1, COL_TITLE)
	self.box.addNotifyRecipient(self, cm_UPDATE)
	self.box.setItemColors(COL_WARN, COL_TITLE)		
	
	self.LoadBox("cv", "cv", "eso", "objects", loadfn)

	self.FillBox()
	self.subpanel.addWidget(self.box)
	self.text = self.box.items[0].Label

    def SetText(self, t):
	self.text = t
	self.draw()
	
    def LoadBox(self, user, passwd, dbase, tablename, loadfn = 1):
	#self.db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	#self.curs = self.db.cursor()
	#self.curs.execute("""SELECT objid FROM objects WHERE flag = ''""")
	#recs = self.curs.fetchall()
	#self.db.commit()
	#self.db.close()
	#l = len(recs)
	#for i in range(l):
	#    self.box.addItem(recs[i][0])
	pass

    def FillBox(self):
	pass
	    
    def doActivation(self):
	curses.curs_set(0)
	self.RollDown()
#	self.Parent.writexy(1,1, "1", COL_WARN)
#	self.text = "1"
#	self.draw()
	
    def draw(self):
	Widget.draw(self)
	self.Parent.writexy(self.rect.left, self.rect.top, 
	                    self.text, self.color)
	
    def RollDown(self):
	if self.state == FALSE:
	    self.subpanel.show()
	self.state = TRUE
	
    def RollUp(self):
	if self.state == TRUE:
	    self.subpanel.hide()
	self.state = FALSE

    def Update(self, msg):
	if msg.args[0] == ty_ListItem:
	    self.text = msg.args[1].Label
	    self.draw()
	    pflush()
	
    def handleEvent(self, key):
	e = Event()
#	e = Widget.handleEvent(self, key)
#	if e.command == ev_NONE:
#	    return e
	if self.state == TRUE:
	    self.subpanel.mainLoop()
	    self.RollUp()
	    e.command = ev_DONE
	else:
	    self.doActivation()
	    self.subpanel.mainLoop()
	    self.RollUp()
	    e.command = ev_NEXT
	
	
	return e

    
class Button(Widget):
    def __init__(self, parent, px, py, width, height, \
                 text, norm_color, active_color, cmd):
	Widget.__init__(self, parent, px, py, height, width, norm_color)
	self.text = center(text, width)
	self.activeColor = active_color
	self.cmd = cmd
	self.Focusable = TRUE
	
    def draw(self):
	Widget.draw(self)
	y = int(self.rect.height / 2)
	if self.wSelected == TRUE:
	    self.Parent.writexy(self.rect.left, self.rect.top + y, \
	                    self.text, self.activeColor, bold = TRUE)
	else:
	    self.Parent.writexy(self.rect.left, self.rect.top + y, \
			    self.text, self.color)
	pflush()
	
    def widgetSelect(self):
	Widget.widgetSelect(self)
	self.draw()
	
    def Leave(self, key = None):
	self.wSelected = FALSE
	self.draw()
	
    def handleEvent(self, key):
	e = Event()
	if key == curses.KEY_LEFT:
	    e.command = ev_PREV
	elif key == curses.KEY_RIGHT:
	    e.command = ev_NEXT
	
	elif key == 10:
	    e.command = ev_OK
	else:
	    e.command = ev_NONE
	return e
	    
	
	
